package kal.base.com.util;

import java.util.HashMap;

public class AlertAPOCode {
	public static HashMap<String, String> map = new HashMap<String, String>();
	public static String[][] arr = {
		{"OTS1", "ǰ"},
		{"OTS2", "Ÿǰ"},
		{"TM", "TARMAC WX"},
		{"NTC", "NOTICE"},
		{"FG1", "FOG ALERT1"},
		{"FG2", "FOG ALERT2"},
		{"FG3", "FOG ALERT3"},
		{"TY", "TYPHOON ALERT"},
		{"SW", "STRONG WIND ALERT"},
		{"WS", "WINDSHEAR ALERT"},
		{"CIR1", "PUS CIRCLING ALERT1"},
		{"CIR2", "PUS CIRCLING ALERT2"},
		{"CIR3", "PUS CIRCLING ALERT3"},
		{"SN1", "SNOW ALERT1"},
		{"SN2", "SNOW ALERT2"},
		{"SN3", "SNOW ALERT3"},
		{"TS", "THUNDERSTORM ALERT"},
		{"YS1", "YELLOW SAND ALERT1"},
		{"YS2", "YELLOW SAND ALERT2"},
		{"YS3", "YELLOW SAND ALERT3"}
	};
	
	static{
		for(int i = 0; i<arr.length; i++){
			map.put(arr[i][0], arr[i][1]);
		}
	}
	
	public static String getAlertValue(String key){
		return map.get(key);
	}
	
	public static String[][] getAlertList(){
		return arr;
	}
}
