package kal.base.ffs.dbbean;

import java.util.ArrayList;
import java.util.HashMap;

import kal.base.com.util.StringUtil;
import kal.base.jdf.db.EntityData;

/**
 * Flight Following Chart - Landed ȭ鿡  Entity
 * ۼ ¥: 2007-01-09
 * @author: 
 */
public class FfsQ040BG extends EntityData {
	
	//
	private String estDepDt;
	private String regionCd;
	private String fltNum;
	private String regno;
	private String sactyp;
	private String stnfr;
	private String stnto;
	private String actDepDt;
	private String landT;
	private String actArvDt;
	private String plnPayload;
	private String actPayload;
	
	//2007.06.29 ߰
	private String syskey;
	private String ddMonYy;
	private String std;
	private String atd;
	private String sta;
	private String eta;
	private String takeoffTmpst;
	private String planid;
	private String extrFuel;
	private String altPort;
	private String refilePoint;
	private String refilePort;
	private String refileAltPorts;
	
	private String firstLegFltDt; //2007.07.06 ߰
	
	//
	private String fltNumColor;
	private String regnoColor;
	private String wxStnfr;
	private String wxStnto;
	
	//ȭ
	private String callSignD;
	private String acRegD;
	private String acTypeD;
	private String podD;
	private String poaD;
	private String atdD;
	private String tdD;
	private String ataD;
	private String plannedFuelD;
	private String actualFuelD;
	private String rsvFuel; // 2011.06.09 ߰
	
	//20160415 ߰
	private String schDepDt;
	private String tkofT;
	private String plnFodFuel;
	private String actFodFuel;
	private String planConfirm;
	private String commented;
	private	ArrayList<HashMap> flightPlanCheckLogT;
	private String legNum;
	private	String releaseSyskey;
	
//	@2014-05-21
	private String schArvDt;
	public String getSchArvDt() {
		return schArvDt;
	}
	public void setSchArvDt(String schArvDt) {
		this.schArvDt = schArvDt;
	}
	
	/**
	 * Returns the acRegD.
	 * @return String
	 */
	public String getAcRegD() {
		return acRegD;
	}

	/**
	 * Returns the actArvDt.
	 * @return String
	 */
	public String getActArvDt() {
		return actArvDt;
	}

	/**
	 * Returns the actDepDt.
	 * @return String
	 */
	public String getActDepDt() {
		return actDepDt;
	}

	/**
	 * Returns the actPayload.
	 * @return String
	 */
	public String getActPayload() {
		return actPayload;
	}

	/**
	 * Returns the actualFuelD.
	 * @return String
	 */
	public String getActualFuelD() {
		return actualFuelD;
	}

	/**
	 * Returns the acTypeD.
	 * @return String
	 */
	public String getAcTypeD() {
		return acTypeD;
	}

	/**
	 * Returns the ataD.
	 * @return String
	 */
	public String getAtaD() {
		return ataD;
	}

	/**
	 * Returns the atdD.
	 * @return String
	 */
	public String getAtdD() {
		return atdD;
	}

	/**
	 * Returns the callSignD.
	 * @return String
	 */
	public String getCallSignD() {
		return callSignD;
	}

	/**
	 * Returns the estDepDt.
	 * @return String
	 */
	public String getEstDepDt() {
		return estDepDt;
	}

	/**
	 * Returns the fltNum.
	 * @return String
	 */
	public String getFltNum() {
		return fltNum;
	}

	/**
	 * Returns the fltNumColor.
	 * @return String
	 */
	public String getFltNumColor() {
		return fltNumColor;
	}

	/**
	 * Returns the landT.
	 * @return String
	 */
	public String getLandT() {
		return landT;
	}

	/**
	 * Returns the plannedFuelD.
	 * @return String
	 */
	public String getPlannedFuelD() {
		return plannedFuelD;
	}

	/**
	 * Returns the plnPayload.
	 * @return String
	 */
	public String getPlnPayload() {
		return plnPayload;
	}

	/**
	 * Returns the poaD.
	 * @return String
	 */
	public String getPoaD() {
		return poaD;
	}

	/**
	 * Returns the podD.
	 * @return String
	 */
	public String getPodD() {
		return podD;
	}

	/**
	 * Returns the regionCd.
	 * @return String
	 */
	public String getRegionCd() {
		return regionCd;
	}

	/**
	 * Returns the regno.
	 * @return String
	 */
	public String getRegno() {
		return regno;
	}

	/**
	 * Returns the regnoColor.
	 * @return String
	 */
	public String getRegnoColor() {
		return regnoColor;
	}

	/**
	 * Returns the sactyp.
	 * @return String
	 */
	public String getSactyp() {
		return sactyp;
	}

	/**
	 * Returns the stnfr.
	 * @return String
	 */
	public String getStnfr() {
		return stnfr;
	}

	/**
	 * Returns the stnto.
	 * @return String
	 */
	public String getStnto() {
		return stnto;
	}

	/**
	 * Returns the tdD.
	 * @return String
	 */
	public String getTdD() {
		return tdD;
	}

	/**
	 * Returns the wxStnfr.
	 * @return String
	 */
	public String getWxStnfr() {
		return wxStnfr;
	}

	/**
	 * Returns the wxStnto.
	 * @return String
	 */
	public String getWxStnto() {
		return wxStnto;
	}

	/**
	 * Sets the acRegD.
	 * @param acRegD The acRegD to set
	 */
	public void setAcRegD(String acRegD) {
		this.acRegD = acRegD;
	}

	/**
	 * Sets the actArvDt.
	 * @param actArvDt The actArvDt to set
	 */
	public void setActArvDt(String actArvDt) {
		this.actArvDt = actArvDt;
	}

	/**
	 * Sets the actDepDt.
	 * @param actDepDt The actDepDt to set
	 */
	public void setActDepDt(String actDepDt) {
		this.actDepDt = actDepDt;
	}

	/**
	 * Sets the actPayload.
	 * @param actPayload The actPayload to set
	 */
	public void setActPayload(String actPayload) {
		this.actPayload = actPayload;
	}

	/**
	 * Sets the actualFuelD.
	 * @param actualFuelD The actualFuelD to set
	 */
	public void setActualFuelD(String actualFuelD) {
		this.actualFuelD = actualFuelD;
	}

	/**
	 * Sets the acTypeD.
	 * @param acTypeD The acTypeD to set
	 */
	public void setAcTypeD(String acTypeD) {
		this.acTypeD = acTypeD;
	}

	/**
	 * Sets the ataD.
	 * @param ataD The ataD to set
	 */
	public void setAtaD(String ataD) {
		this.ataD = ataD;
	}

	/**
	 * Sets the atdD.
	 * @param atdD The atdD to set
	 */
	public void setAtdD(String atdD) {
		this.atdD = atdD;
	}

	/**
	 * Sets the callSignD.
	 * @param callSignD The callSignD to set
	 */
	public void setCallSignD(String callSignD) {
		this.callSignD = callSignD;
	}

	/**
	 * Sets the estDepDt.
	 * @param estDepDt The estDepDt to set
	 */
	public void setEstDepDt(String estDepDt) {
		this.estDepDt = estDepDt;
	}

	/**
	 * Sets the fltNum.
	 * @param fltNum The fltNum to set
	 */
	public void setFltNum(String fltNum) {
		this.fltNum = fltNum;
	}

	/**
	 * Sets the fltNumColor.
	 * @param fltNumColor The fltNumColor to set
	 */
	public void setFltNumColor(String fltNumColor) {
		this.fltNumColor = fltNumColor;
	}

	/**
	 * Sets the landT.
	 * @param landT The landT to set
	 */
	public void setLandT(String landT) {
		this.landT = landT;
	}

	/**
	 * Sets the plannedFuelD.
	 * @param plannedFuelD The plannedFuelD to set
	 */
	public void setPlannedFuelD(String plannedFuelD) {
		this.plannedFuelD = plannedFuelD;
	}

	/**
	 * Sets the plnPayload.
	 * @param plnPayload The plnPayload to set
	 */
	public void setPlnPayload(String plnPayload) {
		this.plnPayload = plnPayload;
	}

	/**
	 * Sets the poaD.
	 * @param poaD The poaD to set
	 */
	public void setPoaD(String poaD) {
		this.poaD = poaD;
	}

	/**
	 * Sets the podD.
	 * @param podD The podD to set
	 */
	public void setPodD(String podD) {
		this.podD = podD;
	}

	/**
	 * Sets the regionCd.
	 * @param regionCd The regionCd to set
	 */
	public void setRegionCd(String regionCd) {
		this.regionCd = regionCd;
	}

	/**
	 * Sets the regno.
	 * @param regno The regno to set
	 */
	public void setRegno(String regno) {
		this.regno = regno;
	}

	/**
	 * Sets the regnoColor.
	 * @param regnoColor The regnoColor to set
	 */
	public void setRegnoColor(String regnoColor) {
		this.regnoColor = regnoColor;
	}

	/**
	 * Sets the sactyp.
	 * @param sactyp The sactyp to set
	 */
	public void setSactyp(String sactyp) {
		this.sactyp = sactyp;
	}

	/**
	 * Sets the stnfr.
	 * @param stnfr The stnfr to set
	 */
	public void setStnfr(String stnfr) {
		this.stnfr = stnfr;
	}

	/**
	 * Sets the stnto.
	 * @param stnto The stnto to set
	 */
	public void setStnto(String stnto) {
		this.stnto = stnto;
	}

	/**
	 * Sets the tdD.
	 * @param tdD The tdD to set
	 */
	public void setTdD(String tdD) {
		this.tdD = tdD;
	}

	/**
	 * Sets the wxStnfr.
	 * @param wxStnfr The wxStnfr to set
	 */
	public void setWxStnfr(String wxStnfr) {
		this.wxStnfr = wxStnfr;
	}

	/**
	 * Sets the wxStnto.
	 * @param wxStnto The wxStnto to set
	 */
	public void setWxStnto(String wxStnto) {
		this.wxStnto = wxStnto;
	}

	/**
	 * Returns the altPort.
	 * @return String
	 */
	public String getAltPort() {
		return altPort;
	}

	/**
	 * Returns the atd.
	 * @return String
	 */
	public String getAtd() {
		return atd;
	}

	/**
	 * Returns the ddMonYy.
	 * @return String
	 */
	public String getDdMonYy() {
		return ddMonYy;
	}

	/**
	 * Returns the eta.
	 * @return String
	 */
	public String getEta() {
		return eta;
	}

	/**
	 * Returns the extrFuel.
	 * @return String
	 */
	public String getExtrFuel() {
		return extrFuel;
	}

	/**
	 * Returns the planid.
	 * @return String
	 */
	public String getPlanid() {
		return planid;
	}

	/**
	 * Returns the refileAltPorts.
	 * @return String
	 */
	public String getRefileAltPorts() {
		return refileAltPorts;
	}

	/**
	 * Returns the refilePoint.
	 * @return String
	 */
	public String getRefilePoint() {
		return refilePoint;
	}

	/**
	 * Returns the refilePort.
	 * @return String
	 */
	public String getRefilePort() {
		return refilePort;
	}

	/**
	 * Returns the sta.
	 * @return String
	 */
	public String getSta() {
		return sta;
	}

	/**
	 * Returns the std.
	 * @return String
	 */
	public String getStd() {
		return std;
	}

	/**
	 * Returns the syskey.
	 * @return String
	 */
	public String getSyskey() {
		return syskey;
	}

	/**
	 * Returns the takeoffTmpst.
	 * @return String
	 */
	public String getTakeoffTmpst() {
		return takeoffTmpst;
	}

	/**
	 * Sets the altPort.
	 * @param altPort The altPort to set
	 */
	public void setAltPort(String altPort) {
		this.altPort = altPort;
	}

	/**
	 * Sets the atd.
	 * @param atd The atd to set
	 */
	public void setAtd(String atd) {
		this.atd = atd;
	}

	/**
	 * Sets the ddMonYy.
	 * @param ddMonYy The ddMonYy to set
	 */
	public void setDdMonYy(String ddMonYy) {
		this.ddMonYy = ddMonYy;
	}

	/**
	 * Sets the eta.
	 * @param eta The eta to set
	 */
	public void setEta(String eta) {
		this.eta = eta;
	}

	/**
	 * Sets the extrFuel.
	 * @param extrFuel The extrFuel to set
	 */
	public void setExtrFuel(String extrFuel) {
		this.extrFuel = extrFuel;
	}

	/**
	 * Sets the planid.
	 * @param planid The planid to set
	 */
	public void setPlanid(String planid) {
		this.planid = planid;
	}

	/**
	 * Sets the refileAltPorts.
	 * @param refileAltPorts The refileAltPorts to set
	 */
	public void setRefileAltPorts(String refileAltPorts) {
		this.refileAltPorts = refileAltPorts;
	}

	/**
	 * Sets the refilePoint.
	 * @param refilePoint The refilePoint to set
	 */
	public void setRefilePoint(String refilePoint) {
		this.refilePoint = refilePoint;
	}

	/**
	 * Sets the refilePort.
	 * @param refilePort The refilePort to set
	 */
	public void setRefilePort(String refilePort) {
		this.refilePort = refilePort;
	}

	/**
	 * Sets the sta.
	 * @param sta The sta to set
	 */
	public void setSta(String sta) {
		this.sta = sta;
	}

	/**
	 * Sets the std.
	 * @param std The std to set
	 */
	public void setStd(String std) {
		this.std = std;
	}

	/**
	 * Sets the syskey.
	 * @param syskey The syskey to set
	 */
	public void setSyskey(String syskey) {
		this.syskey = syskey;
	}

	/**
	 * Sets the takeoffTmpst.
	 * @param takeoffTmpst The takeoffTmpst to set
	 */
	public void setTakeoffTmpst(String takeoffTmpst) {
		this.takeoffTmpst = takeoffTmpst;
	}

	/**
	 * Returns the firstLegFltDt.
	 * @return String
	 */
	public String getFirstLegFltDt() {
		return firstLegFltDt;
	}

	/**
	 * Sets the firstLegFltDt.
	 * @param firstLegFltDt The firstLegFltDt to set
	 */
	public void setFirstLegFltDt(String firstLegFltDt) {
		this.firstLegFltDt = firstLegFltDt;
	}
	
	/**
	 * Returns the rsvFuel.
	 * @return String
	 */
	public String getRsvFuel() {
		return rsvFuel;
	}

	/**
	 * Sets the rsvFuel.
	 * @param rsvFuel The rsvFuel to set
	 */
	public void setRsvFuel(String rsvFuel) {
		this.rsvFuel = rsvFuel;
	}
	
	/**
	 * 20160415 ߰
	 */
	public String getSchDepDt() {
		return schDepDt;
	}
	public void setSchDepDt(String schDepDt) {
		this.schDepDt = schDepDt;
	}
	public String getTkofT() {
		return tkofT;
	}
	public void setTkofT(String tkofT) {
		this.tkofT = tkofT;
	}
	public String getPlnFodFuel() {
		return plnFodFuel;
	}
	public void setPlnFodFuel(String plnFodFuel) {
		this.plnFodFuel = plnFodFuel;
	}
	public String getActFodFuel() {
		return actFodFuel;
	}
	public void setActFodFuel(String actFodFuel) {
		this.actFodFuel = actFodFuel;
	}
	public String getPlanConfirm() {
		return planConfirm;
	}
	public void setPlanConfirm(String planConfirm) {
		this.planConfirm = planConfirm;
	}
	public String getCommented() {
		return commented;
	}
	public void setCommented(String commented) {
		this.commented = commented;
	}
	public ArrayList<HashMap> getFlightPlanCheckLogT() {
		return flightPlanCheckLogT;
	}
	public void setFlightPlanCheckLogT(ArrayList<HashMap> flightPlanCheckLogT) {
		this.flightPlanCheckLogT = flightPlanCheckLogT;
	}
	public String getLegNum() {
		return legNum;
	}
	public void setLegNum(String legNum) {
		this.legNum = legNum;
	}
	public String getReleaseSyskey() {
		return releaseSyskey;
	}
	public void setReleaseSyskey(String releaseSyskey) {
		this.releaseSyskey = releaseSyskey;
	}

}
