package kal.base.ffs.query;

import java.util.HashMap;//@2014-05-12 ~ @2014-05-30

import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Flight Following Chart - Enroute SQL 
  * @author Copyright (c) 2007/01/09  
  */   
public class FfsQ030Query {
	private static FfsQ030Query instance = new FfsQ030Query();
	
	public static FfsQ030Query getInstance() {
		return instance;
	}
	
	/** 
	  * Flight Following Chart - Enroute ȸ SQLԼ.
	  * @return String Query
	  */
	public String selEnroute() {
		StringBuffer sql = new StringBuffer();
		
		/*sql.append(" SELECT ");
		sql.append(" 	B.SYSKEY, "); //2007.03.22 ߰
		sql.append(" 	TO_CHAR(A.FIRST_LEG_FLT_DT,'DDMONYY','nls_date_language=american') DDMONYY, "); // 2007.01.17 ߰
		sql.append(" 	TO_CHAR(A.SCH_DEP_DT,'HH24MI') STD, "); // 2007.01.17 ߰
		sql.append(" 	TO_CHAR(A.ACT_DEP_DT,'HH24MI') ATD, "); // 2007.01.17 ߰
		sql.append(" 	TO_CHAR(A.SCH_ARV_DT,'HH24MI') STA, "); // 2007.06.26 ߰
		sql.append(" 	(A.ACT_ARV_DT-A.EST_ARV_DT)*24*60 ARV_GAP, "); // 2011.06.07 ߰ : 
		sql.append(" 	B.PLANID, "); // 2007.01.17 ߰
		sql.append(" 	TO_CHAR(A.EST_DEP_DT,'YYMMDDHH24MI') EST_DEP_DT, "); // ߰
		sql.append(" 	B.LCF_RATIO, "); // 2007.03.07 ߰
		sql.append(" 	C.REGION_CD, A.FLT_NUM, B.REGNO, B.ACTYP SACTYP, A.STNFR, A.STNTO, ");
		sql.append(" 	TO_CHAR(B.TAKEOFF_TMPST,'YYMMDDHH24MI') TAKEOFF_TMPST, "); // 2007.02.09  : A.TKOF_T -> TAKEOFF_TMPST
		sql.append(" 	TO_CHAR(A.EST_ARV_DT,'YYMMDDHH24MI') EST_ARV_DT, ");
		sql.append(" 	TO_CHAR(SYSDATE - 9/24,'YYMMDDHH24MI') CUR_TIME, "); // 2007.02.12 ߰
		sql.append(" 	B.ALT_PORT, B.EXTR_FUEL+B.PAD_FUEL EXTR_PAD, NVL(B.EXTR_FUEL, 0) EXTR_FUEL, B.SPEED, B.ETOPS_PORTS, ");  // 2007.03.02  Co-RSV  EXTR_FUEL -> B.EXTR_FUEL+B.PAD_FUEL
		sql.append(" 	NVL(B.PAD_FUEL, 0) PAD_FUEL, NVL(B.EXTR_FUEL+B.TANK_FUEL, 0) EXTR_TANK, "); //2010.03.29 ߰ : Co-RSV -> CCF(PAD) / Extra(EXTR+TANK)  и.
		sql.append(" 	B.REFILE_POINT, B.REFILE_PORT, B.REFILE_ALT_PORTS, ");
		sql.append(" 	C.NAI_Y, "); //2008.12.22 ߰ : N
		sql.append("	ROUND(TO_NUMBER((A.SCH_ARV_DT - A.SCH_DEP_DT) * 24 * 60), 0) DIFF_MIN, "); //2008.12.22 ߰ : N  ߰
		//------------> ʹ  
		//sql.append(" 	   F.FLT_NUM_COLOR, F.EXTRA_FUEL, F.CRZ_MODE, "); 2007.01.29  : .
		sql.append(" 	B.DIVERT, F.FLT_LEVEL, F.FOB, F.POINT_ATA, F.WAYPOINT_MISMATCH, "); // 2007.02.01 ߰
		sql.append(" 	F.POS_MSG, "); // 2007.01.30 ߰
		sql.append(" 	F.REGNO REGNO_COLOR, F.WX_STNFR, F.WX_STNTO, F.TAKE_OFF, F.ETA, ");
		sql.append(" 	F.WX_ALT_PORT, F.WX_ETOP_PORT, F.WX_REFILE_PORT, F.WX_REFILE_ALT_PORT, "); // 2007.01.26 ߰ : WX_REFILE_ALT_PORT
		//sql.append(" 	F.NOTAM_STNFR, F.NOTAM_STNTO, F.NOTAM_ALT_PORT, F.NOTAM_ETOP_PORT, ");
		//sql.append(" 	F.NOTAM_REFILE_PORT, F.NOTAM_REFILE_ALT_PORT, ");
		sql.append(" 	F.NOTAM, "); //2007.06.26 : NOTAM  ʵ ߰
		sql.append(" 	F.MEL, "); //2007.06.28 ߰ : M
		sql.append("    F.MAN_WX_STNFR, F.MAN_WX_STNTO, F.MAN_WX_ALT_PORT, ");
		sql.append(" 	A.SACTYP DAILY_SACTYP, "); //2007.06.28 ߰ : 5
		sql.append(" 	T.MEL ACTYP_MEL, "); //2007.06.28 ߰ : 5
		sql.append(" 	AC.RESTRICT_E, "); //2007.06.28 ߰ : R
		sql.append(" 	F.PMSN, TO_CHAR(A.FIRST_LEG_FLT_DT, 'YYYYMMDD') FIRST_LEG_FLT_DT, TO_CHAR(A.SCH_DEP_DT, 'DDMON','nls_date_language=american') SCH_DEP_DT, "); //2007.06.28 ߰ : P
		sql.append(" 	TO_CHAR(A.SCH_DEP_DT, 'DDMONYY','nls_date_language=american') SCHDDMONYY, "); //2007.07.09 ߰ : Position Report  .
		sql.append(" 	TO_CHAR(B.RMK_TMPST,'YYYYMMDDHH24MISS') RMK_TMPST, "); //2007.07.26 ߰ : Call Sign   ǥϱ  .
		sql.append(" 	TO_CHAR(B.POS_TMPST,'YYYYMMDDHH24MISS') POS_TMPST, "); //2007.07.26 ߰ : Call Sign   ǥϱ  .
		//sql.append(" 	TO_CHAR(NVL(B.TAKEOFF_TMPST, '20000101'), 'YYYYMMDD') CHECK_TAKEOFF, "); //2008.09.23 ߰ : UPDATE  ȸؼ ó.
		//sql.append(" 	TO_CHAR(NVL(B.POS_TMPST, '20000101'), 'YYYYMMDD') CHECK_POS, "); //2008.09.23 ߰ : UPDATE  ȸؼ ó.
		//sql.append(" 	TRUNC((SYSDATE - (NVL(B.TAKEOFF_TMPST, SYSDATE) + 9/24)) * 1440, 0) DATA_TAKEOFF, "); //2008.09.23 ߰ : UPDATE  ȸؼ ó.
		//sql.append(" 	TRUNC((SYSDATE - NVL(B.POS_TMPST, SYSDATE)) * 1440, 0) DATA_POS, "); //2008.09.23 ߰ : UPDATE  ȸؼ ó.
		sql.append(" 	F.ALL_COLUMNS ");
		sql.append(" FROM ");
		sql.append(" 	DAILY_SCH_T A, FLIGHT_PLAN_T B, CM_CITYPAIR_DEF_T C, FLIGHT_ALERT_T F, CM_ACTYP_T T, CM_CITYPAIR_AC_T AC ");
		sql.append(" WHERE B.ACTIVE = 'Y' ");
		sql.append(" 	AND B.STATUS = 'AIR' ");
		//sql.append(" 	AND LENGTH(A.TKOF_T) = 4 "); //2010.03.26 ߰->
		sql.append(" 	AND A.SCH_DEP_DT >= SYSDATE - 35/24 "); //2008.06.04 ߰
		sql.append(" 	AND A.SCH_DEP_DT <= SYSDATE + 3/24 "); //2008.06.04 ߰
		sql.append(" 	AND A.ACT_DEP_DT >= SYSDATE - 30/24 ");
		sql.append(" 	AND A.ACT_DEP_DT <= SYSDATE - 8/24 ");
		//sql.append(" 	AND A.DEP_STS = 'ACT' ");	// 2007.01.15 ߰ -> 2007.02.01 ּó
		sql.append(" 	AND A.ARV_STS <> 'ACT' ");	// 2007.01.15 ߰
		sql.append(" 	AND A.DEP_STS <> 'INI' ");	// 2009.02.02 ߰
		sql.append(" 	AND A.ACTNID <> 'CNL' ");		// 2007.01.15 ߰
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" 	AND A.STNFR = B.STNFR ");
		sql.append(" 	AND A.STNTO = B.STNTO ");
		sql.append(" 	AND A.STNFR = C.DEP_PORT ");
		sql.append(" 	AND A.STNTO = C.ARV_PORT ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = F.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND A.FLT_NUM = F.FLT_NUM ");
		sql.append(" 	AND A.STNFR = F.STNFR ");
		sql.append(" 	AND A.STNTO = F.STNTO ");
		sql.append(" 	AND A.KACTYP = T.KACTYP "); //2007.06.28 ߰
		sql.append(" 	AND A.STNFR = AC.DEP_PORT "); //2007.06.28 ߰
		sql.append(" 	AND A.STNTO = AC.ARV_PORT "); //2007.06.28 ߰
		sql.append(" 	AND A.SACTYP = AC.SACTYP "); //2007.06.28 ߰
		sql.append("  AND SUBSTR(A.FLT_NUM, 1, 1) <> '4' "); //2009.08.13 ߰ :  FLT 
		
		sql.append(" ORDER BY B.TAKEOFF_TMPST ");*/
		
//		2013-04-24 ּ Ʒ
		sql.append(" SELECT ");
		sql.append(" 	B.SYSKEY, "); //2007.03.22 ߰
		sql.append(" 	TO_CHAR(A.FIRST_LEG_FLT_DT,'DDMONYY','nls_date_language=american') DDMONYY, "); // 2007.01.17 ߰
		sql.append(" 	TO_CHAR(A.SCH_DEP_DT,'HH24MI') STD, "); // 2007.01.17 ߰
		sql.append(" 	TO_CHAR(A.ACT_DEP_DT,'HH24MI') ATD, "); // 2007.01.17 ߰
		sql.append(" 	TO_CHAR(A.SCH_ARV_DT,'HH24MI') STA, "); // 2007.06.26 ߰
		sql.append(" 	     (A.SCH_ARV_DT - A.EST_ARV_DT)*24*60 STA_ETA, ");
		//sql.append(" 	CASE    WHEN ((A.SCH_ARV_DT - A.EST_ARV_DT)*24*60) > -10 AND ((A.SCH_ARV_DT - A.EST_ARV_DT)*24*60) <= -5 AND ((A.SCH_ARV_DT - A.SCH_DEP_DT)*24*60 > 180)  AND A.KACTYP NOT IN ('ABH','74F', '7FQ', '7FR', '74Y', '7FG', '79S','7GG') THEN '   '   "); //20130424 KIM_HYOJ   ߰
		sql.append(" 	CASE    WHEN ((A.SCH_ARV_DT - A.EST_ARV_DT)*24*60) > -11 AND ((A.SCH_ARV_DT - A.EST_ARV_DT)*24*60) <= -5 AND ((A.SCH_ARV_DT - A.SCH_DEP_DT)*24*60 > 180)  AND A.KACTYP NOT IN ('ABH','74F', '7FQ', '7FR', '74Y', '7FG', '79S','7GG') THEN '   '   "); //20130528 -10 -11
		sql.append("            ELSE NULL   "); //20130424 KIM_HYOJ   ߰
		sql.append("    END AS ETA_MSG,   "); //20130424 KIM_HYOJ   ߰ 2013-04-29 not in ߰

		sql.append(" 	(A.ACT_ARV_DT-A.EST_ARV_DT)*24*60 ARV_GAP, "); // 2011.06.07 ߰ : 
		sql.append(" 	B.PLANID, "); // 2007.01.17 ߰
		sql.append(" 	TO_CHAR(A.EST_DEP_DT,'YYMMDDHH24MI') EST_DEP_DT, "); // ߰
		sql.append(" 	B.LCF_RATIO, "); // 2007.03.07 ߰
		//sql.append(" 	C.REGION_CD, A.FLT_NUM, B.REGNO, B.ACTYP SACTYP, A.STNFR, A.STNTO, ");//@2013-11-07
		sql.append(" 	   DECODE(DECODE(SUBSTR(A.FLT_NUM, 1, 1),'4','JNA','KAL'),'JNA','JNA',C.REGION_CD) REGION_CD, ");//@2013-11-07
		sql.append(" 	  DECODE(SUBSTR(A.FLT_NUM, 1, 1),'4','JNA','KAL') GBN,  ");//@2013-11-07
		sql.append(" 	A.FLT_NUM, B.REGNO, B.ACTYP SACTYP, A.STNFR, A.STNTO, ");
		sql.append(" 	TO_CHAR(B.TAKEOFF_TMPST,'YYMMDDHH24MI') TAKEOFF_TMPST, "); // 2007.02.09  : A.TKOF_T -> TAKEOFF_TMPST
		sql.append(" 	TO_CHAR(A.EST_ARV_DT,'YYMMDDHH24MI') EST_ARV_DT, ");
		sql.append(" 	TO_CHAR(SYSDATE - 9/24,'YYMMDDHH24MI') CUR_TIME, "); // 2007.02.12 ߰
		//sql.append(" 	B.ALT_PORT, B.EXTR_FUEL+B.PAD_FUEL EXTR_PAD, NVL(B.EXTR_FUEL, 0) EXTR_FUEL, B.SPEED, B.ETOPS_PORTS, ");  // 2007.03.02  Co-RSV  EXTR_FUEL -> B.EXTR_FUEL+B.PAD_FUEL
		
		//20140918 EXTR_FUEL_DISC  ( +NVL(FU.PLN_TANK_FUEL,0) )
		//sql.append(" 	B.ALT_PORT, B.EXTR_FUEL+B.PAD_FUEL EXTR_PAD, (NVL(FU.PLN_EXTR_FUEL1,0)+NVL(FU.PLN_EXTR_FUEL2,0))*0.01 EXTR_FUEL_DISC, NVL(FU.PLN_EXTR_FUEL1,0) PLN_EXTR_FUEL1, FU.PLN_EXTR_RSN1, NVL(FU.PLN_EXTR_FUEL2,0) PLN_EXTR_FUEL2, FU.PLN_EXTR_RSN2, B.SPEED, B.ETOPS_PORTS, ");//2014-02-22"
		sql.append(" 	B.ALT_PORT, B.EXTR_FUEL+B.PAD_FUEL EXTR_PAD, (NVL(FU.PLN_EXTR_FUEL1,0)+NVL(FU.PLN_EXTR_FUEL2,0)+NVL(FU.PLN_TANK_FUEL,0))*0.01 EXTR_FUEL_DISC, NVL(FU.PLN_EXTR_FUEL1,0) PLN_EXTR_FUEL1, FU.PLN_EXTR_RSN1, NVL(FU.PLN_EXTR_FUEL2,0) PLN_EXTR_FUEL2, FU.PLN_EXTR_RSN2, B.SPEED, B.ETOPS_PORTS, ");//2014-02-22"
		//20140918 PLN_TANK_FUEL ߰
		sql.append(" 	NVL(FU.PLN_TANK_FUEL,0) PLN_TANK_FUEL, ");
		
		sql.append(" 	NVL(B.PAD_FUEL, 0) PAD_FUEL, NVL(B.EXTR_FUEL+B.TANK_FUEL, 0) EXTR_TANK, "); //2010.03.29 ߰ : Co-RSV -> CCF(PAD) / Extra(EXTR+TANK)  и.
		sql.append(" 	B.REFILE_POINT, B.REFILE_PORT, B.REFILE_ALT_PORTS, ");
		sql.append(" 	C.NAI_Y, "); //2008.12.22 ߰ : N
		sql.append("	ROUND(TO_NUMBER((A.SCH_ARV_DT - A.SCH_DEP_DT) * 24 * 60), 0) DIFF_MIN, "); //2008.12.22 ߰ : N  ߰
		//------------> ʹ  
		//sql.append(" 	   F.FLT_NUM_COLOR, F.EXTRA_FUEL, F.CRZ_MODE, "); 2007.01.29  : .
		sql.append(" 	B.DIVERT, F.FLT_LEVEL, F.FOB, F.POINT_ATA, F.WAYPOINT_MISMATCH, "); // 2007.02.01 ߰
		sql.append(" 	F.POS_MSG, "); // 2007.01.30 ߰
		sql.append(" 	F.REGNO REGNO_COLOR, F.WX_STNFR, F.WX_STNTO, F.TAKE_OFF, F.ETA, ");
		sql.append(" 	F.WX_ALT_PORT, F.WX_ETOP_PORT, F.WX_REFILE_PORT, F.WX_REFILE_ALT_PORT, "); // 2007.01.26 ߰ : WX_REFILE_ALT_PORT
		//sql.append(" 	F.NOTAM_STNFR, F.NOTAM_STNTO, F.NOTAM_ALT_PORT, F.NOTAM_ETOP_PORT, ");
		//sql.append(" 	F.NOTAM_REFILE_PORT, F.NOTAM_REFILE_ALT_PORT, ");
		sql.append(" 	F.NOTAM, "); //2007.06.26 : NOTAM  ʵ ߰
		sql.append(" 	F.MEL, "); //2007.06.28 ߰ : M
		sql.append("    F.MAN_WX_STNFR, F.MAN_WX_STNTO, F.MAN_WX_ALT_PORT, ");
		sql.append("   F.ALT_HIGHTIME, ");//@2014-02-21
		sql.append(" 	A.SACTYP DAILY_SACTYP, "); //2007.06.28 ߰ : 5
		sql.append(" 	T.MEL ACTYP_MEL, "); //2007.06.28 ߰ : 5
		sql.append(" 	AC.RESTRICT_E, "); //2007.06.28 ߰ : R
		sql.append(" 	F.PMSN, TO_CHAR(A.FIRST_LEG_FLT_DT, 'YYYYMMDD') FIRST_LEG_FLT_DT, TO_CHAR(A.SCH_DEP_DT, 'DDMON','nls_date_language=american') SCH_DEP_DT, "); //2007.06.28 ߰ : P
		sql.append(" 	TO_CHAR(A.SCH_DEP_DT, 'DDMONYY','nls_date_language=american') SCHDDMONYY, "); //2007.07.09 ߰ : Position Report  .
		sql.append(" 	TO_CHAR(B.RMK_TMPST,'YYYYMMDDHH24MISS') RMK_TMPST, "); //2007.07.26 ߰ : Call Sign   ǥϱ  .
		sql.append(" 	TO_CHAR(B.POS_TMPST,'YYYYMMDDHH24MISS') POS_TMPST, "); //2007.07.26 ߰ : Call Sign   ǥϱ  .
		//sql.append(" 	TO_CHAR(NVL(B.TAKEOFF_TMPST, '20000101'), 'YYYYMMDD') CHECK_TAKEOFF, "); //2008.09.23 ߰ : UPDATE  ȸؼ ó.
		//sql.append(" 	TO_CHAR(NVL(B.POS_TMPST, '20000101'), 'YYYYMMDD') CHECK_POS, "); //2008.09.23 ߰ : UPDATE  ȸؼ ó.
		//sql.append(" 	TRUNC((SYSDATE - (NVL(B.TAKEOFF_TMPST, SYSDATE) + 9/24)) * 1440, 0) DATA_TAKEOFF, "); //2008.09.23 ߰ : UPDATE  ȸؼ ó.
		//sql.append(" 	TRUNC((SYSDATE - NVL(B.POS_TMPST, SYSDATE)) * 1440, 0) DATA_POS, "); //2008.09.23 ߰ : UPDATE  ȸؼ ó.
		sql.append(" 	F.ALL_COLUMNS ");
		//-----------------	@2014-05-12 start
		sql.append("    ,F.ALT_ENROUTE_FUEL ");
		sql.append("    ,F.ALT_REFILE_FUEL ");
		sql.append("    ,F.ALT_FUEL_OVERBURN ");
		sql.append("    ,CASE ");
		sql.append("        WHEN B.REFILE_Y = 'Y' THEN  'R:' || B.REFILE_POINT || '/' || B.REFILE_PORT || '/' || B.REFILE_ALT_PORTS "); 
		sql.append("        WHEN B.ERA_Y = 'Y' THEN  '3:' || B.ERA_POINT_LAT || B.ERA_POINT_LONG || '/' || B.ERA_PORT ");
		sql.append("        ELSE '' ");                                                                   
		sql.append("    END AS REFILE_ERA ");
		sql.append("    ,F.ALT_REFILE_ACARS ");
		sql.append("      ,B.ALTN_FUEL + B.HOLD_FUEL D1 ");
		sql.append("      ,B.HOLD_FUEL * 1.3 D2 ");
		sql.append("      ,B.REFILE_FUEL + B.ETOP_FUEL D3 ");
		sql.append("      ,B.REFILE_RQRD D4 ");
		//sql.append("      ,B.REFILE_VFR + (0.5 * B.HOLD_FUEL) D5 ");
		sql.append("      ,DECODE(B.REFILE_Y,'Y',B.REFILE_VFR + (0.5 * B.HOLD_FUEL),0) D5 ");

		/*sql.append("      ,CASE ");
		sql.append("          WHEN B.REFILE_Y = 'Y' THEN  '' ");
		sql.append("          WHEN B.ERA_Y = 'Y' THEN  B.ERA_POINT_LAT || B.ERA_POINT_LONG || '/' || B.ERA_PORT ");
		sql.append("         ELSE '5% LCF' || '//' || DECODE(B.ALT_PORT,'','NAR','') || '//' || DECODE(B.ETOPS_Y,'Y','ETOPS','') ");
		sql.append("      END AS D6 ");*/		
		sql.append("		,CASE ");
		sql.append("			WHEN B.ERA_Y = 'Y'  THEN  B.ERA_POINT_LAT || B.ERA_POINT_LONG || '/' || B.ERA_PORT ");
		sql.append("			ELSE ''");
		sql.append("		END AS D6 ");
		sql.append("		,CASE ");
		sql.append("			WHEN  B.REFILE_Y = 'Y'  THEN  'REFILE'");
		sql.append("			WHEN B.ERA_Y = 'Y'  THEN  '3%'");
		sql.append("			ELSE '5% LCF'");
		//20150716 ETOPS -> EDTO  ȭ ǥ ǵ 
		//sql.append("		END || '/' ||  DECODE(B.ALT_PORT,'','NAR','') || '/' || DECODE(B.ETOPS_Y,'Y','ETOPS','') AS D7 ");
		sql.append("		END || '/' ||  DECODE(B.ALT_PORT,'','NAR','') || '/' || DECODE(B.ETOPS_Y,'Y','EDTO','') AS D7 ");		

		sql.append(" 	,  TO_CHAR(A.SCH_ARV_DT,'YYMMDDHH24MI') SCH_ARV_DT  ");
		sql.append(" 	,  B.PLAN_CONFIRM  ");
		sql.append("	,  B.IS_COMMENTED  ");
		sql.append("	,  B.SYSKEY  ");
		//20140903 FLIGHT_ALERT_T.DOC_NO, PRV_DOC_NO ߰
		sql.append("	,  F.DOC_NO  ");
		sql.append("	,  F.PRV_DOC_NO  ");
		//-----------------@2014-05-30 end
		sql.append(" FROM ");
		sql.append(" 	DAILY_SCH_T A, FLIGHT_PLAN_T B, CM_CITYPAIR_DEF_T C, FLIGHT_ALERT_T F, CM_ACTYP_T T, CM_CITYPAIR_AC_T AC , FLT_FUEL_WT_T FU");
		sql.append(" WHERE B.ACTIVE = 'Y' ");
		sql.append(" 	AND B.STATUS = 'AIR' ");
		//sql.append(" 	AND LENGTH(A.TKOF_T) = 4 "); //2010.03.26 ߰->
		//sql.append(" 	AND A.SCH_DEP_DT >= SYSDATE - 35/24 "); //2008.06.04 ߰
		//sql.append(" 	AND A.SCH_DEP_DT <= SYSDATE + 3/24 "); //2008.06.04 ߰
		
		sql.append("   AND A.EST_DEP_DT >= SYSDATE - 35/24 "); //2013-08-09 
        sql.append("   AND A.EST_DEP_DT <= SYSDATE + 3/24 "); //2013-08-09 
        
		sql.append(" 	AND A.ACT_DEP_DT >= SYSDATE - 30/24 ");
		sql.append(" 	AND A.ACT_DEP_DT <= SYSDATE - 8/24 ");
		//sql.append(" 	AND A.DEP_STS = 'ACT' ");	// 2007.01.15 ߰ -> 2007.02.01 ּó
		sql.append(" 	AND A.ARV_STS <> 'ACT' ");	// 2007.01.15 ߰
		sql.append(" 	AND A.DEP_STS <> 'INI' ");	// 2009.02.02 ߰
		sql.append(" 	AND A.ACTNID <> 'CNL' ");		// 2007.01.15 ߰
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" 	AND A.STNFR = B.STNFR ");
		sql.append(" 	AND A.STNTO = B.STNTO ");
		sql.append(" 	AND A.STNFR = C.DEP_PORT ");
		sql.append(" 	AND A.STNTO = C.ARV_PORT ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = F.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND A.FLT_NUM = F.FLT_NUM ");
		sql.append(" 	AND A.STNFR = F.STNFR ");
		sql.append(" 	AND A.STNTO = F.STNTO ");
		sql.append(" 	AND A.KACTYP = T.KACTYP "); //2007.06.28 ߰
		sql.append(" 	AND A.STNFR = AC.DEP_PORT "); //2007.06.28 ߰
		sql.append(" 	AND A.STNTO = AC.ARV_PORT "); //2007.06.28 ߰
		sql.append(" 	AND A.SACTYP = AC.SACTYP "); //2007.06.28 ߰
		//sql.append("  AND SUBSTR(A.FLT_NUM, 1, 1) <> '4' "); //2009.08.13 ߰ :  FLT //@2013-11-07	
		//sql.append("    AND C.REGION_CD !='DOM' ");//@2013-11-07߰  @2013-11-14  
		
		//sql.append(" ORDER BY B.TAKEOFF_TMPST ");//@2013-11-07		
		
		//2014-07-22
		sql.append("  AND A.FIRST_LEG_FLT_DT=FU.FIRST_LEG_FLT_DT(+) ");
		sql.append("  AND A.FLT_NUM=FU.FLT_NUM(+) ");
		sql.append("  AND A.STNFR=FU.STNFR(+) ");
		sql.append("  AND A.STNTO=FU.STNTO(+) ");
		
		sql.append(" ORDER BY GBN ASC, B.TAKEOFF_TMPST "); //@2013-11-07		
		
		//Logger.debug.println("[BASE:FfsQ030Query:selEnroute] sql : "+sql.toString());
		//System.out.println("[BASE:FfsQ030Query:selEnroute] sql : "+sql.toString());
		return sql.toString();
	}
	//20160329   BACKUP
	public String selFuelAcarsMsgBACKUP(String syskey) {//@2014-05-12 ~ @2014-05-30
		StringBuffer sql = new StringBuffer();	
		sql.append("	SELECT");
		sql.append("		'< RECLEARANCE MSG >'||CHR(13)||CHR(10)");
		sql.append("		||'1. FLT ID : KAL'|| FLT_NUM ||'/'|| DATEMON ||CHR(13)||CHR(10)");
		sql.append("		||'2. DEP APO : '|| (SELECT ICAO_PORT FROM CM_PORT_T UB WHERE UB.IATA_PORT = (UA.STNFR)) ||CHR(13)||CHR(10)");
		sql.append("		||'3. ARR APO : '|| (SELECT ICAO_PORT FROM CM_PORT_T UB WHERE UB.IATA_PORT = (UA.STNTO)) ||CHR(13)||CHR(10)");
		sql.append("		||'4. CFPL NO : '|| PLANID ||CHR(13)||CHR(10)");
		sql.append("		||'5. REFILE POINT : '|| REFILE_POINT ||CHR(13)||CHR(10)");
		//20160106 
		/*
		sql.append("		||'6. RQRD NAR : '|| (REFILE_VFR + (0.5 * HOLD_FUEL))*100 || 'LBS' ||CHR(13)||CHR(10)");			
		sql.append("		||'7. FUEL RQRD AT R/P  : '|| REFILE_RQRD || '00LBS' ||CHR(13)||CHR(10)");
		sql.append("		||'8. EST FUEL AT R/P : '|| (ACT_FOB_FUEL - (CURRENT_PLN_FOB_FUEL - REFILE_PLN_FOB_FUEL)) || '00LBS' ||CHR(13)||CHR(10)||CHR(13)||CHR(10)");
		*/
		sql.append("		||CHR(13)||CHR(10)");
		
		sql.append("		||'KAL'|| FLT_NUM ||' IS RECLEARED TO PROCEED TO '|| (SELECT ICAO_PORT FROM CM_PORT_T UB WHERE UB.IATA_PORT = (UA.STNTO)) ||'.'||CHR(13)||CHR(10)");
		sql.append("		||'PLS CTC SELOCC IN CASE OF ANY FUEL ISSUES.'||CHR(13)||CHR(10)");
		sql.append("		AS MSG");
		sql.append("	FROM");
		sql.append("		(");
		sql.append("			SELECT");
		sql.append("				MAX(DECODE(GBN,'CURRENT',TO_CHAR(FIRST_LEG_FLT_DT,'DDMON','nls_date_language=american'))) DATEMON,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',FLT_NUM)) FLT_NUM,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',STNFR)) STNFR,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',STNTO)) STNTO,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',PLANID)) PLANID,      ");
		sql.append("				MAX(DECODE(GBN,'CURRENT',REFILE_POINT)) REFILE_POINT,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',WAYPOINT)) CURRENT_WAYPOINT,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',ALTN_FUEL)) ALTN_FUEL,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',HOLD_FUEL)) HOLD_FUEL,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',REFILE_VFR)) REFILE_VFR,");	
		sql.append("				MAX(DECODE(GBN,'CURRENT',SACTYP)) SACTYP,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',FF_8MIN)) FF_8MIN,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',CONT_FUEL)) CONT_FUEL,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',ACT_FOB_FUEL)) ACT_FOB_FUEL,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',PLN_FOB_FUEL)) CURRENT_PLN_FOB_FUEL,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',TO_NUMBER(SEQ))) CURRENT_SEQ,");
		sql.append("				MAX(DECODE(GBN,'REFILE',REFILE_RQRD)) REFILE_RQRD,");
		sql.append("				MAX(DECODE(GBN,'REFILE',PLN_FOB_FUEL)) REFILE_PLN_FOB_FUEL,");
		sql.append("				MAX(DECODE(GBN,'REFILE',TO_NUMBER(SEQ))) REFILE_SEQ");
		sql.append("			FROM");
		sql.append("				(");
		sql.append("					SELECT");
		sql.append("						SUB.*");
		sql.append("					FROM");
		sql.append("						(");
		sql.append("							SELECT");
		sql.append("								'CURRENT'	GBN");
		sql.append("							,	P.REFILE_POINT");
		sql.append("							,	W.WAYPOINT");
		sql.append("							,	P.REFILE_RQRD");
		sql.append("							,	P.PLN_FOD_FUEL");
		sql.append("							,	P.ALTN_FUEL");
		sql.append("							,	P.HOLD_FUEL");
		sql.append("							,	F.SACTYP");
		sql.append("							,	F.FF_8MIN");
		sql.append("							,	P.CONT_FUEL");
		sql.append("							,	W.ACT_FOB_FUEL");
		sql.append("							,	W.PLN_FOB_FUEL");
		sql.append("							,	W.SEQ");
		sql.append("							,	P.FIRST_LEG_FLT_DT");
		sql.append("							,	P.FLT_NUM");
		sql.append("							,	P.STNFR");
		sql.append("							,	P.STNTO");
		sql.append("							,	P.PLANID");
		sql.append("							,	P.REFILE_VFR");		
		sql.append("							FROM");
		sql.append("								FLIGHT_PLAN_T	P");
		sql.append("							,	WAYPOINT_T	W");
		sql.append("							,	KFOS.CM_FUEL_FLOW_T	F");
		sql.append("							WHERE");
		sql.append("								P.SYSKEY = W.SYSKEY");
		sql.append("							AND P.ACTYP = F.SACTYP");
		sql.append("							AND P.SYSKEY = '"+syskey+"'");
		sql.append("							AND W.PLN_LEVEL != '0'");
		sql.append("							AND W.ATA IS NOT NULL");
		sql.append("							ORDER BY SEQ DESC");
		sql.append("						) SUB");
		sql.append("					WHERE");
		sql.append("						ROWNUM = 1");
		sql.append("					UNION");
		sql.append("					SELECT");
		sql.append("						'REFILE'	GBN");
		sql.append("					,	P.REFILE_POINT");
		sql.append("					,	W.WAYPOINT");
		sql.append("					,	P.REFILE_RQRD");
		sql.append("					,	P.PLN_FOD_FUEL");
		sql.append("					,	P.ALTN_FUEL");
		sql.append("					,	P.HOLD_FUEL");
		sql.append("					,	F.SACTYP");
		sql.append("					,	F.FF_8MIN");
		sql.append("					,	P.CONT_FUEL");
		sql.append("					,	W.ACT_FOB_FUEL");
		sql.append("					,	W.PLN_FOB_FUEL");
		sql.append("					,	W.SEQ");
		sql.append("					,	P.FIRST_LEG_FLT_DT");
		sql.append("					,	P.FLT_NUM");
		sql.append("					,	P.STNFR");
		sql.append("					,	P.STNTO");
		sql.append("					,	P.PLANID");
		sql.append("					,	P.REFILE_VFR");		
		sql.append("					FROM");
		sql.append("						FLIGHT_PLAN_T P");
		sql.append("					,	WAYPOINT_T W");
		sql.append("					,	KFOS.CM_FUEL_FLOW_T F");
		sql.append("					WHERE");
		sql.append("						P.SYSKEY = W.SYSKEY");
		sql.append("					AND P.ACTYP = F.SACTYP");
		sql.append("					AND P.SYSKEY = '"+syskey+"'");
		sql.append("					AND W.WAYPOINT IN	(SELECT P.REFILE_POINT FROM FLIGHT_PLAN_T P WHERE P.SYSKEY = '"+syskey+"')");
		sql.append("					AND W.PLN_LEVEL != '0'");
		sql.append("				) ");
		sql.append("		) UA ");
		//sql.append("	WHERE");
		//sql.append("		CURRENT_SEQ < REFILE_SEQ");

		Logger.debug.println("[BASE:FfsQ030Query:selFuelAcarsMsg] sql : "+sql.toString());
		return sql.toString();
	}
	public String selFuelAcarsMsg(String syskey) {
		StringBuffer sql = new StringBuffer();	
		sql.append("	SELECT");
		//20160701 
		//sql.append("		'< RECLEARANCE MSG >'||CHR(13)||CHR(10)");
		sql.append("		'< OPS INFO MSG >'||CHR(13)||CHR(10)");
		sql.append("		||CHR(13)||CHR(10)");
		//20160627 
		/*
		sql.append("		||'DEST AND ALTN APO NOTAM & WX CONDITION'||CHR(13)||CHR(10)");
		sql.append("		||'ARE VERIFIED TO CONTINUE TO DEST'||CHR(13)||CHR(10)");
		*/
		sql.append("		||'DEST AND ALTN APO NOTAM & WX CONDITION, ETC.'||CHR(13)||CHR(10)");
		sql.append("		||'ARE APPLICABLE FOR OPERATION AS RELEASED'||CHR(13)||CHR(10)");
		
		sql.append("		AS MSG");
		sql.append("	FROM");
		sql.append("		(");
		sql.append("			SELECT");
		sql.append("				MAX(DECODE(GBN,'CURRENT',TO_CHAR(FIRST_LEG_FLT_DT,'DDMON','nls_date_language=american'))) DATEMON,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',FLT_NUM)) FLT_NUM,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',STNFR)) STNFR,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',STNTO)) STNTO,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',PLANID)) PLANID,      ");
		sql.append("				MAX(DECODE(GBN,'CURRENT',REFILE_POINT)) REFILE_POINT,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',WAYPOINT)) CURRENT_WAYPOINT,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',ALTN_FUEL)) ALTN_FUEL,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',HOLD_FUEL)) HOLD_FUEL,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',REFILE_VFR)) REFILE_VFR,");	
		sql.append("				MAX(DECODE(GBN,'CURRENT',SACTYP)) SACTYP,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',FF_8MIN)) FF_8MIN,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',CONT_FUEL)) CONT_FUEL,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',ACT_FOB_FUEL)) ACT_FOB_FUEL,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',PLN_FOB_FUEL)) CURRENT_PLN_FOB_FUEL,");
		sql.append("				MAX(DECODE(GBN,'CURRENT',TO_NUMBER(SEQ))) CURRENT_SEQ,");
		sql.append("				MAX(DECODE(GBN,'REFILE',REFILE_RQRD)) REFILE_RQRD,");
		sql.append("				MAX(DECODE(GBN,'REFILE',PLN_FOB_FUEL)) REFILE_PLN_FOB_FUEL,");
		sql.append("				MAX(DECODE(GBN,'REFILE',TO_NUMBER(SEQ))) REFILE_SEQ");
		sql.append("			FROM");
		sql.append("				(");
		sql.append("					SELECT");
		sql.append("						SUB.*");
		sql.append("					FROM");
		sql.append("						(");
		sql.append("							SELECT");
		sql.append("								'CURRENT'	GBN");
		sql.append("							,	P.REFILE_POINT");
		sql.append("							,	W.WAYPOINT");
		sql.append("							,	P.REFILE_RQRD");
		sql.append("							,	P.PLN_FOD_FUEL");
		sql.append("							,	P.ALTN_FUEL");
		sql.append("							,	P.HOLD_FUEL");
		sql.append("							,	F.SACTYP");
		sql.append("							,	F.FF_8MIN");
		sql.append("							,	P.CONT_FUEL");
		sql.append("							,	W.ACT_FOB_FUEL");
		sql.append("							,	W.PLN_FOB_FUEL");
		sql.append("							,	W.SEQ");
		sql.append("							,	P.FIRST_LEG_FLT_DT");
		sql.append("							,	P.FLT_NUM");
		sql.append("							,	P.STNFR");
		sql.append("							,	P.STNTO");
		sql.append("							,	P.PLANID");
		sql.append("							,	P.REFILE_VFR");		
		sql.append("							FROM");
		sql.append("								FLIGHT_PLAN_T	P");
		sql.append("							,	WAYPOINT_T	W");
		sql.append("							,	KFOS.CM_FUEL_FLOW_T	F");
		sql.append("							WHERE");
		sql.append("								P.SYSKEY = W.SYSKEY");
		sql.append("							AND P.ACTYP = F.SACTYP");
		sql.append("							AND P.SYSKEY = '"+syskey+"'");
		sql.append("							AND W.PLN_LEVEL != '0'");
		sql.append("							AND W.ATA IS NOT NULL");
		sql.append("							ORDER BY SEQ DESC");
		sql.append("						) SUB");
		sql.append("					WHERE");
		sql.append("						ROWNUM = 1");
		sql.append("					UNION");
		sql.append("					SELECT");
		sql.append("						'REFILE'	GBN");
		sql.append("					,	P.REFILE_POINT");
		sql.append("					,	W.WAYPOINT");
		sql.append("					,	P.REFILE_RQRD");
		sql.append("					,	P.PLN_FOD_FUEL");
		sql.append("					,	P.ALTN_FUEL");
		sql.append("					,	P.HOLD_FUEL");
		sql.append("					,	F.SACTYP");
		sql.append("					,	F.FF_8MIN");
		sql.append("					,	P.CONT_FUEL");
		sql.append("					,	W.ACT_FOB_FUEL");
		sql.append("					,	W.PLN_FOB_FUEL");
		sql.append("					,	W.SEQ");
		sql.append("					,	P.FIRST_LEG_FLT_DT");
		sql.append("					,	P.FLT_NUM");
		sql.append("					,	P.STNFR");
		sql.append("					,	P.STNTO");
		sql.append("					,	P.PLANID");
		sql.append("					,	P.REFILE_VFR");		
		sql.append("					FROM");
		sql.append("						FLIGHT_PLAN_T P");
		sql.append("					,	WAYPOINT_T W");
		sql.append("					,	KFOS.CM_FUEL_FLOW_T F");
		sql.append("					WHERE");
		sql.append("						P.SYSKEY = W.SYSKEY");
		sql.append("					AND P.ACTYP = F.SACTYP");
		sql.append("					AND P.SYSKEY = '"+syskey+"'");
		sql.append("					AND W.WAYPOINT IN	(SELECT P.REFILE_POINT FROM FLIGHT_PLAN_T P WHERE P.SYSKEY = '"+syskey+"')");
		sql.append("					AND W.PLN_LEVEL != '0'");
		sql.append("				) ");
		sql.append("		) UA ");

		Logger.debug.println("[BASE:FfsQ030Query:selFuelAcarsMsg] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String selWeatherAcarsMsg(String iataPort) {//@2014-05-12 ~ @2014-05-30
		StringBuffer sql = new StringBuffer();	

		sql.append("	SELECT");
		sql.append("		'DEAR CAPT'||CHR(13)||CHR(10)");
		sql.append("		||'PLZ REFER TO UPDATED WX INFO'||CHR(13)||CHR(10)||CHR(13)||CHR(10)");
		sql.append("		||''|| INSTR(METAR1,'') ||CHR(13)||CHR(10)||CHR(13)||CHR(10)");
		sql.append("		||''|| METAR2 ||CHR(13)||CHR(10)||CHR(13)||CHR(10)");
		sql.append("		||''|| METAR3 ||CHR(13)||CHR(10)||CHR(13)||CHR(10)");
		sql.append("		||''|| TAF1 ||CHR(13)||CHR(10)||CHR(13)||CHR(10)");
		sql.append("		||'IF YOU HAVE ANY QUESTION, PLZ CTC SELOCC.'||CHR(13)||CHR(10)");
		sql.append("		AS MSG");
		sql.append("	FROM");
		sql.append("		(");
		sql.append("			SELECT ");
		sql.append("				MAX(DECODE(N_GBN,'METAR1',WX_TEXT)) METAR1,");
		sql.append("				MAX(DECODE(N_GBN,'METAR2',WX_TEXT)) METAR2,");
		sql.append("				MAX(DECODE(N_GBN,'METAR3',WX_TEXT)) METAR3,      ");
		sql.append("				MAX(DECODE(N_GBN,'TAF1',WX_TEXT)) TAF1");
		sql.append("			FROM");
		sql.append("				(");
		sql.append("					SELECT ");
		sql.append("						A.GBN, A.WX_TEXT, A.GBN || A.RN N_GBN");
		sql.append("					FROM");
		sql.append("						(");
		sql.append("							SELECT");
		sql.append("								'METAR' GBN");
		sql.append("							,	CASE");
		sql.append("									WHEN SUBSTR(WX_TEXT,49,1) = ' ' THEN SUBSTR(WX_TEXT,0,49) || CHR(13)||CHR(10) || SUBSTR(WX_TEXT,49,LENGTH(WX_TEXT))");
		sql.append("									ELSE");
		sql.append("										CASE");
		sql.append("											WHEN SUBSTR(WX_TEXT,50,1) = ' ' THEN SUBSTR(WX_TEXT,0,50) || CHR(13)||CHR(10) || SUBSTR(WX_TEXT,50,LENGTH(WX_TEXT))");
		sql.append("											ELSE");
		sql.append("												CASE");
		sql.append("													WHEN SUBSTR(WX_TEXT,51,1) = ' ' THEN SUBSTR(WX_TEXT,0,51) || CHR(13)||CHR(10) || SUBSTR(WX_TEXT,51,LENGTH(WX_TEXT))");
		sql.append("													ELSE");
		sql.append("														CASE");
		sql.append("															WHEN SUBSTR(WX_TEXT,52,1) = ' ' THEN SUBSTR(WX_TEXT,0,52) || CHR(13)||CHR(10) || SUBSTR(WX_TEXT,52,LENGTH(WX_TEXT))");
		sql.append("															ELSE");
		sql.append("																CASE");
		sql.append("																	WHEN SUBSTR(WX_TEXT,53,1) = ' ' THEN SUBSTR(WX_TEXT,0,53) || CHR(13)||CHR(10) || SUBSTR(WX_TEXT,53,LENGTH(WX_TEXT))");
		sql.append("																	ELSE");
		sql.append("																		CASE");
		sql.append("																			WHEN SUBSTR(WX_TEXT,54,1) = ' ' THEN SUBSTR(WX_TEXT,0,54) || CHR(13)||CHR(10) || SUBSTR(WX_TEXT,54,LENGTH(WX_TEXT))");
		sql.append("																			ELSE");
		sql.append("																				CASE");
		sql.append("																					WHEN SUBSTR(WX_TEXT,55,1) = ' ' THEN SUBSTR(WX_TEXT,0,55) || CHR(13)||CHR(10) || SUBSTR(WX_TEXT,55,LENGTH(WX_TEXT))");
		sql.append("																					ELSE");
		sql.append("																						CASE");
		sql.append("																							WHEN SUBSTR(WX_TEXT,56,1) = ' ' THEN SUBSTR(WX_TEXT,0,56) || CHR(13)||CHR(10) || SUBSTR(WX_TEXT,56,LENGTH(WX_TEXT))");
		sql.append("																						END");
		sql.append("																				END");
		sql.append("																		END");
		sql.append("																END");
		sql.append("														END");
		sql.append("												END");
		sql.append("										END                        ");
		sql.append("								END	WX_TEXT ");
		sql.append("							,	ROW_NUMBER () OVER (ORDER BY TYP_SEQ, WX_TYP, WX_DTG DESC) RN ");
		sql.append("							FROM");
		sql.append("								BS_WEATHER_T ");
		sql.append("							WHERE");
		sql.append("								IATA_PORT = '"+iataPort+"'");
		sql.append("							AND	WX_TYP='SA' ");
		sql.append("							AND	TYP_SEQ=1 AND WX_DTG >= SYSDATE-9/24-3/24 ");
		sql.append("						) A ");
		sql.append("					WHERE");
		sql.append("						RN <= 3 ");
		sql.append("					UNION");
		sql.append("					SELECT ");
		sql.append("						A.GBN");
		sql.append("					,	A.WX_TEXT");
		sql.append("					,	A.GBN || A.RN N_GBN ");
		sql.append("					FROM");
		sql.append("						(");
		sql.append("							SELECT ");
		sql.append("								'TAF' GBN");
		sql.append("							,	WX_TEXT ");
		sql.append("							,	ROW_NUMBER () OVER (ORDER BY TYP_SEQ, WX_TYP, WX_DTG DESC) RN");
		sql.append("							FROM");
		sql.append("								BS_WEATHER_T");
		sql.append("							WHERE");
		sql.append("								IATA_PORT = '"+iataPort+"'");
		sql.append("							AND	WX_TYP='FT'");
		sql.append("							AND	TYP_SEQ=2 AND WX_DTG >= SYSDATE-9/24-12/24 ");
		sql.append("						) A ");
		sql.append("					WHERE");
		sql.append("						A.RN = 1 ");
		sql.append("				)");
		sql.append("		)");

		Logger.debug.println("[BASE:FfsQ030Query:selWeatherAcarsMsg] sql : "+sql.toString());
		return sql.toString();
	}
	/*public String selFuncSendToAcars(String firstLegFltDt, String regno, String fltNum, String stnfr, String stnto, String empNo, String msg) {//@2014-05-12 ~ @2014-05-30
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT KFOS.FUNC_SEND_TO_ACARS(to_date('"+firstLegFltDt+"','YYYYMMDD'),'"+regno+"','"+fltNum+"','"+stnfr+"','"+stnto+"','"+empNo+"','"+msg+"') AS ALT_REFILE_ACARS  FROM DUAL ");

		Logger.debug.println("[BASE:FfsQ030Query:selFuncSendToAcars] sql : "+sql.toString());
		return sql.toString();
	}*/
	public String updAltRefileAcars(String firstLegFltDt,String fltNum, String stnfr,String stnto,String altRefileAcars) {//@2014-05-12 ~ @2014-05-30
		StringBuffer sql = new StringBuffer();
		sql.append("	UPDATE KFOS.FLIGHT_ALERT_T");
		sql.append("	SET ALT_REFILE_ACARS     = '"+altRefileAcars+"'");
		sql.append("	WHERE");
		sql.append("		 FIRST_LEG_FLT_DT =TO_DATE('"+firstLegFltDt+"','YYYYMMDD')");
		sql.append("	AND FLT_NUM ='"+fltNum+"'");
		sql.append("	AND STNFR ='"+stnfr+"'");
		sql.append("	AND STNTO ='"+stnto+"'");
		Logger.debug.println("[BASE:FfsQ020Query:updIsCommented] sql : "+sql.toString());
		return sql.toString();
	}
	
	/**
	 * 20160706 ߰
	 */
	public String updAltRefileAcarsRev(String firstLegFltDt,String fltNum, String stnfr,String stnto,String altRefileAcars) {//@2014-05-12 ~ @2014-05-30
		StringBuffer sql = new StringBuffer();
		sql.append("	UPDATE KFOS.FFS_ALERT_T");
		sql.append("	SET REFILE_ACARS     = '"+altRefileAcars+"'");
		sql.append("	WHERE");
		sql.append("		 FIRST_LEG_FLT_DT =TO_DATE('"+firstLegFltDt+"','YYYYMMDD')");
		sql.append("	AND FLT_NUM ='"+fltNum+"'");
		sql.append("	AND STNFR ='"+stnfr+"'");
		sql.append("	AND STNTO ='"+stnto+"'");
		Logger.debug.println("[BASE:FfsQ020Query:updAltRefileAcarsRev] sql : "+sql.toString());
		return sql.toString();
	}

	
	/** 
	  * STATUS AIR϶...(3) POSITION MGS 1ð 10е Ʈ   --  : 2011.01.13
	  * @return String Query  
	  */
	public String updEnroute1() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE FLIGHT_ALERT_T ");
		//sql.append(" SET POS_MSG = 'RED' "); 2007.01.30 
		sql.append(" SET POS_MSG = '#FA8885' ");
		sql.append(" WHERE (FIRST_LEG_FLT_DT, FLT_NUM, STNFR) IN ");
		
		/*sql.append(" 	(SELECT FIRST_LEG_FLT_DT, FLT_NUM, STNFR ");
		sql.append(" 	FROM FLIGHT_PLAN_T ");
		sql.append(" 	WHERE STATUS  = 'AIR' ");
		sql.append(" 		AND RAMPOUT_TMPST IS NOT NULL ");
		sql.append(" 		AND TAKEOFF_TMPST IS NOT NULL ");
		sql.append(" 		AND POS_TMPST IS NOT NULL ");
		sql.append(" 		AND FIRST_LEG_FLT_DT BETWEEN SYSDATE - 36/24 AND SYSDATE ");
		sql.append(" 		AND ((SYSDATE - 9/24) - POS_TMPST) * 1440 > 89) ");*/ // 2007.03.06 
		
		//--̷ڸ  POS_MSG ȵ ö TAKEOFF_TMPST üũ
		sql.append(" 	(SELECT FIRST_LEG_FLT_DT, FLT_NUM, STNFR ");
		sql.append(" 	FROM FLIGHT_PLAN_T ");
		sql.append(" 	WHERE STATUS  = 'AIR' "); 
		sql.append(" 		AND RAMPOUT_TMPST IS NOT NULL ");
		sql.append(" 		AND TAKEOFF_TMPST IS NOT NULL ");
		sql.append(" 		AND POS_TMPST IS NULL ");
		sql.append(" 		AND FIRST_LEG_FLT_DT BETWEEN SYSDATE - 57/24 AND SYSDATE ");
		sql.append(" 		AND (SYSDATE - (TAKEOFF_TMPST + 9/24)) * 1440 > 69 "); // 2007.03.07  : 1ð30п 1ð10
		sql.append(" 	UNION ");
		//--Ĵ  POS_TMPSTð  ð 
		sql.append(" 	SELECT FIRST_LEG_FLT_DT, FLT_NUM, STNFR ");
		sql.append(" 	FROM FLIGHT_PLAN_T ");
		sql.append(" 	WHERE STATUS  = 'AIR' ");
		sql.append(" 		AND RAMPOUT_TMPST IS NOT NULL ");
		sql.append(" 		AND TAKEOFF_TMPST IS NOT NULL ");
		sql.append(" 		AND POS_TMPST IS NOT NULL ");
		sql.append(" 		AND FIRST_LEG_FLT_DT BETWEEN SYSDATE - 57/24 AND SYSDATE ");
		sql.append(" 		AND (SYSDATE - POS_TMPST) * 1440 > 69) "); // 2007.03.07  : 1ð30п 1ð10
		
		//Logger.debug.println("[BASE:FfsQ030Query:updEnroute1] sql : "+sql.toString());
		//System.out.println("[BASE:FfsQ030Query:updEnroute1] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * POSITION MGS 1ð 10  ȵ ° RED ٲپ ־, ٽ ͼ NULL ٲپ  --  : 2011.01.13
	  * @return String Query  
	  */
	public String updEnroute2() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE FLIGHT_ALERT_T ");
		sql.append(" SET POS_MSG = NULL ");
		sql.append(" WHERE POS_MSG = '#FA8885' ");
		sql.append(" 	AND (FIRST_LEG_FLT_DT, FLT_NUM, STNFR) IN ");
		//-- POS_TMPSTð  ð 
		sql.append(" 	(SELECT FIRST_LEG_FLT_DT, FLT_NUM, STNFR ");
		sql.append(" 	FROM FLIGHT_PLAN_T ");
		sql.append(" 	WHERE STATUS  = 'AIR' ");
		sql.append(" 		AND RAMPOUT_TMPST IS NOT NULL ");
		sql.append(" 		AND TAKEOFF_TMPST IS NOT NULL ");
		sql.append(" 		AND POS_TMPST IS NOT NULL ");
		sql.append(" 		AND FIRST_LEG_FLT_DT BETWEEN SYSDATE - 57/24 AND SYSDATE ");
		sql.append(" 		AND (SYSDATE - POS_TMPST) * 1440 < 70) "); // 2007.03.07  : 1ð30п 1ð10
		
		//Logger.debug.println("[BASE:FfsQ030Query:updEnroute2] sql : "+sql.toString());
		//System.out.println("[BASE:FfsQ030Query:updEnroute2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Enroute  Alert Ruleȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2007/01/29  
	  */
	public String alertRuleEN() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	COLOR, TAG, REMARKS ");
		sql.append(" FROM ");
		sql.append(" 	ALERT_RULE_T ");
		sql.append(" WHERE ");
		sql.append(" 	PROGRESS IN ('EN','AA') ");

		Logger.debug.println("[BASE:FfsQ030Query:alertRuleEN] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SYSDATE ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2008/10/15  
	  */
	public String getSysdate() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SYSDATE,'YYYYMMDD') YYYYMMDD ");
		sql.append(" FROM DUAL ");

		Logger.debug.println("[BASE:FfsQ030Query:getSysdate] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Enroute  ACARS SMI ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2007/05/22  
	  */
	public String acarsSmi(String yyyymmdd, String preSmi, String preFltNum) {
		StringBuffer sql = new StringBuffer();
		
		/*sql.append(" SELECT ");
		sql.append(" 	FLT_NUM, TO_CHAR(MAX(MSG_TIMESTAMP),'YYMMDDHH24MISS') MAX_TM ");
		sql.append(" FROM ");
		sql.append(" 	PE_MSG_T ");
		sql.append(" WHERE ");
		sql.append(" 	SMI IN (" + preSmi + ") ");
		sql.append(" 	AND FLT_NUM IN (" + preFltNum + ") ");
		sql.append(" 	AND FIRST_LEG_FLT_DT BETWEEN SYSDATE - 57/24 AND SYSDATE ");
		sql.append(" 	AND MSG_TIMESTAMP > SYSDATE - 9/24 - 20/24 ");
		sql.append(" GROUP BY FLT_NUM ");
		sql.append(" ORDER BY FLT_NUM ");*/
		
		//2007.05.31 
		sql.append(" SELECT ");
		sql.append(" 	P.FLT_NUM, TO_CHAR(MAX(P.MSG_TIMESTAMP),'YYMMDDHH24MISS') MAX_TM ");
		sql.append(" FROM ");
		sql.append(" 	DAILY_SCH_T D, PE_MSG_T P ");
		sql.append(" WHERE ");
		sql.append(" 	D.FIRST_LEG_FLT_DT >= TO_DATE('"+yyyymmdd+"','YYYYMMDD') - 3 "); //2009.07.23 ߰
		sql.append(" 	AND D.FIRST_LEG_FLT_DT <= TO_DATE('"+yyyymmdd+"','YYYYMMDD') ");  //2009.07.23 ߰
		sql.append(" 	AND P.SMI IN (" + preSmi + ") ");
		sql.append(" 	AND P.FLT_NUM IN (" + preFltNum + ") ");
		//sql.append(" 	AND D.DEP_STS = 'ACT' "); 2007.06.08 ּó
		sql.append(" 	AND D.ARV_STS <> 'ACT' ");
		sql.append(" 	AND D.ACTNID <> 'CNL' ");
		sql.append(" 	AND P.GBN_X NOT IN ('U','M') ");
		sql.append(" 	AND D.ACT_DEP_DT >= SYSDATE - 30/24 ");
		sql.append(" 	AND D.ACT_DEP_DT <= SYSDATE - 8/24 ");
		sql.append(" 	AND D.FIRST_LEG_FLT_DT = P.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND D.FLT_NUM = P.FLT_NUM ");
		sql.append(" 	AND D.STNFR = P.STNFR ");
		sql.append(" 	AND D.STNTO = P.STNTO ");
		sql.append(" GROUP BY P.FLT_NUM ");
		sql.append(" ORDER BY P.FLT_NUM ");

		//Logger.debug.println("[BASE:FfsQ030Query:acarsSmi] sql : "+sql.toString());
		//System.out.println("[BASE:FfsQ030Query:acarsSmi] sql : "+sql.toString());
		return sql.toString();
	}
		
	/** 
	  * Enroute  ACARS SMI RAW_MSG ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2007/05/29  
	  */
	public String acarsRawMsg(String fltNum, String smi) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	FLT_NUM, SMI, RAW_MSG ");
		sql.append(" FROM ");
		sql.append(" 	PE_MSG_T ");
		sql.append(" WHERE ");
		sql.append(" 	FLT_NUM = '" + fltNum + "' ");
		sql.append(" 	AND SMI IN (" + smi + ") ");
		sql.append(" 	AND GBN_X NOT IN ('U','M') "); //2007.05.31 ߰
		sql.append(" 	AND FIRST_LEG_FLT_DT BETWEEN SYSDATE - 57/24 AND SYSDATE ");
		sql.append(" 	AND MSG_TIMESTAMP > SYSDATE - 9/24 - 20/24 ");
		sql.append(" ORDER BY MSG_TIMESTAMP DESC ");

		Logger.debug.println("[BASE:FfsQ030Query:acarsRawMsg] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * XML    -- 
	  * @return String Query  
	  * @author Copyright (c) 2007/07/23 Ǻõ 
	  */
	public String enrouteGenXml() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	W.SYSKEY, W.SEQ, P.FLT_NUM, P.REGNO, P.ACTYP, P.STNFR, P.STNTO, ");
		sql.append(" 	TO_CHAR(P.TAKEOFF_TMPST, 'YYMMDDHH24MI') ATD, ");
		sql.append(" 	W.WAYPOINT WPT, W.LAT, W.LON, ");
		sql.append(" 	TO_CHAR(W.ETA, 'HH24MI') ETO, ");
		sql.append(" 	TO_CHAR(W.ATA, 'HH24MI') ATO, ");
		sql.append(" 	W.PLN_FOB_FUEL ERF, W.ACT_FOB_FUEL ARF, W.PLN_LEVEL EFL, W.ACT_LEVEL AFL, W.REMARKS, ");
		sql.append(" 	A.FOB, A.FLT_LEVEL, A.POS_MSG, A.POINT_ATA, A.WAYPOINT_MISMATCH ");
		sql.append(" FROM ");
		sql.append(" 	FLIGHT_PLAN_T P, WAYPOINT_T W, FLIGHT_ALERT_T A ");
		sql.append(" WHERE ");
		sql.append(" 	P.SYSKEY = W.SYSKEY ");
		sql.append(" 	AND P.FIRST_LEG_FLT_DT BETWEEN SYSDATE - 4 AND SYSDATE - 9/24 ");
		sql.append(" 	AND P.ACTIVE = 'Y' ");
		sql.append(" 	AND P.STATUS = 'AIR' ");
		sql.append(" 	AND P.FIRST_LEG_FLT_DT = A.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND P.FLT_NUM = A.FLT_NUM ");
		sql.append(" 	AND P.STNFR = A.STNFR ");
		sql.append(" 	AND P.STNTO = A.STNTO ");
		sql.append(" ORDER BY FLT_NUM, W.ETA, W.SEQ ASC ");

		Logger.debug.println("[BASE:FfsQ030Query:enrouteGenXml] sql : "+sql.toString());
		return sql.toString();
	}
	
	/**
	 * 20160415 ߰
	 */
	public String selEnrouteRev() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DECODE(DECODE(SUBSTR(ALT.FLT_NUM, 1, 1),'4','JNA','KAL'),'JNA','JNA',DEF.REGION_CD) REGION_CD, ");
		sql.append("   DECODE(SUBSTR(ALT.FLT_NUM, 1, 1),'4','JNA','KAL') GBN, ");
		sql.append("   ALT.FLT_NUM, ");
		sql.append("   ALT.TANKERING_ALERT, ");
		sql.append("   ALT.RESTRICT_E, ");
		sql.append("   ALT.PMSN_ALERT, ");
		sql.append("   ALT.CALLSIGN_ALERT, ");
		sql.append("   ALT.POS_MSG_ALERT, ");
		sql.append("   NVL(ALT.FLT_LEVEL_ALERT, 0) AS FLT_LEVEL_ALERT, ");
		sql.append("   NVL(ALT.POINT_ATA_ALERT, 0) AS POINT_ATA_ALERT, ");
		sql.append("   NVL(ALT.WAYPOINT_MISMATCH, 0) AS WAYPOINT_MISMATCH, ");
		sql.append("   ALT.SYSKEY, ");
		sql.append("   ALT.REGNO, ");
		sql.append("   ALT.MEL_ALERT, ");
		sql.append("   ALT.HIGHTIME_ALERT, ");
		sql.append("   ALT.SACTYP, ");
		sql.append("   ALT.ENROUTE_FUEL, ");
		sql.append("   ALT.REFILE_FUEL, ");
		sql.append("   ALT.FUEL_OVERBURN, ");
		sql.append("   ALT.REFILE_ACARS, ");
		sql.append("   ALT.STNFR, ");
		sql.append("   ALT.STNTO, ");
		
		//@2018-08-23
		sql.append("   ALT.ELDT AS	ELDT, ");
		sql.append("   ALT.ELDT_ALERT, ");	
		sql.append("   ALT.ELDT_MANUAL, ");	
		
		//@2018-10-11
		sql.append("   ALT.PSN_SEND_ACARS, ");
		sql.append("   ALT.PSN_MIN, ");	
		sql.append("   TO_CHAR(ALT.PSN_MANUAL_DT,'YYMMDDHH24MI') PSN_MANUAL_DT, ");	

		sql.append("   TRIM(FLT.ALT_PORT) ALT_PORT, ");
		sql.append("   TO_CHAR(SKD.SCH_DEP_DT,'YYMMDDHH24MI') SCH_DEP_DT, ");
		sql.append("   TO_CHAR(SKD.EST_DEP_DT,'YYMMDDHH24MI') EST_DEP_DT, ");
		sql.append("   TO_CHAR(FLT.RAMPOUT_TMPST,'YYMMDDHH24MI') ACT_DEP_DT, ");
		sql.append("   TO_CHAR(FLT.TAKEOFF_TMPST,'YYMMDDHH24MI') TKOF_DT, ");
		sql.append("   ALT.TAXI_TIME_ALERT, ");
		sql.append("   TRIM(TO_CHAR(TRUNC(FLT.ABHR/60),'00'))||TRIM(TO_CHAR(MOD(FLT.ABHR,60),'00')) ABHR, ");
		sql.append("   TO_CHAR(SKD.EST_ARV_DT,'YYMMDDHH24MI') EST_ARV_DT, ");
		sql.append("   TO_CHAR(SKD.SCH_ARV_DT,'YYMMDDHH24MI') SCH_ARV_DT, ");
		sql.append("   ALT.ETA_ALERT, ");
		sql.append("   TO_CHAR(ROUND(((SYSDATE-9/24)-SKD.EST_DEP_DT)/(SKD.EST_ARV_DT-SKD.EST_DEP_DT)*100,1)) AS PROGRESS, ");
		sql.append("   CASE ");
		sql.append("     WHEN EST_ARV_DT > (SYSDATE-9/24) ");
		sql.append("     THEN '+'||TRIM(TO_CHAR(TRUNC((EST_ARV_DT-(SYSDATE-9/24))*24),'00'))||':'||TRIM(TO_CHAR(MOD((EST_ARV_DT-(SYSDATE-9/24))*60*24,60),'00')) ");
		sql.append("     ELSE '-'||TRIM(TO_CHAR(TRUNC(((SYSDATE-9/24)-EST_ARV_DT)*24),'00'))||':'||TRIM(TO_CHAR(MOD(((SYSDATE-9/24)-EST_ARV_DT)*60*24,60),'00')) ");
		sql.append("   END AS REMAIN_TIME, ");
		sql.append("   FLT.PAD_FUEL, ");
		sql.append("   (NVL(FWT.PLN_EXTR_FUEL1, 0) + NVL(FWT.PLN_EXTR_FUEL2, 0) + NVL(FWT.PLN_TANK_FUEL, 0))/100 EXTR_FUEL, ");
		sql.append("   ALT.DISC_ALERT, ");
		sql.append("   NVL(FWT.PLN_EXTR_FUEL1,0) PLN_EXTR_FUEL1, ");
		sql.append("   FWT.PLN_EXTR_RSN1, ");
		sql.append("   NVL(FWT.PLN_EXTR_FUEL2,0) PLN_EXTR_FUEL2, ");
		sql.append("   FWT.PLN_EXTR_RSN2, ");		
		sql.append("   FLT.SPEED, ");
		sql.append("   TRIM(FLT.ETOPS_PORTS||' '||FLT.ETP_PORTS) AS EDTO_ETP, ");
		sql.append("   CASE ");
		sql.append("     WHEN FLT.REFILE_Y = 'Y' ");
		sql.append("     THEN 'R:'||FLT.REFILE_POINT||'/'||FLT.REFILE_PORT||'/'||FLT.REFILE_ALT_PORTS ");
		sql.append("     WHEN FLT.ERA_Y = 'Y' ");
		//20160713 
		//sql.append("     THEN '3:'||FLT.ERA_POINT_LAT||FLT.ERA_POINT_LONG||'/'||FLT.ERA_PORT ");
		sql.append("     THEN '3:'||SUBSTR(FLT.ERA_POINT_LAT,0,3)||SUBSTR(FLT.ERA_POINT_LONG,0,4)||'/'||FLT.ERA_PORT ");
		
		sql.append("     ELSE '' ");
		sql.append("   END AS REFILE_ERA, ");
		sql.append("   ALT.WEATHER_ALERT, ");
		sql.append("   FLT.PLAN_CONFIRM, ");
		sql.append("   ALT.COMMENTED, ");
		sql.append("   TO_CHAR(ALT.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, ");
		sql.append("   TO_CHAR(SKD.EST_DEP_DT,'DDMON','NLS_DATE_LANGUAGE=AMERICAN') EST_DATE, ");
		sql.append("   ALT.LEG_NUM, ");
		
		sql.append("   TO_CHAR(SKD.FIRST_LEG_FLT_DT,'DDMONYY','nls_date_language=american') DDMONYY, ");
		sql.append("   TO_CHAR(SKD.SCH_DEP_DT,'HH24MI') STD, ");
		sql.append("   TO_CHAR(SKD.ACT_DEP_DT,'HH24MI') ATD, ");
		sql.append("   TO_CHAR(SKD.EST_DEP_DT,'HH24MI') ETD, "); //2016.12.12
		
		sql.append("   FLT.PLANID, ");
		sql.append("   TO_CHAR(SKD.SCH_ARV_DT,'HH24MI') STA, ");
		sql.append("   FLT.EXTR_FUEL + FLT.PAD_FUEL EXTR_PAD, ");
		sql.append("   FLT.REFILE_POINT, ");
		sql.append("   FLT.REFILE_PORT, ");
		sql.append("   FLT.REFILE_ALT_PORTS, ");
		sql.append("   TO_CHAR(SKD.SCH_DEP_DT, 'DDMONYY','nls_date_language=american') SCHDDMONYY, ");
		
		//2016.12.12 
		//sql.append("   FLT.ALTN_FUEL + FLT.HOLD_FUEL D1 , ");
		sql.append("   FLT.ALTN_FUEL + (FLT.HOLD_FUEL*1.3) D1 , ");
		
		sql.append("   FLT.HOLD_FUEL * 1.3 D2 , ");
		sql.append("   FLT.REFILE_FUEL + FLT.ETOP_FUEL D3 , ");
		sql.append("   FLT.REFILE_RQRD D4 , ");
		sql.append("   DECODE(FLT.REFILE_Y,'Y',FLT.REFILE_VFR + (0.5 * FLT.HOLD_FUEL),0) D5 , ");
		sql.append("   CASE WHEN FLT.ERA_Y = 'Y' THEN FLT.ERA_POINT_LAT || FLT.ERA_POINT_LONG || '/' || FLT.ERA_PORT ELSE '' END AS D6 , ");
		sql.append("   CASE WHEN FLT.REFILE_Y = 'Y' THEN 'REFILE'  ");
		sql.append("     WHEN FLT.ERA_Y = 'Y' THEN '3%' ELSE '5% LCF' END || '/' || DECODE(FLT.ALT_PORT,'','NAR','') || '/' || DECODE(FLT.ETOPS_Y,'Y','EDTO','') AS D7 , ");
		
		//2016.12.12 ߰
		sql.append("   FLT.ALTN_FUEL + (FLT.HOLD_FUEL*1.5) D8 , ");
		sql.append("   FLT.HOLD_FUEL AS D9 , ");
		
		sql.append("   ALT.RELEASE_SYSKEY, ");
		sql.append("   NVL(FWT.PLN_TANK_FUEL,0) PLN_TANK_FUEL,  ");
		//2016.12.12 LAND_T, ROUTE ߰
		sql.append("   (CASE WHEN SKD.LAND_T IS NOT NULL THEN SUBSTR(SKD.LAND_T,0,2)||':'||SUBSTR(SKD.LAND_T,3) ELSE NULL END) AS LAND_T,  ");
		sql.append("   FLT.ROUTE ");
		
		//@2018-04-06
		sql.append(",	ALT.EDTO_CONFIRM ");
		sql.append(",	FLT.ETOPS_Y ");

		sql.append(" FROM KFOS.FFS_ALERT_T ALT, ");
		sql.append("   FLIGHT_PLAN_T FLT, ");
		sql.append("   DAILY_SCH_T SKD, ");
		sql.append("   CM_CITYPAIR_DEF_T DEF, ");
		sql.append("   FLT_FUEL_WT_T FWT ");
		sql.append(" WHERE 1                  =1 ");
		sql.append(" AND ALT.STATUS           = 'ENR' ");
		sql.append(" AND ALT.FIRST_LEG_FLT_DT = SKD.FIRST_LEG_FLT_DT ");
		sql.append(" AND ALT.FLT_NUM          = SKD.FLT_NUM ");
		sql.append(" AND ALT.STNFR            = SKD.STNFR ");
		sql.append(" AND ALT.STNTO            = SKD.STNTO ");
		sql.append(" AND SKD.SCH_DEP_DT BETWEEN SYSDATE - 35/24 AND SYSDATE + 3/24 ");
		sql.append(" AND SKD.ACT_DEP_DT BETWEEN SYSDATE - 30/24 AND SYSDATE - 8/24 ");
		sql.append(" AND SKD.ARV_STS         <> 'ACT' ");
		sql.append(" AND SKD.DEP_STS         <> 'INI' ");
		sql.append(" AND SKD.ACTNID          <> 'CNL' ");
		sql.append(" AND ALT.FIRST_LEG_FLT_DT = FLT.FIRST_LEG_FLT_DT ");
		sql.append(" AND ALT.FLT_NUM          = FLT.FLT_NUM ");
		sql.append(" AND ALT.STNFR            = FLT.STNFR ");
		sql.append(" AND ALT.STNTO            = FLT.STNTO ");
		sql.append(" AND FLT.STATUS           = 'AIR' ");
		sql.append(" AND FLT.ACTIVE           = 'Y' ");
		//2016.08.17
		sql.append(" AND (FLT.FLT_NUM NOT LIKE '4%' OR (FLT.FLT_NUM LIKE '4%' AND FLT.REGION_CD <> 'DOM')) ");
		
		sql.append(" AND ALT.STNFR            = DEF.DEP_PORT ");
		sql.append(" AND ALT.STNTO            = DEF.ARV_PORT ");
		//2016.07.27
		sql.append(" AND ALT.FIRST_LEG_FLT_DT = FWT.FIRST_LEG_FLT_DT(+) ");
		sql.append(" AND ALT.FLT_NUM          = FWT.FLT_NUM(+) ");
		sql.append(" AND ALT.STNFR            = FWT.STNFR(+) ");
		sql.append(" AND ALT.STNTO            = FWT.STNTO(+) ");
		sql.append(" ORDER BY GBN DESC, FLT.TAKEOFF_TMPST DESC  ");
		
		System.out.println("[BASE:FfsQ030Query:selEnrouteRev] sql : "+sql.toString());
		return sql.toString();
	}
	
	
	public String updPsnManualDt(String firstLegFltDt, String fltNum, String legNum, String stnfr, String stnto) {//@2018-10-15
		StringBuffer sql = new StringBuffer();
		sql.append("	UPDATE KFOS.FFS_ALERT_T");
		sql.append("	SET PSN_SEND_ACARS  = null");
		sql.append("	, PSN_MIN     		= null");
		sql.append("	, PSN_MANUAL_DT     = sysdate");
		sql.append("	WHERE");
		sql.append("		 FIRST_LEG_FLT_DT =TO_DATE('"+firstLegFltDt+"','YYYYMMDD')");
		sql.append("	AND FLT_NUM ='"+fltNum+"'");
		sql.append("	AND LEG_NUM ="+legNum+"");
		sql.append("	AND STNFR ='"+stnfr+"'");
		sql.append("	AND STNTO ='"+stnto+"'");
		
		Logger.debug.println("[BASE:FfsQ030Query:updPsnManualDt] sql : "+sql.toString());
		return sql.toString();
	}
}
