package kal.base.ffs.query;

import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Flight Plan ȸ ȭ SQL 
  * @author Copyright (c) 2007/07/02  
  */   
public class FfsQ230Query {
	private static FfsQ230Query instance = new FfsQ230Query();
	
	public static FfsQ230Query getInstance() {
		return instance;
	}
	
	/** 
	  * Flight Plan ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2007/07/02  
	  */
	public String selFltPlan(FfsQ230BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	A.FLT_NUM, A.STNFR, A.STNTO, ");
		sql.append(" 	TO_CHAR(A.FIRST_LEG_FLT_DT,'DDMONYY') DDMONYY, ");
		sql.append(" 	TO_CHAR(D.SCH_ARV_DT,'HH24MI') STA, ");
		sql.append(" 	A.EXTR_FUEL + A.PAD_FUEL EXTR_FUEL, ");
		sql.append(" 	A.ALT_PORT, ");
		sql.append(" 	A.REGNO, A.ACTYP, ");
		sql.append(" 	TO_CHAR(D.SCH_DEP_DT,'HH24MI') STD, ");
		sql.append(" 	TO_CHAR(D.ACT_DEP_DT,'HH24MI') ATD, ");
		sql.append(" 	TO_CHAR(A.TAKEOFF_TMPST,'HH24MI') TAKEOFF_TMPST, ");
		sql.append(" 	TO_CHAR(D.EST_ARV_DT,'HH24MI') ETA, ");
		sql.append(" 	A.PLANID, ");
		sql.append(" 	A.REFILE_POINT, A.REFILE_PORT, A.REFILE_ALT_PORTS, ");
		sql.append(" 	A.PLAN_MSG ");
		sql.append(" FROM  ");
		sql.append(" 	FLIGHT_PLAN_T A, DAILY_SCH_T D ");
		sql.append(" WHERE ");
		sql.append(" 	A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" 	AND A.FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" 	AND A.STNFR = '" + params.getStnfr() + "' ");
		sql.append(" 	AND A.STNTO = '" + params.getStnto() + "' ");
		sql.append(" 	AND A.ACTIVE = 'Y' ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = D.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND A.FLT_NUM = D.FLT_NUM ");
		sql.append(" 	AND A.STNFR = D.STNFR ");
		sql.append(" 	AND A.STNTO = D.STNTO ");
		sql.append(" 	AND D.DEP_STS <> 'INI' ");
		sql.append(" 	AND D.ACTNID <> 'CNL' ");
		
		//System.out.println("[BASE:FfsQ230Query:selFltPlan] sql : "+sql.toString());
		Logger.debug.println("[BASE:FfsQ230Query:selFltPlan] sql : "+sql.toString());
		return sql.toString();
	}
}
