package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.IroA050BG;
import kal.base.com.query.ComQ01Query;
import kal.base.com.util.*;

 /**
   * SQL 
   * @author Copyright (c) 
   */   
public class IroA050Query {
	
	private static IroA050Query instance = new IroA050Query();
	
	public static IroA050Query getInstance() {
		return instance;
	}

	/** 
	  * ADDR BOOK ȸ SQLԼ.
	  * @param entity IroA050BG
	  * @return String Query 
	  * @author Copyright (c) 2005/02/04 
	  */
	public String selAddr(IroA050BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Addr_c, Addr_e ");
		sql.append(" From Msg_ADDR_T ");
		sql.append(" Order By Seq_no ");
			
		Logger.debug.println("[BASE:IroA050Query:selAddr] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS_SCH_T Project Number & ASM Message  SQLԼ.
	  * @param params IroA050BG
	  * @return String Query 
	  * @author Copyright (c) 2005/02/07 
	  */
	public String updIropsSchT(IroA050BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" Update Irops_Sch_t");
		sql.append(" Set 	Project_No = '"+params.getProject_no()+"',");
		sql.append("     	Message = '"+StringUtil.DBInsStr(params.getMsg_data())+"'");
		sql.append(" Where First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') And");
		sql.append("       		Flt_Num = '"+params.getFlt_num()+"' And");
		sql.append("       		Stnfr = '"+params.getStnfr()+"' And");
		sql.append("       		Stnto = '"+params.getStnto()+"' And");
		sql.append("       		Seq_Num = '"+params.getSeq_num()+"' And");
		sql.append("       		Option_Num = '"+params.getOption_num()+"'");
		
		Logger.debug.println("[BASE:IroA050Query:updIropsSchT] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * ASM Message  SQLԼ.
	  * @param params IroA050BG
	  * @return String Query 
	  * @author Copyright (c) 2005/02/07 
	  */
	public String insMessageORG(IroA050BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" Insert Into Ms_Telex_Msg_t (Msg_Cat, Msg_Tmpst, Uni_Seq, Msg_Max, Msg_Pos, Origin_Addr, Message, Priority, Project_No, Processed, Error_Reply)");
		sql.append(" Values ('BASEWEB',Sysdate,UNI_SEQ.Nextval,'1','1','"+params.getOrigin_addr()+"','"+StringUtil.DBInsStr(params.getMsg_data())+"','1','"+params.getProject_no()+"','N',' ')");			
		
		Logger.debug.println("[BASE:IroA050Query:insMessage] sql : "+sql.toString());
		return sql.toString();
	}	
	//20150428 MHS
	public String insMessage(IroA050BG params, String mhsMessage){
		
		mhsMessage = mhsMessage != null ? mhsMessage.replace("\"", "") : mhsMessage;
		
		StringBuffer sql = new StringBuffer();

		//sql.append(" Insert Into KFOS.MS_TELEX_MHS_T_TEST (Msg_Cat, Msg_Tmpst, Uni_Seq, Msg_Max, Msg_Pos, Origin_Addr, Message, Priority, Project_No, Processed, Error_Reply)");
		sql.append(" Insert Into KFOS.MS_TELEX_MHS_T (Msg_Cat, Msg_Tmpst, Uni_Seq, Msg_Max, Msg_Pos, Origin_Addr, Message, Priority, Project_No, Processed, Error_Reply)");
		sql.append(" Values ('BASEWEB',Sysdate,UNI_SEQ.Nextval,'1','1','"+params.getOrigin_addr()+"','"+StringUtil.DBInsStr(mhsMessage)+"','1','"+params.getProject_no()+"','N',' ')");			
		
		Logger.debug.println("[BASE:IroA050Query:insMessage] sql : "+sql.toString());
		return sql.toString();
	}
}
