package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Option Comparision SQL 
  * @author Copyright (c) 2009/07/27  
  */   
public class IroA320Query {
	private static IroA320Query instance = new IroA320Query();
	
	public static IroA320Query getInstance() {
		return instance;
	}
	
	/** 
	  * Title ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/30 
	  */
	public String selTitleE(String dssStartDt, String seqNum) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT KOR_N, TO_CHAR(IROPS_DT,'YYYY/MM/DD HH24:MI') IROPS_DT, TITLE_E ");
		sql.append(" FROM DSS_IROPS_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+dssStartDt+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+seqNum);
		
		System.out.println("[BASE:IroA320Query:selTitleE] sql : "+sql.toString());
		return sql.toString();
	}
		
	/** 
	  * SKD  ȸ 1 - DAILY_SCH_T    Ȯ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/27 
	  */
	public String selDailySchT(IroA320BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.TITLE_E, B.COMMENT_E, B.COMMENT_X, ");
		sql.append(" TO_CHAR(C.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, C.FLT_NUM, C.STNFR, C.STNTO, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'DDMON') FLT_DATE, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'YYYYMMDDHH24MI') STD, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'HH24:MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(C.SCH_ARV_DT,'HH24:MI') SCH_ARV_DT, ");
		sql.append(" TO_CHAR(C.EST_DEP_DT,'HH24:MI') EST_DEP_DT, ");
		sql.append(" C.KACTYP, C.REGNO, ");
		sql.append(" C.F_BOOK, C.C_BOOK, C.Y_BOOK, C.F_CHKIN, C.C_CHKIN, C.Y_CHKIN, ROUTE_X CGO_X ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C ");
		sql.append(" WHERE B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND B.SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");
		sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
		sql.append(" AND B.STNFR = C.STNFR ");
		sql.append(" AND B.STNTO = C.STNTO ");
		sql.append(" AND A.PROCESS_X = 'I' ");
		sql.append(" ORDER BY C.SCH_DEP_DT ");
		
		System.out.println("[BASE:IroA320Query:selDailySchT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SKD  ȸ 2 - 1    DSS_NEW_SCH_T    Ȯ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/27 
	  */
	public String selDssNewSchT(IroA320BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.TITLE_E, B.COMMENT_E, B.COMMENT_X, ");
		sql.append(" TO_CHAR(C.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, C.FLT_NUM, C.STNFR, C.STNTO, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'DDMON') FLT_DATE, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'YYYYMMDDHH24MI') STD, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'HH24:MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(C.SCH_ARV_DT,'HH24:MI') SCH_ARV_DT, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'HH24:MI') EST_DEP_DT, ");
		sql.append(" C.KACTYP, C.REGNO, ");
		sql.append(" 0 F_BOOK, 0 C_BOOK , 0 Y_BOOK, 0 F_CHKIN, 0 C_CHKIN, 0 Y_CHKIN, 'CGO' CGO_X ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DSS_NEW_SCH_T C ");
		sql.append(" WHERE B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND B.SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");
		sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
		sql.append(" AND B.STNFR = C.STNFR ");
		sql.append(" AND B.STNTO = C.STNTO ");
		sql.append(" AND A.PROCESS_X = 'I' ");
		sql.append(" ORDER BY C.SCH_DEP_DT ");
		
		System.out.println("[BASE:IroA320Query:selDssNewSchT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Check List  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/30 
	  */
	public String selCheckList(String codeX, String commentX1, String commentX2, String commentX3, String commentX4, String commentX5, String commentX6) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DESC_E ");
		sql.append(" FROM CODE_T ");
		sql.append(" WHERE STEP_X = '1' ");
		sql.append(" AND USE_Y = 'D' ");
		sql.append(" AND CODE_X = '"+codeX+"' ");
		sql.append(" AND (OTHRS_E LIKE '%"+commentX1+"%' ");
		sql.append(" OR OTHRS_E LIKE '%"+commentX2+"%' ");
		sql.append(" OR OTHRS_E LIKE '%"+commentX3+"%' ");
		sql.append(" OR OTHRS_E LIKE '%"+commentX4+"%' ");
		sql.append(" OR OTHRS_E LIKE '%"+commentX5+"%' ");
		sql.append(" OR OTHRS_E LIKE '%"+commentX6+"%') ");
		sql.append(" ORDER BY PRTY_NO ");
		
		System.out.println("[BASE:IroA320Query:selCheckList] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DESK  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/30 
	  */
	public String selDeskInfo(IroA320BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT B.CODE_X, A.KOR_N, TO_CHAR(A.TIMESTAMP - 9/24, 'HH24:MI:SS') TIMESTAMP, A.DECISION_X, A.DECISION_E, A.DESK_X, A.CHECKLIST_E "); //2009.10.06  : TIMESTAMP KST -> UTC
		sql.append(" FROM DSS_IROPS_DESK_T A, CODE_T B ");
		sql.append(" WHERE A.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND A.SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND A.DESK_X = B.DESC_E ");
		sql.append(" AND B.STEP_X = '0' ");
		sql.append(" AND B.CODE_C = 'Head' ");
		sql.append(" AND B.USE_Y = 'N' ");
		//sql.append(" AND B.END_D > TO_CHAR(SYSDATE,'YYYYMMDD') "); //<-  ´ üũ ؾ.
		sql.append(" ORDER BY A.DESK_X ");
		
		System.out.println("[BASE:IroA320Query:selDeskInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_IROPS_DESK_T Update SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/31 
	  */
	public String updCheckList(IroA320BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" UPDATE DSS_IROPS_DESK_T ");
		sql.append(" SET CHECKLIST_E = '"+params.getChecklistE()+"', ");
		sql.append(" DECISION_X = '"+params.getDecisionX()+"', ");
		sql.append(" DECISION_E = '"+params.getDecisionE()+"', ");
		sql.append(" USER_ID = '"+params.getEmpNo()+"', ");
		sql.append(" KOR_N = '"+params.getKorN()+"', ");
		sql.append(" TIMESTAMP = SYSDATE ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");  
		sql.append(" AND SEQ_NUM = "+params.getSeqNum()); 
		sql.append(" AND DESK_X = '"+params.getDeskX()+"' ");
		
		System.out.println("[BASE:IroA320Query:updCheckList] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * PROCESS_X ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/10/15 
	  */
	public String selProcessX(IroA320BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" SELECT PROCESS_X ");
		sql.append(" FROM DSS_IROPS_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");  
		sql.append(" AND SEQ_NUM = "+params.getSeqNum()); 
		
		System.out.println("[BASE:IroA320Query:selProcessX] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_IROPS_T Update (Confirm) SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/31 
	  */
	public String updDssIropsT(IroA320BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" UPDATE DSS_IROPS_T ");
		sql.append(" SET PROCESS_X = 'C' ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");  
		sql.append(" AND SEQ_NUM = "+params.getSeqNum()); 
		
		System.out.println("[BASE:IroA320Query:updDssIropsT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * MSG ϱ   ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/11 
	  */
	public String selMsgInfo(IroA320BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" SELECT TO_CHAR(B.DSS_START_DT, 'YYYYMMDDHH24MISS') DSS_START_DT, B.MSG_NO, B.LVL_NO, A.TITLE_E, A.FLT_NUM, A.SCH_DEP_D ");
		sql.append(" FROM DSS_MSG_HEAD_T A, DSS_MSG_DETAIL_T B ");
		sql.append(" WHERE B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND B.DSS_LVL_X = 'I' ");
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		
		System.out.println("[BASE:IroA320Query:selMsgInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * T/S PAX ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/11 
	  */
	public String selTSPax(IroA320BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(B.SCH_ARV_DT_LOC,'YYYY/MM/DD HH24:MI') SCH_ARV_DT_LOC, ");
		sql.append(" TO_CHAR(A.TRANS_DT,'YYYY/MM/DD HH24:MI') TRANS_DT, ");
		sql.append(" A.TRANS_ARLN_CD, A.TRANS_FLT_NUM, A.TRANS_STN_C, ");
		sql.append(" A.F_CHKIN_Q, A.F_BOOK_Q, A.C_CHKIN_Q, A.C_BOOK_Q, A.Y_CHKIN_Q, A.Y_BOOK_Q, A.BAG_Q ");
		sql.append(" FROM BASE_DCS_TRANS_T A, DAILY_SCH_T B ");
		sql.append(" WHERE A.ARLN_CD = 'KE' ");
		sql.append(" AND A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND A.FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND A.STNFR = '"+params.getStnfr()+"' ");
		sql.append(" AND A.STNTO = '"+params.getStnto()+"' ");
		sql.append(" AND A.DEP_ARV_X = 'A' ");
		sql.append(" AND A.ARLN_CD = B.ARLN_CD ");
		sql.append(" AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" AND A.STNFR = B.STNFR ");
		sql.append(" AND A.STNTO = B.STNTO ");
		
		System.out.println("[BASE:IroA320Query:selTSPax] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * TRANS_ARLN_CD = 'KE' ϶ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/11 
	  */
	public String selTransArlnCdKE(String schArvDtLoc, String transDt, String transFltNum, String transStnC) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SCH_DEP_DT_LOC,'HH24:MI') SCH_DEP_DT_LOC ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE ARLN_CD = 'KE' ");
		sql.append(" AND SCH_DEP_DT_LOC >= TO_DATE('"+schArvDtLoc+"','YYYY/MM/DD HH24:MI') ");
		sql.append(" AND SCH_DEP_DT_LOC >= TO_DATE('"+transDt+"','YYYY/MM/DD HH24:MI') ");
		sql.append(" AND SCH_DEP_DT_LOC <= TO_DATE('"+transDt+"','YYYY/MM/DD HH24:MI') + 1 ");
		sql.append(" AND FLT_NUM = '"+transFltNum+"' ");
		sql.append(" AND STNTO = '"+transStnC+"' ");
		sql.append(" AND ROWNUM = 1 ");
		sql.append(" ORDER BY SCH_DEP_DT_LOC ");
		
		System.out.println("[BASE:IroA320Query:selTransArlnCdKE] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * STNTO = 'ICN' ϶ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/11 
	  */
	public String selStntoICN(String schArvDtLoc, String transDt, String transArlnCd, String transFltNum) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SCH_DT_LOC,'HH24:MI') SCH_DT_LOC ");
		sql.append(" FROM FO_DAILY_RAMP_T ");
		sql.append(" WHERE SCH_DT_LOC >= TO_DATE('"+schArvDtLoc+"','YYYY/MM/DD HH24:MI') ");
		sql.append(" AND SCH_DT_LOC >= TO_DATE('"+transDt+"','YYYY/MM/DD HH24:MI') ");
		sql.append(" AND SCH_DT_LOC <= TO_DATE('"+transDt+"','YYYY/MM/DD HH24:MI') + 1 ");
		sql.append(" AND ARLN_CD = '"+transArlnCd+"' ");
		sql.append(" AND FLT_NUM = '"+transFltNum+"' ");
		sql.append(" AND DEPARV_X = 'D' ");
		sql.append(" AND STN = 'ICN' ");
		
		System.out.println("[BASE:IroA320Query:selStntoICN] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS  / SQLԼ.
	  * @return String Query 
	  * ۼ : 2010/12/30
	  */
	public String deleteIrops(IroA320BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" UPDATE DSS_IROPS_T ");
		sql.append(" SET PROCESS_X = 'M' ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");  
		sql.append(" AND SEQ_NUM = "+params.getSeqNum()); 
		
		System.out.println("[BASE:IroA320Query:deleteIrops] sql : "+sql.toString());
		return sql.toString();
	}
}
