package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.com.query.*;
import kal.base.iro.dbbean.*;
import kal.base.iro.query.*;

  /**
   * Reason Statistics SQL 
   * @author Copyright (c) 2005/12/20 
   */
public class IroQ230Query {
	private static IroQ230Query instance = new IroQ230Query();
	
	public static IroQ230Query getInstance() {
		return instance;
	}
	
	/** 
	  * Reason Statistics main ȸ SQLԼ.
	  * @param entity IroQ230BG 
	  * @return String Query 
	  * @author Copyright (c) 2005/12/20 
	  */
	public String selMain(IroQ230BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Decision_c, Count(*) Ttl_q,");
		sql.append(" Sum((Timestamp_e - Timestamp) * 24 * 60 * 60) ttl_Dur_q,");
		sql.append(" Sum(Decode(Nvl(Message,'A'),'A',1)) ttl_Msg_q, ");
		sql.append(" TRUNC(Sum((Timestamp_e - Timestamp) * 24 * 60 * 60) / Count(*)/3600)||':'||LPAD(TRUNC(MOD(Sum((Timestamp_e - Timestamp) * 24 * 60 * 60) / Count(*),3600)/60),2,0)||':'||LPAD(MOD(MOD(Sum((Timestamp_e - Timestamp) * 24 * 60 * 60) / Count(*),3600),60),2,0) Dur_q,");
		sql.append(" (Count(*) - Sum(Decode(Nvl(Message,'A'),'A',1))) Msg_q");
		sql.append(" From Irops_Sch_T");
		sql.append(" WHERE Timestamp >= TO_DATE('"+params.getFrdate()+" 000000', 'YYYYMMDD HH24MISS') ");
		sql.append(" And Timestamp <= TO_DATE('"+params.getTodate()+" 235959', 'YYYYMMDD HH24MISS') ");
		if (!params.getDiv().equals("")) {
			if (!params.getDiv().equals("1")) {
				sql.append(" And Region_Flt = '1'");
			}
			else {
				sql.append(" And Region_Flt <> '1'");
			}				
		}
		sql.append(" And Complete_y = 'Y'");
		sql.append(" Group By Decision_c");
		
		Logger.debug.println("[BASE:IroQ230Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
