package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.com.query.*;
import kal.base.iro.dbbean.*;
import kal.base.iro.query.*;

  /**
   * Desk Interactive SQL 
   * @author Copyright (c) 2005/12/20 
   */
public class IroQ240Query {
	private static IroQ240Query instance = new IroQ240Query();
	
	public static IroQ240Query getInstance() {
		return instance;
	}
	
	/** 
	  * Desk Interactive main ȸ SQLԼ.
	  * @param entity IroQ240BG 
	  * @return String Query 
	  * @author Copyright (c) 2005/12/20 
	  */
	public String selMain(IroQ240BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select C.Code_x Code_x, ");
		sql.append(" Min(Decode(B.Decision_x,'1', (B.Timestamp - A.Timestamp) * 24 * 60 * 60, ");
		sql.append(" '2', (B.Timestamp - A.Timestamp) * 24 * 60 * 60, ");
		sql.append(" '3', (B.Timestamp - A.Timestamp) * 24 * 60 * 60)) Min_t, ");
		sql.append(" Max(Decode(B.Decision_x,'1', (B.Timestamp - A.Timestamp) * 24 * 60 * 60, ");
		sql.append(" '2', (B.Timestamp - A.Timestamp) * 24 * 60 * 60, ");
		sql.append(" '3', (B.Timestamp - A.Timestamp) * 24 * 60 * 60)) Max_t, ");
		sql.append(" Sum(Decode(B.Decision_x,'1', (B.Timestamp - A.Timestamp) * 24 * 60 * 60)) Ok_t, ");
		sql.append(" Sum(Decode(B.Decision_x,'1', 1)) OK_c, ");
		sql.append(" Sum(Decode(B.Decision_x,'2', (B.Timestamp - A.Timestamp) * 24 * 60 * 60)) Not_t, ");
		sql.append(" Sum(Decode(B.Decision_x,'2', 1)) Not_c, ");
		sql.append(" Sum(Decode(B.Decision_x,'3', (B.Timestamp - A.Timestamp) * 24 * 60 * 60)) Hold_t, ");
		sql.append(" Sum(Decode(B.Decision_x,'3', 1)) Hold_c, ");
		sql.append(" Sum(Decode(B.Decision_x,'4', (B.Timestamp - A.Timestamp) * 24 * 60 * 60)) No_t, ");
		sql.append(" Sum(Decode(B.Decision_x,'4', 1)) No_c, ");
		sql.append("	((nvl(Sum(Decode(B.Decision_x,'1', (B.Timestamp - A.Timestamp) * 24 * 60 * 60)),0) + ");
		sql.append("	nvl(Sum(Decode(B.Decision_x,'2', (B.Timestamp - A.Timestamp) * 24 * 60 * 60)),0) + ");
		sql.append("	nvl(Sum(Decode(B.Decision_x,'3', (B.Timestamp - A.Timestamp) * 24 * 60 * 60)),0))/ ");
		sql.append("	decode((nvl(Sum(Decode(B.Decision_x,'1', 1)),0) +  ");
		sql.append("	nvl(Sum(Decode(B.Decision_x,'2', 1)),0) +  ");
		sql.append("	nvl(Sum(Decode(B.Decision_x,'3', 1)),0)),0,1, ");
		sql.append("	(nvl(Sum(Decode(B.Decision_x,'1', 1)),0) +  ");
		sql.append("	nvl(Sum(Decode(B.Decision_x,'2', 1)),0) +  ");
		sql.append("	nvl(Sum(Decode(B.Decision_x,'3', 1)),0)))) Avg_t, ");
		sql.append(" (nvl(Sum(Decode(B.Decision_x,'1', 1)),0) +  ");
		sql.append(" nvl(Sum(Decode(B.Decision_x,'2', 1)),0) +  ");
		sql.append(" nvl(Sum(Decode(B.Decision_x,'3', 1)),0) +  ");
		sql.append(" nvl(Sum(Decode(B.Decision_x,'4', 1)),0)) Case_t, ");
		sql.append(" (nvl(Sum(Decode(B.Decision_x,'1', 1)),0) + ");
		sql.append(" nvl(Sum(Decode(B.Decision_x,'3', 1)),0)) Opinion_t ");
		sql.append(" From Irops_Sch_T A , Irops_Desk_T B, Code_T C ");
		sql.append(" WHERE A.Timestamp >= TO_DATE('"+params.getFrdate()+" 000000', 'YYYYMMDD HH24MISS') ");
		sql.append(" And A.Timestamp <= TO_DATE('"+params.getTodate()+" 235959', 'YYYYMMDD HH24MISS') ");
		sql.append(" And A.Complete_y = 'Y' ");
		sql.append(" And A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt ");
		sql.append(" And A.Arln_cd = B.Arln_cd ");
		sql.append(" And A.Flt_Num = B.Flt_Num ");
		sql.append(" And A.Stnfr = B.Stnfr ");
		sql.append(" And A.Stnto = B.Stnto ");
		sql.append(" And A.Seq_Num = B.Seq_Num ");
		sql.append(" And A.Option_Num = B.Option_Num ");
		sql.append(" And C.Step_x = '0' ");
		sql.append(" And C.Code_c = 'Head' ");
		sql.append(" And C.Use_y = 'N' ");
		sql.append(" And B.Desk_x = C.Desc_e ");
		if (!params.getDiv().equals("")) {
			sql.append(" And A.Title_x = '"+params.getDiv()+"'");
		}			
		sql.append(" Group By B.Desk_x, C.Code_x ");

		Logger.debug.println("[BASE:IroQ240Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
