package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.com.query.*;
import kal.base.iro.dbbean.*;
import kal.base.iro.query.*;

  /**
   * DSS Messenger List SQL 
   * @author Copyright (c) 2005/12/20 
   */
public class IroQ260Query {
	private static IroQ260Query instance = new IroQ260Query();
	
	public static IroQ260Query getInstance() {
		return instance;
	}
	
	/** 
	  * DSS Messenger List main ȸ SQLԼ.
	  * @param entity IroQ260BG 
	  * @return String Query 
	  * @author Copyright (c) 2005/12/20 
	  */
	public String selMain(IroQ260BG entity){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(A.MSG_DTG, 'YYYYMMDD HH24MISS') MSGDTG, TO_CHAR(A.MSG_DTG, 'HH24:MI:SS') HH24MISS, ");
		sql.append(" 	NVL(B.CODE_X, ' ') CODEX, A.DESK_X, A.USER_N, A.TITLE_E, A.COMMENT_E, TO_CHAR(A.REPLY_DTG, 'YYYYMMDD HH24MISS') REPLYDTG ");
		sql.append(" FROM IROPS_MSG_T A, CODE_T B ");
		sql.append(" WHERE A.MSG_DTG >= TO_DATE('"+entity.getP_msgDtg()+" 000000', 'YYYYMMDD HH24MISS') ");
		sql.append(" 	AND A.MSG_DTG <= TO_DATE('"+entity.getP_msgDtg()+" 235959', 'YYYYMMDD HH24MISS') ");
		if (!(entity.getP_titleE()).equals("")) {
			sql.append(" 	AND A.TITLE_E LIKE '%"+entity.getP_titleE()+"%' ");
		}
		sql.append(" 	AND B.STEP_X(+) = '0' ");
		sql.append(" 	AND B.CODE_C(+) = 'Head' ");
		sql.append(" 	AND B.USE_Y(+) = 'N' ");
		sql.append(" 	AND A.DESK_X = B.DESC_E(+) ");
		sql.append(" ORDER BY A.REPLY_DTG, MSGDTG ");

		Logger.debug.println("[BASE:IroQ260Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
