package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Desk Interactive Statistics SQL 
  * @author Copyright (c) 2009/09/28  
  */ 
public class IroQ520Query {
	private static IroQ520Query instance = new IroQ520Query();
	
	public static IroQ520Query getInstance() {
		return instance;
	}
	
	/** 
	  * Desk Interactive Statistics ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/28  
	  */
	public String selMain(IroQ520BG params) {
		StringBuffer sql = new StringBuffer();
		/*
		sql.append(" SELECT D.PRTY_NO, D.CODE_X, ");
		sql.append(" MIN(DECODE(C.DECISION_X, '1', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60, ");
		sql.append(" '2', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60, ");
		sql.append(" '3', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)) MIN_T, ");
		sql.append(" MAX(DECODE(C.DECISION_X, '1', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60, ");
		sql.append(" '2', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60, ");
		sql.append(" '3', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)) MAX_T, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '1', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)) OK_T, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '1', 1)) OK_C, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '2', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)) NOT_T, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '2', 1)) NOT_C, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '3', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)) HOLD_T, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '3', 1)) HOLD_C, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '4', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)) NO_T, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '4', 1)) NO_C, ");
		sql.append(" ((NVL(SUM(DECODE(C.DECISION_X,'1', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)), 0) + ");
		sql.append(" NVL(SUM(DECODE(C.DECISION_X,'2', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)), 0) + ");
		sql.append(" NVL(SUM(DECODE(C.DECISION_X,'3', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)), 0)) / ");
		sql.append(" DECODE((NVL(SUM(DECODE(C.DECISION_X,'1', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'2', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'3', 1)),0)),0,1, ");
		sql.append(" (NVL(SUM(DECODE(C.DECISION_X,'1', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'2', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'3', 1)),0)))) AVG_T, ");
		sql.append(" (NVL(SUM(DECODE(C.DECISION_X,'1', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'2', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'3', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'4', 1)),0)) CASE_C, ");
		sql.append(" (NVL(SUM(DECODE(C.DECISION_X,'1', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'3', 1)),0)) OPINION_C ");
		sql.append(" FROM DSS_IROPS_SCH_T A, DSS_IROPS_T B, DSS_IROPS_DESK_T C, CODE_T D ");
		sql.append(" WHERE A.SCH_DEP_DT BETWEEN TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
		sql.append(" AND TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
		sql.append(" AND A.DSS_START_DT = B.DSS_START_DT ");
		sql.append(" AND A.SEQ_NUM = B.SEQ_NUM ");
		sql.append(" AND A.DSS_START_DT = C.DSS_START_DT ");
		sql.append(" AND A.SEQ_NUM = C.SEQ_NUM ");
		sql.append(" AND B.PROCESS_X IN ('M') ");
		sql.append(" AND D.STEP_X = '0' ");
		sql.append(" AND D.CODE_C = 'Head' ");
		sql.append(" AND D.USE_Y = 'N' ");
		sql.append(" AND C.DESK_X = D.DESC_E ");
		
		if (!params.getCommentX().equals("")) {
			sql.append(" AND A.COMMENT_X = '"+params.getCommentX()+"' ");
		}
		
		sql.append(" GROUP BY D.PRTY_NO, D.CODE_X ");
		sql.append(" ORDER BY 1 ");
		*/
		
		//2010.05.28  : FLT  CASE  
		sql.append(" SELECT D.PRTY_NO, D.CODE_X, ");
		sql.append(" MIN(DECODE(C.DECISION_X, '1', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60, ");
		sql.append(" '2', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60, ");
		sql.append(" '3', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)) MIN_T, ");
		sql.append(" MAX(DECODE(C.DECISION_X, '1', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60, ");
		sql.append(" '2', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60, ");
		sql.append(" '3', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)) MAX_T, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '1', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)) OK_T, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '1', 1)) OK_C, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '2', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)) NOT_T, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '2', 1)) NOT_C, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '3', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)) HOLD_T, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '3', 1)) HOLD_C, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '4', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)) NO_T, ");
		sql.append(" SUM(DECODE(C.DECISION_X, '4', 1)) NO_C, ");
		sql.append(" ((NVL(SUM(DECODE(C.DECISION_X,'1', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)), 0) + ");
		sql.append(" NVL(SUM(DECODE(C.DECISION_X,'2', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)), 0) + ");
		sql.append(" NVL(SUM(DECODE(C.DECISION_X,'3', (C.TIMESTAMP - B.IROPS_DT) * 24 * 60 * 60)), 0)) / ");
		sql.append(" DECODE((NVL(SUM(DECODE(C.DECISION_X,'1', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'2', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'3', 1)),0)),0,1, ");
		sql.append(" (NVL(SUM(DECODE(C.DECISION_X,'1', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'2', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'3', 1)),0)))) AVG_T, ");
		sql.append(" (NVL(SUM(DECODE(C.DECISION_X,'1', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'2', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'3', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'4', 1)),0)) CASE_C, ");
		//sql.append(" (NVL(SUM(DECODE(C.DECISION_X,'1', 1)),0) + NVL(SUM(DECODE(C.DECISION_X,'3', 1)),0)) OPINION_C ");
		sql.append(" SUM(DECODE(NVL(C.DECISION_E,'A'),'A', 0, 1)) OPINION_C ");
		sql.append(" FROM DSS_IROPS_DESK_T C, CODE_T D, ");
		sql.append("     (SELECT MIN(DECODE(B.COMMENT_X,'CNL', 1, 'DLA', 2, 'CHG', 3, 'RTR', 4, 'DIV', 5, 6)) COMT_X, ");
		sql.append("     MAX(A.DSS_START_DT) DSS_START_DT, MAX(A.SEQ_NUM) SEQ_NUM, MAX(A.IROPS_DT) IROPS_DT ");
		sql.append("     FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B ");
		sql.append("     WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
		sql.append("     AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
		sql.append("     AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append("     AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append("     AND A.PROCESS_X = 'M' ");
		sql.append("     GROUP BY A.DSS_START_DT, B.SEQ_NUM) B ");
		sql.append(" WHERE B.DSS_START_DT = C.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = C.SEQ_NUM ");
		
		if (!params.getCommentX().equals("") && !params.getCommentX().equals("ALL")) {
			
			if (params.getCommentX().equals("CNL")) sql.append(" AND B.COMT_X = 1 ");
			else if (params.getCommentX().equals("DLA")) sql.append(" AND B.COMT_X = 2 ");
			else if (params.getCommentX().equals("CHG")) sql.append(" AND B.COMT_X = 3 ");
			else if (params.getCommentX().equals("RTR")) sql.append(" AND B.COMT_X = 4 ");
			else if (params.getCommentX().equals("DIV")) sql.append(" AND B.COMT_X = 5 ");
			else if (params.getCommentX().equals("NEW")) sql.append(" AND B.COMT_X = 6 ");
		}
		
		sql.append(" AND D.STEP_X = '0' ");
		sql.append(" AND D.CODE_C = 'Head' ");
		sql.append(" AND D.USE_Y = 'N' ");
		sql.append(" AND C.DESK_X = D.DESC_E ");
		sql.append(" GROUP BY D.PRTY_NO, D.CODE_X ");
		sql.append(" ORDER BY 1 ");
		
		System.out.println("[BASE:IroQ520Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
