package kal.base.jdf.serv;

/**
 * @(#)
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  Byoung-chan Eum, bceum@lgeds.lg.co.kr 
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr
 */
import java.io.*;
import java.util.*;
import javax.servlet.*;
 
public class UploadedFile {
	private String dir;
	private String filename;
	private String type;
	/**
	 * 
	 */
	public UploadedFile(String dir, String filename, String type) {
		this.dir = dir;
		this.filename = filename;
		this.type = type;
	}
	/**
	 * 
	 * @return java.lang.String
	 */
	public String getContentType() {
		return type;
	}
	/**
	 * 
	 * @return java.io.File
	 */
	public File getFile() {
		if (dir == null || filename == null) {
		  return null;
		}
		else {
		  return new File(dir + File.separator + filename);
		}
	}
	/**
	 * 
	 * @return java.lang.String
	 */
	public String getFilesystemName() {
		return filename;
	}
}