package kal.base.not.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.not.dbbean.NotA670BG;

 /**
   * Group Address SQL 
   * @author Copyright (c) 2007/09/12 
   */
public class NotA670Query {
	private static NotA670Query instance = new NotA670Query();
	
	public static NotA670Query getInstance() {
		return instance;
	}
		
	/** 
	  * Group Address ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2007/09/12 
	  */
	public String selGrpAddrList(NotA670BG params){
		StringBuffer sql = new StringBuffer();
		
		//20140903 FFS    ȸϵ ߰
		if(params.getIsFfs() != null && "Y".equals(params.getIsFfs())){

			sql.append(" SELECT GRP_NAME AS GROUP_C, DECODE(NTK, 'Email', 'EMail', NTK) AS NETWORK_X, ADDR_LIST AS ADDR_E, ENC_ADDR_LIST AS ENC_ADDR_E ");
			sql.append(" FROM KFOS.FLIGHT_ADDR_T ");
			sql.append(" WHERE 1 = 1 ");
			if("Y".equals(params.getIsFirst()))
				sql.append(" AND IATA_PORT = '" + params.getFfsStnfr() +"' ");
			if (!params.getNetwork_x().equals(""))
				sql.append(" AND UPPER(NTK) = UPPER('" + params.getNetwork_x() +"') ");
			if (!params.getGroup_c().equals(""))
				sql.append( " AND GRP_NAME LIKE '%" + params.getGroup_c() + "%' ");
			
		} else {
			
			sql.append(" SELECT  GROUP_C, NETWORK_X, ADDR_E, ENC_ADDR_E");
			sql.append(" FROM CM_GROUP_ADDR_T");
			sql.append(" WHERE PROJECT_C = 'BASE2'");
			
			if (!params.getNetwork_x().equals(""))
				sql.append(" AND NETWORK_X = '" + params.getNetwork_x() +"' ");
			if (!params.getGroup_c().equals(""))
				sql.append( " AND GROUP_C LIKE '%" + params.getGroup_c() + "%' ");
			
			sql.append( " ORDER BY GROUP_C, SEQ_NO ");
		}

		Logger.debug.println("[BASE:NotA670Query:selGrpAddrList] sql : "+sql.toString());
		return sql.toString();
	}
		
	public String updGrpAddrList(NotA670BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE CM_GROUP_ADDR_T ");
		sql.append(" SET ADDR_E = '"+params.getAddr_e() +"'");
		sql.append(" WHERE PROJECT_C = 'BASE2'");
		sql.append(" 	AND NETWORK_X ='"+ params.getNetwork_x() +"'");
		sql.append(" 	AND GROUP_C= '"+ params.getGroup_c() +"'");
		
		Logger.debug.println("[BASE:NotA670Query:updGrpAddrList] sql : "+sql.toString());
		return sql.toString();	
	}
		
	public String insGrpAddrList(NotA670BG params){
		String seq_no = null;
		if (params.getNetwork_x().equals("EMail")){
			seq_no = "1";
		} else if (params.getNetwork_x().equals("SITA")){
			seq_no = "2";
		} else if (params.getNetwork_x().equals("AFTN")){
			seq_no = "3";
		} else if (params.getNetwork_x().equals("FAX")){
			seq_no = "4";
		}
		
		StringBuffer sql = new StringBuffer();
		
		//2009.01.05 
		sql.append(" INSERT INTO CM_GROUP_ADDR_T (PROJECT_C, NETWORK_X, GROUP_C, SEQ_NO, ADDR_E) VALUES ");
		sql.append(" ('BASE2', '"+ params.getNetwork_x() +"', '"+ params.getGroup_c() +"','"+ seq_no +"','"+ params.getAddr_e() +"') ");
			
		System.out.println("[BASE:NotA670Query:insGrpAddrList] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String delGrpAddrList(NotA670BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append("DELETE FROM CM_GROUP_ADDR_T");
		sql.append(" WHERE PROJECT_C = 'BASE2'");
		sql.append(" 	AND NETWORK_X ='"+ params.getNetwork_x() +"'");
		sql.append(" 	AND GROUP_C= '"+ params.getGroup_c() +"'");
		
		Logger.debug.println("[BASE:NotA670Query:delGrpAddrList] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String selGrpAddrListCnt(NotA670BG params){	
		StringBuffer sql = new StringBuffer();
		
		sql.append("SELECT COUNT(*) AS CNT FROM CM_GROUP_ADDR_T");
		sql.append(" WHERE PROJECT_C = 'BASE2'");
		sql.append(" 	AND NETWORK_X ='"+ params.getNetwork_x() +"'");
		sql.append(" 	AND GROUP_C= '"+ params.getGroup_c() +"'");
		
		Logger.debug.println("[BASE:NotA670Query:delGrpAddrList] sql : "+sql.toString());
		return sql.toString();
	}
		
	/** 
	  * Acars Regno ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2007/10/16 
	  */
	public String selAcarsRegno(NotA670BG params) {	
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT REGNO ");
		sql.append(" FROM CM_REGNO_T ");
		//sql.append(" WHERE REGNO LIKE 'HL7%' "); //2010.04.28  :  ùڸ 8  ߻
		sql.append(" WHERE (REGNO LIKE 'HL7%' OR REGNO LIKE 'HL8%') ");
		sql.append(" 	AND KE_OPRN_Y = 'Y' ");
		sql.append(" 	AND EXP_DT > SYSDATE "); 
		sql.append(" 	AND KACTYP <> 'GRJ' ");
		sql.append(" ORDER BY REGNO ");
		
		Logger.debug.println("[BASE:NotA670Query:selAcarsRegno] sql : "+sql.toString());
		return sql.toString();
	}
}
