package kal.base.not.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.not.dbbean.NotA810BG;

 /**
   * AMS Message SQL 
   * @author Copyright (c) 2007/09/13 
   */
 public class NotA810Query {
	
	private static NotA810Query instance = new NotA810Query();
	public static NotA810Query getInstance() {
		return instance;
	}
	
	public String selAmsMsgList(NotA810BG params){
		
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT TO_CHAR(MSG_DT, 'YYMMDDHH24MISS') MSG_DT, MSG_DTG, MSG_SEQ, MSG_ID, MSG_PRTY, MSG_TITLE, MSG_ORGN, ");
		sql.append(" 	TO_CHAR(MSG_DTG,'YYYY-MM-DD HH24:MI') CMSG_DTG, ");
		sql.append(" 	DECODE(MSG_TYP,31,'NOTAM',32,'SNOTAM',33,'TDM',41,'FPL',42,'POS',50,'MVT',60,'TEXT','WX') MSG_TYP, MSG_CONTENT, ");
		sql.append(" 	MSG_REMARK, MSG_STATUS "); //2008.12.10 ߰
		sql.append(" FROM BS_AFTNMSG_T ");
		sql.append(" WHERE ");
		
		if (params.getSea_ref().equals("SEA")) { //search ư  
			if (params.getDtgFr().equals("") && params.getDtgTo().equals("")) { //---- DTG Է½
				sql.append(" MSG_DT >= SYSDATE - 2/24 ");
			} else {
				sql.append(" MSG_DTG >= TO_DATE('"+params.getDtgFr()+"','YYMMDDHH24MI') "); //---- DTG Է½  
				sql.append(" AND MSG_DTG <= TO_DATE('"+params.getDtgTo()+"','YYMMDDHH24MI') ");
			}
		} else { //refresh ư  
			sql.append("		MSG_DT >= SYSDATE - "+params.getDtg_range()+"/24 "); //2007.09.19  : 2,4,6    ְ .
		}
		
		//if (!params.getCat_all().equals("N")) { //Y  NOTAM, SNOWTAM, TDM, ATSFPL, POS, MVT, TEXT, WX   ȵ  --> 2007.11.27 .
			
			if (!params.getCat_Origin().equals(""))
				sql.append(" AND MSG_ORGN LIKE '"+params.getCat_Origin() +"'||'%'"); //ORIGIN Է½
		
			if(!params.getKeyword().equals(""))
				sql.append( " AND MSG_CONTENT LIKE '%'||'"+params.getKeyword()+"'||'%'"); //KEY WORD Է½
			
			sql.append(" AND ( ");
			//Type 
			if(params.getCat_notam().equals("on")) //NOTAM
				sql.append(" MSG_TYP = 31 OR ");
			if(params.getCat_snowTam().equals("on")) //SNOWTAM
				sql.append(" MSG_TYP = 32 OR ");
			if(params.getCat_tdm().equals("on")) //TDM	
				sql.append(" MSG_TYP = 33 OR ");
			if(params.getCat_ats().equals("on")) //FPL
				sql.append(" MSG_TYP = 41 OR ");
			if(params.getCat_pos().equals("on")) //POS
				sql.append(" MSG_TYP = 42 OR ");
			if(params.getCat_mvt().equals("on")) //MVT
				sql.append(" MSG_TYP = 50 OR ");
			if(params.getCat_text().equals("on")) //TEXT
				sql.append(" MSG_TYP = 60 OR ");
			if(params.getCat_wx().equals("on")) //WX
				sql.append(" (MSG_TYP >= 20 AND MSG_TYP <= 27) ");
			
			if (sql.substring(sql.length()-3).equals("OR "))
				sql.delete(sql.length()-3,sql.length());
			
			sql.append(" )");
			
			//IN, OUT 
			if(params.getCat_in().equals("on") && params.getCat_out().equals("on"))
				sql.append(" AND (MSG_BOUND = 'I' OR MSG_BOUND = 'O' )"); // in, out  
			else if (params.getCat_in().equals("on") && !params.getCat_out().equals("on"))
				sql.append(" AND MSG_BOUND = 'I'");                                     // in  
			else if (!params.getCat_in().equals("on") && params.getCat_out().equals("on"))	
				sql.append(" AND MSG_BOUND = 'O'");                                    // out  
			
			//PROC, CLSD 
			if(params.getStatus_p().equals("on") && params.getStatus_d().equals("on"))
				sql.append(" AND (MSG_STATUS = 'P' OR MSG_STATUS = 'D') "); //PROC, CLSD  
			else if (params.getStatus_p().equals("on") && !params.getStatus_d().equals("on"))
				sql.append(" AND MSG_STATUS = 'P' ");                                      //PROC  
			else if (!params.getStatus_p().equals("on") && params.getStatus_d().equals("on"))	
				sql.append(" AND MSG_STATUS = 'D' ");                                      //CLSD  
		//}
		
		sql.append( " ORDER BY MSG_DTG DESC, MSG_SEQ DESC ");	
		
		System.out.println("[BASE:NotA810Query:selAmsMsgList] sql : "+sql.toString());
		//Logger.debug.println("[BASE:NotA810Query:selAmsMsgList] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String selMsgCont(String DTG, String Seq){
		
		StringBuffer sql = new StringBuffer();
		sql.append(" SELECT MSG_CONTENT");
		sql.append(" FROM BS_AFTNMSG_T");
		sql.append(" WHERE TO_CHAR(MSG_DTG,'YYYY-MM-DD HH24:MI') = '"+ DTG +"'");
		sql.append(" 	AND MSG_SEQ ='"+Seq+"'"); 
		
		Logger.debug.println("[BASE:NotA810Query:selMsgCont] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * remark, status update SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2008/12/15 
	  */
	public String updRemarkStatus(NotA810BG params){
		
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE BS_AFTNMSG_T SET ");
		sql.append(" 	MSG_REMARK = '"+ StringUtil.DBInsStr(params.getRemark()) +"', ");
		sql.append(" 	MSG_STATUS = '"+ params.getStatus() +"' ");
		sql.append(" WHERE MSG_DT = TO_DATE('"+ params.getMsg_dt() +"','YYMMDDHH24MISS') ");
		sql.append(" 	AND MSG_SEQ = '"+ params.getSeq() +"' "); 
		
		System.out.println("[BASE:NotA810Query:updRemarkStatus] sql : "+sql.toString());
		//Logger.debug.println("[BASE:NotA810Query:updRemarkStatus] sql : "+sql.toString());
		return sql.toString();
	}
	
	//20151021 UMS  ߰
	public String selAmsMsgContStr(NotA810BG params){
		
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT MSG_CONTENT ");
		sql.append(" FROM BS_AFTNMSG_T ");
		sql.append(" WHERE MSG_DT = TO_DATE('" + params.getMsg_dt() + "','YYMMDDHH24MISS') ");  
		sql.append(" AND   MSG_SEQ = " + params.getSeq() + " ");
		
		System.out.println("[BASE:NotA810Query:selAmsMsgContStr] sql : "+sql.toString());
		return sql.toString();
	}
	//20151021 UMS  ߰
	public String selTempMailContentStr(NotA810BG params){
		
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT CONTENT ");
		sql.append(" FROM KFOS.BS_TEMP_MAIL_CONTENT_T ");
		sql.append(" WHERE TYP = '" + params.getTyp() + "' ");  
		sql.append(" AND   KEYSTR = '" + params.getKeyStr() + "' ");
		
		System.out.println("[BASE:NotA810Query:selTempMailContentStr] sql : "+sql.toString());
		return sql.toString();
	}
}
