package kal.base.ocb.query;

import kal.base.jdf.com.Logger;
import kal.base.ocb.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * Restriction Airport Popup ȭ鿡  Query
 * ۼ ¥: 2005-03-25
 * @author: 
 */
public class OcbA025Query {
	private static OcbA025Query instance = new OcbA025Query();
	
	public static OcbA025Query getInstance() {
		return instance;
	}

	/** 
	  * Restriction Airport Popup Max Seq_no ȸ SQLԼ
	  * @param entity OcbA025BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/03/25 
	  */
	public String selMaxSeqNo(OcbA025BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Nvl(Max(Seq_No),0) Seq_no ");
		sql.append(" From Irops_Apt_T ");
		sql.append(" Where Irops_d = To_Char(Sysdate,'yyyymmdd') And Apt_c ='"+entity.getApt_c()+"' ");
		
		Logger.debug.println("[BASE:OcbA025Query:selMaxSeqNo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Restriction Airport Popup Է SQLԼ
	  * @param entity OcbA025BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/03/25 
	  */
	public String insIropsAptT(OcbA025BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Insert Into Irops_Apt_T ");
		sql.append("  Values (To_Char(Sysdate,'yyyymmdd'), '"+entity.getApt_c()+"', "+entity.getSeq_no()+", ");
		sql.append("  			'"+entity.getProb_c()+"', '"+entity.getReason_e()+"', '"+entity.getStart_t()+"', '"+entity.getEnd_t()+"', '', ");
		sql.append(" 			'"+entity.getRemark_e()+"', Sysdate) ");
		
		Logger.debug.println("[BASE:OcbA025Query:insIropsAptT] sql : "+sql.toString());
		return sql.toString();
	}
}
