package kal.base.ocb.query;

import kal.base.jdf.com.Logger;
import kal.base.ocb.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * KE Resource Monitor Detail II ȭ鿡  Query
 * ۼ ¥: 2005-04-29
 * @author: HIST  
 */
public class OcbQ120Query {
	private static OcbQ120Query instance = new OcbQ120Query();
	
	public static OcbQ120Query getInstance() {
		return instance;
	}
	
	/** 
	  * KE Resource Monitor Detail II ȸ SQLԼ.
	  * @param reportD String yyyymmdd
	  * @param kacTyp String KACTYP
	  * @return String Query  
	  * @author Copyright (c) 2005/04/29 HIST 
	  */
	public String selKeDetail2(String reportD,String kacTyp) {
		StringBuffer sql = new StringBuffer();
		
		/* 2007.07.04 ּó
		sql.append(" Select A.Flt_Num, A.Regno, A.Stnfr, A.Stnto,");
		sql.append("        	To_Char(A.Sch_Dep_Dt,'hh24:mi') Sch_Dep_Tm,");
		sql.append("        	To_Char(A.Act_Dep_Dt,'hh24:mi') Act_Dep_Tm,");
		sql.append("        	(Substr(Tkof_t,1,2)||':'||Substr(Tkof_t,3,2)) Tkof_t,");
		sql.append("        	To_Char(A.Est_Arv_Dt,'hh24:mi') Est_Arv_Tm,");
		sql.append("        	Nvl(Del_Rc1,' ') Del_Rc1, Del_Dur1, Nvl(Del_Rc2,' ') Del_Rc2, Del_Dur2,");
		sql.append("        	Nvl(A.F_Cfg,0) F_Cfg,Nvl(A.C_Cfg,0) C_Cfg,Nvl(A.Y_Cfg,0) Y_Cfg,");
		sql.append("        	Nvl(A.F_Book,0) F_Book,Nvl(A.C_Book,0) C_Book,Nvl(A.Y_Book,0) Y_Book,");
		sql.append("        	Nvl(A.F_Chkin,0) F_Chkin,Nvl(A.C_Chkin,0) C_Chkin,Nvl(A.Y_Chkin,0) Y_Chkin,");
		sql.append("        	To_Char(A.Sch_Dep_Dt,'yyyymmddhh24mi') Sch_Dep_Dt,");
		sql.append("        	To_Char(A.Act_Dep_Dt + 9/24,'yyyymmddhh24mi') Act_Dep_Dt_Kst,");
		sql.append("        	To_Char(A.First_Leg_Flt_Dt ,'yyyymmdd') First_Leg_Flt_Dt,'UTC' Time_x, ");
		sql.append("			A.HIDEINFO "); // 2006.09.15 ==> ߰
		sql.append(" From Daily_Sch_T A , Code_T B");
		sql.append(" Where A.Arln_Cd = 'KE' And");
		//sql.append("        	A.Sch_Dep_Dt >= To_Date('"+reportD+" 0000','yyyymmdd hh24mi')- 9/24 And");
		//sql.append("        	A.Sch_Dep_Dt <= To_Date('"+reportD+" 2359','yyyymmdd hh24mi')- 9/24 And");
		//sql.append("       		  A.Sch_Dep_Dt >= Sysdate - 1620/1440 And");
		//sql.append("       		  A.Sch_Dep_Dt <= Sysdate + 540/1440  And");
		//In Flight -24ð ش 2005.05.04
		sql.append("            A.Sch_Dep_Dt >= To_Date('"+reportD+" 0000','yyyymmdd hh24mi')- 33/24 And");
		sql.append("        	A.Sch_Dep_Dt <= To_Date('"+reportD+" 2359','yyyymmdd hh24mi')- 9/24 And");
		sql.append("        	A.Actnid  <> 'CNL' And");
		sql.append("        	A.Dep_Sts = 'ACT' And");
		sql.append("        	A.Arv_Sts <> 'ACT' And");
		sql.append("        	B.Step_x = '1'     And");
		sql.append("        	B.Use_y  = 'Y'     And");
		sql.append("        	B.Code_x = 'REPORT ACTYPE' And");
		if (!kacTyp.equals("ALL") && !kacTyp.equals("")) {
			sql.append("        	A.Kactyp = B.Code_c And");
			sql.append("        	B.Desc_e = '"+kacTyp+"'");
		} else {
			sql.append("        	A.Kactyp = B.Code_c");
		}
		sql.append(" Order By Sch_Dep_Dt, 1");
		*/
		
		//2007.07.04 
		sql.append(" Select A.Flt_Num, A.Regno, A.Stnfr, A.Stnto,");
		sql.append(" 	To_Char(A.Sch_Dep_Dt,'hh24:mi') Sch_Dep_Tm,");
		sql.append(" 	To_Char(A.Act_Dep_Dt,'hh24:mi') Act_Dep_Tm,");
		sql.append(" 	(Substr(Tkof_t,1,2)||':'||Substr(Tkof_t,3,2)) Tkof_t,");
		sql.append(" 	To_Char(A.Est_Arv_Dt,'hh24:mi') Est_Arv_Tm,");
		sql.append(" 	Nvl(Del_Rc1,' ') Del_Rc1, Del_Dur1, Nvl(Del_Rc2,' ') Del_Rc2, Del_Dur2,");
		sql.append(" 	Nvl(A.F_Cfg,0) F_Cfg,Nvl(A.C_Cfg,0) C_Cfg,Nvl(A.Y_Cfg,0) Y_Cfg,");
		sql.append(" 	Nvl(A.F_Book,0) F_Book,Nvl(A.C_Book,0) C_Book,Nvl(A.Y_Book,0) Y_Book,");
		sql.append(" 	Nvl(A.F_Chkin,0) F_Chkin,Nvl(A.C_Chkin,0) C_Chkin,Nvl(A.Y_Chkin,0) Y_Chkin,");
		sql.append(" 	To_Char(A.Sch_Dep_Dt,'yyyymmddhh24mi') Sch_Dep_Dt,");
		sql.append(" 	To_Char(A.Act_Dep_Dt + 9/24,'yyyymmddhh24mi') Act_Dep_Dt_Kst,");
		sql.append(" 	To_Char(A.First_Leg_Flt_Dt ,'yyyymmdd') First_Leg_Flt_Dt,'UTC' Time_x,");
		sql.append(" 	A.HIDEINFO");
		sql.append(" From Daily_Sch_T A , Cm_Actyp_T B");
		sql.append(" Where A.Arln_Cd = 'KE' And ");
		sql.append(" 	A.Sch_Dep_Dt >= To_Date('"+reportD+" 0000','yyyymmdd hh24mi')- 33/24 And");
		sql.append(" 	A.Sch_Dep_Dt <= To_Date('"+reportD+" 2359','yyyymmdd hh24mi')- 9/24 And");
		sql.append(" 	A.Actnid  <> 'CNL' And");
		sql.append(" 	A.Dep_Sts = 'ACT' And");
		sql.append(" 	A.Arv_Sts <> 'ACT' And");
		sql.append(" 	B.Owner  = 'KE'    And");
		//sql.append(" 	B.Kactyp <> 'GRJ'  And");//2012 05 30
		sql.append(" 	A.Kactyp = B.Kactyp");
		if (!kacTyp.equals("ALL") && !kacTyp.equals("")) {
			//sql.append(" 	And B.Report_Actyp = '"+kacTyp+"'");//2012 05 30
			//@2018-06-11 sql.append(" 	And B.Gactyp = '"+kacTyp+"'");//2012 05 30 
			
			//@2018-06-11 ߰
			sql.append("	AND	CASE");
			sql.append("				WHEN B.GACTYP='747' AND B.KACTYP IN('74I') THEN '74I'");
			sql.append("				WHEN B.GACTYP='737' AND B.KACTYP IN ('73W') THEN '73W'");
			sql.append("				ELSE");
			sql.append("					B.GACTYP");
			sql.append("			END = '"+kacTyp+"'");
			sql.append("	AND B.KACTYP	NOT IN ('76F', 'GRJ')");
		}
		sql.append(" Order By Sch_Dep_Dt, 1");
		
		Logger.debug.println("[BASE:OcbQ120Query:selKeDetail2] sql : "+sql.toString());
		System.out.println("[BASE:OcbQ120Query:selKeDetail2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SKD/Daily SKD Display Crew ȸ SQLԼ.
	  * @param params OcbQ120BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/01/17 HIST 
	  */
	public String selCrew(OcbQ120BG params) {
		StringBuffer sql = new StringBuffer();

		int int_dt = Integer.parseInt(params.getSch_dep_dt().substring(0,8));
		
		if (int_dt < 20100501) {
		
			sql.append(" Select Substr(D.Surname,1,30) Surname");
			sql.append(" From DUTY_PRD_SEG_V B,ROSTER_V C, CREW_V D");
			sql.append(" Where B.Delete_Ind = 'N' And");
			sql.append("            B.First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') and");
			sql.append("            B.Flt_Num    = '"+params.getFlt_num()+"'       And");
			sql.append("            B.Port_a     = '"+params.getStnfr()+"'        And");
			sql.append("            B.Port_b     = '"+params.getStnto()+"'        And");
			sql.append("            B.Series_num = C.Series_Num And");
			sql.append("            C.Delete_Ind = 'N' And");
			sql.append("            C.Staff_Num  = D.Staff_Num And");
			sql.append("           (C.Acting_Rank = 'CAP' or B.Cop_Duty_Cd In('CM','P1','P2')) And");
			sql.append("            Rownum = 1");
			
		} else {
			
			sql.append(" Select Substr(D.Surname,1,30) Surname");
			//2017.02.09
			sql.append(" From DUTY_PRD_SEG_V@kfos2airfd B,ROSTER_V@kfos2airfd C, CREW_V@kfos2airfd D");
			//sql.append(" From DUTY_PRD_SEG_V@KFOS2FDPRD B,ROSTER_V@KFOS2FDPRD C, CREW_V@KFOS2FDPRD D");
			sql.append(" Where B.Delete_Ind = 'N' And");
			sql.append("            B.First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') and");
			sql.append("            B.Flt_Num    = '"+params.getFlt_num()+"'       And");
			sql.append("            B.Port_a     = '"+params.getStnfr()+"'        And");
			sql.append("            B.Port_b     = '"+params.getStnto()+"'        And");
			sql.append("            B.Series_num = C.Series_Num And");
			sql.append("            C.Delete_Ind = 'N' And");
			sql.append("            C.Staff_Num  = D.Staff_Num And");
			sql.append("           (C.Acting_Rank = 'CAP' or B.Cop_Duty_Cd In('CM','P1','P2')) And");
			sql.append("            Rownum = 1");
		}
		
		Logger.debug.println("[BASE:SkdQ010Query:selCrew] sql : "+sql.toString());
		return sql.toString();
	}		
	
}//end of class
