package kal.base.ocb.query;

import kal.base.jdf.com.Logger;
import kal.base.ocb.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * Departure On Time Pcnt Detail I ȭ鿡  Query
 * ۼ ¥: 2005-04-28
 * @author: 
 */
public class OcbQ130Query {
	private static OcbQ130Query instance = new OcbQ130Query();
	
	public static OcbQ130Query getInstance() {
		return instance;
	}
	
	/** 
	  * Departure On Time Pcnt Detail I ȸ SQLԼ.
	  * @param entity OcbQ130BG Departure On Time Pcnt Detail I 
	  * @return String Query  
	  * @author Copyright (c) 2005/04/28 
	  */
	public String selMain(OcbQ130BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Decode(StnFr, 'GMP',1,'ICN',2,'CJU',3,'PUS',4,'NRT',5,6) Station, Count(*) Total, 'A' AB ");
		sql.append(" From Daily_Sch_t ");
		sql.append(" Where Arln_cd = 'KE' And ");
		sql.append("        Sch_Dep_Dt >= To_Date('"+ entity.getToday() +" 0000','yyyymmdd hh24mi') - 9/24 And  ");
		sql.append("        Sch_Dep_Dt <= To_Date('"+ entity.getToday() +" 2359','yyyymmdd hh24mi') - 9/24 And  ");
		sql.append("        SUBSTR(FLT_NUM,1,1) <> 4 AND ");//2012.05.30 ߰
		sql.append("        Actnid <> 'CNL'  And ");
		sql.append("        Dep_Sts = 'ACT'  And ");
		sql.append("        Dep_Sts <> 'INI' And ");
		sql.append("		Kactyp Not In ('7FG','79S','7GG','ABH') And  "); //2009.05.21 ߰ : 7GG, ABH
		sql.append("        Stnfr in('ICN','GMP','CJU','PUS','NRT','LAX') ");
		sql.append(" Group by Stnfr ");
		sql.append(" Union ");
		sql.append(" Select Decode(StnFr,'GMP',1,'ICN',2,'CJU',3,'PUS',4,'NRT',5,6) Station, Count(*) Total, 'B' AB ");
		sql.append(" From Daily_Sch_t ");
		sql.append(" Where Arln_cd = 'KE' And ");
		sql.append("        Sch_Dep_Dt >= To_Date('"+ entity.getToday() +" 0000','yyyymmdd hh24mi') - 9/24 And  ");
		sql.append("        Sch_Dep_Dt <= To_Date('"+ entity.getToday() +" 2359','yyyymmdd hh24mi') - 9/24 And  ");
		//sql.append("        Act_Dep_dt - Sch_Dep_Dt > 3/1440 And  ");//2012.05.30 
		// 2012.05.30 غ 5
		sql.append("        Act_Dep_dt - Sch_Dep_Dt > 5/1440 And  ");
		sql.append("        SUBSTR(FLT_NUM,1,1) <> 4 AND ");//2012.05.30 ߰
		sql.append("        Actnid  <> 'CNL'  And ");
		sql.append("        Dep_Sts = 'ACT'  And ");
		sql.append("		Kactyp Not In ('7FG','79S','7GG','ABH') And  "); //2009.05.21 ߰ : 7GG, ABH
		sql.append("        Stnfr in('ICN','GMP','CJU','PUS','NRT','LAX') ");
		sql.append(" Group By Stnfr ");
		sql.append(" Order By 1,3  ");
		
		//System.out.println("[BASE:OcbQ130Query:selMain] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ130Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
