package kal.base.ocb.query;

import kal.base.jdf.com.Logger;
import kal.base.ocb.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * Departure On Time Pcnt Detail II ȭ鿡  Query
 * ۼ ¥: 2005-04-29
 * @author: 
 */
public class OcbQ140Query {
	private static OcbQ140Query instance = new OcbQ140Query();
	
	public static OcbQ140Query getInstance() {
		return instance;
	}
	/** 
	  * Departure On Time Pcnt Detail II main ȸ SQLԼ.
	  * @param entity OcbQ140BG Departure On Time Pcnt Detail II
	  * @return String Query 
	  * @author Copyright (c) 2005/04/29 
	  */
	public String selMain(OcbQ140BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select ");
		sql.append(" 	Est_Dep_Dt Ord_1,Sch_Dep_Dt Ord_2,");
		sql.append(" 	Flt_Num, To_Char(Sch_Dep_Dt,'yyyy/mm/dd') Sch_Dep_Date, Kactyp, Regno, Stnfr,  Stnto, ");
		sql.append("		Spot_Out, Spot_In, To_Char(Sch_Dep_Dt,'hh24:mi') Sch_Dep_Dt, To_Char(Sch_Arv_Dt,'hh24:mi') Sch_Arv_Dt, ");
		sql.append(" 	To_Char(Est_Dep_Dt,'hh24:mi') Est_Dep_Dt, To_Char(Act_Dep_Dt,'hh24:mi') Act_Dep_Dt, ");
		sql.append(" 	(Substr(Tkof_t,1,2)||':'||Substr(Tkof_t,3,2)) Tkof_t, Dep_Gmt_Offset, Dep_Sts, Arv_Sts, To_Char(Est_Arv_Dt,'hh24:mi') Est_Arv_Dt, ");
		sql.append(" 	To_Char(Act_Arv_Dt,'hh24:mi') Act_Arv_Dt, (Substr(Land_t,1,2)||':'||Substr(Land_t,3,2)) Land_t, Arv_Gmt_Offset, To_Char(Sch_Dep_Dt,'yyyymmddhh24mi') Sch_Dep_Dt_Full, ");
		sql.append(" 	Nvl(Del_Rc1,' ') Del_Rc1, Del_Dur1, Nvl(Del_Rc2,' ') Del_Rc2, Del_Dur2, ");
		sql.append(" 	To_Char(Act_Dep_Dt + (540/1440),'yyyymmddhh24mi') Act_Dep_Dt_Kst, To_Char(First_Leg_Flt_Dt,'yyyymmdd') First_Leg_Flt_Dt, ");
		sql.append("		HIDEINFO "); // 2006.09.15 ==> ߰
		sql.append(" From ");
		sql.append(" 	Daily_Sch_T ");
		sql.append(" Where ");
		sql.append(" 	Arln_Cd = 'KE' And ");
		sql.append(" 	Sch_Dep_Dt >= To_Date('"+entity.getStart_date()+" 0000','yyyymmdd hh24mi') - (540/1440) And ");
		sql.append(" 	Sch_Dep_Dt <= To_Date('"+entity.getEnd_date()+" 2359','yyyymmdd hh24mi') - (540/1440) And ");
		sql.append(" 	Dep_Sts    = 'ACT'  And ");
		sql.append(" 	Actnid       <> 'CNL' And ");
		sql.append("		Kactyp Not In ('7FG','79S','7GG','ABH') And  "); //2009.05.21 ߰ : 7GG, ABH
		sql.append("  	StnFr = '"+entity.getStnfr()+"'  ");
		sql.append(" Order By Ord_1, Ord_2 ");
		
		//System.out.println("[BASE:OcbQ140Query:selMain] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ140Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
