package kal.base.pbf.serv;

/**
 * 
 * @(#) PublicBaseServlet.java
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 *  
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 *  
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr.
 */
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.*;

import kal.base.jdf.com.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.serv.HttpUtility;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.JDFBaseServlet;
import kal.base.jdf.serv.ApplicationException;
import kal.base.com.util.StringUtil;

public abstract class PublicBaseServlet extends JDFBaseServlet {

	/**
	 * PublicBaseServlet constructor comment.
	 */
	public PublicBaseServlet() {
		super();
	}

	/**
	 * ƹ͵  ʰ, ٷ performTask(req,res);  մϴ.
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 */
	protected void performPreTask(HttpServletRequest req, HttpServletResponse res) throws Exception  {
		// nothing to do
		// If you want to use try{}catch block for performTask(), it's ok. 
		// But, remember that JDFBaseServlet already support the functionallity.
		performTask(req,res);	
	}
	
	/**
	 * ƹ͵  ʰ, ٷ selectPreTask(req,res);  մϴ.
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 */
	protected void selectPreTask(HttpServletRequest req, HttpServletResponse res) throws Exception  {
		// nothing to do
		// If you want to use try{}catch block for performTask(), it's ok. 
		// But, remember that JDFBaseServlet already support the functionallity.
		selectTask(req,res);	
	}
	
	/**
	 * ƹ͵  ʰ, ٷ insertPreTask(req,res);  մϴ.
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 */
	protected void insertPreTask(HttpServletRequest req, HttpServletResponse res) throws Exception  {
		// nothing to do
		// If you want to use try{}catch block for performTask(), it's ok. 
		// But, remember that JDFBaseServlet already support the functionallity.
		insertTask(req,res);	
	}
	
	/**
	 * ƹ͵  ʰ, ٷ updatePreTask(req,res);  մϴ.
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 */
	protected void updatePreTask(HttpServletRequest req, HttpServletResponse res) throws Exception  {
		// nothing to do
		// If you want to use try{}catch block for performTask(), it's ok. 
		// But, remember that JDFBaseServlet already support the functionallity.
		updateTask(req,res);	
	}
	
	/**
	 * ƹ͵  ʰ, ٷ deletePreTask(req,res);  մϴ.
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 */
	protected void deletePreTask(HttpServletRequest req, HttpServletResponse res) throws Exception  {
		// nothing to do
		// If you want to use try{}catch block for performTask(), it's ok. 
		// But, remember that JDFBaseServlet already support the functionallity.
		deleteTask(req,res);	
	}
	
	/**
	 * ƹ͵  ʰ, ٷ checkPreTask(req,res);  մϴ.
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 */
	protected void checkPreTask(HttpServletRequest req, HttpServletResponse res) throws Exception  {
		// nothing to do
		// If you want to use try{}catch block for performTask(), it's ok. 
		// But, remember that JDFBaseServlet already support the functionallity.
		checkTask(req,res);	
	}

	/**
	 * ڴ  method implementationϿ Ͻø ˴ϴ.
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 */
	protected void performTask (HttpServletRequest req, HttpServletResponse res) throws Exception {};
	
	/**
	 * Process  select ϶ Ѵ.
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 */
	protected void selectTask (HttpServletRequest req, HttpServletResponse res) throws Exception {};
	
	/**
	 * Process  insert ϶ Ѵ.
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 */
	protected void insertTask (HttpServletRequest req, HttpServletResponse res) throws Exception {};
	
	/**
	 * Process  update ϶ Ѵ.
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 */
	protected void updateTask (HttpServletRequest req, HttpServletResponse res) throws Exception {};
	
	/**
	 * Process  delete ϶ Ѵ.
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 */
	protected void deleteTask (HttpServletRequest req, HttpServletResponse res) throws Exception {};
	
	/**
	 * Process     Ѵ.
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 */
	protected void checkTask (HttpServletRequest req, HttpServletResponse res) throws Exception {};

	/**
	 * printMessagePage(req,res, "ڸ޼", "ڿ Debug޼")
	 * <p>
	 * pbf.properties  gov.mpbbis.pbf.jspDebugMessageMode  true̸,
	 * "ڿ  Debug޼" JSP Ϸ ٿ ɴϴ.
	 * ׷   ʵ  Flag false ٲٽø,
	 *  ҽ  ʰ "ڸ޼" µ Դϴ.
	 * <p>
	 * JSP "/pbf/message.jsp" Դϴ.
	 * JSP ο ݵ jdf_user_msg  jdf_debug_msg  useBean
	 * ̿Ͽ ϼž մϴ.
	 *
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 * @param user_msg  ڿ  ޼
	 * @param debug_msg ߽ ڰ Debugging   ޼, 
	 *                                   ô  ʵ .
	 */
	protected void printMessagePage(HttpServletRequest req, HttpServletResponse res, 
		String user_msg, String debug_msg) 
	{
		
		if ( user_msg == null ) user_msg = "message is null";
		req.setAttribute("jdf_user_msg", user_msg);
		
		System.out.println("[PublicBaseServlet:printMessagePage] Error user_msg : "+user_msg);

		if ( debug_msg == null ) debug_msg = "";
		else {
			try {
				//kal.base.jdf.com.Config conf = new kal.base.jdf.com.Configuration();
				//boolean mode =  conf.getBoolean("kal.base.jdf.com.jspDebugMessageMode");
				boolean mode = false; //߽ô true ϰ, ô false ϴ  Ϲ  ̴.
				
				if ( mode ) {
					Logger.debug.println(debug_msg);
				}
			}
			catch(Exception e){}
		}
		System.out.println("[PublicBaseServlet] Error debug_msg : "+debug_msg);
		req.setAttribute("jdf_debug_msg", debug_msg);
		printJspPage(req, res, "/jsp/common/message.jsp");
	}
	
   /**
	 * printMessagePage2(req,res, "ڸ޼", "Redirectin ")
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 * @param user_msg  ڿ  ޼
	 * @param next_page Redirection ų 
	 */
	protected void printMessagePage2(HttpServletRequest req, HttpServletResponse res, 
		String user_msg, String next_page, String process_mode) 
	{
		if ( user_msg != null ) {
			//߿  ϳ 
			//req.setAttribute("successMessage", user_msg);
			user_msg = StringUtil.tokenMessage(user_msg);
			Logger.debug.println("[PublicBaseServelt:printMessagePage2] next_page : "+next_page);
			Logger.debug.println("[PublicBaseServelt:printMessagePage2] user_msg : "+user_msg);
			req.setAttribute("errorMessage", user_msg);
			req.setAttribute("processMode", process_mode);
			printJspPage(req, res, next_page);
		}
	}

	/**
	 * printMessagePage(req,res, "ڸ޼", "ڿ Debug޼")
	 * <p>
	 * pbf.properties  gov.mpbbis.pbf.jspDebugMessageMode  true̸,
	 * "ڿ  Debug޼" JSP Ϸ ٿ ɴϴ.
	 * ׷   ʵ  Flag false ٲٽø,
	 *  ҽ  ʰ "ڸ޼" µ Դϴ.
	 * <p>
	 * JSP "/pbf/message.jsp" Դϴ.
	 * JSP ο ݵ jdf_user_msg  jdf_debug_msg  useBean
	 * ̿Ͽ ϼž մϴ.
	 *
	 * @param req javax.servlet.http.HttpServletRequest
	 * @param res javax.servlet.http.HttpServletResponse
	 * @param user_msg  ڿ  ޼
	 * @param debug_msg ߽ ڰ Debugging   ޼, 
	 *                                   ô  ʵ .
	 */
	protected void printPopupMessagePage(HttpServletRequest req, HttpServletResponse res, 
		String user_msg, String debug_msg) 
	{
	}
	
	/**
	 *  ߻ ޽ setting
	 * @param req HttpServletRequest
	 * @param errorMessage String  ޽
	 * @exception ApplicationException
	 * @author Copyright (c) 2004 HIST 
	 */
	public void errorMsg(HttpServletRequest req, String errorMessage) {
		req.setAttribute("errorMessage", errorMessage);
	}
	
	/**
	 *   ̷  ޽ óϱ  ޼ҵ
	 * @param req HttpServletRequest
	 * @param code String	ó ޽
	 * @exception ApplicationException
	 * @author Copyright (c) 2004 HIST 
	 */
	public void successMsg(HttpServletRequest req, String message) {
		req.setAttribute("successMessage", message);
	}
}