package kal.base.rep.query;

import kal.base.jdf.com.Logger;
import kal.base.rep.dbbean.RepQ330BG;
import kal.base.com.query.*;

 /**
   * PAX Load Factor SQL 
   * @author Copyright (c) 2005/07/27 
   */  
public class RepQ330Query {
	private static RepQ330Query instance = new RepQ330Query();
	
	public static RepQ330Query getInstance() {
		return instance;
	}
	/** 
	  *  ߻ Ȳ   ȸ SQLԼ.
	  * @param entity RepQ330BG Operation
	  * @return String Query 
	  * @author Copyright (c) 2005/07/27 
	  */
	public String selMain(RepQ330BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select  Decode(kactyp,'M1F','CGO','7FQ','CGO','7FR','CGO','74Y','CGO','7FG','CGO','79S','CGO','7GG','CGO','ABH','CGO','74F','CGO','74N','CGO','77X','CGO',Decode(Region_Flt,1,'DOM','PAX')) Dom_Pax, "); //2009.05.21 ߰ : 7GG, ABH, 2010.03.26 ߰ : 74F, 2012.02.22 ߰ : 74N, 77X
		sql.append(" 	Decode(Actnid,'CNL','CNL','NEW') New_Cnl, ");
		sql.append(" 	Decode(Nvl(Del_Dur1,0),0,'REG','DEL') Reg_Del, ");
		sql.append(" 	Sum(Nvl(F_Cfg + C_Cfg + Y_Cfg, 0)) Sum1, ");
		sql.append("      Sum(Nvl(F_Chkin + C_Chkin + Y_Chkin, 0)) Sum2 ");
		sql.append(" From Daily_Sch_t ");
		sql.append(" Where Sch_Dep_Dt >= To_Date('"+entity.getToday()+" 0000','yyyymmdd hh24mi') - 33/24 And ");
		sql.append("      Sch_Dep_Dt <= To_Date('"+entity.getToday()+" 2359','yyyymmdd hh24mi') - 33/24 And ");
		sql.append("      Stnfr <> Stnto And  ");
		sql.append("      (Dep_Sts = 'ACT' or (Actnid = 'CNL' And Sch_Dep_Dt <= TimeStamp + 36/24)) ");
		sql.append(" Group By  Decode(kactyp,'M1F','CGO','7FQ','CGO','7FR','CGO','74Y','CGO','7FG','CGO','79S','CGO','7GG','CGO','ABH','CGO','74F','CGO','74N','CGO','77X','CGO',Decode(Region_Flt,1,'DOM','PAX')), "); //2009.05.21 ߰ : 7GG, ABH, 2010.03.26 ߰ : 74F, 2012.02.22 ߰ : 74N, 77X
		sql.append("  	Decode(Actnid,'CNL','CNL','NEW'), ");
		sql.append(" 	Decode(Nvl(Del_Dur1,0),0,'REG','DEL')  ");
		
		//System.out.println("[BASE:RepQ330Query:selMain] sql : "+sql.toString());
		Logger.debug.println("[BASE:RepQ330Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
