package kal.base.skd.dbbean;

import kal.base.jdf.db.EntityData;

/**
 * SKD/Daily SKD Display ȭ鿡  Entity
 * ۼ ¥: 2005-01-17
 * @author: HIST  
 */
public class SkdQ010BG extends EntityData{
	//DB Field
	private String sch_dep_dt;
	private String flt_num;
	private String leg_num;
	private String kactyp;
	private String stnfr;
	private String stnto;
	private String sch_dep_tm;
	private String sch_arv_tm;
	private String actnid;
	private String chgreas;
	private String svc;
	private String dep_sts;
	private String supply;
	private double f_cfg;
	private double c_cfg;
	private double y_cfg;
	private String rsvn;
	private double f_book;
	private double c_book;
	private double y_book;
	private double f_chkin;
	private double c_chkin;
	private double y_chkin;
	private String l_f;
	private String key_sch_dep_dt;
	private String timestamp;
	private String first_leg_flt_dt;
	private String regno;
	private String surname;
	
	private String staffNum; //2007.11.05 ߰
	
	private String act_dep_tm;
	private String act_arv_tm;
	private String spot_in;
	private String spot_out;
	
	//Custom 
	private String dom_int_x;
	private String time_x;
	private String sch_dep_dt_kst;	//KST
	private String act_dep_dt_kst;		//KST
	
	private String hideInfo; // 2006.09.15 ==> ߰
	
	private String sort; //2009.10.12 ߰
	
	//20150603 ߰
	private String sch_dep_dt_loc;
	
	//2016.12.26 ߰
	private String est_dep_tm;
	private String est_arv_tm;
	
	//2017.01.11 ߰
	private String tkof_t;
	
	//@2019-01-22
	private String est_dep_dt;
	private String est_arv_dt;
	
	/**
	 * Returns the act_arv_tm.
	 * @return String
	 */
	public String getAct_arv_tm() {
		return act_arv_tm;
	}

	/**
	 * Returns the act_dep_tm.
	 * @return String
	 */
	public String getAct_dep_tm() {
		return act_dep_tm;
	}

	/**
	 * Returns the actnid.
	 * @return String
	 */
	public String getActnid() {
		return actnid;
	}

	/**
	 * Returns the c_book.
	 * @return double
	 */
	public double getC_book() {
		return c_book;
	}

	/**
	 * Returns the c_cfg.
	 * @return double
	 */
	public double getC_cfg() {
		return c_cfg;
	}

	/**
	 * Returns the c_chkin.
	 * @return double
	 */
	public double getC_chkin() {
		return c_chkin;
	}

	/**
	 * Returns the chgreas.
	 * @return String
	 */
	public String getChgreas() {
		return chgreas;
	}

	/**
	 * Returns the dep_sts.
	 * @return String
	 */
	public String getDep_sts() {
		return dep_sts;
	}

	/**
	 * Returns the dom_int_x.
	 * @return String
	 */
	public String getDom_int_x() {
		return dom_int_x;
	}

	/**
	 * Returns the f_book.
	 * @return double
	 */
	public double getF_book() {
		return f_book;
	}

	/**
	 * Returns the f_cfg.
	 * @return double
	 */
	public double getF_cfg() {
		return f_cfg;
	}

	/**
	 * Returns the f_chkin.
	 * @return double
	 */
	public double getF_chkin() {
		return f_chkin;
	}

	/**
	 * Returns the first_leg_flt_dt.
	 * @return String
	 */
	public String getFirst_leg_flt_dt() {
		return first_leg_flt_dt;
	}

	/**
	 * Returns the flt_num.
	 * @return String
	 */
	public String getFlt_num() {
		return flt_num;
	}

	/**
	 * Returns the kactyp.
	 * @return String
	 */
	public String getKactyp() {
		return kactyp;
	}

	/**
	 * Returns the key_sch_dep_dt.
	 * @return String
	 */
	public String getKey_sch_dep_dt() {
		return key_sch_dep_dt;
	}

	/**
	 * Returns the l_f.
	 * @return String
	 */
	public String getL_f() {
		return l_f;
	}

	/**
	 * Returns the leg_num.
	 * @return String
	 */
	public String getLeg_num() {
		return leg_num;
	}

	/**
	 * Returns the regno.
	 * @return String
	 */
	public String getRegno() {
		return regno;
	}

	/**
	 * Returns the rsvn.
	 * @return String
	 */
	public String getRsvn() {
		return rsvn;
	}

	/**
	 * Returns the sch_arv_tm.
	 * @return String
	 */
	public String getSch_arv_tm() {
		return sch_arv_tm;
	}

	/**
	 * Returns the sch_dep_dt.
	 * @return String
	 */
	public String getSch_dep_dt() {
		return sch_dep_dt;
	}

	/**
	 * Returns the sch_dep_tm.
	 * @return String
	 */
	public String getSch_dep_tm() {
		return sch_dep_tm;
	}

	/**
	 * Returns the spot_in.
	 * @return String
	 */
	public String getSpot_in() {
		return spot_in;
	}

	/**
	 * Returns the spot_out.
	 * @return String
	 */
	public String getSpot_out() {
		return spot_out;
	}

	/**
	 * Returns the stnfr.
	 * @return String
	 */
	public String getStnfr() {
		return stnfr;
	}

	/**
	 * Returns the stnto.
	 * @return String
	 */
	public String getStnto() {
		return stnto;
	}

	/**
	 * Returns the supply.
	 * @return String
	 */
	public String getSupply() {
		return supply;
	}

	/**
	 * Returns the surname.
	 * @return String
	 */
	public String getSurname() {
		return surname;
	}

	/**
	 * Returns the svc.
	 * @return String
	 */
	public String getSvc() {
		return svc;
	}

	/**
	 * Returns the time_x.
	 * @return String
	 */
	public String getTime_x() {
		return time_x;
	}

	/**
	 * Returns the timestamp.
	 * @return String
	 */
	public String getTimestamp() {
		return timestamp;
	}

	/**
	 * Returns the y_book.
	 * @return double
	 */
	public double getY_book() {
		return y_book;
	}

	/**
	 * Returns the y_cfg.
	 * @return double
	 */
	public double getY_cfg() {
		return y_cfg;
	}

	/**
	 * Returns the y_chkin.
	 * @return double
	 */
	public double getY_chkin() {
		return y_chkin;
	}

	/**
	 * Sets the act_arv_tm.
	 * @param act_arv_tm The act_arv_tm to set
	 */
	public void setAct_arv_tm(String act_arv_tm) {
		this.act_arv_tm = act_arv_tm;
	}

	/**
	 * Sets the act_dep_tm.
	 * @param act_dep_tm The act_dep_tm to set
	 */
	public void setAct_dep_tm(String act_dep_tm) {
		this.act_dep_tm = act_dep_tm;
	}

	/**
	 * Sets the actnid.
	 * @param actnid The actnid to set
	 */
	public void setActnid(String actnid) {
		this.actnid = actnid;
	}

	/**
	 * Sets the c_book.
	 * @param c_book The c_book to set
	 */
	public void setC_book(double c_book) {
		this.c_book = c_book;
	}

	/**
	 * Sets the c_cfg.
	 * @param c_cfg The c_cfg to set
	 */
	public void setC_cfg(double c_cfg) {
		this.c_cfg = c_cfg;
	}

	/**
	 * Sets the c_chkin.
	 * @param c_chkin The c_chkin to set
	 */
	public void setC_chkin(double c_chkin) {
		this.c_chkin = c_chkin;
	}

	/**
	 * Sets the chgreas.
	 * @param chgreas The chgreas to set
	 */
	public void setChgreas(String chgreas) {
		this.chgreas = chgreas;
	}

	/**
	 * Sets the dep_sts.
	 * @param dep_sts The dep_sts to set
	 */
	public void setDep_sts(String dep_sts) {
		this.dep_sts = dep_sts;
	}

	/**
	 * Sets the dom_int_x.
	 * @param dom_int_x The dom_int_x to set
	 */
	public void setDom_int_x(String dom_int_x) {
		this.dom_int_x = dom_int_x;
	}

	/**
	 * Sets the f_book.
	 * @param f_book The f_book to set
	 */
	public void setF_book(double f_book) {
		this.f_book = f_book;
	}

	/**
	 * Sets the f_cfg.
	 * @param f_cfg The f_cfg to set
	 */
	public void setF_cfg(double f_cfg) {
		this.f_cfg = f_cfg;
	}

	/**
	 * Sets the f_chkin.
	 * @param f_chkin The f_chkin to set
	 */
	public void setF_chkin(double f_chkin) {
		this.f_chkin = f_chkin;
	}

	/**
	 * Sets the first_leg_flt_dt.
	 * @param first_leg_flt_dt The first_leg_flt_dt to set
	 */
	public void setFirst_leg_flt_dt(String first_leg_flt_dt) {
		this.first_leg_flt_dt = first_leg_flt_dt;
	}

	/**
	 * Sets the flt_num.
	 * @param flt_num The flt_num to set
	 */
	public void setFlt_num(String flt_num) {
		this.flt_num = flt_num;
	}

	/**
	 * Sets the kactyp.
	 * @param kactyp The kactyp to set
	 */
	public void setKactyp(String kactyp) {
		this.kactyp = kactyp;
	}

	/**
	 * Sets the key_sch_dep_dt.
	 * @param key_sch_dep_dt The key_sch_dep_dt to set
	 */
	public void setKey_sch_dep_dt(String key_sch_dep_dt) {
		this.key_sch_dep_dt = key_sch_dep_dt;
	}

	/**
	 * Sets the l_f.
	 * @param l_f The l_f to set
	 */
	public void setL_f(String l_f) {
		this.l_f = l_f;
	}

	/**
	 * Sets the leg_num.
	 * @param leg_num The leg_num to set
	 */
	public void setLeg_num(String leg_num) {
		this.leg_num = leg_num;
	}

	/**
	 * Sets the regno.
	 * @param regno The regno to set
	 */
	public void setRegno(String regno) {
		this.regno = regno;
	}

	/**
	 * Sets the rsvn.
	 * @param rsvn The rsvn to set
	 */
	public void setRsvn(String rsvn) {
		this.rsvn = rsvn;
	}

	/**
	 * Sets the sch_arv_tm.
	 * @param sch_arv_tm The sch_arv_tm to set
	 */
	public void setSch_arv_tm(String sch_arv_tm) {
		this.sch_arv_tm = sch_arv_tm;
	}

	/**
	 * Sets the sch_dep_dt.
	 * @param sch_dep_dt The sch_dep_dt to set
	 */
	public void setSch_dep_dt(String sch_dep_dt) {
		this.sch_dep_dt = sch_dep_dt;
	}

	/**
	 * Sets the sch_dep_tm.
	 * @param sch_dep_tm The sch_dep_tm to set
	 */
	public void setSch_dep_tm(String sch_dep_tm) {
		this.sch_dep_tm = sch_dep_tm;
	}

	/**
	 * Sets the spot_in.
	 * @param spot_in The spot_in to set
	 */
	public void setSpot_in(String spot_in) {
		this.spot_in = spot_in;
	}

	/**
	 * Sets the spot_out.
	 * @param spot_out The spot_out to set
	 */
	public void setSpot_out(String spot_out) {
		this.spot_out = spot_out;
	}

	/**
	 * Sets the stnfr.
	 * @param stnfr The stnfr to set
	 */
	public void setStnfr(String stnfr) {
		this.stnfr = stnfr;
	}

	/**
	 * Sets the stnto.
	 * @param stnto The stnto to set
	 */
	public void setStnto(String stnto) {
		this.stnto = stnto;
	}

	/**
	 * Sets the supply.
	 * @param supply The supply to set
	 */
	public void setSupply(String supply) {
		this.supply = supply;
	}

	/**
	 * Sets the surname.
	 * @param surname The surname to set
	 */
	public void setSurname(String surname) {
		this.surname = surname;
	}

	/**
	 * Sets the svc.
	 * @param svc The svc to set
	 */
	public void setSvc(String svc) {
		this.svc = svc;
	}

	/**
	 * Sets the time_x.
	 * @param time_x The time_x to set
	 */
	public void setTime_x(String time_x) {
		this.time_x = time_x;
	}

	/**
	 * Sets the timestamp.
	 * @param timestamp The timestamp to set
	 */
	public void setTimestamp(String timestamp) {
		this.timestamp = timestamp;
	}

	/**
	 * Sets the y_book.
	 * @param y_book The y_book to set
	 */
	public void setY_book(double y_book) {
		this.y_book = y_book;
	}

	/**
	 * Sets the y_cfg.
	 * @param y_cfg The y_cfg to set
	 */
	public void setY_cfg(double y_cfg) {
		this.y_cfg = y_cfg;
	}

	/**
	 * Sets the y_chkin.
	 * @param y_chkin The y_chkin to set
	 */
	public void setY_chkin(double y_chkin) {
		this.y_chkin = y_chkin;
	}

	/**
	 * Returns the sch_dep_dt_kst.
	 * @return String
	 */
	public String getSch_dep_dt_kst() {
		return sch_dep_dt_kst;
	}

	/**
	 * Sets the sch_dep_dt_kst.
	 * @param sch_dep_dt_kst The sch_dep_dt_kst to set
	 */
	public void setSch_dep_dt_kst(String sch_dep_dt_kst) {
		this.sch_dep_dt_kst = sch_dep_dt_kst;
	}

	/**
	 * Returns the act_dep_dt_kst.
	 * @return String
	 */
	public String getAct_dep_dt_kst() {
		return act_dep_dt_kst;
	}

	/**
	 * Sets the act_dep_dt_kst.
	 * @param act_dep_dt_kst The act_dep_dt_kst to set
	 */
	public void setAct_dep_dt_kst(String act_dep_dt_kst) {
		this.act_dep_dt_kst = act_dep_dt_kst;
	}

	/**
	 * Returns the hideInfo.
	 * @return String
	 */
	public String getHideInfo() {
		return hideInfo;
	}

	/**
	 * Sets the hideInfo.
	 * @param hideInfo The hideInfo to set
	 */
	public void setHideInfo(String hideInfo) {
		this.hideInfo = hideInfo;
	}

	/**
	 * @return
	 */
	public String getStaffNum() {
		return staffNum;
	}

	/**
	 * @param string
	 */
	public void setStaffNum(String string) {
		staffNum = string;
	}

	/**
	 * @return sort
	 */
	public String getSort() {
		return sort;
	}

	/**
	 * @param sort Ϸ sort
	 */
	public void setSort(String sort) {
		this.sort = sort;
	}

	/**
	 * 20150603 ߰
	 */
	public String getSch_dep_dt_loc() {
		return sch_dep_dt_loc;
	}
	public void setSch_dep_dt_loc(String sch_dep_dt_loc) {
		this.sch_dep_dt_loc = sch_dep_dt_loc;
	}
	
	/**
	 * 2016.12.26 ߰
	 */
	public String getEst_dep_tm() {
		return est_dep_tm;
	}
	public void setEst_dep_tm(String est_dep_tm) {
		this.est_dep_tm = est_dep_tm;
	}
	
	public String getEst_arv_tm() {
		return est_arv_tm;
	}
	public void setEst_arv_tm(String est_arv_tm) {
		this.est_arv_tm = est_arv_tm;
	}
	
	/**
	 * 2017.01.11 ߰
	 */
	
	public String getTkof_t() {
		return tkof_t;
	}
	
	public void setTkof_t(String tkof_t) {
		this.tkof_t = tkof_t;
	}
	
	//@2019-01-22
	public String getEst_dep_dt() {
		return est_dep_dt;
	}	
	public void setEst_dep_dt(String est_dep_dt) {
		this.est_dep_dt = est_dep_dt;
	}
	public String getEst_arv_dt() {
		return est_arv_dt;
	}	
	public void setEst_arv_dt(String est_arv_dt) {
		this.est_arv_dt = est_arv_dt;
	}
}
