package kal.base.skd.query;

import kal.base.jdf.com.Logger;
import kal.base.skd.dbbean.SkdA080BG;
import kal.base.com.query.*;
import kal.base.com.util.StringUtil;

 /**
   * RAD SQL 
   * @author Copyright (c) 2009/10/15 
   */    
public class SkdA080Query {
	private static SkdA080Query instance = new SkdA080Query();
	
	public static SkdA080Query getInstance() {
		return instance;
	}
	
	/** 
	  * KACTYP ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/10/15 
	  */
	public String selKactyp() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT KACTYP, PAX_Y ");
		sql.append(" FROM CM_ACTYP_T ");
		sql.append(" WHERE ACTIVE = 'Y' ");
		sql.append(" ORDER BY PRTY_NO ");
		
		System.out.println("[BASE:SkdA080Query:selKactyp] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * RAD Main ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/10/15 
	  */
	public String selMain(SkdA080BG params, String kactyp) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT S.KACTYP, S.REGNO, S.FLT_NUM ");
		//sql.append(" FROM DAILY_SCH_T S, "); //2009.10.30 Ͻ Ʒ ̺ 
		sql.append(" FROM DAILY_SCH_X@BASEDEV S, ");
		sql.append(" (SELECT A.KACTYP, NVL(B.RAD_DT, SYSDATE-3) RAD_TIMESTAMP, A.PRTY_NO ");
		sql.append(" FROM CM_ACTYP_T A, ADMRAD_JOB_T B ");
		sql.append(" WHERE A.ACTIVE = 'Y' ");
		
		if (!kactyp.equals("")) {
			sql.append(" AND A.KACTYP IN ("+kactyp+") ");
		}
		
		sql.append(" AND B.JOB_D(+) = TO_DATE('20"+params.getDt()+"','YYYYMMDD') "); 
		sql.append(" AND A.KACTYP = B.KACTYP(+)) T ");
		sql.append(" WHERE S.EST_DEP_DT >= TO_DATE('20"+params.getDt()+" 0000','YYYYMMDD HH24MI') ");
		sql.append(" AND S.EST_DEP_DT <= TO_DATE('20"+params.getDt()+" 2359','YYYYMMDD HH24MI') ");
		sql.append(" AND S.ACTNID <> 'CNL' ");
		sql.append(" AND DEP_STS IN ('SCH','EST') ");
		sql.append(" AND ADMRAD = 'R' ");
		sql.append(" AND S.KACTYP = T.KACTYP ");
		sql.append(" AND S.TIMESTAMP >= T.RAD_TIMESTAMP ");
		sql.append(" ORDER BY  T.PRTY_NO, S.KACTYP, S.REGNO, S.EST_DEP_DT ");
		
		System.out.println("[BASE:SkdA080Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ޼ ۼҶ ʿ TIME ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/10/19 
	  */
	public String selTime(SkdA080BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(TO_DATE('20"+params.getDt()+"','YYYYMMDD'),'DDMON') DDMON, ");
		sql.append(" TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS') TIMESTAMP, ");
		sql.append(" TO_CHAR(SYSDATE-9/24, 'DDHH24MI') UTCTIME ");
		sql.append(" FROM DUAL ");
		
		System.out.println("[BASE:SkdA080Query:selTime] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ⵵  ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/10/20 
	  */
	public String selAirport(SkdA080BG params, String kactyp) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT S.STNFR ");
		//sql.append(" FROM DAILY_SCH_T S, "); //2009.10.30 Ͻ Ʒ ̺ 
		sql.append(" FROM DAILY_SCH_X@BASEDEV S, ");
		sql.append(" (SELECT A.KACTYP, NVL(B.RAD_DT, SYSDATE-3) RAD_TIMESTAMP, A.PRTY_NO ");
		sql.append(" FROM CM_ACTYP_T A, ADMRAD_JOB_T B ");
		sql.append(" WHERE A.ACTIVE = 'Y' ");
		sql.append(" AND A.KACTYP IN ("+kactyp+") "); //kactyp ݵ ִ!
		sql.append(" AND B.JOB_D(+) = TO_DATE('20"+params.getDt()+"','YYYYMMDD') "); 
		sql.append(" AND A.KACTYP = B.KACTYP(+)) T ");
		sql.append(" WHERE S.EST_DEP_DT >= TO_DATE('20"+params.getDt()+" 0000','YYYYMMDD HH24MI') ");
		sql.append(" AND S.EST_DEP_DT <= TO_DATE('20"+params.getDt()+" 2359','YYYYMMDD HH24MI') ");
		sql.append(" AND S.ACTNID <> 'CNL' ");
		sql.append(" AND DEP_STS IN ('SCH','EST') ");
		sql.append(" AND ADMRAD = 'R' ");
		sql.append(" AND S.KACTYP = T.KACTYP ");
		sql.append(" AND S.TIMESTAMP >= T.RAD_TIMESTAMP ");
		sql.append(" UNION ");
		sql.append(" SELECT S.STNTO ");
		//sql.append(" FROM DAILY_SCH_T S, "); //2009.10.30 Ͻ Ʒ ̺ 
		sql.append(" FROM DAILY_SCH_X@BASEDEV S, ");
		sql.append(" (SELECT A.KACTYP, NVL(B.RAD_DT, SYSDATE-3) RAD_TIMESTAMP, A.PRTY_NO ");
		sql.append(" FROM CM_ACTYP_T A, ADMRAD_JOB_T B ");
		sql.append(" WHERE A.ACTIVE = 'Y' ");
		sql.append(" AND A.KACTYP IN ("+kactyp+") "); //kactyp ݵ ִ!
		sql.append(" AND B.JOB_D(+) = TO_DATE('20"+params.getDt()+"','YYYYMMDD') "); 
		sql.append(" AND A.KACTYP = B.KACTYP(+)) T ");
		sql.append(" WHERE S.EST_DEP_DT >= TO_DATE('20"+params.getDt()+" 0000','YYYYMMDD HH24MI') ");
		sql.append(" AND S.EST_DEP_DT <= TO_DATE('20"+params.getDt()+" 2359','YYYYMMDD HH24MI') ");
		sql.append(" AND S.ACTNID <> 'CNL' ");
		sql.append(" AND DEP_STS IN ('SCH','EST') ");
		sql.append(" AND ADMRAD = 'R' ");
		sql.append(" AND S.KACTYP = T.KACTYP ");
		sql.append(" AND S.TIMESTAMP >= T.RAD_TIMESTAMP ");
		
		System.out.println("[BASE:SkdA080Query:selAirport] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SVC ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/11/16 
	  */
	public String selSvc(SkdA080BG params, String kactyp) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DISTINCT S.SVC ");
		//sql.append(" FROM DAILY_SCH_T S, "); //2009.10.30 Ͻ Ʒ ̺ 
		sql.append(" FROM DAILY_SCH_X@BASEDEV S, ");
		sql.append(" (SELECT A.KACTYP, NVL(B.RAD_DT, SYSDATE-3) RAD_TIMESTAMP, A.PRTY_NO ");
		sql.append(" FROM CM_ACTYP_T A, ADMRAD_JOB_T B ");
		sql.append(" WHERE A.ACTIVE = 'Y' ");
		sql.append(" AND A.KACTYP IN ("+kactyp+") "); //kactyp ݵ ִ!
		sql.append(" AND B.JOB_D(+) = TO_DATE('20"+params.getDt()+"','YYYYMMDD') "); 
		sql.append(" AND A.KACTYP = B.KACTYP(+)) T ");
		sql.append(" WHERE S.EST_DEP_DT >= TO_DATE('20"+params.getDt()+" 0000','YYYYMMDD HH24MI') ");
		sql.append(" AND S.EST_DEP_DT <= TO_DATE('20"+params.getDt()+" 2359','YYYYMMDD HH24MI') ");
		sql.append(" AND S.ACTNID <> 'CNL' ");
		sql.append(" AND DEP_STS IN ('SCH','EST') ");
		sql.append(" AND ADMRAD = 'R' ");
		sql.append(" AND S.KACTYP = T.KACTYP ");
		sql.append(" AND S.TIMESTAMP >= T.RAD_TIMESTAMP ");
		
		System.out.println("[BASE:SkdA080Query:selSvc] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ADDRESS ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/10/20 
	  */
	public String selAddress(String airport, String serviceType) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DISTINCT MA.MESSAGE_ADDRESS_BODY ");
		sql.append(" FROM MESSAGE_ADDRESS_POLICY@TEST1_KOPSDB MAP, ");
		sql.append(" MESSAGE_ADDRESS_POLICY_ADDRESS@TEST1_KOPSDB MAPA, ");
		sql.append(" MESSAGE_ADDRESS@TEST1_KOPSDB MA ");
		sql.append(" WHERE MAP.AIRLINE_CODE = 'KE' ");
		sql.append(" AND MAP.AIRPORT_CODE IN ("+airport+") ");
		sql.append(" AND MAP.SERVICE_TYPE_CATEGORY IN ("+serviceType+") ");
		sql.append(" AND MAP.CHANGE_TYPE_NAME = 'ADD' ");
		sql.append(" AND MAP.MESSAGE_ADDRESS_POLICY_ID = MAPA.MESSAGE_ADDRESS_POLICY_ID ");
		sql.append(" AND MAPA.MESSAGE_ADDRESS_ID = MA.MESSAGE_ADDRESS_ID ");
		sql.append(" AND MA.MESSAGE_ADDRESS_TYPE = 'SITA' ");
		sql.append(" AND MA.EXPIRATION_DATE IS NULL ");
		
		System.out.println("[BASE:SkdA080Query:selAddress] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * MSG  SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/10/20 
	  */
	public String insMsTelexMsgT(String origin, String msg, String projectNo) {
		StringBuffer sql = new StringBuffer();
		
		//sql.append(" INSERT INTO MS_TELEX_MSG_T "); 2009.10.30 Ͻ Ʒ ̺ 
		sql.append(" INSERT INTO MS_TELEX_MSG_X ");
		sql.append(" (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ");
		sql.append(" ORIGIN_ADDR, MESSAGE, PRIORITY, PROJECT_NO, PROCESSED, ERROR_REPLY)");
		sql.append(" VALUES ('BASERAD', SYSDATE, UNI_SEQ.NEXTVAL, 1, 1, ");
		sql.append(" '"+origin+"', '"+msg+"', 1, '"+projectNo+"', 'Y', '') "); //׽Ʈ ϴ  Y
		
		System.out.println("[BASE:SkdA080Query:insMsTelexMsgT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ADMRAD_JOB_T ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/10/20 
	  */
	public String selAdmradJobT(SkdA080BG params, String kactyp) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(RAD_DT, 'YYYYMMDDHH24MISS') RAD_DT ");
		sql.append(" FROM ADMRAD_JOB_T ");
		sql.append(" WHERE JOB_D = TO_DATE('20"+params.getDt()+"','YYYYMMDD') ");
		sql.append(" AND KACTYP = '"+kactyp+"' ");
		
		System.out.println("[BASE:SkdA080Query:selAdmradJobT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ADMRAD_JOB_T Է SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/10/20 
	  */
	public String insAdmradJobT(SkdA080BG params, String kactyp, String regno) { //regno = 'HL7554 HL7584...'
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO ADMRAD_JOB_T(JOB_D, KACTYP, REGNO_E, RAD_DT) ");
		sql.append(" VALUES (TO_DATE('20"+params.getDt()+"','YYYYMMDD'), '"+kactyp+"', '"+regno+"', TO_DATE('"+params.getTimestamp()+"','YYYYMMDDHH24MISS')) ");
		
		System.out.println("[BASE:SkdA080Query:insAdmradJobT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ADMRAD_JOB_T  SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/10/20 
	  */
	public String updAdmradJobT(SkdA080BG params, String kactyp) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE ADMRAD_JOB_T ");
		sql.append(" SET RAD_DT = TO_DATE('"+params.getTimestamp()+"','YYYYMMDDHH24MISS'), ");
		sql.append(" RACES_DT = '', ");
		sql.append(" FOIS_DT = '' ");
		sql.append(" WHERE JOB_D = TO_DATE('20"+params.getDt()+"','YYYYMMDD') ");
		sql.append(" AND KACTYP = '"+kactyp+"' ");
		
		System.out.println("[BASE:SkdA080Query:updAdmradJobT] sql : "+sql.toString());
		return sql.toString();
	}
}
