package kal.base.sta.query;

import kal.base.jdf.com.Logger;
import kal.base.sta.dbbean.*;
import kal.base.com.query.*;

 /**
   * OPS Statistics/Operation Status-LEG SQL 
   * @author Copyright (c) 2005/01/26 HIST  
   */  
public class StaQ110Query {
	
	private static StaQ110Query instance = new StaQ110Query();
	
	public static StaQ110Query getInstance() {
		return instance;
	}
	
	/** 
	  * OPS Statistics/Operation Status-LEG Main ȸ SQLԼ.
	  * @param params StaQ110BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/01/26 HIST 
	  */
	public String selMain(StaQ110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Stnfr,Stnto,Decode(Actnid,'CNL','CNL','NEW') Actnid,Count(*) Data_Cnt, 'A' Flt_Mode,");
		sql.append("            Nvl(Sum(F_Cfg + Y_Cfg + Y_Cfg),0) Supply,Nvl(Sum(F_Chkin + C_Chkin + Y_Chkin),0) Onboard");
		sql.append(" From Daily_Sch_t");
		sql.append(" Where Arln_cd = 'KE' And");
		sql.append(" 			SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.31 ߰ :  FLT 
		sql.append("            Sch_Dep_Dt >= To_Date('"+params.getFrom_date()+" 0000','yyyymmdd hh24mi') And");
		sql.append("        	Sch_Dep_Dt <= To_Date('"+params.getTo_date()+" 2358','yyyymmdd hh24mi') And");
		sql.append("        	Timestamp >= Sch_Dep_Dt - 39/24 And");
		//DOM/INT/CGO ȸ
		sql.append(ComQ01Query.getInstance().selDomIntQ(params.getDom_int_x()));
		//Regular ȸ
		if (params.getReg_x().equals("REGULAR"))
			sql.append("            Svc In ('J','F','M') And");
		else if (params.getReg_x().equals("NONREG"))
			sql.append("            Svc In ('G','A','C','H') And");
		else if (params.getReg_x().equals("NONREV"))
			sql.append("            Svc In ('J','F','M','G','A','C','H') And");
		//Station ȸ
		if (!params.getStn().equals(""))
			sql.append("            (Stnfr = '"+params.getStn()+"' Or Stnto = '"+params.getStn()+"') And");
		sql.append("			Stnfr <> Stnto And");
		sql.append("        	Dep_Sts <> 'INI'");
		sql.append(" Group By Stnfr,Stnto,Decode(Actnid,'CNL','CNL','NEW')");
		sql.append(" Union");
		sql.append(" Select Stnfr,Stnto,'NEW' Actnid,Count(*) Data_Cnt,'B' Flt_Mode,0 Supply,0 Onboard");
		sql.append(" From Daily_Sch_t");
		sql.append(" Where Arln_cd = 'KE' And");
		sql.append(" 			SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.31 ߰ :  FLT 
		sql.append("            Sch_Dep_Dt >= To_Date('"+params.getFrom_date()+" 0000','yyyymmdd hh24mi') And");
		sql.append("        	Sch_Dep_Dt <= To_Date('"+params.getTo_date()+" 2358','yyyymmdd hh24mi') And");
		//ð ȸ
		if (!params.getStart_tm().equals(""))
			sql.append("       Act_Dep_dt - Sch_Dep_Dt > "+params.getStart_tm()+"/1440 And");
		else 
			sql.append("       Act_Dep_dt - Sch_Dep_Dt > 3/1440 And");
		if (!params.getEnd_tm().equals(""))	
			sql.append("       Act_Dep_dt - Sch_Dep_Dt < "+params.getEnd_tm()+"/1440 And");
		sql.append("       	 	Dep_Sts <> 'INI'  And");
		//DOM/INT/CGO ȸ
		sql.append(ComQ01Query.getInstance().selDomIntQ(params.getDom_int_x()));
		//Regular ȸ
		if (params.getReg_x().equals("REGULAR"))
			sql.append("            Svc In ('J','F','M') And");
		else if (params.getReg_x().equals("NONREG"))
			sql.append("            Svc In ('G','A','C','H') And");
		else if (params.getReg_x().equals("NONREV"))
			sql.append("            Svc In ('J','F','M','G','A','C','H') And");
		//Station ȸ
		if (!params.getStn().equals(""))
			sql.append("            (Stnfr = '"+params.getStn()+"' Or Stnto = '"+params.getStn()+"') And");
		sql.append("			Stnfr <> Stnto And");
		sql.append("        	Actnid  <> 'CNL'");
		sql.append(" Group By Stnfr, Stnto");
		sql.append(" Order By Stnfr,Stnto,Flt_Mode,Actnid");
				
		//Logger.debug.println("[BASE:StaQ110Query:selMain] sql : "+sql.toString());
		System.out.println("[BASE:StaQ110Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}	
}
