package kal.base.sta.query;

import kal.base.jdf.com.Logger;
import kal.base.sta.dbbean.*;
import kal.base.com.query.*;

 /**
   * OPS Statistics/Flying Time Status-REG SQL 
   * @author Copyright (c) 2005/01/27 HIST  
   */  
public class StaQ320Query {
	
	private static StaQ320Query instance = new StaQ320Query();
	
	public static StaQ320Query getInstance() {
		return instance;
	}
	
	/** 
	  * OPS Statistics/Flying Time Status-REG Main ȸ SQLԼ.
	  * @param params StaQ320BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/01/27 HIST 
	  */
	public String selMain(StaQ320BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Kactyp, Regno, Svc, Decode(Region_Leg,'1','DOM','INT') Region_Leg,");
		sql.append("           Count(*) Data_Cnt, Sum((Act_Arv_dt - Act_Dep_Dt) * 24) Dly_Tm");
		sql.append(" From Daily_Sch_T");
		sql.append(" Where Arln_Cd = 'KE'        And");
		sql.append(" 			SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.31 ߰ :  FLT 
		sql.append("            Sch_Dep_Dt >= To_Date('"+params.getFrom_date()+" 0000','yyyymmdd hh24mi') And");
		sql.append("       		Sch_Dep_Dt <= To_Date('"+params.getTo_date()+" 2359','yyyymmdd hh24mi') And");
		sql.append("       		Actnid  <> 'CNL'  And");
		if (!params.getActyp().equals(""))
			sql.append("       		Kactyp = '"+params.getActyp()+"'  And");
		sql.append("       		Stnfr   <> Stnto");
		sql.append(" Group By Kactyp , Regno, Svc,  Decode(Region_Leg,'1','DOM','INT')");
		sql.append(" Order by Kactyp,Regno");
				
		//Logger.debug.println("[BASE:StaQ320Query:selMain] sql : "+sql.toString());
		System.out.println("[BASE:StaQ320Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}	
	
}//end of class
