package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.SupA320BG;
import kal.base.com.query.ComQ01Query;

 /**
   * Q-LIST WEATHER LIST SQL 
   * @author Copyright (c) 2005/06/28 
   */
public class SupA320Query {
	private static SupA320Query instance = new SupA320Query();
	
	public static SupA320Query getInstance() {
		return instance;
	}
	
	/** 
	  * Q-LIST WEATHER LIST main ȸ SQLԼ.	
	  * @param entity SupA310BG Q-LIST WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/06/28 
	  */
	public String selMain(SupA320BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT TO_CHAR(TIMESTMP-9/24,'yymmdd hh24miss') TIMESTMP, MSG_SEQ, MSG_TYP, MSG_TEXT, COR_Y ");
		sql.append(" FROM BS_WEATHER_QUE_T ");
		sql.append(" ORDER BY TIMESTMP DESC ");
		
		Logger.debug.println("[BASE:SupA320Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Q-LIST WEATHER LIST  SQLԼ.
	  * @param entity SupA310BG Q-LIST WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/06/29 
	  */
	public String delMain(SupA320BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE FROM BS_WEATHER_QUE_T ");
		sql.append(" WHERE TIMESTMP = TO_DATE('"+ entity.getTimestmp() +"','yymmdd hh24miss') + 9/24 AND");
		sql.append(" 		   MSG_SEQ = "+ entity.getMsg_seq());
		
		Logger.debug.println("[BASE:SupA320Query:delMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Q-LIST WEATHER LIST  SQLԼ.
	  * @param entity SupA310BG Q-LIST WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/07 
	  */
	public String updMain(SupA320BG entity){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE BS_WEATHER_QUE_T ");
		sql.append(" SET MSG_TEXT = '"+ entity.getMsg_text() +"', ");
		sql.append(" MSG_TYP = '"+ entity.getMsg_typ() +"', "); //2010.02.08 ߰
		sql.append(" COR_Y = 'Y' ");
		sql.append(" WHERE TIMESTMP = TO_DATE('"+ entity.getTimestmp() +"','yymmdd hh24miss') + 9/24 AND");
		sql.append(" 		   MSG_SEQ = "+ entity.getMsg_seq());
		
		Logger.debug.println("[BASE:SupA320Query:updMain] sql : "+sql.toString());
		return sql.toString();
	}
}
