package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * BASE2 ETOP Airport Management  Query
 * ۼ ¥: 2005-05-27
 * @author: HIST  
 */
public class SupA650Query {
	private static SupA650Query instance = new SupA650Query();
	
	public static SupA650Query getInstance() {
		return instance;
	}

	/** 
	  * BASE2 ETOP Airport Management ȸ SQLԼ.
	  * @param params SupA650BG Parameter Object
	  * @return String Query  
	  * @author Copyright (c) 2005/05/27 HIST 
	  */
	public String selETOPInfo(SupA650BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT *");
		sql.append(" FROM BS_ETOP_PORT_T");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"'");
		sql.append(" AND ARR_STN = '"+params.getArr_stn()+"'");
		
		Logger.debug.println("[BASE:SupA650Query:selETOPInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BASE2 ETOP Airport Management  SQLԼ.
	  * @param params SupA650BG Parameter Object
	  * @return String Query  
	  * @author Copyright (c) 2005/05/27 HIST 
	  */
	public String delETOPInfo(SupA650BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE BS_ETOP_PORT_T");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"'");
		sql.append(" AND ARR_STN = '"+params.getArr_stn()+"'");
		
		Logger.debug.println("[BASE:SupA650Query:delETOPInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2 ETOP Airport Management Է SQLԼ.
	  * @param params SupA650BG Parameter Object
	  * @param etop_stn String ETOPAiport Station's
	  * @return String Query  
	  * @author Copyright (c) 2005/05/27 HIST 
	  */
	public String insETOPInfo(SupA650BG params, String etop_stn) {
		StringBuffer sql = new StringBuffer();

		sql.append(" INSERT INTO BS_ETOP_PORT_T");
		sql.append(" VALUES ('"+params.getDep_stn()+"','"+params.getArr_stn()+"','"+etop_stn+"',SYSDATE,'"+params.getUser_id()+"')");
		
		Logger.debug.println("[BASE:SupA650Query:insETOPInfo] sql : "+sql.toString());
		return sql.toString();
	}	
}//end of class
