package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.sup.dbbean.*;

 /**
   * Weather World Wide SQL 
   * @author Copyright (c) 2005/09/05 
   */
public class SupQ520Query {
	private static SupQ520Query instance = new SupQ520Query();
	
	public static SupQ520Query getInstance() {
		return instance;
	}

	/** 
	  * Weather World Wide Main ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/09/05 
	  */
	public String selWorldWeatherWatch(){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT 	A.ICAO_PORT,A.IATA_PORT,A.WX_STS,DECODE(A.VIS,'9999','More than 10Km',A.VIS||'m') VIS,A.WIND,A.TEMP,");
		//sql.append("        		DECODE(A.WDIR,'NW','ϼǳ','N','ǳ','NE','ϵǳ','E','ǳ','SE','ǳ','S','ǳ','SW','ǳ','W','ǳ') WDIR,");
		sql.append("        		A.WDIR, "); //2010.01.26  : ǥ 
		sql.append("        		B.PORT_E,NVL(B.COORD_X1,0) COORD_X1,NVL(B.COORD_Y1,0) COORD_Y1,");
		sql.append("        		C.DESC_E,C.OTHRS_E,C.CODE_C,TO_CHAR(A.METAR_DTG,'DDMONYY HH24MI')||'Z' METAR_DTG");
		sql.append(" FROM  BS_WEATHER_WATCH_T A, CM_PORT_T B,");
		sql.append("     		(SELECT CODE_C,DESC_E,OTHRS_E");
		sql.append("      		  FROM CODE_T");
		sql.append("      		  WHERE STEP_X = '9' ");
		//sql.append("      		  AND CODE_X = 'WXR STS') C");
		sql.append("      		  AND CODE_X = 'WXR STS2') C");
		sql.append(" WHERE A.ICAO_PORT = B.ICAO_PORT");
		sql.append(" AND A.WX_STS = C.CODE_C(+)");
		sql.append(" AND B.WX_ACTIVE = 'W'");
		sql.append(" AND (B.COORD_X1 > 0 AND B.COORD_Y1 > 0)");
		sql.append(" AND (A.METAR_DTG >= SYSDATE-9/24-3/24 OR A.TAF_DTG >= SYSDATE-9/24-2)");

		Logger.debug.println("[BASE:SupQ510Query:selWorldWeatherWatch] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Weather Station ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/09/05 
	  */
	public String selBsPortT(){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT 	ICAO_PORT, IATA_PORT");
		sql.append(" FROM  CM_PORT_T");

		Logger.debug.println("[BASE:SupQ510Query:selWorldWeatherWatch] sql : "+sql.toString());
		return sql.toString();
	}	
}
