package kal.base.sys.query;

import kal.base.jdf.com.Logger;
import kal.base.sys.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * BASE2 Log System  Query
 * ۼ ¥: 2005-04-04
 * @author: HIST  
 */
public class SysA010Query {
	private static SysA010Query instance = new SysA010Query();
	
	public static SysA010Query getInstance() {
		return instance;
	}
	
	/** 
	  * BASE2   ȸ SQLԼ.
	  * @param empNo String User ID
	  * @param randomC String Random Code
	  * @return String Query  
	  * @author Copyright (c) 2005/04/04 HIST 
	  */
	//public String selUserInfo(String empNo,String pswdNo) {
	public String selUserInfo(String empNo,String randomC) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select A.Emp_No,A.Project_C,A.Login_Y,A.Auth_Pmsn,B.Kor_N,B.Dept_C");
		sql.append(" From Password_Auth_T A,Password_T B");
		sql.append(" Where A.Emp_No = B.Emp_No And");
		sql.append("       		((A.Emp_No = '"+empNo.toUpperCase()+"') Or (B.It_Id = '"+empNo.toUpperCase()+"')) And");
		sql.append("       		Random_c = '"+randomC.toUpperCase()+"' And");
		/*
			if (!(empNo.toUpperCase()).equals("GUEST"))
			sql.append("       		Translate(B.Pswd_No,'OK6IEV2MAS8RBTD4FG3L1JN70QPH9ZXUYW5C','0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ') = '"+pswdNo.toUpperCase()+"' And");
		*/
		sql.append("       		A.PROJECT_C = 'BASE2'");
		
		Logger.debug.println("[BASE:SysA010Query:selUserInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2    - LogIn SQLԼ.
	  * @param params SysA010BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2005/04/06 HIST 
	  */
	public String updUserInfo(SysA010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Update Password_Auth_t");
		sql.append(" Set 	Use_Cnt = (Select Use_Cnt+1 From Password_Auth_t Where Emp_No = '"+params.getEmp_no().toUpperCase()+"' And Project_c = 'BASE2'),");
		sql.append("     	Login_d = sysdate,");
		sql.append("     	Login_y = 'Y',");
		sql.append("     	Ip_n = '"+params.getIp_n()+"',");
		sql.append("     	Pc_n = '"+params.getPc_n()+"',");
		sql.append("     	Random_c = ''");
		sql.append(" Where Emp_No = '"+params.getEmp_no().toUpperCase()+"' And");
		sql.append("       		Project_c = 'BASE2'");
		
		Logger.debug.println("[BASE:SysA010Query:updUserInfo] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * BASE2    - LogOut SQLԼ.
	  * @param params SysA010BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2005/04/06 HIST 
	  */
	public String updUserOut(SysA010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Update Password_Auth_t");
		sql.append(" Set 	Login_y = 'N',");
		sql.append(" 		Random_c = '"+params.getRandom_c()+"'");
		sql.append(" Where Emp_No = '"+params.getEmp_no().toUpperCase()+"' And");
		sql.append("       		Project_c = 'BASE2'");
		
		Logger.debug.println("[BASE:SysA010Query:updUserOut] sql : "+sql.toString());
		System.out.println("[BASE:SysA010Query:updUserOut] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Random Code Է/ SQLԼ.
	  * @param String empNo, String projectC, String rndmCd
	  * @return String Query 
	  * @author Copyright (c) 2007/12/21 
	  */
	public String updRndmCd(String empNo, String projectC, String rndmCd) {
		StringBuffer sql = new StringBuffer();	
		
		sql.append(" UPDATE PASSWORD_AUTH_T ");
		sql.append(" SET RANDOM_C = '"+ rndmCd +"' ");
		sql.append(" WHERE EMP_NO = '"+ empNo +"' ");
		sql.append(" 	AND PROJECT_C = '"+ projectC +"' ");
		
		Logger.debug.println("[SIGN:SysA010Query:updRndmCd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Random Code ȸ SQLԼ.
	  * @param String empNo, String projectC, String rndmCd
	  * @return String Query 
	  * @author Copyright (c) 2007/12/21 
	  */
	public String selRndmCd(String empNo, String projectC) {
		StringBuffer sql = new StringBuffer();	
		
		sql.append(" SELECT EMP_NO, PROJECT_C, RANDOM_C ");
		sql.append(" FROM PASSWORD_AUTH_T ");
		sql.append(" WHERE EMP_NO = '"+ empNo +"' ");
		sql.append(" 	AND PROJECT_C = '"+ projectC +"' ");
		
		Logger.debug.println("[SIGN:SysA010Query:selRndmCd] sql : "+sql.toString());
		return sql.toString();
	}
		
}//end of class
