package kal.base.com.ejb;
import kal.base.jdf.db.BusinessException;
import java.util.List;
import java.util.Vector;
import java.util.Hashtable;
/**
 * Remote interface for Enterprise Bean: ComAllSL
 */
public interface ComAllSL extends javax.ejb.EJBObject {
	/** 
	  * DB Table ȸ Լ.
	  *  Table SELECT ,TABLE,ȸ,ORDERBY  ȸѴ
	  *  Լ  DB TABLE FLEXIBLE ȸ   ȸϴ
	  * @param arrParam String[] ȸ  [0]SELECT [1]TABLE [2]WHERE [3]ORDERBY [4]SELECT
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/06 HIST 
	  */
	public List selDbTable(String[] arrParam)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  *  DB ð ȸ SQLԼ.
	  * @param format String Return Date Format  ex) YYYYMMDD
	  * @param setTime String  ð ex) GMT : 540/1440   KST : 0
	  * @return String ȸ DB Time
	  * @exception Exception
	  * @author Copyright (c) 2005/01/06 HIST 
	  */
	public String selDbTime(String format, String setTime)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * ACTYP ȸ Լ.
	  * @return Vector ȸ ACTYP
	  * @exception Exception
	  * @author Copyright (c) 2005/01/27 HIST 
	  */
	public Vector selActyp() throws BusinessException, java.rmi.RemoteException;
	/** 
	  * Desk Description ȸ Լ.
	  * @param String descE Desk_Code
	  * @return String ȸ Code_x
	  * @exception Exception
	  * @author Copyright (c) 2005/02/05 HIST 
	  */
	public String selDesk(String deskX)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * FTS  ȸ SQLԼ.
	  * @param empNo String USER ID
	  * @return String ȸ FTS 
	  * @exception Exception
	  * @author Copyright (c) 2005/04/26 HIST 
	  */
	public String selFtsAuth(String empNo)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * FTS Menu ȸ SQLԼ.
	  * @return String ȸ FTS Menu
	  * @exception Exception
	  * @author Copyright (c) 2005/04/27 HIST 
	  */
	public Hashtable selFtsMenu()
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * Region Flight ȸ SQLԼ.
	  * @param fltNum String Flight Number
	  * @return String ȸ Region Flight Code
	  * @exception Exception
	  * @author Copyright (c) 2005/04/26 HIST 
	  */
	public String getRegionFlt(String fltNum)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * Region X ȸ SQLԼ.
	  * @param stnFr String  Station From
	  * @param stnTo String  Station To
	  * @return String ȸ Region X Code
	  * @exception Exception
	  * @author Copyright (c) 2005/04/26 HIST 
	  */
	public String getRegionX(String stnFr, String stnTo)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  *  IP Check Լ.
	  * @param arrIP String[]  IP Code
	  * @return boolean  
	  * @exception Exception
	  * @author Copyright (c) 2005/05/04 HIST 
	  */
	public boolean selIpCheck(String[] arrIP)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * IROPS ߻  ȸ SQLԼ.
	  * @return Hashtable ȸ IROPSǼ
	  * @exception Exception
	  * @author Copyright (c) 2005/07/05 HIST 
	  */
	public Hashtable selIropsData()
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * Area Code ȸ SQLԼ.
	  * @return List ȸ Area Code
	  * @exception Exception
	  * @author Copyright (c) 2005/07/05 HIST 
	  */
	public List selAreaList(String mode)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>Java Mail Sending Լ</b>. 
	  * @param from String  
	  * @param to String[] ޴»
	  * @param subject String 
	  * @param contents String 
	  * @return  String Mail ۽  
	  * @exception Exception
	  * @author Copyright (c) 2004/07/20 HIST 
	  */
	public String sendMail(String host,
		String from,
		String[] to,
		String subject,
		String contents)
		throws BusinessException, java.rmi.RemoteException;
	/**
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String getNaiRange() throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param host
	 * @param from
	 * @param to
	 * @param subject
	 * @param contents
	 * @param printedAt
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String sendMailNOTAM(String host, String from, String[] to, String subject, String contents, String printedAt) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param flt_num
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selFlightPlan(String flt_num) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param name_n
	 * @param flt_num
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String confirmFlightPlan(String name_n, String flt_num) throws BusinessException, java.rmi.RemoteException;
	/** 
	  * Irops Image Titles
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2012/01/15 
	  */
	public Hashtable selIropsImgTitles() throws BusinessException,java.rmi.RemoteException;

}
