package kal.base.iro.ejb;
import kal.base.jdf.db.BusinessException;
import java.util.*;
import kal.base.iro.dbbean.IroA010BG;
import java.util.Hashtable;
import kal.base.iro.dbbean.IroA020BG;
import kal.base.iro.dbbean.IroA030BG;
import kal.base.iro.dbbean.IroA040BG;
import kal.base.iro.dbbean.IroA110BG;
import kal.base.iro.dbbean.IroQ120BG;
import kal.base.iro.dbbean.IroA050BG;
import kal.base.iro.dbbean.IroQ060BG;
import kal.base.iro.dbbean.IroQ130BG;
import kal.base.iro.dbbean.IroQ070BG;
import kal.base.iro.dbbean.IroQ140BG;
import kal.base.iro.dbbean.IroQ260BG;
import kal.base.iro.dbbean.IroQ280BG;
import kal.base.iro.dbbean.IroA270BG;
import kal.base.iro.dbbean.IroQ290BG;

import kal.base.iro.dbbean.IroQ210BG;
import kal.base.iro.dbbean.IroQ220BG;
import kal.base.iro.dbbean.IroQ230BG;
import kal.base.iro.dbbean.IroQ240BG;
import kal.base.iro.dbbean.IroA310BG;
import kal.base.iro.dbbean.IroA320BG;
import kal.base.iro.dbbean.IroA330BG;
import kal.base.iro.dbbean.IroA340BG;
import kal.base.iro.dbbean.IroQ350BG;
import kal.base.iro.dbbean.IroQ360BG;
import kal.base.iro.dbbean.IroQ370BG;
import kal.base.iro.dbbean.IroQ410BG;
import kal.base.iro.dbbean.IroQ420BG;
import kal.base.iro.dbbean.IroQ430BG;
import kal.base.iro.dbbean.IroQ440BG;
import kal.base.iro.dbbean.IroQ450BG;
import kal.base.iro.dbbean.IroQ460BG;
import kal.base.iro.dbbean.IroQ470BG;
import kal.base.iro.dbbean.IroQ510BG;
import kal.base.iro.dbbean.IroQ520BG;

import kal.base.iro.dbbean.IroQ710BG;//@2013-10-xx
import kal.base.iro.dbbean.IroA810BG;//@2013-10-xx
/**
 * Remote interface for Enterprise Bean: IroAllSL
 */
public interface IroAllSL extends javax.ejb.EJBObject {
	
	/** 
	  * <b>IRR/DSS Current Flight Schedule Desk Select Code ȸԼ</b>. 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public Hashtable selIroA010Desk()
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS Current Flight Schedule Alert Message ԷԼ</b>. 
	  * @param params IroA010BG Է Parameter
	  * @return String Է ϷῩ Y/N
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String insIroA010AlertMsg(IroA010BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS Current Flight Schedule Alert Message ȸԼ</b>. 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public Hashtable selIroA010AlertMsg()
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS Current Flight Schedule Alert Message ExpireԼ</b>. 
	  * @param params IroA010BG  Parameter & 
	  * @return String  ϷῩ Y/N
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String updIroA010AlertMsg(IroA010BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS Current Flight Schedule Job Select ȸԼ</b>. 
	  * @param params IroA010BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public Hashtable selIroA010Job(IroA010BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS Current Flight Schedule Main ȸԼ</b>. 
	  * @param params IroA010BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public Hashtable selIroA010Main(IroA010BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS Current Flight Schedule IROPS Data Լ</b>. 
	  * @param newData IroA010BG NEW   NEW DATA
	  * @param hashParam Hashtable Grid Data
	  * @return Hashtable FLAG:忩, MSG:ش Flight Message
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public Hashtable insIroA010Irops(IroA010BG newData,Hashtable hashParam)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS  IROPS Flight Status Main ȸԼ</b>. 
	  * @param params IroA020BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public Hashtable selIroA020Main(IroA020BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS  IROPS Flight Status Լ</b>. 
	  * @param params IroA020BG ȸ
	  * @return String ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String delIroA020Irops(IroA020BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS  Option Comparison Main ȸԼ</b>. 
	  * @param params IroA030BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public Hashtable selIroA030Main(IroA030BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS  Option Comparison Flight Info ȸԼ</b>. 
	  * @param params IroA030BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public Hashtable selIroA030FltInfo(IroA030BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS  Option Comparison Option Suggest ԷԼ</b>. 
	  * @param params IroA030BG Է
	  * @return String Է¸޼
	  * @exception Exception
	  * @author Copyright (c) 2005/02/05 HIST 
	  */
	public String insIroA030OptionDesk(IroA030BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS  Option Comparison Comments ȸԼ</b>. 
	  * @param params IroA030BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public Hashtable selIroA030Comments(IroA030BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS  Option Comparison Check List Item ȸԼ</b>. 
	  * @param params IroA030BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public Hashtable selIroA030Check(IroA030BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS  Option Comparison Comments Լ</b>. 
	  * @param params IroA030BG ȸ
	  * @return String  Message
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String updIroA030Comments(IroA030BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS  Decision Making&Action Main ȸԼ</b>. 
	  * @param params IroA040BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/07 HIST 
	  */
	public Hashtable selIroA040Main(IroA040BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS  Decision Making&Action Main Լ</b>. 
	  * @param params IroA040BG ȸ
	  * @return String  
	  * @exception Exception
	  * @author Copyright (c) 2005/02/07 HIST 
	  */
	public String updIroA040Main(IroA040BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  *  IROPS REPORT main ȸԼ. 
	  * @param params IroA110BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/01 
	  */
	public Hashtable selIroA110Main(IroA110BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  *  IROPS REPORT main update Լ. 
	  * @param params IroA110BG 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/01 
	  */
	public int updIroA110Main(IroA110BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  *  Daily IROPS REPORT main ȸԼ. 
	  * @param params IroQ120BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 
	  */
	public Hashtable selIroQ120Main(IroQ120BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * ADDR BOOK ȸԼ. 
	  * @param params IroA050BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/04 
	  */
	public Hashtable selIroA050Addr(IroA050BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  *  Message Board  Լ. 
	  * @param params IroA050BG 
	  * @return String  
	  * @exception Exception
	  * @author Copyright (c) 2005/02/07 
	  */
	public String insIroA050Message(IroA050BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IROPS Queue Main ȸԼ</b>. 
	  * @param params IroQ060BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/04/26 HIST 
	  */
	public Hashtable selIroQ060Main(IroQ060BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * SKD   Process Update Լ. 
	  * @param params IroQ130BG 
	  * @return int returnValue(0 : update , 1 : update , 2 : update  Ǿƴ)
	  * @exception Exception
	  * @author Copyright (c) 2005/04/22 
	  */
	public int updIroQ130Process(IroQ130BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * SKD   ȸ Լ. 
	  * @param params IroQ130BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/04/25 
	  */
	public Hashtable selIroQ130Main(IroQ130BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IROPS Message Main ȸԼ</b>. 
	  * @param params IroQ070BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/07/04 HIST 
	  */
	public Hashtable selIroQ070Main(IroQ070BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>IRR/DSS  IROPS MULTI Data Լ</b>. 
	  * @param hashParam Hashtable Grid Data
	  * @return boolean 忩
	  * @exception Exception
	  * @author Copyright (c) 2005/07/08 HIST 
	  */
	public boolean insIroA080Irops(Hashtable hashParam)
		throws BusinessException, java.rmi.RemoteException;

	/** 
	  *  Monthly IROPS REPORT main ȸԼ.
	  * @param params IroQ140BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/07/13 
	  */
	public Hashtable selIroQ140Main(IroQ140BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  *  Dailly IROPS REPORT main update Լ. 
	  * @param params IroA120BG 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/01 
	  */
	public int updIroQ120Main(Hashtable hashData)
		throws BusinessException, java.rmi.RemoteException;
	/** DSS Messenger List main ȸԼ. 
	  * @param params IroQ260BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/12/20 
	  */
	public Hashtable selIroQ260Main(IroQ260BG params)
		throws BusinessException, java.rmi.RemoteException;
	/**
	  *  DSS Messenger ȸԼ. 
	  * @param params IroQ280BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/12/20 
	  */
	public Hashtable selIroQ280Main(IroQ280BG params)
		throws BusinessException, java.rmi.RemoteException;
	/**
	  *  DSS Messenger Է Լ. 
	  * @param params IroA270BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/12/20 
	  */
	public int insIroA270Main(IroA270BG params)
		throws BusinessException, java.rmi.RemoteException;
	/**
	  *  DSS Messenger Popup ȸԼ. 
	  * @param params IroQ290BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/12/20 
	  */
	public Hashtable selIroQ290Main(IroQ290BG params)
		throws BusinessException, java.rmi.RemoteException;
	/**
	  *  DSS Messenger Popup ȸԼ. 
	  * @param params IroQ290BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/12/20 
	  */
	public Hashtable selIroQ290Detail(IroQ290BG params)
		throws BusinessException, java.rmi.RemoteException;
	//****************************************************************************************************************
	//****************************************************************************************************************
	//****************************************************************************************************************
	//****************************************************************************************************************
	// 2006.01.12 ߰

	public Hashtable selIroQ210Main(IroQ210BG params)
		throws BusinessException, java.rmi.RemoteException;
	public Hashtable selIroQ220Main(IroQ220BG params)
		throws BusinessException, java.rmi.RemoteException;
	public Hashtable selIroQ230Main(IroQ230BG params)
		throws BusinessException, java.rmi.RemoteException;
	public Hashtable selIroQ240Main(IroQ240BG params)
		throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroA310Main(IroA310BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroA310IropsFlt(IroA310BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param newData
	 * @param keyData
	 * @param hashParam
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable insIroA310Irops(IroA310BG newData, IroA310BG keyData, Hashtable hashParam) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String selIroA310chkIropsFlt(IroA310BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroA320Main(IroA320BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroA320CheckList(IroA320BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroA320DeskInfo(IroA320BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String updIroA320CheckList(IroA320BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String updIroA320Confirm(IroA320BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param dssStartDt
	 * @param seqNum
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String selIroA320TitleE(String dssStartDt, String seqNum) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroA330IropsInfo(IroA330BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroA330Main(IroA330BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable updIroA330AppRej(IroA330BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroA340Main(IroA340BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroA340AddrBook(IroA340BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable insIroA340MsgSend(IroA340BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String updIroA340Processed(IroA340BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ350Main(IroQ350BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String selIroQ350ProcessX(IroQ350BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ360Main(IroQ360BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String selIroQ360ProcessX(IroQ360BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ370Main(IroQ370BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String selIroQ370ProcessX(IroQ370BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ410Main(IroQ410BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ420Main(IroQ420BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ430Main(IroQ430BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ440Main(IroQ440BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ430IropsReport(IroQ430BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ450Main(IroQ450BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String updIroQ460OccGoc(IroQ460BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ460Main(IroQ460BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ460IropsMsg(IroQ460BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ460HistoryMsg(IroQ460BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ450DssMsg(IroQ450BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String selIroQ450CheckIssue(IroQ450BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ450Message(IroQ450BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String selIroQ450CheckComplete(IroQ450BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String insIroQ450Message(IroQ450BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroA320MsgInfo(IroA320BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroA320TSPaxInfo(IroA320BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ470Main(IroQ470BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroA310DeskCode() throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String updIroQ420HideY(IroQ420BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ430User() throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ510Main(IroQ510BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ520Main(IroQ520BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String delIroA320Irops(IroA320BG params) throws BusinessException, java.rmi.RemoteException;
	
	/**@2013-10-xx
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ710Main(IroQ710BG params) throws BusinessException, java.rmi.RemoteException;
	/**@2013-10-xx
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroQ711Main(IroQ710BG params) throws BusinessException, java.rmi.RemoteException;
	/**@2013-10-xx
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selIroA810Main(IroA810BG params) throws BusinessException, java.rmi.RemoteException;
	/**@2013-10-xx
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String insIroA810(IroA810BG params) throws BusinessException, java.rmi.RemoteException;
	/**@2013-10-xx
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String updIroA810(IroA810BG params) throws BusinessException, java.rmi.RemoteException;
	/**@2013-10-xx
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String delIroA810(IroA810BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	  * 20151021
	  * UMS  ߰
	 */
	public String selDssIropsMsgStr(IroA340BG params) throws BusinessException, java.rmi.RemoteException;
}
