package kal.base.com.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.com.ejb.ComAllSL;
import kal.base.sys.dbbean.*;

/**
 * IROPS ߻  ȸ Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/07/05 HIST  
 */
public class ComQ010Serv extends PublicBaseServlet{
	/** 
	  *  IROPS ߻  ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/05 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//EJB LookUp
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			Hashtable hashData  = sl.selIropsData();
			req.setAttribute("hashData",hashData);
			req.setAttribute("startParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:ComQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:ComQ010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
