package kal.base.com.serv;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.OutputStream;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.StringUtil;
import kal.base.jdf.com.Logger;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;

/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class fileDown extends PublicBaseServlet{
	
	private final int DEFAULT_BUFFER_SIZE = 4096;
    private final String clientEncoding = "euc-kr"; 
    private final String jvmEncoding = System.getProperty("file.encoding");	

	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String prefix = StringUtil.checkString(box.getString("prefix"));					
		//String filename = StringUtil.toKSC5601(box.getString("filename"));
		String filename = StringUtil.unescape(box.getString("filename"));			
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			
			if( filename.indexOf("..") != -1){ 
	            res.setContentType("text/plain;charset="+clientEncoding);
	            throw new Exception ("file[" + filename + "] could not contains \"..\" for security");
	        }
	
	        File file = new File(prefix + filename);
	        //System.out.println("######### file.getAbsolutePath()====>" + file.getAbsolutePath()); //2008.03.28
	        if (!file.exists()){
	            res.setContentType("text/plain;charset="+clientEncoding);
	            throw new Exception ("file[" + filename + "] does not exist in the directory, "+ prefix);
	            //throw new Exception ("file[" + filename + "] does not exist in the directory, "+ file.getAbsolutePath() + " <- file.getAbsolutePath()");
	        }
	        
	        String filename_8859_1 = new String(filename.getBytes("EUC-KR"),"ISO-8859-1");
	        String client = req.getHeader("User-Agent");
	        res.reset();
	        
	        if (client.indexOf("MSIE 5.5") != -1) {
	            res.setHeader("Content-Type", "doesn/matter;charset=8859_1");
	            res.setHeader("Content-Disposition", "filename="+filename_8859_1 +";");
	        } 
	        else {
	            res.setHeader("Content-Type", "application/octet-stream;charset=8859_1");
	            res.setHeader("Content-Disposition", "attachment; filename="+filename_8859_1+";");
	        }
	        
	        res.setHeader("Content-Transfer-Encoding", "binary;");
	        res.setHeader("Pragma", "no-cache;");
	        res.setHeader("Expires", "-1;");
	        res.setHeader("Content-Length", ""+file.length() );
	
	        InputStream in = null;
	        OutputStream os = null;
	        ServletOutputStream fout = res.getOutputStream();
	
	        try {
	            in = new FileInputStream(file);
	            os = res.getOutputStream();
	
	            byte[] buf = new byte[4096]; //buffer size 4K.
	            int count = 0;
	            
	            while ((count = in.read(buf)) != -1) {
	                os.write(buf,0,count);
	                os.flush();
	            }
	
	        } catch(Exception e) {
	        	throw new Exception(e.getMessage());
	        }
	        
	        finally {
	            if(in != null) try{in.close();}catch(Exception e){}
	            if(os != null) try{os.close();}catch(Exception e){}
	        }

		} catch(Exception e) {
				Logger.debug.println("[BASE:fileDown:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
		} 
	}//end checkTask

}
