package kal.base.com.wbsvc;

import java.util.*;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.ejb.EJBFinder; 
import kal.base.ocb.ejb.OcbAllSL;
import kal.base.ocb.dbbean.OcbQ010BG;

public class WbSvcIropsStatus {
	
	public WbSvcIropsStatus() { }
	
	/** 
	  * IROPS STATUS ȸ
	  * QRS  񽺿
	  *  3 
	  */
	public String iropsStatus() { 
		
		String returnValue = "";
		
		try {
			//Parameter 
			String reportD = ComUtil.getInstance().selDbTime("YYYYMMDD","0");
			
			//EJB LookUp
			OcbAllSL sl = (OcbAllSL)EJBFinder.lookup("ejb/OcbAllSL");			
			Hashtable hashData = sl.selOcbQ010IropsStatus(reportD, "Y");
			
			int cnt = 0;
			
			if (hashData != null) {
				List listIrops = (List)hashData.get("IROPS_LIST_ALL");
				if (listIrops != null &&listIrops.size() > 0) {
					for (int i=0; i<listIrops.size(); i++) {
						// KE1020|08JUL^KE0024|07JUL^KE0072|07JUL  .
						// 2010.08.19  : KE1306|19AUG|KWJ/GMP^KE1908|19AUG|CJU/KWJ^KE0953|19AUG|TAS/CAI  .
						if (cnt < 3) {
							if (cnt == 0) {
								returnValue = "KE" + StringUtil.checkString(((OcbQ010BG)listIrops.get(i)).getIrops_flt_num()) + "|" 
													+ StringUtil.checkString(((OcbQ010BG)listIrops.get(i)).getIrops_ddmon()) + "|" 
													+ StringUtil.checkString(((OcbQ010BG)listIrops.get(i)).getIrops_stnfr()) + "/" 
													+ StringUtil.checkString(((OcbQ010BG)listIrops.get(i)).getIrops_stnto());
							} else {
								returnValue = returnValue + "^" + "KE" + StringUtil.checkString(((OcbQ010BG)listIrops.get(i)).getIrops_flt_num()) + "|" 
													+ StringUtil.checkString(((OcbQ010BG)listIrops.get(i)).getIrops_ddmon()) + "|" 
													+ StringUtil.checkString(((OcbQ010BG)listIrops.get(i)).getIrops_stnfr()) + "/" 
													+ StringUtil.checkString(((OcbQ010BG)listIrops.get(i)).getIrops_stnto());
							}
						}
						cnt++;
					}
				}
			}
			
			System.out.println("[BASE:WbSvcIropsStatus:iropsStatus]>>>>>"+returnValue);
		
		} catch (Exception e) {
			return "[BASE:WbSvcIropsStatus:iropsStatus:Exception] " + ((Exception)e).getMessage();
		} 
		
		return returnValue;
	} 
}
