package kal.base.ffs.daemon;

import java.util.Collection;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import kal.base.com.util.StringUtil;
import kal.base.ffs.dbbean.FfsA080BG;
import kal.base.ffs.ejb.FfsAllSL;
import kal.base.jdf.ejb.EJBFinder;

public class FfsA080DataMgr {
    public Collection getData(String rCd, String fromDt, String toDt, String naiRange){
    	Hashtable hashData = new Hashtable();
    	List list = new LinkedList();
    	
    	int rCnt = rCd.length() / 3;
    	
    	int fromD = Integer.parseInt(fromDt);
    	int toD     = Integer.parseInt(toDt);
    	
    	try{
    		
    		FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
    		
    		//  뼱  뼱 .   
    		String regionStr = "";
    		for(int a=0;a<rCnt;a++){
				String selectedRegion = rCd.substring(a*3, (a+1)*3);
				/*
				//@2018-08-29
				if(selectedRegion.equals("AME")||selectedRegion.equals("SEA")||selectedRegion.equals("JPN")){
				    regionStr += "'"+selectedRegion+"',";
				}*/
				regionStr += "'"+selectedRegion+"',";				
			}
    		regionStr = regionStr.substring(0, regionStr.length()-1);
    		   		
    		
    		FfsA080BG params = new FfsA080BG();
    		
    		params.setRegionCd(regionStr);
    		params.setFromDt(fromDt);
    		params.setToDt(toDt);
    		
    		list = sl.selFfsRouteTab(params);
    		
    		return list;
    		
    	}catch(Exception e){
    		return list;
    	}
    }
    
}
