package kal.base.ffs.daemon;

import java.io.*;
import java.util.*;
import java.text.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
//import kal.base.ffs.dbbean.FfsQ010BG;
import kal.base.ffs.dbbean.FfsQ020BG;

import kal.base.jdf.ejb.EJBFinder;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Released
 */
public class FfsQ020DataMgr {
	
	public Collection getData(String rCd, String fromDt, String toDt, String smiStr, String empNo, String naiRange){ //2007.06.04 ߰ : smiStr, empNo -> 2008.12.02 ߰ : naiRange
		
		// 2007.01.24 ߰ => Alert Rule ƿ´.
		HashMap alertRule = FfsQ020Daemon.alertRule;
		
		// 2007.06.04 ߰ => Acars Alert  ´.
		HashMap acarsAlert = FfsQ070Daemon.acarsAlert;
		
		HashMap hMap = FfsQ020Task.hMap;		//ͼ
		
		//System.out.println("FfsQ020Task.hMap.size() =====>"+hMap.size());
		
		//HashMap hashData = new HashMap();	//2007.06.15 
		Hashtable hashData = new Hashtable();	//´~
		
		//± ۼ
		String hTag1 = "<table width='100%' height='20' bgcolor='";
		String hTag2 = "' border='0' cellpadding='0' cellspacing='0' class='txt5'><tr><td align='center'>";
		String fTag = "</td></tr></table>";
			
		//RegionCd 
		int rCnt = rCd.length() / 3;	
		//FromDt, ToDt ڷ
		int fromD = Integer.parseInt(fromDt);
		int toD = Integer.parseInt(toDt);
		
		int lineCnt = 0;	
		int nextId = 0;
			
		//2007.06.04 ߰ ********************************************************************************
		HashMap fList = new HashMap();
		int fListId = 0;
		
		//fltNum  شϴ ͸ 
		for (int i=0; i<hMap.size(); i++) {
			//RegionCd üũ
			boolean rChk = false;
			String regionCd = ((FfsQ020BG)hMap.get(new Integer(i))).getRegionCd();
			for (int a=1; a<=rCnt ; a++) {
				if (regionCd.equals(rCd.substring((a-1)*3,a*3))) rChk = true;
			}
			
			//FromDt, ToDt üũ
			boolean dChk = false;
			int estDepDt = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getEstDepDt());
			if (estDepDt >= fromD && estDepDt <= toD) dChk = true;
			
			if (rChk && dChk) {
				fList.put(new Integer(fListId), ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum());
				fListId++;
			}
		}
		
		//SMI, FLT_NUM ݵ Ѵ Ѱ ̻  ϵ Ѵ.
		Hashtable tmData = new Hashtable();
		if (!smiStr.equals("") && fListId > 0){
			try {
				//EJB LookUp
				FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
				tmData = sl.selAcarsSmiRE(smiStr, fList);
				
			} catch(Exception e) {
				Logger.debug.println("[BASE:FfsQ020DataMgr:getData] "+((Exception)e).getMessage());
			}
		}
		//***********************************************************************************************
		
		for (int i=0; i<hMap.size(); i++) {
			
			//RegionCd üũ
			boolean rChk = false;
			String regionCd = ((FfsQ020BG)hMap.get(new Integer(i))).getRegionCd();
			for (int a=1; a<=rCnt ; a++) {
				if (regionCd.equals(rCd.substring((a-1)*3,a*3))) rChk = true;
			}
			
			//FromDt, ToDt üũ
			boolean dChk = false;
			int estDepDt = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getEstDepDt());
			if (estDepDt >= fromD && estDepDt <= toD) dChk = true;
			
			if (rChk && dChk) {
				
				// 2007.01.31 ߰ : ,Ž ˾
				String notEtd = ((FfsQ020BG)hMap.get(new Integer(i))).getEstDepDt();
				if(notEtd.length() == 10) notEtd = notEtd.substring(0,6);
				
				//  ±׿ ͸ Ѵ.
				FfsQ020BG entity = new FfsQ020BG();
				
				//String lcfD = ""; //2007.04.04 ߰ => 2007.04.09 ּó : Call Sign Բ 
				
				String callSignD = "";
				String acRegD = "";
				String acTypeD = "";
				String podD = "";
				String poaD = "";
				String etdD = "";
				//@2018-08-14
				String cobt			=	"";
				String cobtAlert	=	"";
				String tsat			=	"";
				String tsatAlert	=	"";
				
				String atdD = "";
				String etaD = "";
				String ftD = "";
				String altD = "";
				String routeD = ""; //2007.06.27 ߰
				String ccfD = ""; //2010.03.29 ߰
				String extraD = "";
				String cruiseModeD = "";
				String etopsD = "";
				String refileD = "";
				//String nfD = "";
				//String ntD = "";
				//String naD = "";
				//String neD = "";
				//String nrD = "";
				//String nraD = "";
				String notamD = ""; //2007.06.25  : NOTAM  ʵ ߰
				String acarsD = ""; //2007.06.04 ߰
				String pldD = ""; //2008.08.19 ߰
				String planId = ""; //2013-02-04 ߰
				String planNo = ""; //2013-02-04 ߰
				String etaMsg = ""; //2013-04-24
				
				// ALL_COLUMNS      ĥǾ Ѵ.
				String clrAllColumns = ((FfsQ020BG)hMap.get(new Integer(i))).getAllColumns();			
				
				//2007.05.21 ߰ : ¦θ  ̱.
				String bgColor = "";
				if (nextId % 2 == 0) bgColor = "#F0FFF0";
				else bgColor = "#FFFFFF";
				
				/*
				// 2007.04.04 ߰ => 2007.04.09  : Call Sign Բ  => 2007.06.27  :  
				// LCF 5% ==================================================================================================
				//String clrLcf = bgColor;
				String lcfRatio = "";
				if (((FfsQ020BG)hMap.get(new Integer(i))).getLcfRatio().equals("5")) { // LCF 5%϶ ǥѴ.
					lcfRatio = "&nbsp;" + "<img src='/BASERoot/images/5pro_btn.gif' width='20' height='11' border='0'>";
				}
				//if (!clrAllColumns.equals("")) clrLcf = clrAllColumns; // ALL_COLUMNS
				//lcfD = hTag1 + clrLcf + hTag2 + lcfRatio + fTag;
				*/
				
				// Call Sign ==================================================================================================
				String clrCallSign = ((FfsQ020BG)hMap.get(new Integer(i))).getFltNumColor();
				String callSignTag1 = "";
				String callSignTag2 = "";
				if (clrCallSign.equals("")) clrCallSign = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrCallSign) && tagAR.equals("FLT_NUM_COLOR")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					callSignTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"callSign_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					callSignTag2 = "</a>";
				}
				
				//2007.06.27 ߰ : Tankering T
				String tnkrIcon = "";
				if ((((FfsQ020BG)hMap.get(new Integer(i))).getTankeringY()).equals("Y")) {
					tnkrIcon = "<img src='/BASERoot/images/t_icon_new.gif' width='16' height='16' border='0' align='absmiddle'>";
				}
				//2007.06.27 ߰ : LCF 5%
				String lcf5Icon = "";
				//2008.10.28  : 
				//1. NAI_Y = 'Y' ̰ LCF_RATIO = '5' ̸,  N ǥ
				//2. NAI_Y = 'Y' ̰ LCF_RATIO = '5' ƴϸ, N ǥ
				//3. NAI_Y = 'Y' ƴϰ ALT_PORT ,  N ǥ
				//4. ׿ܴ  5% 꿡 .
				//2008.12.02 ߰ : NAI RANGE < SCH_ARV_DT - SCH_DEP_DT() ̸ NAI_Y = 'Y' -> 'N'
				if (naiRange.equals("")) naiRange = "180";
				String diffMin = ((FfsQ020BG)hMap.get(new Integer(i))).getDiffMin();
				//System.out.println("##### 2008.12.02 -----> "+((FfsQ020BG)hMap.get(new Integer(i))).getFltNum()+" / "+naiRange+" / "+diffMin+" / "+((FfsQ020BG)hMap.get(new Integer(i))).getNaiY());
				if ((((FfsQ020BG)hMap.get(new Integer(i))).getNaiY()).equals("Y") && Integer.parseInt(naiRange) >= Integer.parseInt(diffMin)) {
					/*if (((FfsQ020BG)hMap.get(new Integer(i))).getLcfRatio().equals("5")) {
						lcf5Icon = "<a onMouseOver='JavaScript:showInfo(\""+ "NAI  LCF 5% Ǿϴ." +"\", \"nCallSign_"+ lineCnt +"\", 80, 73)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/n_pink_blinking.gif' width='16' height='16' border='0' align='absmiddle'></a>";
					} else {
						lcf5Icon = "<img src='/BASERoot/images/n_pink_02.gif' width='16' height='16' border='0' align='absmiddle'>";
					}*/
					//2008.12.22  : ALT_PORT ִ üũ.
					if (((FfsQ020BG)hMap.get(new Integer(i))).getAltPort().length() == 3) {
						if (((FfsQ020BG)hMap.get(new Integer(i))).getLcfRatio().equals("5")) {
							//LCF 5%϶ Ʒ߿ Ѱ ش Ǹ ̴ 5  . ƴϸ Ϲ 5  .
							boolean lcf5Flg = false;
							//if ((((FfsQ020BG)hMap.get(new Integer(i))).getRegionCd()).equals("CHN")) lcf5Flg = true; 2009.09.21 .
							if ((((FfsQ020BG)hMap.get(new Integer(i))).getSactyp()).equals("AB6") || (((FfsQ020BG)hMap.get(new Integer(i))).getSactyp()).equals("ABF") || (((FfsQ020BG)hMap.get(new Integer(i))).getSactyp()).equals("GRJ")
							    || (((FfsQ020BG)hMap.get(new Integer(i))).getSactyp()).equals("74N")  || (((FfsQ020BG)hMap.get(new Integer(i))).getSactyp()).equals("388") ) lcf5Flg = true; //2012.03.06 : 74N, 388 ߰(Ե ű ǿ ش)
							//2008.06.24 ߰ : Area ߱̾ URC Ϲ 5  .
							//2009.09.21 .
							/*if (((((FfsQ020BG)hMap.get(new Integer(i))).getStnfr()).equals("URC") && (((FfsQ020BG)hMap.get(new Integer(i))).getStnto()).equals("ICN")) 
							|| ((((FfsQ020BG)hMap.get(new Integer(i))).getStnfr()).equals("ICN") && (((FfsQ020BG)hMap.get(new Integer(i))).getStnto()).equals("URC"))) {
								lcf5Flg = false;
							}*/
							//2007.07.06  : StringTokenizer ̻Ÿ..
							String allMel = ((FfsQ020BG)hMap.get(new Integer(i))).getMel();
							String allActypMel = ((FfsQ020BG)hMap.get(new Integer(i))).getActypMel();
							if (!allMel.equals("") && !allActypMel.equals("")) {
								StringTokenizer stMel = new StringTokenizer(allMel, " ");
								while(stMel.hasMoreTokens()) {
									String tokenMel = stMel.nextToken();
									StringTokenizer stActypMel = new StringTokenizer(allActypMel, " ");
									while(stActypMel.hasMoreTokens()) {
										String tokenActypMel = stActypMel.nextToken();
										if (tokenMel.equals(tokenActypMel)) lcf5Flg = true;
									}
								}
							}
							if (lcf5Flg) { //
								lcf5Icon = "<a onMouseOver='JavaScript:showInfo(\""+ "NAI /   LCF 5% Ǿϴ." +"\", \"nCallSign_"+ lineCnt +"\", 80, 83)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/5_icon01_new.gif' width='16' height='16' border='0' align='absmiddle'></a>";
							} else { 	//Ϲ
								lcf5Icon = "<a onMouseOver='JavaScript:showInfo(\""+ "NAI /   LCF 5% Ǿϴ." +"\", \"nCallSign_"+ lineCnt +"\", 80, 83)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/5_icon_new.gif' width='16' height='16' border='0' align='absmiddle'></a>";
							}
						} else {
							//2009.10.22  :  N (NAI ̳  ǽ ) ǥ ʴ´.
							//lcf5Icon = "<img src='/BASERoot/images/n_pink_01.gif' width='16' height='16' border='0' align='absmiddle'>";
						}
					} else {
						/*if (((FfsQ020BG)hMap.get(new Integer(i))).getLcfRatio().equals("5")) {
							lcf5Icon = "<a onMouseOver='JavaScript:showInfo(\""+ "NAI /  LCF 5% Ǿϴ." +"\", \"nCallSign_"+ lineCnt +"\", 80, 73)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/n_pink_blinking.gif' width='16' height='16' border='0' align='absmiddle'></a>";
						} else {
							lcf5Icon = "<img src='/BASERoot/images/n_pink_02.gif' width='16' height='16' border='0' align='absmiddle'>";
						}*/
						//2009.12.23  : NAI  ߿ LCF 5%    N -> Ϲ N   (NAI   Ϲ N  ǥ)
						lcf5Icon = "<img src='/BASERoot/images/n_pink_02.gif' width='16' height='16' border='0' align='absmiddle'>";
					}
				} else if (((FfsQ020BG)hMap.get(new Integer(i))).getAltPort().length() != 3) {
					lcf5Icon = "<a onMouseOver='JavaScript:showInfo(\""+ "NAI  ƴմϴ." +"\", \"nCallSign_"+ lineCnt +"\", 80, 83)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/n_pink_blinking.gif' width='16' height='16' border='0' align='absmiddle'></a>";
				} else {
					if (((FfsQ020BG)hMap.get(new Integer(i))).getLcfRatio().equals("5")) {
						//LCF 5%϶ Ʒ߿ Ѱ ش Ǹ ̴ 5  . ƴϸ Ϲ 5  .
						boolean lcf5Flg = false;
						//if ((((FfsQ020BG)hMap.get(new Integer(i))).getRegionCd()).equals("CHN")) lcf5Flg = true; 2009.09.21 .
						if ((((FfsQ020BG)hMap.get(new Integer(i))).getSactyp()).equals("AB6") || (((FfsQ020BG)hMap.get(new Integer(i))).getSactyp()).equals("ABF") || (((FfsQ020BG)hMap.get(new Integer(i))).getSactyp()).equals("GRJ")
							|| (((FfsQ020BG)hMap.get(new Integer(i))).getSactyp()).equals("74N")  || (((FfsQ020BG)hMap.get(new Integer(i))).getSactyp()).equals("388") ) lcf5Flg = true; //2012.03.06 : 74N, 388 ߰(Ե ű ǿ ش)
						//2008.06.24 ߰ : Area ߱̾ URC Ϲ 5  .
						//2009.09.21 .
						/*if (((((FfsQ020BG)hMap.get(new Integer(i))).getStnfr()).equals("URC") && (((FfsQ020BG)hMap.get(new Integer(i))).getStnto()).equals("ICN")) 
						|| ((((FfsQ020BG)hMap.get(new Integer(i))).getStnfr()).equals("ICN") && (((FfsQ020BG)hMap.get(new Integer(i))).getStnto()).equals("URC"))) {
							lcf5Flg = false;
						}*/
						//2007.07.06  : StringTokenizer ̻Ÿ..
						String allMel = ((FfsQ020BG)hMap.get(new Integer(i))).getMel();
						String allActypMel = ((FfsQ020BG)hMap.get(new Integer(i))).getActypMel();
						if (!allMel.equals("") && !allActypMel.equals("")) {
							StringTokenizer stMel = new StringTokenizer(allMel, " ");
							while(stMel.hasMoreTokens()) {
								String tokenMel = stMel.nextToken();
								StringTokenizer stActypMel = new StringTokenizer(allActypMel, " ");
								while(stActypMel.hasMoreTokens()) {
									String tokenActypMel = stActypMel.nextToken();
									if (tokenMel.equals(tokenActypMel)) lcf5Flg = true;
								}
							}
						}
						if (lcf5Flg) { //
							lcf5Icon = "<img src='/BASERoot/images/5_icon01_new.gif' width='16' height='16' border='0' align='absmiddle'>";
						} else { 	//Ϲ
							lcf5Icon = "<img src='/BASERoot/images/5_icon_new.gif' width='16' height='16' border='0' align='absmiddle'>";
						}
					}
				}
				//2007.06.28 ߰ : ѻ R
				String restrictIcon = "";
				if (!(((FfsQ020BG)hMap.get(new Integer(i))).getRestrictE()).equals("")) {
					restrictIcon = "<a onMouseOver='JavaScript:showInfo(\""+ ((FfsQ020BG)hMap.get(new Integer(i))).getRestrictE() +"\", \"rCallSign_"+ lineCnt +"\", 80, 101)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/r_icon_new.gif' width='16' height='16' border='0' align='absmiddle'></a>";
				}
				//2007.06.28 ߰ :  P
				String pmsnIcon = "";
				if ((((FfsQ020BG)hMap.get(new Integer(i))).getPmsn()).equals("Y") || (((FfsQ020BG)hMap.get(new Integer(i))).getPmsn()).equals("A")) {
					pmsnIcon = "<a href='JavaScript:popupPmsn(\""+ ((FfsQ020BG)hMap.get(new Integer(i))).getSchDepDt() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getFirstLegFltDt() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getStnfr() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getStnto() +"\")' style='cursor:hand'>";
					pmsnIcon += "<img src='/BASERoot/images/p_icon_new.gif' width='16' height='16' border='0' align='absmiddle'></a>";
				} else if ((((FfsQ020BG)hMap.get(new Integer(i))).getPmsn()).equals("N")) {
					pmsnIcon = "<a href='JavaScript:popupPmsn(\""+ ((FfsQ020BG)hMap.get(new Integer(i))).getSchDepDt() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getFirstLegFltDt() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getStnfr() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getStnto() +"\")' style='cursor:hand'>";
					pmsnIcon += "<img src='/BASERoot/images/p_icon01_new.gif' width='16' height='16' border='0' align='absmiddle'></a>";
				}
				//2007.11.28 ߰ : OUTFOB F
				String outfobIcon = "";
				if (!(((FfsQ020BG)hMap.get(new Integer(i))).getAcOutfob()).equals("0")) {//PE_ACARS_SKD_T.OUT_FOB 0 ƴҶ .
					if (!(((FfsQ020BG)hMap.get(new Integer(i))).getDiff()).equals("")) { //DIFF  .
						int diff = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getDiff());
						if (diff >= 2000) {
							outfobIcon = "<a onMouseOver='JavaScript:showInfo(\""+ "ž Ramp Fuel  FPL  "+ diff +"LBS ϴ." +"\", \"fCallSign_"+ lineCnt +"\", 90, 137)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/f_icon_new.gif' width='16' height='16' border='0' align='absmiddle'></a>";
						} else if (diff < 0) {
							outfobIcon = "<a onMouseOver='JavaScript:showInfo(\""+ "ž Ramp Fuel  FPL  "+ diff*(-1) +"LBS ϴ." +"\", \"fCallSign_"+ lineCnt +"\", 90, 137)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/f_icon_new.gif' width='16' height='16' border='0' align='absmiddle'></a>";
						}	
					}
				}
				//2011.12.06 ߰
				String manWxIcon = "";
				if(!(((FfsQ020BG)hMap.get(new Integer(i))).getManWxStnfr().equals(""))||!(((FfsQ020BG)hMap.get(new Integer(i))).getManWxStnto().equals(""))){
					manWxIcon = "<a href='JavaScript:viewAlertAPO(\""+ ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum() +"\",\""+((FfsQ020BG)hMap.get(new Integer(i))).getStnfr()+"\",\""+((FfsQ020BG)hMap.get(new Integer(i))).getStnto()+"\")' onMouseOver='JavaScript:showInfo(\"ALERT APO  Դϴ\", \"wCallSign_"+ lineCnt +"\", 80, 155)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					manWxIcon += "<img src='/BASERoot/images/w_icon.gif' width='16' height='16' border='0' align='absmiddle'></a>";
				}
				
				if (!clrAllColumns.equals("")) clrCallSign = clrAllColumns; //ALL_COLUMNS
				callSignD = hTag1 + clrCallSign + hTag2 + "<table border='0' cellpadding='0' cellspacing='0' class='txt5'><tr>" + callSignTag1 + "<td width='45' height='16'>&nbsp;&nbsp;<a href='JavaScript:popupFPL(\""+ ((FfsQ020BG)hMap.get(new Integer(i))).getFirstLegFltDt() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getStnfr() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getStnto() +"\")'>";
				callSignD += "<font class='txt5_line'>" + ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum() + "</font></a></td>" + callSignTag2 + "<td width='18'>" + tnkrIcon + "</td><td width='18'>" +  lcf5Icon + "</td><td width='18'>" + restrictIcon + "</td><td width='18'>" + pmsnIcon + "</td><td width='18'>" + outfobIcon + "</td><td width='18'>" + manWxIcon + "</td></tr></table>" + fTag;
				callSignD += "<div id='callSign_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				callSignD += "<div id='rCallSign_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>"; //2007.04.09 : LCF 5% ߰
				callSignD += "<div id='fCallSign_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>"; //2007.11.28 : OUTFOB ߰
				callSignD += "<div id='nCallSign_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>"; //2008.10.29 : N  ߰
				callSignD += "<div id='wCallSign_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>"; //2011.12.06 : W  ߰
								
				// A/C Reg ==================================================================================================				
				String clrAcReg = ((FfsQ020BG)hMap.get(new Integer(i))).getRegnoColor();
				String acRegTag1 = "";
				String acRegTag2 = "";
				String regMsg = "";
				if (clrAcReg.equals("")) clrAcReg = bgColor;
				else {//2011.12.26  : altMtow plnMtow ϴ  鼭.. str ܺη  str  ޽   
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						
						//2011.12.26  : dual mtow ߰  Ʒ ڵ ü
						//if (colorAR.equals(clrAcReg) && tagAR.equals("REGNO")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
						if (colorAR.equals(clrAcReg) && tagAR.equals("REGNO")) regMsg = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					acRegTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"acReg_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					acRegTag2 = "</a>";
				}
				if (!clrAllColumns.equals("")) clrAcReg = clrAllColumns; // ALL_COLUMNS
				
				//2007.06.27 ߰ : MEL
				String melIcon = "";
				if (!(((FfsQ020BG)hMap.get(new Integer(i))).getMel()).equals("")) {
					melIcon = "<a href='JavaScript:popupMel(\""+ ((FfsQ020BG)hMap.get(new Integer(i))).getRegno() +"\")'><img src='/BASERoot/images/m_icon_new.gif' width='15' height='16' border='0' align='absmiddle'></a>";
				}
				
				//2009.10.22 ߰ : UKFOS EXTRA FUEL
				//FLIGHT_PLAN_T.EXTR_FUEL(100) < CM_REGNO_T.EXTR_FUEL ̸ ̴ E  .
				String extrIcon = "";
				if (Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getExtrFuel())*100 < Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getRegnoExtrFuel())) {
					extrIcon = "<a onMouseOver='JavaScript:showInfo(\"Extra Fuel["+ ((FfsQ020BG)hMap.get(new Integer(i))).getExtrRsn() +":"+ ((FfsQ020BG)hMap.get(new Integer(i))).getRegnoExtrFuel() +"lbs]  ž\", \"eAcReg_"+ lineCnt +"\", 80, 214)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/E_flash_btn.gif' width='16' height='16' border='0' align='absmiddle'></a>";
				}
				
				//2011.12.26 ߰
				//2012.09.07  : multi mtow 
				String altMtowIcon = "";
				String multiMtowIcon = "";
				int altMtow = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getAltMtow());
				int plnMtow = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getPlnMtow());
								
				
				//2009.10.22  : Regno տ HL ڸ ؼ .
				String subRegno = "";
				if (((FfsQ020BG)hMap.get(new Integer(i))).getRegno().length() >= 2) subRegno = (((FfsQ020BG)hMap.get(new Integer(i))).getRegno()).substring(2);
				int firstRegnoNum = Integer.parseInt(subRegno.substring(0,1));
				
				if(firstRegnoNum==7){//HL  regno 7 Ҷ 
					if(altMtow == 753900 || altMtow == 573200 || altMtow == 588600 || altMtow == 701000 || altMtow == 820000 || altMtow == 910500){
					    multiMtowIcon = "M";
					}else if(altMtow == 155500 || altMtow == 507063 || altMtow == 654700 || altMtow == 511400 || altMtow == 559900 || altMtow == 615000 || altMtow == 738500 || altMtow == 844300 || altMtow == 478402){//@2014-02-20 || altMtow == 478402 ߰
						multiMtowIcon = "L";//2012.11.26 : 559600->559900 : 773
					}
				}else{
					if(altMtow == 753900 || altMtow == 573200 || altMtow == 588600 ||altMtow == 701000 || altMtow == 820000 || altMtow == 910500){
						//multiMtowIcon = "C";
						multiMtowIcon = "M";
					}else if(altMtow == 155500 || altMtow == 507063 || altMtow == 654700 || altMtow == 511400 || altMtow == 559900 || altMtow == 615000 || altMtow == 738500 || altMtow == 844300 || altMtow == 478402){//@2014-02-20 || altMtow == 478402 ߰
						//multiMtowIcon = "B";
						multiMtowIcon = "L";//2012.11.26 : 559600->559900 : 773
					}
				}
				
				if(altMtow>0){//2012.09.07  => 2012.09.07 :   ġ   L iconǥ 
					//altMtowIcon = "<img src='/BASERoot/images/L_icon.gif' width='16' height='16' border='0' align='absmiddle'>";
					//2012.11.21 : LOW, MIDDLE 뿡  شϴ (M, L ) ⺻  (Ķ)
					altMtowIcon = "<img src='/BASERoot/images/"+multiMtowIcon+"_icon_blue.gif' width='16' height='16' border='0' align='absmiddle'>";
				}
				
				//2011.12.26 ߰
				//ALTERNATE MTOW && PLAN MTOW    ٸ A/C Reg Field  ߰, 콺 Over Ʒ LABEL ǥ
				//2012.04.25 
                //ALTERNATE MTOW PLAN MTOW  ũ A/C Reg Field  ߰, 콺 Over Ʒ LABEL ǥ
				//2012.09.07  : * ALTERNATE MTOW  ذ̹Ƿ plan mtow ذ ũ  ǥ
				if(altMtow>0 && altMtow < plnMtow*100){//altMtow>0 && altMtow != plnMtow*100
					String mtowMsg = "&amp;lt;Wrong MTOW><br>";
					mtowMsg += "ذ : "+altMtow+"<br>";
					mtowMsg += "PLAN : "+plnMtow*100;
					if(!regMsg.equals("")){
					    regMsg = regMsg += "<br>------------------<br>"+mtowMsg;
					}else{
						regMsg = mtowMsg;
					}
					//altMtowIcon = "<img src='/BASERoot/images/L_icon_new.gif' width='16' height='16' border='0' align='absmiddle'>";//2012.08.07  :   ġ   L iconǥ
                    altMtowIcon = "<img src='/BASERoot/images/"+altMtowIcon+"_icon_red.gif' width='16' height='16' border='0' align='absmiddle'>";//2012.11.21  :   ġ   LOW, MIDDLE ߾ ϴ () 
					subRegno = "<blink><strong>"+subRegno+"</strong></blink>";
				}

				if((((FfsQ020BG)hMap.get(new Integer(i))).getSactyp()).equals("74N") && 	Integer.parseInt((((FfsQ020BG)hMap.get(new Integer(i))).getLdw()))<=5700){//@2014-02-06
					regMsg+=" B747-8F װ Կ    Ȯ";
					clrAcReg	=	"#AACCFF";
				}
				
				if(!regMsg.equals("")){
				    acRegTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ regMsg +"\", \"acReg_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					acRegTag2 = "</a>";
				}
				//@2014-02-21 hIcon
				String hIcon	=	"";
				
				if(((FfsQ020BG)hMap.get(new Integer(i))).getAltHightime().equals("Y")){
					hIcon	="<img src='/BASERoot/images/H_icon_green.gif' width='16' height='16' border='0' align='absmiddle' alt='HIGH TIME ENGINE'>";
				}
				
				acRegD = hTag1 + clrAcReg + "' border='0' cellpadding='0' cellspacing='0' class='txt5'><tr>" + acRegTag1 + "<td width='40' align='center'>"+ subRegno + "</td>" + acRegTag2 + "<td width='17' align='left'>" + melIcon + "</td><td width='18' align='left'>" + extrIcon + "</td><td width='18' align='left'>" + altMtowIcon + "</td><td width='18' align='left'>" + hIcon + "</td>" + fTag;//@2014-02-21 hIcon
				acRegD += "<div id='acReg_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				acRegD += "<div id='eAcReg_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				
				// A/C Type ==================================================================================================
				String clrAcType = bgColor;
				if (!clrAllColumns.equals("")) clrAcType = clrAllColumns; // ALL_COLUMNS
				acTypeD = hTag1 + clrAcType + hTag2 + ((FfsQ020BG)hMap.get(new Integer(i))).getSactyp() + fTag;
				
				// POD ==================================================================================================
				String clrPod = ((FfsQ020BG)hMap.get(new Integer(i))).getWxStnfr();
				String clrManPod = ((FfsQ020BG)hMap.get(new Integer(i))).getManWxStnfr();
				String stnfr = ((FfsQ020BG)hMap.get(new Integer(i))).getStnfr(); // 2007.01.31 ߰ : ,Ž ˾
				String podTag1 = "";
				String podTag2 = "";
				if (clrPod.equals("")&&clrManPod.equals("")) {
					clrPod = bgColor;
					podTag1 = "<a onClick='JavaScript:viewWeather(\""+ stnfr +"\")' style='cursor:hand'>";
					podTag2 = "</a>";
				} else {
					String str = "";
					//String manStr = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrPod) && tagAR.equals("WX_STNFR")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
						//if (colorAR.equals(clrManPod) && tagAR.equals("MAN_WX_STNFR")) manStr = "ALERT APO  Դϴ";
					}
					if (!clrManPod.equals("")) {//manStr.equals("")
						clrPod = clrManPod;
						String manStr = "ALERT APO  Դϴ";
						if(!str.equals("")){
							str = manStr + "<br>-----------------<br>" +str;
						}else{
							str = manStr;
						}
					}
					podTag1 = "<a onClick='JavaScript:viewWeather(\""+ stnfr +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"pod_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					podTag2 = "</a><div id='pod_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrPod = clrAllColumns; // ALL_COLUMNS
				podD = podTag1 + hTag1 + clrPod + hTag2 + stnfr + fTag + podTag2;
				
				// POA ==================================================================================================
				String clrPoa = ((FfsQ020BG)hMap.get(new Integer(i))).getWxStnto();
				String clrManPoa = ((FfsQ020BG)hMap.get(new Integer(i))).getManWxStnto();
				String stnto = ((FfsQ020BG)hMap.get(new Integer(i))).getStnto(); // 2007.01.31 ߰ : ,Ž ˾
				String poaTag1 = "";
				String poaTag2 = "";
				if (clrPoa.equals("")&&clrManPoa.equals("")) {
					clrPoa = bgColor;
					poaTag1 = "<a onClick='JavaScript:viewWeather(\""+ stnto +"\")' style='cursor:hand'>";
					poaTag2 = "</a>";
				} else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrPoa) && tagAR.equals("WX_STNTO")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					if(!clrManPoa.equals("")){
						clrPoa = clrManPoa;
						String manStr = "ALERT APO  Դϴ";
						if(!str.equals("")){
							str = manStr + "<br>-----------------<br>"+str;
						}else{
							str = manStr;
						}
					}
					poaTag1 = "<a onClick='JavaScript:viewWeather(\""+ stnto +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"poa_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					poaTag2 = "</a><div id='poa_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrPoa = clrAllColumns; // ALL_COLUMNS
				poaD = poaTag1 + hTag1 + clrPoa + hTag2 + stnto + fTag + poaTag2;
				
				// ETD ==================================================================================================
				String clrEtd = ((FfsQ020BG)hMap.get(new Integer(i))).getEtd();
				String etdTag1 = "";
				String etdTag2 = "";
				if (clrEtd.equals("")) clrEtd = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrEtd) && tagAR.equals("ETD")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					etdTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"etd_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					etdTag2 = "</a><div id='etd_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrEtd = clrAllColumns; // ALL_COLUMNS
				String tmpEtd = "";
				if (((FfsQ020BG)hMap.get(new Integer(i))).getEstDepDt().length() == 10) tmpEtd = ((FfsQ020BG)hMap.get(new Integer(i))).getEstDepDt().substring(6,8) + ":" + ((FfsQ020BG)hMap.get(new Integer(i))).getEstDepDt().substring(8,10);
				etdD = etdTag1 + hTag1 + clrEtd + hTag2 + tmpEtd + fTag + etdTag2;
								
				// COBT ==================================================================================================
				//@2018-08-14
				String clrCobt	=	((FfsQ020BG)hMap.get(new Integer(i))).getCobt();
				cobt	=	clrCobt;
				cobt	=	"00:00";
				
				// COBT_ALERT ==================================================================================================
				//@2018-08-14
				String clrCobtAlert	=	((FfsQ020BG)hMap.get(new Integer(i))).getCobtAlert();
				cobtAlert	=	clrCobtAlert;
				cobtAlert	=	"A";				
				
				// COBT ==================================================================================================
				//@2018-08-14
				String clrTsat	=	((FfsQ020BG)hMap.get(new Integer(i))).getTsat();
				tsat	=	clrTsat;
				tsat	=	"00:00";
				
				// COBT_ALERT ==================================================================================================
				//@2018-08-14
				String clrTsatAlert	=	((FfsQ020BG)hMap.get(new Integer(i))).getTsatAlert();
				tsatAlert	=	clrTsatAlert;
				tsatAlert	=	"A";
				
				// ATD ==================================================================================================
				String clrAtd = ((FfsQ020BG)hMap.get(new Integer(i))).getAtd();
				/*
				//2008.09.24 ߰ **************************************************************
				//(1) ATD ȵ  ETD SYSDATE-9 30̻ ̰  -> #81C6FE (BLUE)
				//(2) TKOF ȵ  ATD SYSDATE-9 30̻ ̰  -> #FA8885 (RED)
				if (((FfsQ020BG)hMap.get(new Integer(i))).getCheckRampout().equals("20000101")) {
					if (Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getDataEtd()) < 30) {
						clrAtd = "";
					} else {
						clrAtd = "#81C6FE";
					}
				} else {
					if (Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getDataRampout()) < 30) {
						if (Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getDataEtd()) < 30) {
							clrAtd = "";
						} else {
							clrAtd = "#81C6FE";
						}
					} else {
						clrAtd = "#FA8885";
					}
				}
				//*****************************************************************************
				 */
				String atdTag1 = "";
				String atdTag2 = "";
				if (clrAtd.equals("")) clrAtd = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrAtd) && tagAR.equals("ATD")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					atdTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"atd_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					atdTag2 = "</a><div id='atd_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrAtd = clrAllColumns; // ALL_COLUMNS
				String tmpAtd = "";
				if (((FfsQ020BG)hMap.get(new Integer(i))).getActDepDt().length() == 10) tmpAtd = ((FfsQ020BG)hMap.get(new Integer(i))).getActDepDt().substring(6,8) + ":" + ((FfsQ020BG)hMap.get(new Integer(i))).getActDepDt().substring(8,10);
				String blink1 = "";
				String blink2 = "";
				if (!tmpAtd.equals("")) {
					blink1 = "<blink><strong>";
					blink2 = "</strong></blink>";
				}
				atdD = atdTag1 + hTag1 + clrAtd + hTag2 + blink1 + tmpAtd + blink2 + fTag + atdTag2;
				
				// ETA ==================================================================================================
				String clrEta = ((FfsQ020BG)hMap.get(new Integer(i))).getEta();
				String etaTag1 = "";
				String etaTag2 = "";
				String gStr       = "";//2013-04-24
				if (clrEta.equals("")) clrEta = bgColor;
				else {
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrEta) && tagAR.equals("ETA")) gStr = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					etaTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ gStr +"\", \"eta_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					etaTag2 = "</a><div id='eta_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				//	2013-04-24  ߰	
				etaMsg=	 ((FfsQ020BG)hMap.get(new Integer(i))).getEtaMsg();
				if (etaMsg!=null && etaMsg.length()!=0){
					if(!gStr.equals("")){
						gStr +="<br/>";
					}else{
						clrEta = "#00FF00";
						
					}
					gStr+=etaMsg;
					etaTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ gStr +"\", \"eta_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					etaTag2 = "</a><div id='eta_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
					
				}
				
				if (!clrAllColumns.equals("")) clrEta = clrAllColumns; // ALL_COLUMNS
				String tmpEta = "";
				if (((FfsQ020BG)hMap.get(new Integer(i))).getEstArvDt().length() == 10) tmpEta = ((FfsQ020BG)hMap.get(new Integer(i))).getEstArvDt().substring(6,8) + ":" + ((FfsQ020BG)hMap.get(new Integer(i))).getEstArvDt().substring(8,10);
				etaD = etaTag1 + hTag1 + clrEta + hTag2 + tmpEta + fTag + etaTag2;
		
				// F/T ==================================================================================================
				String clrFt = ((FfsQ020BG)hMap.get(new Integer(i))).getFlyingTime();
				String ftTag1 = "";
				String ftTag2 = "";
				if (clrFt.equals("")) clrFt = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrFt) && tagAR.equals("FLYING_TIME")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					ftTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"ft_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					ftTag2 = "</a><div id='ft_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrFt = clrAllColumns; // ALL_COLUMNS
				ftD = ftTag1 + hTag1 + clrFt + hTag2 + ((FfsQ020BG)hMap.get(new Integer(i))).getAbhr() + fTag + ftTag2;
				
				// ALT ==================================================================================================
				String clrAlt = ((FfsQ020BG)hMap.get(new Integer(i))).getWxAltPort();
				String clrManAlt = ((FfsQ020BG)hMap.get(new Integer(i))).getManWxAltPort();
				String altPort = ((FfsQ020BG)hMap.get(new Integer(i))).getAltPort(); // 2007.01.31 ߰ : ,Ž ˾
				String altTag1 = "";
				String altTag2 = "";
				if (clrAlt.equals("")&&clrManAlt.equals("")) {
					clrAlt = bgColor;
					if (!altPort.equals("")) { //ĭ(  )  ˾ ʿ.
						altTag1 = "<a onClick='JavaScript:viewWeather(\""+ altPort +"\")' style='cursor:hand'>";
						altTag2 = "</a>";
					}
				} else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrAlt) && tagAR.equals("WX_ALT_PORT")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					if(!clrManAlt.equals("")){
						clrAlt = clrManAlt;
						String manStr = "ALERT APO  Դϴ";
						if(!str.equals("")){
							str = manStr + "<br>-----------------<br>" + str;
						}else{
							str = manStr;
						}
					}
					altTag1 = "<a onClick='JavaScript:viewWeather(\""+ altPort +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"alt_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					altTag2 = "</a><div id='alt_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrAlt = clrAllColumns; // ALL_COLUMNS
				
				if(stnto.equals(clrAlt))	{//2013-04-01
					clrAlt	=	"red";
				}
				//System.out.println(altPort+"========"+stnto+"======"+clrAlt);	
				altD = altTag1 + hTag1 + clrAlt + hTag2 + altPort + fTag + altTag2;
				
				//2007.06.27 ߰
				// Route ==================================================================================================
				String clrRoute = bgColor;
				String routeTag1 = "";
				String routeTag2 = "";
				//FLIGHT_PLAN_T.ROUTE  CM_CITYPAIR_DEF_T.ROUTE_NO  ٸ  :  ְ ǥ
				if (!((FfsQ020BG)hMap.get(new Integer(i))).getRoute().equals(((FfsQ020BG)hMap.get(new Integer(i))).getRouteNo())) {
					clrRoute = "#81C6FE"; //blue
					String routeNoStr = " ";
					if (!((FfsQ020BG)hMap.get(new Integer(i))).getRouteNo().equals(""))  routeNoStr = ((FfsQ020BG)hMap.get(new Integer(i))).getRouteNo();
					routeTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ "FPL  Route   Ǿ ϴ Route Name(" + routeNoStr + ") ٸϴ. Ȯ Ͻʽÿ." +"\", \"route_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					routeTag2 = "</a><div id='route_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				
				if (!clrAllColumns.equals("")) clrRoute = clrAllColumns; // ALL_COLUMNS
				routeD = routeTag1 + hTag1 + clrRoute + hTag2 + ((FfsQ020BG)hMap.get(new Integer(i))).getRoute() + fTag + routeTag2;
				
				//2010.03.29 ߰
				// CCF(PAD) ===============================================================================================
				String clrCcf = ((FfsQ020BG)hMap.get(new Integer(i))).getExtraFuel();
				String ccfTag1 = "";
				String ccfTag2 = "";
				if (clrCcf.equals("")) clrCcf = bgColor;
				else {
					String str = "";
					//2007.11.28 
					//REFILE_POINT, REFILE_PORT  ϸ CC_FUEL_95
					//REFILE_POINT, REFILE_PORT  ٸ, LCF_RATIO ʵ  5 Ͽ 5  CC_FUEL_75
					//LCF_RATIO ʵ  10̸ CC_FUEL_50
					//2009.10.29  : ALERT ޼ , 100 
					if (!(((FfsQ020BG)hMap.get(new Integer(i))).getRefilePoint()).equals("") && !(((FfsQ020BG)hMap.get(new Integer(i))).getRefilePort()).equals("")) {
						//CC_FUEL_95
						str = "FPL ž CCF žǾ ϴ CCF(" + Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getCcFuel95())*100 + "LBS) ϴ. Ȯ Ͻʽÿ.";
					} else {
						/*if (((FfsQ020BG)hMap.get(new Integer(i))).getLcfRatio().equals("5")) {
							//CC_FUEL_75
							str = "FPL ž CCF žǾ ϴ CCF(" + Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getCcFuel75())*100 + "LBS) ϴ. Ȯ Ͻʽÿ.";
						} else if (((FfsQ020BG)hMap.get(new Integer(i))).getLcfRatio().equals("10")) {
							//CC_FUEL_50
							str = "FPL ž CCF žǾ ϴ CCF(" + Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getCcFuel50())*100 + "LBS) ϴ. Ȯ Ͻʽÿ.";
						}*/
						//2010.08.02  : ALT_PORT  75, ׿ 50
						if (((FfsQ020BG)hMap.get(new Integer(i))).getAltPort().equals("")) {
							//CC_FUEL_75
							str = "FPL ž CCF žǾ ϴ CCF(" + Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getCcFuel75())*100 + "LBS) ϴ. Ȯ Ͻʽÿ.";
						} else {
							//CC_FUEL_50
							str = "FPL ž CCF žǾ ϴ CCF(" + Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getCcFuel50())*100 + "LBS) ϴ. Ȯ Ͻʽÿ.";
						}
					}
					ccfTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"ccf_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					ccfTag2 = "</a><div id='ccf_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrCcf = clrAllColumns; // ALL_COLUMNS
				ccfD = ccfTag1 + hTag1 + clrCcf + hTag2 + ((FfsQ020BG)hMap.get(new Integer(i))).getPadFuel() + fTag + ccfTag2;
				
				// EXTRA -> Co-RSV -> 2010.03.29  : EXTRA(EXTR+TANK) ================================================
				//2010.08.05  : alert color, msg ǥ .
				//String clrExtra = ((FfsQ020BG)hMap.get(new Integer(i))).getExtraFuel();
				String clrExtra = bgColor;
				String extraTag1 = "";
				String extraTag2 = "";
				/*
				if (clrExtra.equals("")) clrExtra = bgColor;
				else {
					String str = "";
					//for (int a=0; a<alertRule.size(); a++) {
					//	String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
					//	String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
					//	if (colorAR.equals(clrExtra) && tagAR.equals("EXTRA_FUEL")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					//}
					//2007.11.28 
					//REFILE_POINT, REFILE_PORT  ϸ CC_FUEL_95
					//REFILE_POINT, REFILE_PORT  ٸ, LCF_RATIO ʵ  5 Ͽ 5  CC_FUEL_75
					//LCF_RATIO ʵ  10̸ CC_FUEL_50
					//2009.10.29  : ALERT ޼ , 100 
					if (!(((FfsQ020BG)hMap.get(new Integer(i))).getRefilePoint()).equals("") && !(((FfsQ020BG)hMap.get(new Integer(i))).getRefilePort()).equals("")) {
						//CC_FUEL_95
						str = "FPL ž CCF žǾ ϴ CCF(" + Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getCcFuel95())*100 + "LBS) ϴ. Ȯ Ͻʽÿ.";
					} else {
						//if (((FfsQ020BG)hMap.get(new Integer(i))).getLcfRatio().equals("5")) {
							//CC_FUEL_75
						//	str = "FPL ž CCF žǾ ϴ CCF(" + Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getCcFuel75())*100 + "LBS) ϴ. Ȯ Ͻʽÿ.";
						//} else if (((FfsQ020BG)hMap.get(new Integer(i))).getLcfRatio().equals("10")) {
							//CC_FUEL_50
							str = "FPL ž CCF žǾ ϴ CCF(" + Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getCcFuel50())*100 + "LBS) ϴ. Ȯ Ͻʽÿ.";
						//}
						//2010.08.02  : ALT_PORT  75, ׿ 50
						if (((FfsQ020BG)hMap.get(new Integer(i))).getAltPort().equals("")) {
							//CC_FUEL_75
							str = "FPL ž CCF žǾ ϴ CCF(" + Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getCcFuel75())*100 + "LBS) ϴ. Ȯ Ͻʽÿ.";
						} else {
							//CC_FUEL_50
							str = "FPL ž CCF žǾ ϴ CCF(" + Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getCcFuel50())*100 + "LBS) ϴ. Ȯ Ͻʽÿ.";
						}
					}
					extraTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"extra_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					extraTag2 = "</a><div id='extra_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				*/
				if (!clrAllColumns.equals("")) clrExtra = clrAllColumns; // ALL_COLUMNS
				
				//2011.10.04 ߰
				String msg = "";
				String msgTr = "";
				int msgCnt = 0;
				int plnExtrFuel1 = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getPlnExtrFuel1());
				String plnExtrRsn1 = ((FfsQ020BG)hMap.get(new Integer(i))).getPlnExtrRsn1();
				int plnExtrFuel2 = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getPlnExtrFuel2());
				String plnExtrRsn2 = ((FfsQ020BG)hMap.get(new Integer(i))).getPlnExtrRsn2();
				
				int plnTankFuel = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getPlnTankFuel());
				
				//msg1
				if((plnExtrFuel1>0 && plnExtrRsn1 == null)||(plnExtrFuel2>0 && plnExtrRsn2 == null)){
					clrExtra = "#FF9999";
					msgCnt++;
					msg = "Code Missing";
					msgTr = "<tr height=16><td align=left>"+msg+"</td></tr>";
				}else{					
					if(plnExtrFuel1>0 && plnExtrFuel2==0){
						msgCnt++;
						msg = plnExtrFuel1+" : "+plnExtrRsn1;
						msgTr = "<tr height=16><td align=left>"+msg+"</td></tr>";
					}else if(plnExtrFuel1>0 && plnExtrFuel2>0){
						msgCnt++;
						msgTr = "<tr height=16><td align=left>"+plnExtrFuel1+" : "+plnExtrRsn1+"</td></tr>";
						msgTr += "<tr height=16><td align=left>"+plnExtrFuel2+" : "+plnExtrRsn2+"</td></tr>";
					}
					
				}
				
				if(plnTankFuel > 0){
					msgCnt++;
					msgTr += "<tr height=16><td align=left>"+plnTankFuel+" : TC</td></tr>";
				}
				
				//msg2				
				
				int plnExtrTankFuel = (plnExtrFuel1+plnExtrFuel2+plnTankFuel)/100;
				/* 2011.10.14 
				    int extrFuel = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getExtrFuel()) * 100;
				    if(extrFuel!=plnExtrFuel1+plnExtrFuel2){
					msgCnt++;
					clrExtra = "#FF9999";
					msg = "Chk Extra Fuel";
					if(msgCnt==2){//msg1  ϱ   ׾ش
						msgTr += "<tr><td align=left height=1>----------------</td></tr>";
					}
					msgTr += "<tr height=16><td align=left>"+msg+"</td></tr>";
					msgTr += "<tr height=16><td align=left>*PLAN : ["+extrFuel+"]</td></tr>";
					msgTr += "<tr height=16><td align=left>*FUEL : ["+(plnExtrFuel1+plnExtrFuel2)+"]</td></tr>";
				}*/
				//				2013-02-04߰
				planId=	 ((FfsQ020BG)hMap.get(new Integer(i))).getPlanId();
				planNo	=	 ((FfsQ020BG)hMap.get(new Integer(i))).getPlanNo();
				
				//planNo	=	"1234";
				if((planId!=null && !planId.equals(planNo))||(planId==null && planNo!=null)){
					clrExtra = "#FF9999";
					msgCnt++;
					msgTr += "<tr height=16><td align=left>ȹ ID("+planId+") Fuel ID("+planNo+") ġ ʽϴ.</td></tr>";
				}
				String msgTb = "<table border=0 cellpadding=0 cellspacing=0 class=txt5>"+msgTr+"</table>";
				
				if(msgCnt>0){
					extraTag1 = "<a onClick='JavaScript:fuelWeightPopup(\""+ ((FfsQ020BG)hMap.get(new Integer(i))).getSchDepDt2() +"\",\""+ ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum() +"\",\""+ stnfr +"\",\""+ stnto +"\")' onMouseOver='JavaScript:showInfo(\""+ msgTb +"\", \"extra_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
				}else{
					extraTag1 = "<a onClick='JavaScript:fuelWeightPopup(\""+ ((FfsQ020BG)hMap.get(new Integer(i))).getSchDepDt2() +"\",\""+ ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum() +"\",\""+ stnfr +"\",\""+ stnto +"\")' >";
				}
				extraTag2 = "</a><div id='extra_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				
				//extraD = extraTag1 + hTag1 + clrExtra + hTag2 + ((FfsQ020BG)hMap.get(new Integer(i))).getExtrTank() + fTag + extraTag2;//2011.10.14 
				extraD = extraTag1 + hTag1 + clrExtra + hTag2 + plnExtrTankFuel + fTag + extraTag2;//2011.09.29~2010.10.14  (getExtrTank()->plnExtrTankFuel)
				
				// Cruise Mode -> CRZ ====================================================================================
				String clrCruiseMode = ((FfsQ020BG)hMap.get(new Integer(i))).getCrzMode();
				String cruiseModeTag1 = "";
				String cruiseModeTag2 = "";
				if (clrCruiseMode.equals("")) clrCruiseMode = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrCruiseMode) && tagAR.equals("CRZ_MODE")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					cruiseModeTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"cruiseMode_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					cruiseModeTag2 = "</a><div id='cruiseMode_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrCruiseMode = clrAllColumns; // ALL_COLUMNS
				
				//2010.04.06  : CI   տ CI ٿش.
				String tmpCrz = ((FfsQ020BG)hMap.get(new Integer(i))).getSpeed();
				if (tmpCrz.length() >= 2 && !(tmpCrz.substring(0,2)).equals("CI")) tmpCrz = "CI" + tmpCrz;
				
				cruiseModeD = cruiseModeTag1 + hTag1 + clrCruiseMode + hTag2 + tmpCrz + fTag + cruiseModeTag2;
				
				// ETOPS ==================================================================================================
				String clrEtops = ((FfsQ020BG)hMap.get(new Integer(i))).getWxEtopPort();
				String etopsPorts = ((FfsQ020BG)hMap.get(new Integer(i))).getEtopsPorts(); // 2007.01.31 ߰ : ,Ž ˾
				String etopsTag1 = "";
				String etopsTag2 = "";
				if (clrEtops.equals("")) {
					clrEtops = bgColor;
					if (!etopsPorts.equals("")) { //ĭ(  )  ˾ ʿ.
						etopsTag1 = "<a onClick='JavaScript:viewWeather(\""+ etopsPorts +"\")' style='cursor:hand'>";
						etopsTag2 = "</a>";
					}
				} else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrEtops) && tagAR.equals("WX_ETOP_PORT")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					etopsTag1 = "<a onClick='JavaScript:viewWeather(\""+ etopsPorts +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"etops_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					etopsTag2 = "</a><div id='etops_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrEtops = clrAllColumns; // ALL_COLUMNS
				etopsD = etopsTag1 + hTag1 + clrEtops + hTag2 + etopsPorts + fTag + etopsTag2;
				
				// Refile ==================================================================================================				
				String clrRefile = "";
				// 2007.01.26 : WX_REFILE_PORT  WX_REFILE_ALT_PORT Refile  
				String clrRefile1 = ((FfsQ020BG)hMap.get(new Integer(i))).getWxRefilePort();
				String clrRefile2 = ((FfsQ020BG)hMap.get(new Integer(i))).getWxRefileAltPort();
				if (!clrRefile1.equals("")) clrRefile = clrRefile1;
				else clrRefile = clrRefile2;
				
				String refilePort = ((FfsQ020BG)hMap.get(new Integer(i))).getRefilePort(); // 2007.01.31 ߰ : ,Ž ˾
				String refileAltPorts = ((FfsQ020BG)hMap.get(new Integer(i))).getRefileAltPorts(); // 2007.01.31 ߰ : ,Ž ˾
				String refileTag1 = "";
				String refileTag2 = ""; 
				if (clrRefile.equals("")) {
					clrRefile = bgColor;
					if (!(refilePort.equals("") && refileAltPorts.equals(""))) { //ĭ(  )  ˾ ʿ.
						refileTag1 = "<a onClick='JavaScript:viewWeather(\""+ refilePort +" "+ refileAltPorts +"\")' style='cursor:hand'>";
						refileTag2 = "</a>";
					}
				} else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (!clrRefile1.equals("")) {
							if (colorAR.equals(clrRefile1) && tagAR.equals("WX_REFILE_PORT")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
						} else {	
							if (colorAR.equals(clrRefile2) && tagAR.equals("WX_REFILE_ALT_PORT")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
						}
					}
					refileTag1 = "<a onClick='JavaScript:viewWeather(\""+ refilePort +" "+ refileAltPorts +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"refile_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					refileTag2 = "</a><div id='refile_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrRefile = clrAllColumns; // ALL_COLUMNS
				String tmpRefile = ((FfsQ020BG)hMap.get(new Integer(i))).getRefilePoint() + "/" + refilePort + "/" + refileAltPorts;
				if (tmpRefile.equals("//")) tmpRefile = ""; // 2007.01.17  ==> // Ⱥ̰ ó
				refileD = refileTag1 + hTag1 + clrRefile + hTag2 + tmpRefile + fTag + refileTag2;
				
				/*
				// NF ==================================================================================================
				String clrNf = ((FfsQ020BG)hMap.get(new Integer(i))).getNotamStnfr();
				String nfTag1 = "";
				String nfTag2 = "";
				if (clrNf.equals("")) clrNf = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNf) && tagAR.equals("NOTAM_STNFR")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					nfTag1 = "<a onClick='JavaScript:viewNotam(\""+ stnfr +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"nf_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					nfTag2 = "</a><div id='nf_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrNf = clrAllColumns; // ALL_COLUMNS
				nfD = nfTag1 + hTag1 + clrNf + hTag2 + "&nbsp;" + fTag + nfTag2;
				
				// NT ==================================================================================================
				String clrNt = ((FfsQ020BG)hMap.get(new Integer(i))).getNotamStnto();
				String ntTag1 = "";
				String ntTag2 = "";
				if (clrNt.equals("")) clrNt = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNt) && tagAR.equals("NOTAM_STNTO")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					ntTag1 = "<a onClick='JavaScript:viewNotam(\""+ stnto +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"nt_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					ntTag2 = "</a><div id='nt_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrNt = clrAllColumns; // ALL_COLUMNS
				ntD = ntTag1 + hTag1 + clrNt + hTag2 + "&nbsp;" + fTag + ntTag2;
				
				// NA ==================================================================================================
				String clrNa = ((FfsQ020BG)hMap.get(new Integer(i))).getNotamAltPort();
				String naTag1 = "";
				String naTag2 = "";
				if (clrNa.equals("")) clrNa = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNa) && tagAR.equals("NOTAM_ALT_PORT")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					naTag1 = "<a onClick='JavaScript:viewNotam(\""+ altPort +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"na_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					naTag2 = "</a><div id='na_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrNa = clrAllColumns; // ALL_COLUMNS
				naD = naTag1 + hTag1 + clrNa + hTag2 + "&nbsp;" + fTag + naTag2;
				
				// NE ==================================================================================================
				String clrNe = ((FfsQ020BG)hMap.get(new Integer(i))).getNotamEtopPort();
				String neTag1 = "";
				String neTag2 = "";
				if (clrNe.equals("")) clrNe = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNe) && tagAR.equals("NOTAM_ETOP_PORT")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					neTag1 = "<a onClick='JavaScript:viewNotam(\""+ etopsPorts +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"ne_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					neTag2 = "</a><div id='ne_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrNe = clrAllColumns; // ALL_COLUMNS
				neD = neTag1 + hTag1 + clrNe + hTag2 + "&nbsp;" + fTag + neTag2;
				
				// NR ==================================================================================================
				String clrNr = ((FfsQ020BG)hMap.get(new Integer(i))).getNotamRefilePort();
				String nrTag1 = "";
				String nrTag2 = "";
				if (clrNr.equals("")) clrNr = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNr) && tagAR.equals("NOTAM_REFILE_PORT")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					nrTag1 = "<a onClick='JavaScript:viewNotam(\""+ refilePort +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"nr_"+ lineCnt +"\", 100, 885)' onMouseOut='JavaScript:hideInfo()'>";
					nrTag2 = "</a><div id='nr_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrNr = clrAllColumns; // ALL_COLUMNS
				nrD = nrTag1 + hTag1 + clrNr + hTag2 + "&nbsp;" + fTag + nrTag2;
				
				// NRA ==================================================================================================
				String clrNra = ((FfsQ020BG)hMap.get(new Integer(i))).getNotamRefileAltPort();
				String nraTag1 = "";
				String nraTag2 = "";
				if (clrNra.equals("")) clrNra = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNra) && tagAR.equals("NOTAM_REFILE_ALT_PORT")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					nraTag1 = "<a onClick='JavaScript:viewNotam(\""+ refileAltPorts +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"nra_"+ lineCnt +"\", 100, 885)' onMouseOut='JavaScript:hideInfo()'>";
					nraTag2 = "</a><div id='nra_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrNra = clrAllColumns; // ALL_COLUMNS
				nraD = nraTag1 + hTag1 + clrNra + hTag2 + "&nbsp;" + fTag + nraTag2;
				*/
				
				//2007.06.25 ߰
				// NOTAM ==================================================================================================
				String clrNotam = ((FfsQ020BG)hMap.get(new Integer(i))).getNotam();
				String notamPort = stnfr + " " + stnto + " " + altPort + " " + etopsPorts + " " + refilePort + " " + refileAltPorts; //  Ž ѹ 
				String notamTag1 = "";
				String notamTag2 = "";
				if (clrNotam.equals("")) {
					clrNotam = bgColor;
					notamTag1 = "<a onClick='JavaScript:viewNotam(\""+ notamPort +"\",\""+ notEtd +"\")' style='cursor:hand'>";
					notamTag2 = "</a>";
				} else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ020BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNotam) && tagAR.equals("NOTAM")) str = ((FfsQ020BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					notamTag1 = "<a onClick='JavaScript:viewNotam(\""+ notamPort +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"notam_"+ lineCnt +"\", 70, 0)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					notamTag2 = "</a><div id='notam_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				if (!clrAllColumns.equals("")) clrNotam = clrAllColumns; // ALL_COLUMNS
				notamD = notamTag1 + hTag1 + clrNotam + hTag2 + "&nbsp;" + fTag + notamTag2;
				
				// 2007.06.04 ߰
				// ACARS ==================================================================================================
				String clrAcars = bgColor;
				String acarsTag1 = "";
				String acarsTag2 = "";
				String acarsSmi = "";

				if (tmData != null) {
					List listData = (List)tmData.get("RE_SMILIST");
					if (listData != null) {
						for (int a=0; a<listData.size(); a++) {
							String smiFltNum = ((FfsQ020BG)listData.get(a)).getSmiFltNum();
							String smiTimeStamp = ((FfsQ020BG)listData.get(a)).getSmiTimeStamp();
							//ش FLT_NUM SMI Ʈ FLT_NUM ؼ    ǥ. -> 
							if (((FfsQ020BG)hMap.get(new Integer(i))).getFltNum().equals(smiFltNum)) {
								//acarsAlert ش KEY ϴ 
								if (acarsAlert.get(empNo+smiFltNum) != null) {
									//DB TIMESTAMP > acarsAlert TIMESTAMP ΰ  ǥ
									if (Long.parseLong(smiTimeStamp) > Long.parseLong(acarsAlert.get(empNo+smiFltNum).toString())) {
										acarsTag1 = "<a onClick='JavaScript:updateAcars(\""+ empNo + "\", \"" + ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum() + "\", \"" + smiStr + "\")' style='cursor:hand'>";
										acarsTag2 = "</a>";
										acarsSmi = "<img src='/BASERoot/images/msg_icon02_new.gif' width='13' height='13' border='0'>";
									//2007.06.01 ߰ : Ŭ߰ų  ƴ 쿡 MSG  ְ  ǥش.
									} else {
										acarsTag1 = "<a onClick='JavaScript:updateAcars(\""+ empNo + "\", \"" + ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum() + "\", \"" + smiStr + "\")' style='cursor:hand'>";
										acarsTag2 = "</a>";
										acarsSmi = "<img src='/BASERoot/images/msg_icon03.gif' width='14' height='13' border='0'>"; //2007.06.08 :  
									}
								//acarsAlert ش KEY  ʴ 
								} else {
									acarsTag1 = "<a onClick='JavaScript:updateAcars(\""+ empNo + "\", \"" + ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum() + "\", \"" + smiStr + "\")' style='cursor:hand'>";
									acarsTag2 = "</a>";
									acarsSmi = "<img src='/BASERoot/images/msg_icon02_new.gif' width='13' height='13' border='0'>";
								}
							}
						}
					}
				}
				acarsD = acarsTag1 + hTag1 + clrAcars + hTag2 + acarsSmi + fTag + acarsTag2;
				
				//2008.08.19 ߰
				// PLD ==================================================================================================
				String clrPld = bgColor;
				String tmpPld = "";
				String pldTag1 = "";
				String pldTag2 = "";
				if (!((FfsQ020BG)hMap.get(new Integer(i))).getStatusX().equals("")) {
					int plnPayload = 0;
					int reqPaxPldWt = 0;
					int reqCgoPldWt = 0;
					int reqOthPldWt = 0;
					int accPaxPldWt = 0;
					int accCgoPldWt = 0;
					int accOthPldWt = 0;
					// 2008.12.17 ߰ : REQ_PAX_DTG, REQ_CGO_DTG ǥ
					String reqPaxDtg = "";
					String reqCgoDtg = "";
					//	2008.09.22  : Table 󿡴  ǥ, 콺  󼼳 ֱ.
					if (!((FfsQ020BG)hMap.get(new Integer(i))).getPlnPayload().equals("")) plnPayload = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getPlnPayload());
					if (!((FfsQ020BG)hMap.get(new Integer(i))).getReqPaxPldWt().equals("")) reqPaxPldWt = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getReqPaxPldWt());
					if (!((FfsQ020BG)hMap.get(new Integer(i))).getReqCgoPldWt().equals("")) reqCgoPldWt = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getReqCgoPldWt());
					if (!((FfsQ020BG)hMap.get(new Integer(i))).getReqOthPldWt().equals("")) reqOthPldWt = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getReqOthPldWt());
					if (!((FfsQ020BG)hMap.get(new Integer(i))).getAccPaxPldWt().equals("")) accPaxPldWt = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getAccPaxPldWt());
					if (!((FfsQ020BG)hMap.get(new Integer(i))).getAccCgoPldWt().equals("")) accCgoPldWt = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getAccCgoPldWt());
					if (!((FfsQ020BG)hMap.get(new Integer(i))).getAccOthPldWt().equals("")) accOthPldWt = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getAccOthPldWt());
					
					if (!((FfsQ020BG)hMap.get(new Integer(i))).getReqPaxDtg().equals("")) reqPaxDtg = "@" + ((FfsQ020BG)hMap.get(new Integer(i))).getReqPaxDtg() + "Z";
					if (!((FfsQ020BG)hMap.get(new Integer(i))).getReqCgoDtg().equals("")) reqCgoDtg = "@" + ((FfsQ020BG)hMap.get(new Integer(i))).getReqCgoDtg() + "Z";
					
					if (((FfsQ020BG)hMap.get(new Integer(i))).getStatusX().equals("R")) {
						tmpPld = "<a href='JavaScript:popupPLD(\""+ ((FfsQ020BG)hMap.get(new Integer(i))).getFirstLegFltDt() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getStnfr() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getStnto() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getDdmon() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getRegno() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getInputTyp() +"\", \""+ ((FfsQ020BG)hMap.get(new Integer(i))).getTelexAddr() +"\")'>";
						tmpPld += "<font class='txt5_line'>" + String.valueOf((reqPaxPldWt + reqCgoPldWt + reqOthPldWt) / 100).toString() + "/" + String.valueOf((accPaxPldWt + accCgoPldWt + accOthPldWt) / 100).toString() + "</font></a>";
						
						/* 2012.05.09  : Ʒ 2012.05.09 ߰  ǥ
						//2009.10.21 ߰ : SACTYP 74Y̰ ACC_PACK1   PACK, FUEL ADD ǥ.
						String packFuelAdd = "";
						if (((FfsQ020BG)hMap.get(new Integer(i))).getSactyp().equals("74Y") && !((FfsQ020BG)hMap.get(new Integer(i))).getAccPack1().equals("")) {
							//H/N/N  Է
							String accPack = "";
							int accH = 0;
							if (((FfsQ020BG)hMap.get(new Integer(i))).getAccPack1().equals("HIGH")) { //HIGH Ǵ NORMAL .
								accPack = "H"; 
								accH++; 
							} else {
								accPack = "N";
							}
							if (((FfsQ020BG)hMap.get(new Integer(i))).getAccPack2().equals("HIGH")) { 
								accPack = accPack + "/H"; 
								accH++; 
							} else {
								accPack = accPack + "/N"; 
							}
							if (((FfsQ020BG)hMap.get(new Integer(i))).getAccPack3().equals("HIGH")) { 
								accPack = accPack + "/H"; 
								accH++; 
							} else {
								accPack = accPack + "/N"; 
							}
							// NORMAL 0%, HIGH 1 0.3%,  HIGH 0.8%
							String accFuelAdd = "";
							if (accH == 0) accFuelAdd = "0%";
							else if (accH == 1) accFuelAdd = "0.3%";
							else if (accH == 3) accFuelAdd = "0.8%";
							
							//H/N/N  Է
							String reqPack = "";
							int reqH = 0;
							if (((FfsQ020BG)hMap.get(new Integer(i))).getReqPack1().equals("HIGH")) { //HIGH Ǵ NORMAL .
								reqPack = "H"; 
								reqH++; 
							} else {
								reqPack = "N";
							}
							if (((FfsQ020BG)hMap.get(new Integer(i))).getReqPack2().equals("HIGH")) { 
								reqPack = reqPack + "/H"; 
								reqH++; 
							} else {
								reqPack = reqPack + "/N"; 
							}
							if (((FfsQ020BG)hMap.get(new Integer(i))).getReqPack3().equals("HIGH")) { 
								reqPack = reqPack + "/H"; 
								reqH++; 
							} else {
								reqPack = reqPack + "/N"; 
							}
							// NORMAL 0%, HIGH 1 0.3%,  HIGH 0.8%
							String reqFuelAdd = "";
							if (reqH == 0) reqFuelAdd = "0%";
							else if (reqH == 1) reqFuelAdd = "0.3%";
							else if (reqH == 3) reqFuelAdd = "0.8%";
							
							packFuelAdd = "<tr height=3><td colspan=4 align=left>-------------------------------------------</td></tr>";
							packFuelAdd += "<tr height=16><td colspan=2 align=left>PACK :&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+accPack+"</td><td align=left>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+reqPack+"</td><td align=left></td></tr>";
							packFuelAdd += "<tr height=16><td colspan=2 align=left>FUEL ADD : "+accFuelAdd+"</td><td align=left>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+reqFuelAdd+"</td><td align=left></td></tr>";
						}*/
						
						
						//	2012.05.09 ߰
                        //	FODIS Payload(PLD)   µ ȭ ž  Է¹ 濡  ʵ ߰ ǥ  
						String fuelAdd = "";
						
						String mdAcConfig = ((FfsQ020BG)hMap.get(new Integer(i))).getMdAcConfig();
						String ldAcConfigFwd = ((FfsQ020BG)hMap.get(new Integer(i))).getLdAcConfigFwd();
						String ldAcConfigAft = ((FfsQ020BG)hMap.get(new Integer(i))).getLdAcConfigAft();
						String aniPeriFuelAdd = ((FfsQ020BG)hMap.get(new Integer(i))).getAniPeriFuelAdd();
						String ldAcConfig = "";
						String ldAcConfigBoth = "";
						String mdLdRecirFan = "";

                        //	FODIS Payload(PLD)	Animal / Perishable   µ ȭ ž縦 Էϰ   µ ȭ ž簡 ִ  ( žߴٰ ٽ   Ѱ  )
						if(!(mdAcConfig.equals("")&&ldAcConfigFwd.equals("")&&ldAcConfigAft.equals("")) &&              /* Animal / Perishable   µ ȭ ž  Է  */
						   !(mdAcConfig.equals("")&&( ldAcConfigFwd.equals("OFF")||ldAcConfigFwd.equals("") )&&( ldAcConfigAft.equals("OFF")||ldAcConfigAft.equals("") ))){   /*   µ ȭ ž簡 ִ  */
                            
							if (((FfsQ020BG)hMap.get(new Integer(i))).getSactyp().equals("74Y")) {
	                        	
							}else if(((FfsQ020BG)hMap.get(new Integer(i))).getSactyp().equals("77X")){
								
								mdLdRecirFan = StringUtil.checkString(((FfsQ020BG)hMap.get(new Integer(i))).getMdLdRecirFan());
							}
							
							//ldAcConfig = ldAcConfigFwd+"/"+ldAcConfigAft+"/"+ldAcConfigBoth;
							
							//if(ldAcConfigFwd.equals("ON")) ldAcConfig = "FWD ON";
							//if(ldAcConfigAft.equals("ON")) ldAcConfig = "AFT ON";
							
							/*if( ldAcConfigFwd.equals("ON") && ldAcConfigAft.equals("ON") ) ldAcConfig = "BOTH ON";
							else if( ldAcConfigFwd.equals("OFF") && ldAcConfigAft.equals("OFF") ) ldAcConfig = "OFF";
							else if( ldAcConfigFwd.equals("Blank") && ldAcConfigAft.equals("Blank") ) ldAcConfig = "Blank";
							else{
								if(ldAcConfigFwd.equals("ON") && ldAcConfigAft.equals("OFF")) ldAcConfig = "FWD ON";
								if(ldAcConfigFwd.equals("OFF") && ldAcConfigAft.equals("ON")) ldAcConfig = "AFT ON";
							}*/
                            //	777F => LOWER LOBE  ȭ   : LOW, 744F => LOWER LOBE  ȭ   : ON
							if(ldAcConfigFwd.equals("ON")||ldAcConfigFwd.equals("LOW")) ldAcConfig = "FWD ON";
							if(ldAcConfigAft.equals("ON")||ldAcConfigAft.equals("LOW")) ldAcConfig = "AFT ON";
							if( (ldAcConfigFwd.equals("ON") && ldAcConfigAft.equals("ON"))|| (ldAcConfigFwd.equals("LOW") && ldAcConfigAft.equals("LOW")) ) ldAcConfig = "BOTH ON";
							else if( ldAcConfigFwd.equals("OFF") && ldAcConfigAft.equals("OFF") ) ldAcConfig = "OFF";
							
							fuelAdd = "<tr height=3><td colspan=4 align=left>---------------------------------</td></tr>";
							fuelAdd += "<tr height=16><td colspan=4 align=left>Animal & Perishable CGO</td></tr>";
							fuelAdd += "<tr height=16><td colspan=4 align=left>M: "+mdAcConfig+", L: "+ldAcConfig+"</td></tr>";
							//MAINDECK, LOWERDECK RECIR    777F=>77X  ش
							if(((FfsQ020BG)hMap.get(new Integer(i))).getSactyp().equals("77X")){
								fuelAdd += "<tr height=16><td colspan=4 align=left>Recir PAN: "+mdLdRecirFan+"</td></tr>";
							}
							fuelAdd += "<tr height=16><td colspan=4 align=left>FUEL ADD : "+aniPeriFuelAdd+"%</td></tr>";
						}
						
						String str = "<table border=0 cellpadding=0 cellspacing=0 class=txt5>";
						str += "<tr height=16><td colspan=4 align=left> * KE" + ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum() + "</td></tr>";
						str += "<tr height=16><td width=30 align=left></td><td width=73 align=center>Previous PLD</td><td colspan=2 align=center>Changed PLD</td></tr>";
						str += "<tr height=16><td align=left>PAX:</td><td align=right>" + String.valueOf(accPaxPldWt).toString() + "LBS</td><td width=73 align=right>" + String.valueOf(reqPaxPldWt).toString() + "LBS</td><td width=54 align=left>&nbsp;(" + String.valueOf(reqPaxPldWt - accPaxPldWt).toString() + ")</td></tr>";
						str += "<tr height=16><td align=left>CGO:</td><td align=right>" + String.valueOf(accCgoPldWt).toString() + "LBS</td><td align=right>" + String.valueOf(reqCgoPldWt).toString() + "LBS</td><td align=left>&nbsp;(" + String.valueOf(reqCgoPldWt - accCgoPldWt).toString() + ")</td></tr>";
						str += "<tr height=16><td align=left>OTH:</td><td align=right>" + String.valueOf(accOthPldWt).toString() + "LBS</td><td align=right>" + String.valueOf(reqOthPldWt).toString() + "LBS</td><td align=left>&nbsp;(" + String.valueOf(reqOthPldWt - accOthPldWt).toString() + ")</td></tr>";
						str += "<tr height=16><td align=left>TTL:</td><td align=right>" + String.valueOf(accPaxPldWt + accCgoPldWt + accOthPldWt).toString() + "LBS</td><td align=right>" + String.valueOf(reqPaxPldWt + reqCgoPldWt + reqOthPldWt).toString() + "LBS</td><td align=left>&nbsp;(" + String.valueOf((reqPaxPldWt + reqCgoPldWt + reqOthPldWt) - (accPaxPldWt + accCgoPldWt + accOthPldWt)).toString() + ")</td></tr>";
						//if (!packFuelAdd.equals("")) str += packFuelAdd; //2009.10.21 ߰
						if(!fuelAdd.equals("")) str += fuelAdd;//2012.05.09 ߰
						str += "</table>";
						
						pldTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"pld_"+ lineCnt +"\", 230, 979)' onMouseOut='JavaScript:hideInfo()'>";
						pldTag2 = "</a><div id='pld_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
						
						clrPld = "#FA8885"; //red
						
					} else {
						tmpPld = String.valueOf(plnPayload).toString();
						
						//2009.10.21 ߰ : SACTYP 74Y̰ ACC_PACK1   PACK, FUEL ADD ǥ.
						/*String packFuelAdd = "";
						if (((FfsQ020BG)hMap.get(new Integer(i))).getSactyp().equals("74Y") && !((FfsQ020BG)hMap.get(new Integer(i))).getAccPack1().equals("")) {
							//H/N/N  Է
							String accPack = "";
							int accH = 0;
							if (((FfsQ020BG)hMap.get(new Integer(i))).getAccPack1().equals("HIGH")) { //HIGH Ǵ NORMAL .
								accPack = "H"; 
								accH++; 
							} else {
								accPack = "N";
							}
							if (((FfsQ020BG)hMap.get(new Integer(i))).getAccPack2().equals("HIGH")) { 
								accPack = accPack + "/H"; 
								accH++; 
							} else {
								accPack = accPack + "/N"; 
							}
							if (((FfsQ020BG)hMap.get(new Integer(i))).getAccPack3().equals("HIGH")) { 
								accPack = accPack + "/H"; 
								accH++; 
							} else {
								accPack = accPack + "/N"; 
							}
							// NORMAL 0%, HIGH 1 0.3%,  HIGH 0.8%
							String accFuelAdd = "";
							if (accH == 0) accFuelAdd = "0%";
							else if (accH == 1) accFuelAdd = "0.3%";
							else if (accH == 3) accFuelAdd = "0.8%";
							
							packFuelAdd = "<tr height=3><td colspan=3 align=left>---------------------------------</td></tr>";
							packFuelAdd += "<tr height=16><td colspan=2 align=left>PACK :&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+accPack+"</td><td align=left><td></tr>";
							packFuelAdd += "<tr height=16><td colspan=2 align=left>FUEL ADD : "+accFuelAdd+"</td><td align=left><td></tr>";
						}*/
						
						
						//	2012.05.09 ߰
                        //	FODIS Payload(PLD)   µ ȭ ž  Է¹ 濡  ʵ ߰ ǥ  
						String fuelAdd = "";
						
						String mdAcConfig = ((FfsQ020BG)hMap.get(new Integer(i))).getMdAcConfig();
						String ldAcConfigFwd = ((FfsQ020BG)hMap.get(new Integer(i))).getLdAcConfigFwd();
						String ldAcConfigAft = ((FfsQ020BG)hMap.get(new Integer(i))).getLdAcConfigAft();
						String aniPeriFuelAdd = ((FfsQ020BG)hMap.get(new Integer(i))).getAniPeriFuelAdd();
						String ldAcConfig = "";
						String ldAcConfigBoth = "";
						String mdLdRecirFan = "";

                        //	FODIS Payload(PLD)	Animal / Perishable   µ ȭ ž縦 Էϰ   µ ȭ ž簡 ִ  ( žߴٰ ٽ   Ѱ  )
						if(!(mdAcConfig.equals("")&&ldAcConfigFwd.equals("")&&ldAcConfigAft.equals("")) &&             /*Animal / Perishable   µ ȭ ž  Է */       
								!(mdAcConfig.equals("")&&( ldAcConfigFwd.equals("OFF")||ldAcConfigFwd.equals("") )&&( ldAcConfigAft.equals("OFF")||ldAcConfigAft.equals("") ))){  /*   µ ȭ ž簡 ִ */
                            
							if (((FfsQ020BG)hMap.get(new Integer(i))).getSactyp().equals("74Y")) {
	                        	
							}else if(((FfsQ020BG)hMap.get(new Integer(i))).getSactyp().equals("77X")){
								
								mdLdRecirFan = StringUtil.checkString(((FfsQ020BG)hMap.get(new Integer(i))).getMdLdRecirFan());
							}
							
							//ldAcConfig = ldAcConfigFwd+"/"+ldAcConfigAft+"/"+ldAcConfigBoth;
							
							//if(ldAcConfigFwd.equals("ON")) ldAcConfig = "FWD ON";
							//if(ldAcConfigAft.equals("ON")) ldAcConfig = "AFT ON";
							
							/*if( ldAcConfigFwd.equals("ON") && ldAcConfigAft.equals("ON") ) ldAcConfig = "BOTH ON";
							else if( ldAcConfigFwd.equals("OFF") && ldAcConfigAft.equals("OFF") ) ldAcConfig = "OFF";
							else if( ldAcConfigFwd.equals("Blank") && ldAcConfigAft.equals("Blank") ) ldAcConfig = "Blank";
							else{
								if(ldAcConfigFwd.equals("ON") && ldAcConfigAft.equals("OFF")) ldAcConfig = "FWD ON";
								if(ldAcConfigFwd.equals("OFF") && ldAcConfigAft.equals("ON")) ldAcConfig = "AFT ON";
							}*/
                            //	777F => LOWER LOBE  ȭ   : LOW, 744F => LOWER LOBE  ȭ   : ON
							if(ldAcConfigFwd.equals("ON")||ldAcConfigFwd.equals("LOW")) ldAcConfig = "FWD ON";
							if(ldAcConfigAft.equals("ON")||ldAcConfigAft.equals("LOW")) ldAcConfig = "AFT ON";
							if( (ldAcConfigFwd.equals("ON") && ldAcConfigAft.equals("ON"))|| (ldAcConfigFwd.equals("LOW") && ldAcConfigAft.equals("LOW")) ) ldAcConfig = "BOTH ON";
							else if( ldAcConfigFwd.equals("OFF") && ldAcConfigAft.equals("OFF") ) ldAcConfig = "OFF";
							
							fuelAdd = "<tr height=3><td colspan=3 align=left>---------------------------------</td></tr>";
							fuelAdd += "<tr height=16><td colspan=3 align=left>Animal & Perishable CGO</td></tr>";
							fuelAdd += "<tr height=16><td colspan=3 align=left>M: "+mdAcConfig+", L: "+ldAcConfig+"</td></tr>";
							//MAINDECK, LOWERDECK RECIR    777F=>77X  ش
							if(((FfsQ020BG)hMap.get(new Integer(i))).getSactyp().equals("77X")){
								fuelAdd += "<tr height=16><td colspan=3 align=left>Recir PAN: "+mdLdRecirFan+"</td></tr>";
							}
							fuelAdd += "<tr height=16><td colspan=3 align=left>FUEL ADD : "+aniPeriFuelAdd+"%</td></tr>";
						}
						
						String str = "<table border=0 cellpadding=0 cellspacing=0 class=txt5>";
						str += "<tr height=16><td colspan=3 align=left> * KE" + ((FfsQ020BG)hMap.get(new Integer(i))).getFltNum() + "</td></tr>";
						str += "<tr height=16><td width=37 align=left>PAX :</td><td width=65 align=right>" + String.valueOf(reqPaxPldWt).toString() + "LBS</td><td align=left>" + reqPaxDtg + "<td></tr>";
						str += "<tr height=16><td align=left>CGO :</td><td align=right>" + String.valueOf(reqCgoPldWt).toString() + "LBS</td><td align=left>" + reqCgoDtg + "<td></tr>";
						str += "<tr height=16><td align=left>OTH :</td><td align=right>" + String.valueOf(reqOthPldWt).toString() + "LBS</td><td align=left><td></tr>";
						str += "<tr height=16><td align=left>REQ :</td><td align=right>" + String.valueOf(reqPaxPldWt + reqCgoPldWt + reqOthPldWt).toString() + "LBS</td><td align=left><td></tr>";
						str += "<tr height=3><td colspan=3 align=left>---------------------------------</td></tr>";
						str += "<tr height=16><td align=left>PLAN:</td><td align=right>" + String.valueOf(plnPayload * 100).toString() + "LBS</td><td align=left><td></tr>";
						//if (!packFuelAdd.equals("")) str += packFuelAdd; //2009.10.21 ߰
						if(!fuelAdd.equals("")) str += fuelAdd;//2012.05.09 ߰
						str += "</table>";
						
						pldTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"pld_"+ lineCnt +"\", 178, 1031)' onMouseOut='JavaScript:hideInfo()'>";
						pldTag2 = "</a><div id='pld_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
						
						//2008.09.26  : PLN_PAYLOAD < REQ   RED -> REQ - PLN_PAYLOAD > 100   RED
						//if ((plnPayload * 100) < (reqPaxPldWt + reqCgoPldWt + reqOthPldWt)) clrPld = "#FA8885"; //red
						if (((reqPaxPldWt + reqCgoPldWt + reqOthPldWt) - (plnPayload * 100)) > 100) clrPld = "#FA8885"; //red
					}
				}
				if (!clrAllColumns.equals("")) clrPld = clrAllColumns; // ALL_COLUMNS
				pldD = pldTag1 + hTag1 + clrPld + hTag2 + tmpPld + fTag + pldTag2;
				
				
				// !!
				//entity.setLcfD(lcfD); //2007.04.04 ߰ => 2007.04.09 ּó : Call Sign Բ 
				
				entity.setCallSignD(callSignD);
				entity.setAcRegD(acRegD);
				entity.setAcTypeD(acTypeD);
				entity.setPodD(podD);
				entity.setPoaD(poaD);
				entity.setEtdD(etdD);
				//@2018-08-14
				entity.setCobt(cobt);
				entity.setCobtAlert(cobtAlert);	
				entity.setTsat(tsat);
				entity.setTsatAlert(tsatAlert);
				
				entity.setAtdD(atdD);
				entity.setEtaD(etaD);
				entity.setFtD(ftD);
				entity.setAltD(altD);
				entity.setRouteD(routeD); //2007.06.27 ߰
				entity.setCcfD(ccfD); //2010.03.29 ߰
				entity.setExtraD(extraD);
				entity.setCruiseModeD(cruiseModeD);
				entity.setEtopsD(etopsD);
				entity.setRefileD(refileD);
				//entity.setNfD(nfD);
				//entity.setNtD(ntD);
				//entity.setNaD(naD);
				//entity.setNeD(neD);
				//entity.setNrD(nrD);
				//entity.setNraD(nraD);
				entity.setNotamD(notamD); //2007.06.25  : NOTAM  ʵ ߰
				entity.setAcarsD(acarsD); //2007.06.04 ߰
				entity.setPldD(pldD); //2008.08.19 ߰
				
				entity.setPlanId(planId);//2013-02-04 ߰
				entity.setPlanNo(planNo);//2013-02-04 ߰
				entity.setEtaMsg(etaMsg);//2013-04-24
				
				lineCnt = lineCnt + 1;
				
				hashData.put(new Integer(nextId), entity);
				nextId++;
			}
		}
		
		//System.out.println("2_hMap.size()      =>"+hMap.size());
		//System.out.println("2_hashData.size()=>"+hashData.size());
		
		return hashData.values();	
	}
	
	//PDP_FLT_PAYLOAD_T.STATUS_X  R   , Before Release, Enroute, Landed    ֵ Alert.
	//2008.08.27 ߰
	public String getPayloadAlert(String rCd, String fromDt, String toDt) {
		
		String returnValue = "";
		
		HashMap hMap = FfsQ020Task.hMap; //´.
			
		//RegionCd 
		int rCnt = rCd.length() / 3;
		//FromDt, ToDt ڷ
		int fromD = Integer.parseInt(fromDt);
		int toD = Integer.parseInt(toDt);
		
		for (int i=0; i<hMap.size(); i++) {
			
			//RegionCd üũ
			boolean rChk = false;
			String regionCd = ((FfsQ020BG)hMap.get(new Integer(i))).getRegionCd();
			for (int a=1; a<=rCnt ; a++) {
				if (regionCd.equals(rCd.substring((a-1)*3,a*3))) rChk = true;
			}
			
			//FromDt, ToDt üũ
			boolean dChk = false;
			int estDepDt = Integer.parseInt(((FfsQ020BG)hMap.get(new Integer(i))).getEstDepDt());
			if (estDepDt >= fromD && estDepDt <= toD) dChk = true;
			
			if (rChk && dChk) {
				
				if (((FfsQ020BG)hMap.get(new Integer(i))).getStatusX().equals("R")) {
					returnValue = "R";
				}
			}
		}
		
		return returnValue;
	}
}
