package kal.base.ffs.daemon;

import java.io.FileReader;
import java.io.BufferedReader;
import java.util.Timer;
import java.util.TimerTask;
import java.util.HashMap;
import java.rmi.RemoteException;

import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Enroute
 */
public class FfsQ030Daemon {
	
	private static FfsQ030Daemon FfsQ030Daemon = new FfsQ030Daemon();
	
	public static FfsQ030Daemon getInstance() {
		return FfsQ030Daemon;
	}
	
	public static int i = 0;
	
	// 2007.01.24 ߰
	public static HashMap alertRule;
	
	private FfsQ030Daemon() {
		if (FfsQ030Daemon.i == 0) {
			try {
				Timer timer;
				timer = new Timer();
				timer.scheduleAtFixedRate(new FfsQ030Task(timer),0,60000); //60ʸ ȸ
				Logger.debug.println("<< FfsQ030Daemon Start >>");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	// 2007.01.24 ߰
	public static void FfsQ030AlertRule() {
		try {
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");			
			alertRule = sl.selAlertRule("3");
		} catch(Exception e) {
			if (e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ030AlertRule] "+((RemoteException)e).getMessage());
			} else {
				Logger.debug.println("[BASE:FfsQ030AlertRule] "+((Exception)e).getMessage());
			}
		}
	}
}