package kal.base.ffs.daemon;

import java.io.*;
import java.util.*;
import java.text.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.FfsQ010BG;
import kal.base.ffs.dbbean.FfsQ020BG;
import kal.base.ffs.dbbean.FfsQ030BG;

import kal.base.jdf.ejb.EJBFinder;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Enroute
 */
public class FfsQ030DataMgr {
	
	public Collection getData(String rCd, String fromDt, String toDt, String smiStr, String empNo, String naiRange) { //2007.05.22 ߰ : smiStr, empNo -> 2008.12.22 ߰ : naiRange
		
		// 2007.01.24 ߰ => Alert Rule ƿ´.
		HashMap alertRule = FfsQ030Daemon.alertRule;
		
		// 2007.05.28 ߰ => Acars Alert  ´.
		HashMap acarsAlert = FfsQ060Daemon.acarsAlert;
		
		HashMap hMap = FfsQ030Task.hMap;		//ͼ
		
		System.out.println("FfsQ030Task.hMap.size() =====>"+hMap.size());
		
		//HashMap hashData = new HashMap();	//2007.06.15 
		Hashtable hashData = new Hashtable();	//´~
		
		//± ۼ
		String hTag1 = "<table width='100%' height='20' bgcolor='";
		String hTag2 = "' border='0' cellpadding='0' cellspacing='0' class='txt5'><tr><td align='center'>";
		String fTag = "</td></tr></table>";
			
		//RegionCd 
		int rCnt = rCd.length() / 3;	
		//FromDt, ToDt ڷ
		int fromD = Integer.parseInt(fromDt);
		int toD_a = Integer.parseInt(toDt);
		
		int lineCnt = 0;	
		int nextId = 0;
		
		//2007.05.22 ߰ ********************************************************************************
		HashMap fList = new HashMap();
		int fListId = 0;
		
		//fltNum  شϴ ͸ 
		for (int i=0; i<hMap.size(); i++) {
			//RegionCd üũ
			boolean rChk = false;
			String regionCd = ((FfsQ030BG)hMap.get(new Integer(i))).getRegionCd();
			for (int a=1; a<=rCnt ; a++) {
				if (regionCd.equals(rCd.substring((a-1)*3,a*3))) rChk = true;
			}
			
			//FromDt, ToDt üũ
			boolean dChk = false;
			int estDepDt = Integer.parseInt(((FfsQ030BG)hMap.get(new Integer(i))).getEstDepDt());
			if (estDepDt >= fromD && estDepDt <= toD_a) dChk = true;
			
			if (rChk && dChk) {
				fList.put(new Integer(fListId), ((FfsQ030BG)hMap.get(new Integer(i))).getFltNum());
				fListId++;
			}
		}
		
		//SMI, FLT_NUM ݵ Ѵ Ѱ ̻  ϵ Ѵ.
		Hashtable tmData = new Hashtable();
		if (!smiStr.equals("") && fListId > 0){
			try {
				//EJB LookUp
				FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
				tmData = sl.selAcarsSmiEN(smiStr, fList);
				
			} catch(Exception e) {
				Logger.debug.println("[BASE:FfsQ030DataMgr:getData] "+((Exception)e).getMessage());
			}
		}
		//***********************************************************************************************
		
		for (int i=0; i<hMap.size(); i++) {
			
			//RegionCd üũ
			boolean rChk = false;
			String regionCd = ((FfsQ030BG)hMap.get(new Integer(i))).getRegionCd();
			for (int a=1; a<=rCnt ; a++) {
				if (regionCd.equals(rCd.substring((a-1)*3,a*3))) rChk = true;
			}
			
			//FromDt, ToDt üũ
			boolean dChk = false;
			int estDepDt = Integer.parseInt(((FfsQ030BG)hMap.get(new Integer(i))).getEstDepDt());
			if (estDepDt >= fromD && estDepDt <= toD_a) dChk = true;
			
			if (rChk && dChk) {
				
				// 2007.01.31 ߰ : ,Ž ˾
				String notEtd = ((FfsQ030BG)hMap.get(new Integer(i))).getEstDepDt();
				if(notEtd.length() == 10) notEtd = notEtd.substring(0,6);
			
				//  ±׿ ͸ Ͽ ´.
				FfsQ030BG entity = new FfsQ030BG();
				
				String regionD = "";
				//String lcfD = ""; //2007.03.07 ߰ => 2007.06.28 
				String callSignD = "";
				String acRegD = "";
				String acTypeD = "";
				String podD = "";
				String poaD = "";
				String toD = "";
				String etaD = "";
				String statusD = "";
				String altD = "";
				String ccfD = ""; //2010.03.29 ߰
				String extraD = "";
				String cruiseModeD = "";
				String etopsD = "";
				String refileD = "";
				//String nfD = "";
				//String ntD = "";
				//String naD = "";
				//String neD = "";
				//String nrD = "";
				//String nraD = "";
				String notamD = ""; //2007.06.26  : NOTAM  ʵ ߰
				String acarsD = ""; //2007.05.22 ߰
				String etaMsg = ""; //2013-04-24
				
				// ALL_COLUMNS      ĥǾ Ѵ.-> 2007.02.01 : Enroute .
				//String clrAllColumns = ((FfsQ030BG)hMap.get(new Integer(i))).getAllColumns();
				
				//2007.05.21 ߰ : ¦θ  ̱.
				String bgColor = "";
				if (nextId % 2 == 0) bgColor = "#E0FFFF"; //#F0F8FF
				else bgColor = "#FFFFFF";
				
				// Region ==================================================================================================
				String clrRegion = bgColor;
				regionD = hTag1 + clrRegion + hTag2 + ((FfsQ030BG)hMap.get(new Integer(i))).getRegionCd() + fTag;
				
				/*
				// 2007.03.07 ߰ => 2007.06.28  :  
				// LCF 5% ==================================================================================================
				String clrLcf = bgColor;
				String lcfRatio = "";
				if (((FfsQ030BG)hMap.get(new Integer(i))).getLcfRatio().equals("5")) { // LCF 5%϶ ǥѴ.
					lcfRatio = "<img src='/BASERoot/images/5percent_btn.gif' width='26' height='16' border='0'>";
				}
				lcfD = hTag1 + clrLcf + hTag2 + lcfRatio + fTag;
				*/
				
				// Call Sign ==================================================================================================
				// 2007.02.05  POS_MSG, FLT_LEVEL, FOB, POINT_ATA, WAYPOINT_MISMATCH 
				//  ϳ  CallSign  ǥϰ ִ ŭ ʸ ش.
				String posMsg = ((FfsQ030BG)hMap.get(new Integer(i))).getPosMsg();
				/*
				//2008.09.24 ߰ **************************************************************
				//(3) POSITION MGS 1ð 10е Ʈ  . -> #FA8885 (RED)
				//POSITION MGS 1ð 10  ȵ ° RED ٲپ ־, ٽ ͼ NULL ٲپ .
				if (((FfsQ030BG)hMap.get(new Integer(i))).getCheckTakeoff().equals("20000101")) {
					posMsg = "";
				} else if (((FfsQ030BG)hMap.get(new Integer(i))).getCheckPos().equals("20000101")) {
					if (Integer.parseInt(((FfsQ030BG)hMap.get(new Integer(i))).getDataTakeoff()) < 70) {
						posMsg = "";
					} else {
						posMsg = "#FA8885";
					}
				} else {
					if (Integer.parseInt(((FfsQ030BG)hMap.get(new Integer(i))).getDataPos()) < 70) {
						posMsg = "";
					} else {
						posMsg = "#FA8885";
					}
				}
				//*****************************************************************************
				 */
				String fltLevel = ((FfsQ030BG)hMap.get(new Integer(i))).getFltLevel();
				String fob = ((FfsQ030BG)hMap.get(new Integer(i))).getFob();
				String pointAta = ((FfsQ030BG)hMap.get(new Integer(i))).getPointAta();
				String waypointMismatch = ((FfsQ030BG)hMap.get(new Integer(i))).getWaypointMismatch();
				String posTmpst = ((FfsQ030BG)hMap.get(new Integer(i))).getPosTmpst(); //2007.07.26 ߰ : Call Sign   ǥϱ  
				String rmkTmpst = ((FfsQ030BG)hMap.get(new Integer(i))).getRmkTmpst(); //2007.07.26 ߰ : Call Sign   ǥϱ  
				String clrCallSign = bgColor;
				String callSignTag1 = "";
				String callSignTag2 = "";
				if (!(posMsg + fltLevel + fob + pointAta + waypointMismatch).equals("")) {
					//clrCallSign = "#FA8885";
					//2007.07.26  : (#FA8885) ϶ FLIGHT_PLAN_T.POS_TMPST FLIGHT_PLAN_T.RMK_TMPST  (#F9F168) ǥ.
					if (posTmpst.equals(rmkTmpst) && !posTmpst.equals("")) clrCallSign = "#F9F168"; // : posTmpst null  ??
					else clrCallSign = "#FA8885"; //
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if ((colorAR.equals(posMsg) && tagAR.equals("POS_MSG")) || (colorAR.equals(fltLevel) && tagAR.equals("FLT_LEVEL")) || (colorAR.equals(fob) && tagAR.equals("FOB")) || (colorAR.equals(pointAta) && tagAR.equals("POINT_ATA")) || (colorAR.equals(waypointMismatch) && tagAR.equals("WAYPOINT_MISMATCH"))) {
							if (str.equals("")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
							else str = str + "<br>------------------<br>" + ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
						}
					}
					callSignTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"callSign_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					callSignTag2 = "</a>";
				}
				
				String posMsgTag1 = "";
				String posMsgTag2 = "";
				if (!posMsg.equals("")) {
					posMsgTag1 = "<blink><strong>";
					posMsgTag2 = "</strong></blink>";
				}
				
				//2007.06.28 ߰ : LCF 5%
				String lcf5Icon = "";
				//2008.12.22  : 
				//1. NAI_Y = 'Y' ̰ LCF_RATIO = '5' ̸,  N ǥ
				//2. NAI_Y = 'Y' ̰ LCF_RATIO = '5' ƴϸ, N ǥ
				//3. NAI_Y = 'Y' ƴϰ ALT_PORT ,  N ǥ
				//4. ׿ܴ  5% 꿡 .
				// NAI RANGE < SCH_ARV_DT - SCH_DEP_DT() ̸ NAI_Y = 'Y' -> 'N'
				if (naiRange.equals("")) naiRange = "180";
				String diffMin = ((FfsQ030BG)hMap.get(new Integer(i))).getDiffMin();
				//System.out.println("##### 2008.12.29 -----> "+((FfsQ030BG)hMap.get(new Integer(i))).getFltNum()+" / "+naiRange+" / "+diffMin+" / "+((FfsQ030BG)hMap.get(new Integer(i))).getNaiY());
				if ((((FfsQ030BG)hMap.get(new Integer(i))).getNaiY()).equals("Y") && Integer.parseInt(naiRange) >= Integer.parseInt(diffMin)) {
					/*if (((FfsQ030BG)hMap.get(new Integer(i))).getLcfRatio().equals("5")) {
						lcf5Icon = "<a onMouseOver='JavaScript:showInfo(\""+ "NAI  LCF 5% Ǿϴ." +"\", \"nCallSign_"+ lineCnt +"\", 80, 107)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/n_pink_blinking.gif' width='16' height='16' border='0' align='absmiddle'></a>";
					} else {
						lcf5Icon = "<img src='/BASERoot/images/n_pink_02.gif' width='16' height='16' border='0' align='absmiddle'>";
					}*/
					//2008.12.22  : ALT_PORT ִ üũ.
					if (((FfsQ030BG)hMap.get(new Integer(i))).getAltPort().length() == 3) {
						if (((FfsQ030BG)hMap.get(new Integer(i))).getLcfRatio().equals("5")) {
							//LCF 5%϶ Ʒ߿ Ѱ ش Ǹ ̴ 5  . ƴϸ Ϲ 5  .
							boolean lcf5Flg = false;
							//if ((((FfsQ030BG)hMap.get(new Integer(i))).getRegionCd()).equals("CHN")) lcf5Flg = true; 2009.09.21 .
							if ((((FfsQ030BG)hMap.get(new Integer(i))).getSactyp()).equals("AB6") || (((FfsQ030BG)hMap.get(new Integer(i))).getSactyp()).equals("ABF") || (((FfsQ030BG)hMap.get(new Integer(i))).getSactyp()).equals("GRJ")
								|| (((FfsQ030BG)hMap.get(new Integer(i))).getSactyp()).equals("74N")  || (((FfsQ030BG)hMap.get(new Integer(i))).getSactyp()).equals("388") ) lcf5Flg = true; //2012.03.06 : 74N, 388 ߰(Ե ű ǿ ش)
							//2008.06.24 ߰ : Area ߱̾ URC Ϲ 5  .
							//2009.09.21 .
							/*if (((((FfsQ030BG)hMap.get(new Integer(i))).getStnfr()).equals("URC") && (((FfsQ030BG)hMap.get(new Integer(i))).getStnto()).equals("ICN")) 
							|| ((((FfsQ030BG)hMap.get(new Integer(i))).getStnfr()).equals("ICN") && (((FfsQ030BG)hMap.get(new Integer(i))).getStnto()).equals("URC"))) {
								lcf5Flg = false;
							}*/
							//2007.07.06  : StringTokenizer ̻Ÿ..
							String allMel = ((FfsQ030BG)hMap.get(new Integer(i))).getMel();
							String allActypMel = ((FfsQ030BG)hMap.get(new Integer(i))).getActypMel();
							if (!allMel.equals("") && !allActypMel.equals("")) {
								StringTokenizer stMel = new StringTokenizer(allMel, " ");
								while(stMel.hasMoreTokens()) {
									String tokenMel = stMel.nextToken();
									StringTokenizer stActypMel = new StringTokenizer(allActypMel, " ");
									while(stActypMel.hasMoreTokens()) {
										String tokenActypMel = stActypMel.nextToken();
										if (tokenMel.equals(tokenActypMel)) lcf5Flg = true;
									}
								}
							}
							if (lcf5Flg) { //
								lcf5Icon = "<a onMouseOver='JavaScript:showInfo(\""+ "NAI /   LCF 5% Ǿϴ." +"\", \"nCallSign_"+ lineCnt +"\", 80, 128)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/5_icon01_new.gif' width='16' height='16' border='0' align='absmiddle'></a>";
							} else { 	//Ϲ
								lcf5Icon = "<a onMouseOver='JavaScript:showInfo(\""+ "NAI /   LCF 5% Ǿϴ." +"\", \"nCallSign_"+ lineCnt +"\", 80, 128)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/5_icon_new.gif' width='16' height='16' border='0' align='absmiddle'></a>";
							}
						} else {
							lcf5Icon = "<img src='/BASERoot/images/n_pink_01.gif' width='16' height='16' border='0' align='absmiddle'>";
						}
					} else {
						if (((FfsQ030BG)hMap.get(new Integer(i))).getLcfRatio().equals("5")) {
							lcf5Icon = "<a onMouseOver='JavaScript:showInfo(\""+ "NAI /  LCF 5% Ǿϴ." +"\", \"nCallSign_"+ lineCnt +"\", 80, 128)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/n_pink_blinking.gif' width='16' height='16' border='0' align='absmiddle'></a>";
						} else {
							lcf5Icon = "<img src='/BASERoot/images/n_pink_02.gif' width='16' height='16' border='0' align='absmiddle'>";
						}
					}
				} else if (((FfsQ030BG)hMap.get(new Integer(i))).getAltPort().length() != 3) {
					lcf5Icon = "<a onMouseOver='JavaScript:showInfo(\""+ "NAI  ƴմϴ." +"\", \"nCallSign_"+ lineCnt +"\", 80, 128)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/n_pink_blinking.gif' width='16' height='16' border='0' align='absmiddle'></a>";
				} else {
					
					if (((FfsQ030BG)hMap.get(new Integer(i))).getLcfRatio().equals("5")) {
						//LCF 5%϶ Ʒ߿ Ѱ ش Ǹ ̴ 5  . ƴϸ Ϲ 5  .
						boolean lcf5Flg = false;
						//if ((((FfsQ030BG)hMap.get(new Integer(i))).getRegionCd()).equals("CHN")) lcf5Flg = true; 2009.09.21 .
						if ((((FfsQ030BG)hMap.get(new Integer(i))).getSactyp()).equals("AB6") || (((FfsQ030BG)hMap.get(new Integer(i))).getSactyp()).equals("ABF") || (((FfsQ030BG)hMap.get(new Integer(i))).getSactyp()).equals("GRJ")
							|| (((FfsQ030BG)hMap.get(new Integer(i))).getSactyp()).equals("74N")  || (((FfsQ030BG)hMap.get(new Integer(i))).getSactyp()).equals("388") ) lcf5Flg = true; //2012.03.06 : 74N, 388 ߰(Ե ű ǿ ش)
						//2008.06.24 ߰ : Area ߱̾ URC Ϲ 5  .
						//2009.09.21 .
						/*if (((((FfsQ030BG)hMap.get(new Integer(i))).getStnfr()).equals("URC") && (((FfsQ030BG)hMap.get(new Integer(i))).getStnto()).equals("ICN")) 
						|| ((((FfsQ030BG)hMap.get(new Integer(i))).getStnfr()).equals("ICN") && (((FfsQ030BG)hMap.get(new Integer(i))).getStnto()).equals("URC"))) {
							lcf5Flg = false;
						}*/
						//2007.07.06  : StringTokenizer ̻Ÿ..				
						String allMel = ((FfsQ030BG)hMap.get(new Integer(i))).getMel();
						String allActypMel = ((FfsQ030BG)hMap.get(new Integer(i))).getActypMel();
						if (!allMel.equals("") && !allActypMel.equals("")) {
							StringTokenizer stMel = new StringTokenizer(allMel, " ");
							while(stMel.hasMoreTokens()) {
								String tokenMel = stMel.nextToken();
								StringTokenizer stActypMel = new StringTokenizer(allActypMel, " ");
								while(stActypMel.hasMoreTokens()) {
									String tokenActypMel = stActypMel.nextToken();
									if (tokenMel.equals(tokenActypMel)) lcf5Flg = true;
								}
							}
						}
						if (lcf5Flg) { //
							lcf5Icon = "<img src='/BASERoot/images/5_icon01_new.gif' width='16' height='16' border='0' align='absmiddle'>";
						} else { 	//Ϲ
							lcf5Icon = "<img src='/BASERoot/images/5_icon_new.gif' width='16' height='16' border='0' align='absmiddle'>";
						}
					}
				}
				
				//2007.06.28 ߰ : ѻ R
				String restrictIcon = "";
				if (!(((FfsQ030BG)hMap.get(new Integer(i))).getRestrictE()).equals("")) {
					restrictIcon = "<a onMouseOver='JavaScript:showInfo(\""+ ((FfsQ030BG)hMap.get(new Integer(i))).getRestrictE() +"\", \"rCallSign_"+ lineCnt +"\", 80, 146)' onMouseOut='JavaScript:hideInfo()'><img src='/BASERoot/images/r_icon_new.gif' width='16' height='16' border='0' align='absmiddle'></a>";
				}
				//2007.06.28 ߰ :  P
				String pmsnIcon = "";
				if ((((FfsQ030BG)hMap.get(new Integer(i))).getPmsn()).equals("Y") || (((FfsQ030BG)hMap.get(new Integer(i))).getPmsn()).equals("A")) {
					pmsnIcon = "<a href='JavaScript:popupPmsn(\""+ ((FfsQ030BG)hMap.get(new Integer(i))).getSchDepDt() +"\", \""+ ((FfsQ030BG)hMap.get(new Integer(i))).getFirstLegFltDt() +"\", \""+ ((FfsQ030BG)hMap.get(new Integer(i))).getFltNum() +"\", \""+ ((FfsQ030BG)hMap.get(new Integer(i))).getStnfr() +"\", \""+ ((FfsQ030BG)hMap.get(new Integer(i))).getStnto() +"\")' style='cursor:hand'>";
					pmsnIcon += "<img src='/BASERoot/images/p_icon_new.gif' width='16' height='16' border='0' align='absmiddle'></a>";
				} else if ((((FfsQ030BG)hMap.get(new Integer(i))).getPmsn()).equals("N")) {
					pmsnIcon = "<a href='JavaScript:popupPmsn(\""+ ((FfsQ030BG)hMap.get(new Integer(i))).getSchDepDt() +"\", \""+ ((FfsQ030BG)hMap.get(new Integer(i))).getFirstLegFltDt() +"\", \""+ ((FfsQ030BG)hMap.get(new Integer(i))).getFltNum() +"\", \""+ ((FfsQ030BG)hMap.get(new Integer(i))).getStnfr() +"\", \""+ ((FfsQ030BG)hMap.get(new Integer(i))).getStnto() +"\")' style='cursor:hand'>";
					pmsnIcon += "<img src='/BASERoot/images/p_icon01_new.gif' width='16' height='16' border='0' align='absmiddle'></a>";
				}
				//2011.12.06 ߰ : Apo Alert W
				String manWxIcon = "";
				if(!((((FfsQ030BG)hMap.get(new Integer(i))).getManWxStnfr()).equals(""))||!((((FfsQ030BG)hMap.get(new Integer(i))).getManWxStnto()).equals(""))){
					manWxIcon = "<a href='JavaScript:viewAlertAPO(\""+((FfsQ030BG)hMap.get(new Integer(i))).getFltNum()+"\",\""+((FfsQ030BG)hMap.get(new Integer(i))).getStnfr()+"\",\""+((FfsQ030BG)hMap.get(new Integer(i))).getStnto()+"\")' onMouseOver='JavaScript:showInfo(\"ALERT APO  Դϴ\",\"wCallSign_"+lineCnt+"\", 80, 164)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					manWxIcon += "<img src='/BASERoot/images/w_icon.gif' width='16' height='16' border='0' align='absmiddle'></a>";
				}
				
				String dtlSyskey = ((FfsQ030BG)hMap.get(new Integer(i))).getSyskey(); //2007.03.22 ߰
				String dtlFltId = ((FfsQ030BG)hMap.get(new Integer(i))).getFltNum();
				String dtlDep = ((FfsQ030BG)hMap.get(new Integer(i))).getStnfr();
				String dtlArr = ((FfsQ030BG)hMap.get(new Integer(i))).getStnto();
				String dtlDate = ((FfsQ030BG)hMap.get(new Integer(i))).getDdMonYy();
				String dtlAcReg = ((FfsQ030BG)hMap.get(new Integer(i))).getRegno(); 
				String dtlAcType = ((FfsQ030BG)hMap.get(new Integer(i))).getSactyp();
				String dtlStd= ((FfsQ030BG)hMap.get(new Integer(i))).getStd();
				String dtlAtd = ((FfsQ030BG)hMap.get(new Integer(i))).getAtd();
				String dtlTo = ((FfsQ030BG)hMap.get(new Integer(i))).getTkofT();
				if (dtlTo.length() == 10) dtlTo = dtlTo.substring(6,8) + dtlTo.substring(8,10);
				String dtlEta = ((FfsQ030BG)hMap.get(new Integer(i))).getEstArvDt();
				if (dtlEta.length() == 10) dtlEta = dtlEta.substring(6,8) + dtlEta.substring(8,10);
				String dtlFpl = ((FfsQ030BG)hMap.get(new Integer(i))).getPlanid();
				
				String dtlSta = ((FfsQ030BG)hMap.get(new Integer(i))).getSta(); //2007.06.26 ߰
				String dtlExtra = ((FfsQ030BG)hMap.get(new Integer(i))).getExtrFuel(); //2007.06.26 ߰
				String dtlAlt = ((FfsQ030BG)hMap.get(new Integer(i))).getAltPort(); //2007.06.26 ߰
				String dtlRefilePoint = ((FfsQ030BG)hMap.get(new Integer(i))).getRefilePoint(); //2007.06.26 ߰
				String dtlRefilePort = ((FfsQ030BG)hMap.get(new Integer(i))).getRefilePort(); //2007.06.26 ߰
				String dtlRefileAltPorts = ((FfsQ030BG)hMap.get(new Integer(i))).getRefileAltPorts(); //2007.06.26 ߰
				
				String dtlFirstLegFltDt = ((FfsQ030BG)hMap.get(new Integer(i))).getFirstLegFltDt(); //2007.07.03 ߰
				
				String dtlSchDdMonYy = ((FfsQ030BG)hMap.get(new Integer(i))).getSchDdMonYy(); //2007.07.09 ߰
				
				callSignD = hTag1 + clrCallSign +  hTag2 + "<table border='0' cellpadding='0' cellspacing='0' class='txt5'><tr>" + callSignTag1 + "<td width='50' height='16'>&nbsp;&nbsp;" + "<a href='JavaScript:fltDetail(\""+dtlSyskey+"\",\""+dtlFltId+"\",\""+dtlDep+"\",\""+dtlArr+"\",\""+dtlDate+"\",\""+dtlAcReg+"\",\""+dtlAcType+"\",\""+dtlStd+"\",\""+dtlAtd+"\",\""+dtlTo+"\",\""+dtlEta+"\",\""+dtlFpl+"\",\""+dtlSta+"\",\""+dtlExtra+"\",\""+dtlAlt+"\",\""+dtlRefilePoint+"\",\""+dtlRefilePort+"\",\""+dtlRefileAltPorts+"\",\""+dtlFirstLegFltDt+"\",\""+dtlSchDdMonYy+"\")'>";
				callSignD += "<font class='txt5_line'>" + posMsgTag1 + ((FfsQ030BG)hMap.get(new Integer(i))).getFltNum() + posMsgTag2 + "</font></a>" + "</td>" + callSignTag2 + "<td width='18'>" +  lcf5Icon + "</td><td width='18'>" + restrictIcon + "</td><td width='18'>" + pmsnIcon + "</td><td width='18'>" + manWxIcon + "</td></tr></table>" + fTag + "<div id='callSign_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				callSignD += "<div id='rCallSign_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				callSignD += "<div id='nCallSign_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>"; //2008.12.22 : N  ߰
				callSignD += "<div id='wCallSign_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>"; //2011.12.06 : W  ߰
				
				// A/C Reg ==================================================================================================
				//2007.06.27 ߰ : MEL
				String melIcon = "";
				if (!(((FfsQ030BG)hMap.get(new Integer(i))).getMel()).equals("")) {
					melIcon = "&nbsp;" + "<a href='JavaScript:popupMel(\""+ ((FfsQ030BG)hMap.get(new Integer(i))).getRegno() +"\")'><img src='/BASERoot/images/m_icon_new.gif' width='15' height='16' border='0' align='absmiddle'></a>";
				}
				
				String clrAcReg = ((FfsQ030BG)hMap.get(new Integer(i))).getRegnoColor();
				String acRegTag1 = "";
				String acRegTag2 = "";
				if (clrAcReg.equals("")) clrAcReg = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrAcReg) && tagAR.equals("REGNO")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					acRegTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"acReg_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					acRegTag2 = "</a><div id='acReg_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				//				@2014-02-21 hIcon
				String hIcon	=	"";
				
				if(((FfsQ030BG)hMap.get(new Integer(i))).getAltHightime().equals("Y")){
					hIcon	="<img src='/BASERoot/images/H_icon_green.gif' width='16' height='16' border='0' align='absmiddle' alt='HIGH TIME ENGINE'>";
				}
				
				acRegD = acRegTag1 + hTag1 + clrAcReg + "' border='0' cellpadding='0' cellspacing='0' class='txt5'><tr><td align='left'>&nbsp;&nbsp;&nbsp;&nbsp;" + ((FfsQ030BG)hMap.get(new Integer(i))).getRegno() + "&nbsp;&nbsp;" + melIcon+ "&nbsp;&nbsp;" + hIcon + fTag + acRegTag2;//				@2014-02-21 hIcon
				
				// A/C Type ==================================================================================================
				String clrAcType = bgColor;
				acTypeD = hTag1 + clrAcType + hTag2 + ((FfsQ030BG)hMap.get(new Integer(i))).getSactyp() + fTag;
				
				// POD ==================================================================================================
				String clrPod = ((FfsQ030BG)hMap.get(new Integer(i))).getWxStnfr();
				String clrManPod = ((FfsQ030BG)hMap.get(new Integer(i))).getManWxStnfr();
				String stnfr = ((FfsQ030BG)hMap.get(new Integer(i))).getStnfr(); // 2007.01.31 ߰ : ,Ž ˾
				String podTag1 = "";
				String podTag2 = "";
				if (clrPod.equals("")&&clrManPod.equals("")) {
					clrPod = bgColor;
					podTag1 = "<a onClick='JavaScript:viewWeather(\""+ stnfr +"\")' style='cursor:hand'>";
					podTag2 = "</a>";
				} else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrPod) && tagAR.equals("WX_STNFR")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					if(!clrManPod.equals("")){
						clrPod = clrManPod;
						String manStr = "ALERT APO  Դϴ";
						if(!str.equals("")){
							str = manStr + "<br>-----------------<br>" + str;
						}else{
							str = manStr;
						}
					}
					podTag1 = "<a onClick='JavaScript:viewWeather(\""+ stnfr +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"pod_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					podTag2 = "</a><div id='pod_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				podD = podTag1 + hTag1 + clrPod + hTag2 + stnfr + fTag + podTag2;
				
				// POA ==================================================================================================
				String clrPoa = ((FfsQ030BG)hMap.get(new Integer(i))).getWxStnto();
				String clrManPoa = ((FfsQ030BG)hMap.get(new Integer(i))).getManWxStnto();
				String stnto = ((FfsQ030BG)hMap.get(new Integer(i))).getStnto(); // 2007.01.31 ߰ : ,Ž ˾
				String divert = ((FfsQ030BG)hMap.get(new Integer(i))).getDivert(); // 2007.02.05 ߰ : DIVERT Y϶ BLINK ó
				String poaTag1 = "";
				String poaTag2 = "";
				if (clrPoa.equals("")&&clrManPoa.equals("")) {
					clrPoa = bgColor;
					poaTag1 = "<a onClick='JavaScript:viewWeather(\""+ stnto +"\")' style='cursor:hand'>";
					poaTag2 = "</a>";
				} else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrPoa) && tagAR.equals("WX_STNTO")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					if(!clrManPoa.equals("")){
						clrPoa = clrManPoa;
						String manStr = "ALERT APO  Դϴ";
						if(!str.equals("")){
							str = manStr + "<br>-----------------<br>"+str;
						}else{
							str = manStr;
						}
					}
					poaTag1 = "<a onClick='JavaScript:viewWeather(\""+ stnto +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"poa_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					poaTag2 = "</a><div id='poa_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				String divertTag1 = "";
				String divertTag2 = "";
				if (divert.equals("Y")) {
					divertTag1 = "<blink><font color='red'><strong>";
					divertTag2 = "</strong></font></blink>";
				}
				poaD = poaTag1 + hTag1 + clrPoa + hTag2 + divertTag1 + stnto + divertTag2 + fTag + poaTag2;
				
				// T/O ==================================================================================================
				String clrTo = ((FfsQ030BG)hMap.get(new Integer(i))).getTakeOff();
				String toTag1 = "";
				String toTag2 = "";
				if (clrTo.equals("")) clrTo = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrTo) && tagAR.equals("TAKE_OFF")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					toTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"to_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					toTag2 = "</a><div id='to_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				String tmpTo = "";
				if (((FfsQ030BG)hMap.get(new Integer(i))).getTkofT().length() == 10) tmpTo = ((FfsQ030BG)hMap.get(new Integer(i))).getTkofT().substring(6,8) + ((FfsQ030BG)hMap.get(new Integer(i))).getTkofT().substring(8,10);
				toD = toTag1 + hTag1 + clrTo + hTag2 + tmpTo + fTag + toTag2;
				
				// ETA ==================================================================================================
				String clrEta = ((FfsQ030BG)hMap.get(new Integer(i))).getEta();
				String etaTag1 = "";
				String etaTag2 = "";
				String gStr       = "";//2011.06.07  : alert  ߰  ,  ִ alert ߻   alert 
				if (clrEta.equals("")) clrEta = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrEta) && tagAR.equals("ETA")) {
							str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
							gStr = str;
						}
					}
					etaTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"eta_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					etaTag2 = "</a><div id='eta_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
//				2013-04-24  ߰	
				etaMsg=	 ((FfsQ030BG)hMap.get(new Integer(i))).getEtaMsg();
				if (etaMsg!=null && etaMsg.length()!=0){
					if(!gStr.equals("")){
						gStr +="<br/>";
					}else{
						clrEta = "#00FF00";
						
					}
					gStr+=etaMsg;
					etaTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ gStr +"\", \"eta_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					etaTag2 = "</a><div id='eta_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";

				}
				
				// 2011.06.07 ߰ :   else   ߰  ʿ
				//װ ̷   ETA STA  +(-) 1ð ̻  ߻  Alerting ǥ
				//1ð ̻ /   ETA    (Alerting)
				Double arvGap = Double.parseDouble(((FfsQ030BG)(hMap.get(new Integer(i)))).getArvGap());
				if(arvGap>=60){
					String str = "1ð ̻   ";
					if(!gStr.equals("")) str = gStr+"<br/>";
					clrEta = "#FA8885";
					etaTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"eta_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					etaTag2 = "</a><div id='eta_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}else if(arvGap<=-60){
					String str = "1ð ̻   ";
					if(!gStr.equals("")) str = gStr+"<br/>";
					clrEta = "#FA8885";
					etaTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ str +"\", \"eta_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					etaTag2 = "</a><div id='eta_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				
				String tmpEta = "";
				if (((FfsQ030BG)hMap.get(new Integer(i))).getEstArvDt().length() == 10) tmpEta = ((FfsQ030BG)hMap.get(new Integer(i))).getEstArvDt().substring(6,8) + ":" + ((FfsQ030BG)hMap.get(new Integer(i))).getEstArvDt().substring(8,10);
				etaD = etaTag1 + hTag1 + clrEta + hTag2 + tmpEta + fTag + etaTag2;
				
				// 2007.02.12 ߰
				// Status ==================================================================================================
				//String clrStatus = bgColor;
				String clrStatus = "#FFFFFF";
				
				// ð  ǥϱ
				String strStatus = ""; //  ǥ 
				String tmpStatus = ""; // ̹
				int dur = 0; // Ҷ  ð(д)
				
				try { //  ð д .
					dur = StringUtil.minsBetween("20"+((FfsQ030BG)hMap.get(new Integer(i))).getCurTime(), "20"+((FfsQ030BG)hMap.get(new Integer(i))).getEstArvDt());
				} catch (ParseException e) {
					Logger.debug.println("[BASE:FfsQ030DataMgr:getData] "+((ParseException)e).getMessage());
				}
				
				if (dur >= 0) {
					// YYMMDDHH24MI
					double sTo = 0; // TAKEOFF_TMPST
					if (((FfsQ030BG)hMap.get(new Integer(i))).getTkofT().length() == 10) sTo = Double.parseDouble(((FfsQ030BG)hMap.get(new Integer(i))).getTkofT().substring(6,10));
					double sCur = Double.parseDouble(((FfsQ030BG)hMap.get(new Integer(i))).getCurTime().substring(6,10)); // SYSDATE - 9/24
					double sEta = Double.parseDouble(((FfsQ030BG)hMap.get(new Integer(i))).getEstArvDt().substring(6,10)); // EST_ARV_DT
					
					if (sTo > sCur) {
						sCur = sCur + 2400;
						sEta = sEta + 2400;
					}
					if (sCur > sEta) {
						sEta = sEta + 2400;
					} 
					
					double bar = 0; //  Status Bar  ( ð/ ð * 10)
					if ((sEta - sTo) != 0) bar = ((sCur - sTo) / (sEta - sTo)) * 10;
									
					if (bar < 1) tmpStatus = "";
					else if (bar >= 1 && bar < 2) tmpStatus = "<img src='/BASERoot/images/blue_icon01.gif' width='50' height='14' border='0'>";
					else if (bar >= 2 && bar < 3) tmpStatus = "<img src='/BASERoot/images/blue_icon02.gif' width='50' height='14' border='0'>";
					else if (bar >= 3 && bar < 4) tmpStatus = "<img src='/BASERoot/images/blue_icon03.gif' width='50' height='14' border='0'>";
					else if (bar >= 4 && bar < 5) tmpStatus = "<img src='/BASERoot/images/blue_icon04.gif' width='50' height='14' border='0'>";
					else if (bar >= 5 && bar < 6) tmpStatus = "<img src='/BASERoot/images/blue_icon05.gif' width='50' height='14' border='0'>";
					else if (bar >= 6 && bar < 7) tmpStatus = "<img src='/BASERoot/images/blue_icon06.gif' width='50' height='14' border='0'>";
					else if (bar >= 7 && bar < 8) tmpStatus = "<img src='/BASERoot/images/blue_icon07.gif' width='50' height='14' border='0'>";
					else if (bar >= 8 && bar < 9) tmpStatus = "<img src='/BASERoot/images/blue_icon08.gif' width='50' height='14' border='0'>";
					else if (bar >= 9 && bar < 10)  tmpStatus = "<img src='/BASERoot/images/blue_icon09.gif' width='50' height='14' border='0'>";
					else tmpStatus = "<img src='/BASERoot/images/blue_icon10.gif' width='50' height='14' border='0'>";
					
					strStatus = StringUtil.minTohm(dur) + "<br>ҽϴ.";
					
				} else { // ð - ,  ̹ ̰,  ð ǥѴ.
					tmpStatus = "<img src='/BASERoot/images/red_icon01.gif' width='50' height='14' border='0'>";
					
					dur = dur * (-1); // + ٲش.
					strStatus = StringUtil.minTohm(dur) + "<br>ǰ ֽϴ.";
				}
				
				String statusTag1 = "<a onMouseOver='JavaScript:showInfo(\""+ strStatus +"\", \"status_"+ lineCnt +"\", 60, 0)' onMouseOut='JavaScript:hideInfo()'>";
				String statusTag2 = "</a><div id='status_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				
				statusD = statusTag1 + hTag1 + clrStatus + hTag2 + tmpStatus + fTag + statusTag2;
				
				// ALT ==================================================================================================
				String clrAlt = ((FfsQ030BG)hMap.get(new Integer(i))).getWxAltPort();
				String clrManAlt = ((FfsQ030BG)hMap.get(new Integer(i))).getManWxAlertPort();
				String altPort = ((FfsQ030BG)hMap.get(new Integer(i))).getAltPort(); // 2007.01.31 ߰ : ,Ž ˾
				String altTag1 = "";
				String altTag2 = "";
				if (clrAlt.equals("")&&clrManAlt.equals("")) {
					clrAlt = bgColor;
					altTag1 = "<a onClick='JavaScript:viewWeather(\""+ altPort +"\")' style='cursor:hand'>";
					altTag2 = "</a>";
				} else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrAlt) && tagAR.equals("WX_ALT_PORT")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					if(!clrManAlt.equals("")){
						clrAlt = clrManAlt;
						String manStr = "ALERT APO  Դϴ";
						if(!str.equals("")){
							str = manStr + "<br>-----------------<br>"+str;
						}else{
							str = manStr;
						}
					}
					altTag1 = "<a onClick='JavaScript:viewWeather(\""+ altPort +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"alt_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					altTag2 = "</a><div id='alt_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				altD = altTag1 + hTag1 + clrAlt + hTag2 + altPort + fTag + altTag2;
				
				//2010.03.29 ߰
				// CCF(PAD) ===============================================================================================
				String clrCcf = bgColor;
				ccfD = hTag1 + clrCcf + hTag2 + ((FfsQ030BG)hMap.get(new Integer(i))).getPadFuel() + fTag;
				
				// EXTRA -> Co-RSV -> 2010.03.29  : EXTRA(EXTR+TANK) ================================================
				String clrExtra = bgColor;
				extraD = hTag1 + clrExtra + hTag2 + ((FfsQ030BG)hMap.get(new Integer(i))).getExtrTank() + fTag;
				
				// Cruise Mode ==================================================================================================
				String clrCruiseMode = bgColor;
				
				//2010.04.06  : CI   տ CI ٿش.
				String tmpCrz = ((FfsQ030BG)hMap.get(new Integer(i))).getSpeed();
				if (tmpCrz.length() >= 2 && !(tmpCrz.substring(0,2)).equals("CI")) tmpCrz = "CI" + tmpCrz;
				
				cruiseModeD = hTag1 + clrCruiseMode + hTag2 + tmpCrz + fTag;
				
				// ETOPS ==================================================================================================
				String clrEtops = ((FfsQ030BG)hMap.get(new Integer(i))).getWxEtopPort();
				String etopsPorts = ((FfsQ030BG)hMap.get(new Integer(i))).getEtopsPorts(); // 2007.01.31 ߰ : ,Ž ˾
				String etopsTag1 = "";
				String etopsTag2 = "";
				if (clrEtops.equals("")) {
					clrEtops = bgColor;
					if (!etopsPorts.equals("")) { //ĭ(  )  ˾ ʿ.
						etopsTag1 = "<a onClick='JavaScript:viewWeather(\""+ etopsPorts +"\")' style='cursor:hand'>";
						etopsTag2 = "</a>";
					}
				} else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrEtops) && tagAR.equals("WX_ETOP_PORT")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					etopsTag1 = "<a onClick='JavaScript:viewWeather(\""+ etopsPorts +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"etops_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					etopsTag2 = "</a><div id='etops_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				etopsD = etopsTag1 + hTag1 + clrEtops + hTag2 + etopsPorts + fTag + etopsTag2;
				
				// Refile ==================================================================================================
				String clrRefile = "";
				// 2007.01.26 : WX_REFILE_PORT  WX_REFILE_ALT_PORT Refile  
				String clrRefile1 = ((FfsQ030BG)hMap.get(new Integer(i))).getWxRefilePort();
				String clrRefile2 = ((FfsQ030BG)hMap.get(new Integer(i))).getWxRefileAltPort();
				if (!clrRefile1.equals("")) clrRefile = clrRefile1;
				else clrRefile = clrRefile2;
				
				String refilePort = ((FfsQ030BG)hMap.get(new Integer(i))).getRefilePort(); // 2007.01.31 ߰ : ,Ž ˾
				String refileAltPorts = ((FfsQ030BG)hMap.get(new Integer(i))).getRefileAltPorts(); // 2007.01.31 ߰ : ,Ž ˾
				String refileTag1 = "";
				String refileTag2 = ""; 
				if (clrRefile.equals("")) {
					clrRefile = bgColor;
					if (!(refilePort.equals("") && refileAltPorts.equals(""))) { //ĭ(  )  ˾ ʿ.
						refileTag1 = "<a onClick='JavaScript:viewWeather(\""+ refilePort +" "+ refileAltPorts +"\")' style='cursor:hand'>";
						refileTag2 = "</a>";
					}
				} else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (!clrRefile1.equals("")) {
							if (colorAR.equals(clrRefile1) && tagAR.equals("WX_REFILE_PORT")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
						} else {	
							if (colorAR.equals(clrRefile2) && tagAR.equals("WX_REFILE_ALT_PORT")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
						}
					}
					refileTag1 = "<a onClick='JavaScript:viewWeather(\""+ refilePort +" "+ refileAltPorts +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"refile_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					refileTag2 = "</a><div id='refile_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				String tmpRefile = ((FfsQ030BG)hMap.get(new Integer(i))).getRefilePoint() + "/" + refilePort + "/" + refileAltPorts;
				if (tmpRefile.equals("//")) tmpRefile = ""; // 2007.01.17  ==> // Ⱥ̰ ó
				refileD = refileTag1 + hTag1 + clrRefile + hTag2 + tmpRefile + fTag + refileTag2;
				
				/*
				// NF ==================================================================================================
				String clrNf = ((FfsQ030BG)hMap.get(new Integer(i))).getNotamStnfr();
				String nfTag1 = "";
				String nfTag2 = "";
				if (clrNf.equals("")) clrNf = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNf) && tagAR.equals("NOTAM_STNFR")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					nfTag1 = "<a onClick='JavaScript:viewNotam(\""+ stnfr +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"nf_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					nfTag2 = "</a><div id='nf_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				nfD = nfTag1 + hTag1 + clrNf + hTag2 + "&nbsp;" + fTag + nfTag2;
				
				// NT ==================================================================================================
				String clrNt = ((FfsQ030BG)hMap.get(new Integer(i))).getNotamStnto();
				String ntTag1 = "";
				String ntTag2 = "";
				if (clrNt.equals("")) clrNt = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNt) && tagAR.equals("NOTAM_STNTO")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					ntTag1 = "<a onClick='JavaScript:viewNotam(\""+ stnto +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"nt_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					ntTag2 = "</a><div id='nt_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				ntD = ntTag1 + hTag1 + clrNt + hTag2 + "&nbsp;" + fTag + ntTag2;
				
				// NA ==================================================================================================
				String clrNa = ((FfsQ030BG)hMap.get(new Integer(i))).getNotamAltPort();
				String naTag1 = "";
				String naTag2 = "";
				if (clrNa.equals("")) clrNa = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNa) && tagAR.equals("NOTAM_ALT_PORT")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					naTag1 = "<a onClick='JavaScript:viewNotam(\""+ altPort +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"na_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					naTag2 = "</a><div id='na_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				naD = naTag1 + hTag1 + clrNa + hTag2 + "&nbsp;" + fTag + naTag2;
				
				// NE ==================================================================================================
				String clrNe = ((FfsQ030BG)hMap.get(new Integer(i))).getNotamEtopPort();
				String neTag1 = "";
				String neTag2 = "";
				if (clrNe.equals("")) clrNe = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNe) && tagAR.equals("NOTAM_ETOP_PORT")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					neTag1 = "<a onClick='JavaScript:viewNotam(\""+ etopsPorts +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"ne_"+ lineCnt +"\", 100, 0)' onMouseOut='JavaScript:hideInfo()'>";
					neTag2 = "</a><div id='ne_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				neD = neTag1 + hTag1 + clrNe + hTag2 + "&nbsp;" + fTag + neTag2;
				
				// NR ==================================================================================================
				String clrNr = ((FfsQ030BG)hMap.get(new Integer(i))).getNotamRefilePort();
				String nrTag1 = "";
				String nrTag2 = "";
				if (clrNr.equals("")) clrNr = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNr) && tagAR.equals("NOTAM_REFILE_PORT")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					nrTag1 = "<a onClick='JavaScript:viewNotam(\""+ refilePort +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"nr_"+ lineCnt +"\", 100, 885)' onMouseOut='JavaScript:hideInfo()'>";
					nrTag2 = "</a><div id='nr_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				nrD = nrTag1 + hTag1 + clrNr + hTag2 + "&nbsp;" + fTag + nrTag2;
				
				// NRA ==================================================================================================
				String clrNra = ((FfsQ030BG)hMap.get(new Integer(i))).getNotamRefileAltPort();
				String nraTag1 = "";
				String nraTag2 = "";
				if (clrNra.equals("")) clrNra = bgColor;
				else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNra) && tagAR.equals("NOTAM_REFILE_ALT_PORT")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					nraTag1 = "<a onClick='JavaScript:viewNotam(\""+ refileAltPorts +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"nra_"+ lineCnt +"\", 100, 885)' onMouseOut='JavaScript:hideInfo()'>";
					nraTag2 = "</a><div id='nra_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				nraD = nraTag1 + hTag1 + clrNra + hTag2 + "&nbsp;" + fTag + nraTag2;
				*/
				
				//2007.06.26 ߰
				// NOTAM ==================================================================================================
				String clrNotam = ((FfsQ030BG)hMap.get(new Integer(i))).getNotam();
				String notamPort = stnfr + " " + stnto + " " + altPort + " " + etopsPorts + " " + refilePort + " " + refileAltPorts; //  Ž ѹ 
				String notamTag1 = "";
				String notamTag2 = "";
				if (clrNotam.equals("")) {
					clrNotam = bgColor;
					notamTag1 = "<a onClick='JavaScript:viewNotam(\""+ notamPort +"\",\""+ notEtd +"\")' style='cursor:hand'>";
					notamTag2 = "</a>";
				} else {
					String str = "";
					for (int a=0; a<alertRule.size(); a++) {
						String colorAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getColorAR();
						String tagAR = ((FfsQ030BG)alertRule.get(new Integer(a))).getTagAR();
						if (colorAR.equals(clrNotam) && tagAR.equals("NOTAM")) str = ((FfsQ030BG)alertRule.get(new Integer(a))).getRemarksAR();
					}
					notamTag1 = "<a onClick='JavaScript:viewNotam(\""+ notamPort +"\",\""+ notEtd +"\")' onMouseOver='JavaScript:showInfo(\""+ str +"\", \"notam_"+ lineCnt +"\", 70, 0)' onMouseOut='JavaScript:hideInfo()' style='cursor:hand'>";
					notamTag2 = "</a><div id='notam_"+ lineCnt +"' style=\"position:absolute;visibility:hidden;border:1px solid black;font-size:9px;color:#333333;layer-background-color:lightyellow;background-color:lightyellow;padding-left:5px\"></div>";
				}
				notamD = notamTag1 + hTag1 + clrNotam + hTag2 + "&nbsp;" + fTag + notamTag2;
				
				// 2007.05.22 ߰
				// ACARS ==================================================================================================
				String clrAcars = bgColor;
				String acarsTag1 = "";
				String acarsTag2 = "";
				
				//2007.05.28 ߰ :  ǥÿ  ǥ÷ 
				String acarsSmi = "";

				if (tmData != null) {
					List listData = (List)tmData.get("EN_SMILIST");
					if (listData != null) {
						for (int a=0; a<listData.size(); a++) {
							String smiFltNum = ((FfsQ030BG)listData.get(a)).getSmiFltNum();
							String smiTimeStamp = ((FfsQ030BG)listData.get(a)).getSmiTimeStamp();
							//ش FLT_NUM SMI Ʈ FLT_NUM ؼ    ǥ. -> 
							if (((FfsQ030BG)hMap.get(new Integer(i))).getFltNum().equals(smiFltNum)) {
								//acarsAlert ش KEY ϴ 
								if (acarsAlert.get(empNo+smiFltNum) != null) {
									//2007.05.28 ߰ : DB TIMESTAMP > acarsAlert TIMESTAMP ΰ  ǥ
									if (Long.parseLong(smiTimeStamp) > Long.parseLong(acarsAlert.get(empNo+smiFltNum).toString())) {
										acarsTag1 = "<a onClick='JavaScript:updateAcars(\""+ empNo + "\", \"" + ((FfsQ030BG)hMap.get(new Integer(i))).getFltNum() + "\", \"" + smiStr + "\")' style='cursor:hand'>";
										acarsTag2 = "</a>";
										acarsSmi = "<img src='/BASERoot/images/msg_icon02_new.gif' width='13' height='13' border='0'>";
									//2007.06.01 ߰ : Ŭ߰ų  ƴ 쿡 MSG  ְ  ǥش.
									} else {
										acarsTag1 = "<a onClick='JavaScript:updateAcars(\""+ empNo + "\", \"" + ((FfsQ030BG)hMap.get(new Integer(i))).getFltNum() + "\", \"" + smiStr + "\")' style='cursor:hand'>";
										acarsTag2 = "</a>";
										acarsSmi = "<img src='/BASERoot/images/msg_icon03.gif' width='14' height='13' border='0'>"; //2007.06.08 :  
									}
								//acarsAlert ش KEY  ʴ 
								} else {
									acarsTag1 = "<a onClick='JavaScript:updateAcars(\""+ empNo + "\", \"" + ((FfsQ030BG)hMap.get(new Integer(i))).getFltNum() + "\", \"" + smiStr + "\")' style='cursor:hand'>";
									acarsTag2 = "</a>";
									acarsSmi = "<img src='/BASERoot/images/msg_icon02_new.gif' width='13' height='13' border='0'>";
								}
							}
						}
					}
				}
				acarsD = acarsTag1 + hTag1 + clrAcars + hTag2 + acarsSmi + fTag + acarsTag2;
				
				
				// !!
				entity.setRegionD(regionD);
				//entity.setLcfD(lcfD); //2007.03.07 ߰ => 2007.06.28 
				entity.setCallSignD(callSignD);
				entity.setAcRegD(acRegD);
				entity.setAcTypeD(acTypeD);
				entity.setPodD(podD);
				entity.setPoaD(poaD);
				entity.setToD(toD);
				entity.setEtaD(etaD);
				entity.setStatusD(statusD);
				entity.setAltD(altD);
				entity.setCcfD(ccfD); //2010.03.29 ߰
				entity.setExtraD(extraD);
				entity.setCruiseModeD(cruiseModeD);
				entity.setEtopsD(etopsD);
				entity.setRefileD(refileD);
				//entity.setNfD(nfD);
				//entity.setNtD(ntD);
				//entity.setNaD(naD);
				//entity.setNeD(neD);
				//entity.setNrD(nrD);
				//entity.setNraD(nraD);
				entity.setNotamD(notamD); //2007.06.26  : NOTAM  ʵ ߰
				entity.setAcarsD(acarsD); //2007.05.22 ߰
			
				lineCnt = lineCnt + 1;
				
				hashData.put(new Integer(nextId), entity);
				nextId++;
			}
		}
		
		//System.out.println("3_hMap.size()      =>"+hMap.size());
		//System.out.println("3_hashData.size()=>"+hashData.size());
		
		return hashData.values();	
	}
}
