package kal.base.ffs.daemon.sort;

/**
 * @author sunpark
 * 20160617
 * table sort object
 */

import java.util.Iterator;

import kal.base.ffs.dbbean.FfsQ010BG;

public class BeforReleaseComparator extends FFSComparator {
	
	public int compareMulti(Iterator typeIt, FfsQ010BG data1, FfsQ010BG data2) {
        int result = 0;
        
        SortData sortData = (SortData)typeIt.next();

        if("0".equals(sortData.getColumn())) {
            result = data1.getFltNum().compareTo(data2.getFltNum());
            result *= sortData.getOrder();
        } else if("1".equals(sortData.getColumn())) {
            result = data1.getRegno().compareTo(data2.getRegno());
            result *= sortData.getOrder();
        } else if("2".equals(sortData.getColumn())) {
        	 result = data1.getSactyp().compareTo(data2.getSactyp());
             result *= sortData.getOrder();
        } else if("3".equals(sortData.getColumn())) {
	       	 result = data1.getStnfr().compareTo(data2.getStnfr());
	         result *= sortData.getOrder();
	    } else if("4".equals(sortData.getColumn())) {
	       	 result = data1.getStnto().compareTo(data2.getStnto());
	         result *= sortData.getOrder();
	    } else if("5".equals(sortData.getColumn())) {
	       	 result = data1.getAltPort().compareTo(data2.getAltPort());
	         result *= sortData.getOrder();
	    } else if("6".equals(sortData.getColumn())) {
	       	 result = data1.getSchDepDt().compareTo(data2.getSchDepDt());
	         result *= sortData.getOrder();
	    } else if("7".equals(sortData.getColumn())) {
	       	 result = data1.getEstDepDt().compareTo(data2.getEstDepDt());
	         result *= sortData.getOrder();
	    } else if("8".equals(sortData.getColumn())) {
	       	 result = data1.getSchArvDt().compareTo(data2.getSchArvDt());
	         result *= sortData.getOrder();
	    } else if("9".equals(sortData.getColumn())) {
	       	 result = data1.getEstArvDt().compareTo(data2.getEstArvDt());
	         result *= sortData.getOrder();
	    }
        
        if(result == 0 && typeIt.hasNext()) {
            return compareMulti(typeIt, data1, data2);
        }
        
        return result; 
    }
	
	public int compare(Object obj1, Object obj2) {
        int result = 0;
        
        FfsQ010BG data1 = (FfsQ010BG)obj1;
        FfsQ010BG data2 = (FfsQ010BG)obj2;
        
        Iterator typeIt = types.iterator();
        
        result = compareMulti(typeIt, data1, data2);
        
        return result;
    }
}
