package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.serv.ComUtil;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ffs.dbbean.*;
import kal.base.ffs.ejb.FfsAllSL;

public class FfsQ710Serv extends PublicBaseServlet {
	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
		
		   FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
		
			Hashtable hashData  = sl.selFfsQ710Main();	

			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("JinAir Citypair", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			
			req.setAttribute("hashData", hashData);
			req.setAttribute("dataComplete","S");
			
			System.out.println(req);
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			e.printStackTrace();
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ710Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:FfsQ710Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	
	}//end selectTask

}
