package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupA310BG;
import kal.base.sup.dbbean.SupA360BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * WEATHER LIST Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2011/11/04 
 */
public class FfsQ810Serv extends PublicBaseServlet {
	/** 
	  * WEATHER LIST Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2011/11/04 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try{
			
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selFFSQ810Main(new SupA360BG());
			req.setAttribute("hashData", hashData);
			req.setAttribute("returnParam", "Y");
			
            //  
			printJspPage(req, res, returnPage);
		}catch(Exception e){
			if(e instanceof RemoteException){
				Logger.debug.println("[BASE:FFSQ810Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "select");
			} else {
				Logger.debug.println("[BASE:FFSQ810Serv:selectTask] "+e.getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "select");
			}
		}
	}
}
