package kal.base.ocb.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ocb.dbbean.*;
import kal.base.ocb.ejb.OcbAllSL;
import kal.base.com.ejb.ComAllSL;

/**
 * OCB Daily Operations Information2 Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/03/29 HIST  
 */
public class OcbQ030Serv  extends PublicBaseServlet{
	/** 
	  * Daily Operations Information2 Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/03/29 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String reportD = StringUtil.checkString(box.getString("report_d"));				//ȸ YYYYMMDD
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//EJB LookUp
			OcbAllSL ocbSL = (OcbAllSL)EJBFinder.lookup("ejb/OcbAllSL");
			Hashtable hashData  = ocbSL.selOcbQ030Main("20"+reportD);
			
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Daily OPS Info2", null, "", MessageCode.getInstance().SELECT_MSG));
			req.setAttribute("hashData",hashData);
			req.setAttribute("reportD",reportD);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:OcbQ030Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:OcbQ030Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
}//end of class
