package kal.base.ocb.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ocb.dbbean.*;
import kal.base.ocb.ejb.OcbAllSL;

/**
 * KE Resource Monitor Detail 1  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/04/28 HIST  
 */
public class OcbQ110Serv extends PublicBaseServlet{

	/** 
	  * KE Resource Monitor Detail 1  Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/04/28 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    	//Box ü 
		String reportM = StringUtil.checkString(box.getString("report_m"));			//Report Month
		String reportD = StringUtil.checkString(box.getString("report_d"));			//Report Date
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			OcbAllSL ocbSL = (OcbAllSL)EJBFinder.lookup("ejb/OcbAllSL");
			Hashtable hashData  = ocbSL.selOcbQ110Main(reportM,reportD);
			
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("KE Resource Monitor Detail I", null, "", MessageCode.getInstance().SELECT_MSG));
			req.setAttribute("hashData",hashData);
			req.setAttribute("reportM",reportM);
			req.setAttribute("reportD",reportD);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:OcbQ110Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:OcbQ110Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
	
}//end of class
