package kal.base.skd.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;
import javax.servlet.http.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.skd.dbbean.SkdQ090BG;
import kal.base.skd.ejb.SkdAllSL;

/**
 * RAD ȸ Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2010/01/14 
 */
public class SkdQ090Serv extends PublicBaseServlet{
	
	/** 
	  * RAD MSG ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2010/01/14 
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		
		String dt = StringUtil.checkString(box.getString("dt"));					//YYMMDD
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//EJB Parameter 
			SkdQ090BG params = new SkdQ090BG();
			
			params.setDt(dt);
			
			//EJB LookUp
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData  = sl.selSkdQ090Main(params);
			
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("RAD ȸ", hashData, "RAD_MSG", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData", hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SkdA080Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SkdA080Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	
	
}//end class
