package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sup.dbbean.*;
import kal.base.wea.ejb.WeaAllSL;
import kal.base.sys.dbbean.*;

/**
 * BASE2 Link Site Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/08/23 HIST 
 */
public class SupA910Serv extends PublicBaseServlet{
	/**
	  * BASE2 Link Site ȸ Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/08/23 HIST 
	  */
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		try {
			//EJB LookUp
			WeaAllSL sl = (WeaAllSL)EJBFinder.lookup("ejb/WeaAllSL");
			Hashtable hashData = sl.selSupA910Main();
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Link Site", null, "", MessageCode.getInstance().SELECT_MSG));
			req.setAttribute("hashData",hashData);
			req.setAttribute("startPage","Y");

			//  
			printJspPage(req, res, "/jsp/sup/SupA910UI.jsp");
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA910Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),"/jsp/sup/SupA910UI.jsp","select");
			} else {
				Logger.debug.println("[BASE:SupA910Serv:selectTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),"/jsp/sup/SupA910UI.jsp","select");
			}
		}
	}//end of function
}
