package kal.fts.com.util;

import java.io.*;
import java.text.*;
import java.util.*;

/**
 * Ŭ ۼ  ֱ  String ó ƿ Ŭ
 * @author Copyright (c) 2002 HIST 
 */
public final class StringUtil {
	public StringUtil() {
		super();
	}

    /**
     * Null ڿ 鹮ڿ ٲٰų  Ե ڿ  Ѵ.
     * @param str String Message
     * @return  str.trim()  ŵ ޼
     * @author Copyright (c) 2004 HIST 
     */
	public static String checkString(String str) {
		if(str != null)
			return str.trim();
		else
			return "";
	}    
	
	/**
     * Remote Exception Error Message мؼ   ߻ ޼ Ѵ
     * @param strMsg String Remote Exception Message
     * @return  str   ޼
     * @author Copyright (c) 2004 HIST 
     */
    public static String tokenMessage(String strMsg) {
    	if (strMsg == null || strMsg.length() == 0) return "";
    	
    	String str = null;
    	
    	//lastIndex  -1 Ѵ
    	int startIndex = strMsg.lastIndexOf("##");
    	int endIndex = strMsg.lastIndexOf("::");
    	
    	if (startIndex == -1 || endIndex == -1) str = strMsg;
    	else str = strMsg.substring(startIndex+2, endIndex);
    	return str;
    }	
    
	/**
     * RDO SLOT ACTYP RANK ڵ
     * @param acTyp String actyp
     * @return  arrRank String[] Rank Code List
     * @author Copyright (c) 2004 HIST 
     */
    public static String[] checkActyp(String acTyp) {
    	/*
		744    CAP    RC    F/O
		777    CAP    RC    F/O
		747    CAP    F/O   F/E
		M11   CAP    RC    F/O
		330    CAP    RC    F/O
		AB6   CAP    F/O
		737    CAP    F/O
		*/
    	String[] arrRank = null;
    	
    	if (acTyp == null || acTyp.length() == 0) return arrRank;
    	
    	if (acTyp.equals("744") || acTyp.equals("777") || acTyp.equals("M11") || acTyp.equals("330")) {
    		arrRank = new String[3];
    		arrRank[0] = "CAP";
    		arrRank[1] = "RC";
    		arrRank[2] = "F/O";
    	} else if (acTyp.equals("747")) {
    		arrRank = new String[3];
    		arrRank[0] = "CAP";
    		arrRank[1] = "F/O";
    		arrRank[2] = "F/E";
    	} else if (acTyp.equals("AB6") || acTyp.equals("737")) {
    		arrRank = new String[2];
    		arrRank[0] = "CAP";
    		arrRank[1] = "F/O";
    	} else return arrRank;

    	return arrRank;
    }	    

}//end class