package kal.base.com.util;

import java.io.*;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;
import java.text.*;
import java.lang.reflect.*;
import java.net.URLEncoder;
import java.net.URLDecoder;

/**
 *   Ͻʽÿ.
 * ۼ ¥: (2002-06-20  9:52:48)
 * @author: kshan-H(Ѱ)
 */
public class HttpUtil 
{
	
	
	/**
	 * HttpUtil  ּ.
	 */
	public HttpUtil() 
	{
		super();
	}

	/*************************************************************************************************************
	 * Encoding Լ  
	 *************************************************************************************************************/
		
	public static String Uni2Ksc(String s)
		throws UnsupportedEncodingException
	{
		if(s == null)
			return null;
		else
			return new String(s.getBytes("8859_1"), "KSC5601");
	}
	
	public static String Uni2UTF8(String s)
		throws UnsupportedEncodingException
	{
		if(s == null)
			return null;
		else
			return new String(s.getBytes("8859_1"), "UTF8");
	}
	
	public static String Ksc2Uni(String s)
		throws UnsupportedEncodingException
	{
		if(s == null)
			return null;
		else
			return new String(s.getBytes("KSC5601"), "8859_1");
	}
	
	public static String Ksc2UniNNull(String s)
		throws UnsupportedEncodingException
	{
		if(s == null)
			return "";
		if("null".equals(s))
			return "";
		else
			return new String(s.getBytes("KSC5601"), "8859_1");
	}

	/*************************************************************************
	 *  Ķ  ѱ encoding Ѵ.
	 * @param <code>String</code> _paramValue : encoding 
	 * @return <code>String</code> paramValue : encoding 
	 **/
	 public static String paramEncode(String _paramValue)
	 {
		 String paramValue = _paramValue;
		 try{
			 paramValue = URLEncoder.encode(paramValue);
		 }
		 catch (NullPointerException e){
			 e.printStackTrace();
			 return null;
		 }//end of try		 
		 return paramValue;
	 }//paraEncode


	/*************************************************************************
	 *  Ķ  ѱ encoding Ѵ.
	 *   null̶   Ķ͸   ִ.
	 * @param <code>String</code> _paramValue : encoding 
	 * @param <cdoe>String</code> _nullToValue : _paramValue null  ü 
	 * @return <code>String</code> paramValue : encoding 
	 **/
	 public static String paramEncode(String _paramValue, String _nullToValue)
	 {
		 String paramValue = _paramValue;
		 String nullToValue = _nullToValue;
		 
		 if (paramValue == null){
			 paramValue = nullToValue;
		 }
		 else
		 {
			 try{
				 paramValue = URLEncoder.encode(paramValue);
			 }catch(NullPointerException e){}
			 
		 }			
		 
		 return paramValue;
	 }//paraEncode

 	/*************************************************************************
	 * ڵ Ǿ Ѿ Ķ  decoding Ѵ.
	 * @param <code>String</code> _paramValue : encoding 
	 * @return <code>String</code> paramValue : decoding 
	 **/
	 public static String paramDecode(String _paramValue)
	 {
		 String paramValue = _paramValue;
		 try{
			 paramValue = URLDecoder.decode(paramValue);
		 }
		 catch (Exception e){
			 e.printStackTrace();
			 return null;
		 }//end of try		 
		 return paramValue;
	 }//paraEncode


	/*************************************************************************
	 * ڵ Ǿ Ѿ Ķ  decoding Ѵ.
	 *   null̶   Ķ͸   ִ.
	 * @param <code>String</code> _paramValue : encoding 
	 * @param <cdoe>String</code> _nullToValue : _paramValue null  ü 
 	 * @return <code>String</code> paramValue : decoding 
	 **/
	 public static String paramDecode(String _paramValue, String _nullToValue)
	 {
		 String paramValue = _paramValue;
		 String nullToValue = _nullToValue;
		 
		 if (paramValue == null){
			 paramValue = nullToValue;
		 }
		 else
		 {
			 try{
				 paramValue = URLDecoder.decode(paramValue);
			 }catch(Exception e){}
		 }		
		 
		 return paramValue;
	 }//paraEncode
	
	/*************************************************************************************************************
	 * NULL  üũ ʱⰪ setting
	 *************************************************************************************************************/
	 
	/*************************************************************************
	 *	NULL ̸ "" return Ѵ.
	 **/
	public static String toNNull(String s)
	{
		if(s == null)
			return "";
		if("null".equals(s))
			return "";
		else
			return s;
	}

	/*************************************************************************
	 *	NULL ̰ų "" ̸ ʱⰪ y return Ѵ.
	 **/
	public static String toNNull(String s,String y)
	{
		if(s == null)
			return y;
		if("null".equals(s))
			return y;
		if ("".equals(s))
			return y;
		else
			return s;
	}
	
	/*************************************************************************************************************
	 *¥(DATE) Լ  
	 *************************************************************************************************************/

	/*************************************************************************
	 *	System  ¥ return
	 * return 20020701
	 **/	
	public static String currentDate()
	{
		Calendar calendar = Calendar.getInstance();
		int i = calendar.get(1);
		int j = calendar.get(2) + 1;
		int k = calendar.get(5);
		String s = "";
		s = s + i;
		if(j < 10)
			s = s + "0";
		s = s + j;
		if(k < 10)
			s = s + "0";
		s = s + k;
		return s;
	}

	/*************************************************************************
	 *	System  ¥ return
	 * retun int[0]=2002, int[1]=7, int[2]=1
	 **/	
	public static int[] getDefaultDay() 
	{                   
  		int arrDate[] = new int[3]; 		
		Calendar cr = Calendar.getInstance();
		
		arrDate[0] = cr.get( Calendar.YEAR );
		arrDate[1] = cr.get( Calendar.MONTH ) + 1;
		arrDate[2] = cr.get( Calendar.DATE );
		return arrDate;
	}
	 
	 /*************************************************************************
	 * 1 ~ 10("2002-07-01" ) 	--> div_c='1'
	 * 11 ~ 20("2002-07-13" ) 	--> div_c='2'
	 * 21 ~ ("2002-07-27" ) 	--> div_c='3'
	 **/
	public static char chgDivDate(String sysDate)
	{ 
		char div_c=' ';
		String _date[] = HttpUtil.toNullDateFormat(sysDate, "-");

		int div_int = Integer.parseInt( _date[2] );

		if( (0<div_int) && (div_int<11) )
			div_c = '1';	
		else if( (10<div_int) && (div_int<21) )
			div_c = '2';
		else if( (20<div_int) && (div_int<32) )
			div_c = '3';
		
		return div_c;
	}
	 
	 /*************************************************************************
	 * sep  е String  ¥ ͸ sep  δ.
	 * "2002-07-01" 	--> return str[0]:2002, str[2]:07, str[2]:01
	 * "2002/07/01" 		--> return str[0]:2002, str[2]:07, str[2]:01
	 **/
	public static String[] toNullDateFormat(String str, String sep)
	{
		String tokenDate[] = new String[3];

		try
		{
			StringTokenizer strT = new StringTokenizer(str, sep);
			if(strT.hasMoreTokens() && (strT.countTokens() == 3))
			{
				//ù° ū  Ÿ.
				tokenDate[0] = strT.nextToken();

				//ι° ū  Ÿ.
				tokenDate[1] = strT.nextToken();

				//° ū  Ÿ.
				tokenDate[2]  = strT.nextToken();
			}else if( str.length() == 8 )
			{
				tokenDate[0] = str.substring(0,4);
				tokenDate[1] = str.substring(4,6);
				tokenDate[2] = str.substring(6);
			}
			return tokenDate;
		}catch(Exception ex)
		{
			Calendar cr = Calendar.getInstance();
			tokenDate[0] = cr.get( Calendar.YEAR ) + "";
			tokenDate[1] = (cr.get( Calendar.MONTH ) + 1) + "";
			tokenDate[2] = cr.get( Calendar.DATE ) + "";
			return tokenDate;
		}
	}

	/*************************************************************************
	 *	 Է ŭ ¥ ϱ (1  10  100 ... -1, -10, -100)		
	 * 1) CalculateDate(3) --> Default Today(20020703) 		return 20020706
	 * 1) CalculateDate("20020703",13) -->  return 20020716
	 **/
	
	public static String CalculateDate(String strtDate, int day) 
	{
		try{
			return HttpUtil.CalculateDate(strtDate, day, "yyyyMMdd");
		}catch( ParseException pe )
		{	return strtDate;	}
	}

	public static String CalculateDate(int day) 
	{
		try{
			return HttpUtil.CalculateDate(HttpUtil.currentDate(), day, "yyyyMMdd");
		}catch( ParseException pe )
		{	return HttpUtil.currentDate();	}
	}
	
	public static String CalculateDate(String strtDate, int day, String format) throws ParseException
	{
		String resultDate = "";
		
		SimpleDateFormat formatter = new SimpleDateFormat (format, Locale.UK);
		Calendar calendar = formatter.getCalendar();
		Date date = HttpUtil.check(strtDate, format);
		date.setTime(date.getTime() + ((long)day * 1000 * 60 * 60 * 24));
		
		calendar.setTime(date);
		
		int rightYear = calendar.get( Calendar.YEAR );
		resultDate = rightYear+"";
		
		int rightMonth = calendar.get( Calendar.MONTH ) + 1;
		
		if( rightMonth <10 ) 
			resultDate += "0"+rightMonth;
		else 
			resultDate += rightMonth+"";
		int rightDate = calendar.get( Calendar.DATE );
		if( rightDate <10 ) 
			resultDate += "0"+rightDate;
		else 
			resultDate += rightDate + "";

		return resultDate;
	}
	
	/*************************************************************************
	 *             ¥   Ѵ..                  
	 *	HttpUtil.calGapDate("20021225", "20030101", "yyyyMMdd"); -> 7
	 **/
	public static int calGapDate(String to, String from, String format) throws ParseException
	{
		int gap =0;
		
		SimpleDateFormat formatter = new SimpleDateFormat (format, Locale.UK);
		Calendar calendar = formatter.getCalendar();
		Date date_to = HttpUtil.check(to, format);
		Date date_from = check(from, format);
		
		gap = (new Long((date_from.getTime() - date_to.getTime()) / ((new Integer(1000 * 60 * 60 * 24)).longValue()))).intValue();
		return gap;
	}
	
	/*************************************************************************
	 *         .                  
	 *	HttpUtil.getLastDay("200212"); 
	 **/
	public static String getLastDay(String month) throws ParseException
	{
		String lastDay = "";
		try
		{
			String tDay = (HttpUtil.CalculateDate(month+"01", 31, "yyyyMMdd")).substring(0,6);
			lastDay = (HttpUtil.CalculateDate(tDay+"01", -1, "yyyyMMdd")).substring(6);
		}catch( ParseException pe )
		{	
			lastDay = (HttpUtil.currentDate()).substring(6);	
		}
		
		return lastDay;
	}
	
	/*************************************************************************
	 *            year, month, week, day   ش.                  
	 *	HttpUtil.whichDayWeek("20021126", "yyyyMMdd");
	 **/
	public static int[] whichDayWeek(String s, String format) throws ParseException 
	{
		int calDate[] = new int[4];
		SimpleDateFormat formatter = new SimpleDateFormat (format, Locale.UK);
		Date date = check(s, format);
		Calendar calendar = formatter.getCalendar();
		calendar.setTime(date);

		calDate[0] = calendar.get( Calendar.DATE );
		calDate[1] = calendar.get(Calendar.DAY_OF_WEEK);
		calDate[2] = calendar.get( Calendar.MONTH ) + 1;
		calDate[3] = calendar.get( Calendar.YEAR );
		return calDate;
	}
	
	public static String getWeek(String _date, char f ) throws Exception 
	{
        	int dayOfWeek = (HttpUtil.whichDayWeek(_date, "yyyyMMdd"))[1];
                String w="";
            
                if (dayOfWeek == Calendar.MONDAY) 			w = ((f=='K')?"":"MON");
                else if (dayOfWeek == Calendar.TUESDAY) 		w = ((f=='K')?"ȭ":"TUE");
                else if (dayOfWeek == Calendar.WEDNESDAY) 	w = ((f=='K')?"":"WED"); 
                else if (dayOfWeek == Calendar.THURSDAY) 		w = ((f=='K')?"":"THU");
                else if (dayOfWeek == Calendar.FRIDAY) 			w = ((f=='K')?"":"FRI");
                else if (dayOfWeek == Calendar.SATURDAY) 		w = ((f=='K')?"":"SAT");
                else if (dayOfWeek == Calendar.SUNDAY) 		w = ((f=='K')?"":"SUN");
                return w;
        }
	
	/*************************************************************************
	 *              yyyyMMdd  ´ Ȯ                    
	 *
	 **/
	public static Date check(String s, String format) throws ParseException 
	{
		if ( s == null )
			throw new ParseException("date string to check is null", 0);
		if ( format == null )
			throw new ParseException("format string to check date is null", 0);
		SimpleDateFormat formatter =  new SimpleDateFormat (format, Locale.UK);
		Date date = null;
		try {
			date = formatter.parse(s);
		}
		catch(ParseException e) {  
			throw new ParseException(" wrong date:\"" + s +  "\" with format \"" + format + "\"", 0);
		}
		if ( ! formatter.format(date).equals(s) )
			throw new ParseException( "Out of bound date:\"" + s + "\" with format \"" + format + "\"", 0);
		return date;
	}	

	/*************************************************************************************************************
	 * ð(TIME) Լ  
	 *************************************************************************************************************/
	
	/*************************************************************************
	 *	System  ð return
	 * retun 10  24
	 **/	
	public static String getCurrentTime()
	{
		SimpleDateFormat simpledateformat = new SimpleDateFormat("HH '\uC2DC' mm '\uBD84'");
		Date date = new Date();
		String s = simpledateformat.format(date);
		return s;
	}
	
	/*************************************************************************
	 *	System  ð return
	 * retun 1024
	 **/	
	public static String CurrentTimeHHmm()
	{
		SimpleDateFormat simpledateformat = new SimpleDateFormat("HHmm");
		Date date = new Date();
		String s = simpledateformat.format(date);
		return s;
	} 
	
	/*************************************************************************
	 * 0000 ~ 1200 	--> div_c='1'
	 * 1201 ~ 2400 	--> div_c='2'
	 **/
	public static char chgDivTime(String sysTime)
	{ 
		char div_c=' ';
		int div_int = Integer.parseInt(sysTime);

		if( (0<=div_int) && (div_int<=1200) )
			div_c = '1';	
		else if( (1200<div_int) && (div_int<2400) )
			div_c = '2';
			
		return div_c;
	}

	/*************************************************************************************************************
	 * 
	 *************************************************************************************************************/
	 
	/*************************************************************************
	 * ù Ʈ(ĺ) upperCaseϰ  lowerCase Ѵ.(ڴ blank )
	 * han KYUNG ShIN 		--> Han Kyung Shin
	 * queen of my Heart	--> Queen Of My Heart
	 **/ 
	public static String firstUpper(String str)
	{
		int tknCnt = 0;
		String t_str = "";
		StringBuffer sb = new StringBuffer();

		try
		{
			StringTokenizer strT = new StringTokenizer(str, " ");
			tknCnt = strT.countTokens();
			
			if( tknCnt > 0 )
			{
				for(int i=0; i<tknCnt; i++)
					sb.append( HttpUtil.firstUpperCase((String)strT.nextToken()) +" ");

				t_str = sb.toString();
			}else
				t_str = HttpUtil.firstUpperCase(str);			
			
			return t_str;
		}catch(Exception ex)
		{
			return str;
		}
	}

	public static String firstUpperCase(String str)
	{
		String t_str = "";
		byte _byte[] = null;
		try
		{
			if( str.length() > 0 )
			{
				t_str = str.substring(0,1);
				_byte = t_str.getBytes();
				if( (t_str.getBytes().length == 1) && 
					( (_byte[0]>=97 && _byte[0]<=122)  ||
					  (_byte[0]>=65 && _byte[0]<=90) )	
					)
					str = t_str.toUpperCase() + (str.substring(1)).toLowerCase();
				return str;
			}else
				return "";

		}catch(Exception ex)
		{
			return str;
		}
	}
	 
	/**************************************************************************
	 * ڿ ȯ.
	 * 
	 **/
	public static String strReplace(String str,String oldChar,String newChar)
	{
		for(int index = 0; (index = str.indexOf(oldChar, index)) >= 0; index += newChar.length()){
			str = str.substring(0,index) + newChar + str.substring(index + oldChar.length());
		}

		return str;
	}
	 
	/**************************************************************************
	 * 3ڸ ĸ(,) ־ִ Լ
	 * 
	 **/
	public static String commaDigits(String comm)
	{
		String tStr = "";
		int flag = 0;
		//comm.replaceAll(",",""); JDK 1.4  ĺ
		comm = HttpUtil.removeTkn(comm,",");

		if(Integer.parseInt(comm)<0)
		{
			flag = 1;
			comm = Integer.parseInt(comm)*(-1)+"";
		}
		
		int tLen = comm.length();
		if (tLen <= 3 )
			tStr = comm;
		else
		{
			for(int i=0; i<tLen; i++)
			{
				if (i!=0 && ( i % 3 == tLen % 3) )     
					tStr += ",";
				tStr += comm.charAt(i);
			}
		}
		if(flag == 1)	tStr = "-" + tStr;
		
		return tStr;
	}
	
	/**************************************************************************
	 *  Ưȣ(\/\$\^\*\(\)\+\.\?\\\{\}\|\[\]-:,  etc)  
	 * removeTkn(str,  ū(') );
	 * 2002-07-01 			--> 20020701 (str, "-");
	 * han,kyung,shin		--> hankyungshin (str, ",");
	 **/
	public static String removeTkn(String str, String sep)
	{
		String t_str = "";
		StringBuffer sb = new StringBuffer();
		StringTokenizer strT = new StringTokenizer(str, sep);
		int tknCnt = strT.countTokens();
		
		if( tknCnt > 0 )
		{
			while( strT.hasMoreTokens() )
				sb.append( strT.nextToken() );
			t_str = sb.toString();
		}else
			t_str = str;			
		
		return t_str;
	}

	/*********************************************************
	 * Remove Blank
	 * rmvBlank() Լ.
	 *
	 */
	public static String rmvBlank(String chkStr) 
	{
		String str = "";
		for (int i = 0;i < chkStr.length();i++) 
		{
			char ch = chkStr.charAt(i);
			if (ch != ' ') str += ch;
		}
		return str;              
	}
	
	/*********************************************************
	 * String length Column size ʰ  column size  ɰ  Field  setting Ѵ.
	 *	char c[] : content(۳ ü) 
	 *  	BS : column size                
	 */
	public static int byteToUnicode(byte b[], char c[], int BS, String content[]) throws Exception 
	{
		int byteSize = 0;					// byte size(1byte)
		int unicdSize = 0;					// unicode(2byte)
		int add=0;							// increase
		int NLU = 0;						// \n unicode
		int lastChar = 0;					// Last getChars
		int NLB[] = new int[content.length];		// \n byte
		int NLBO[] = new int[content.length];	// \n byte


		for( unicdSize =0; (unicdSize<c.length && add<content.length); unicdSize++ )
		{
			if( c[unicdSize] > 127 )
				byteSize +=2;	
			else
			{
				if( c[unicdSize] == 10 )
				{
					if( add==0 ) NLB[add] = byteSize+1;
					else NLB[add] = NLB[add-1] + byteSize+1;
					NLBO[add] = byteSize+1;
					NLU = unicdSize;
				}
				byteSize++;
			}
			
			if( (BS <= byteSize) && (add < content.length) )
			{
				if( NLU == 0 )
				{
					if( add==0 ) NLB[add] = byteSize;
					else NLB[add] = NLB[add-1] + byteSize;
					NLBO[add] = byteSize;
					NLU = unicdSize;
				}
				
				if( add == (content.length-2) )
					lastChar = NLU;
				unicdSize = NLU;
				NLU = 0;
				byteSize = 0;
				if( add != (content.length-1) )
					add++;
			}
		}

		if( add==0 ) 
			content[0] = new String(b, 0, b.length, "KSC5601");
		else 
		{
			for(int j=0; j<=add; j++)
			{
				if( j==0 ) 
					content[j] = new String(b, 0, NLBO[j], "KSC5601");
				else if( j==add )
				{
					if( b.length-NLB[j-1] < BS )
						content[j] = new String(b, NLB[j-1], b.length-NLB[j-1], "KSC5601");
					else
						//content[j] = new String(c, lastChar, (new Double(Math.floor(BS/2.0)).intValue()) );
						content[j] = new String(c, lastChar, BS/2);
				}
				else
					content[j] = new String(b, NLB[j-1], NLBO[j], "KSC5601");
			}
		}
		return add;
	}
	
	/*********************************************************
	 * substirng
	 *
	 *
	 */
	public static String getSubString( String str, int start )
	{
		if( str==null || "".equals(str) )
			str = "";
		else if( str.length() <= start )
			str = "";
		else
			str = str.substring(start);
		return str;
	}
	
	/*********************************************************
	 * byte substring
	 *
	 *
	 */
	public String getShortString( String str, int byteSize )
	{
		int rSize = 0;
		int len = 0;
		
		if ( str.getBytes().length > byteSize ) 
		{
			for ( ; rSize < str.length(); rSize++ ) {
				if ( str.charAt( rSize ) > 0x007F )
					len += 2;
				else 
					len++;
					
				if ( len > byteSize )
					break;
			}
			str = str.substring( 0, rSize );
		}
		
		return str;
	}
	
	/*********************************************************
	 * Bean Class  ""  ʱȭ
	 *
	 */
	public static void fixBlank(Object o)
	{
		if ( o == null ) return;
		
		Class c = o.getClass();
		if ( c.isPrimitive() ) return;
		
		Field[] fields = c.getFields();
		for (int i=0 ; i<fields.length; i++) 
		{
			try {
				Object f = fields[i].get(o);
				Class fc = fields[i].getType();
				
				if ( fc.getName().equals("java.lang.String") ) 
				{
					fields[i].set(o, "");
				}
			}
			catch(Exception e){
			}
		}
	}
	
	/*********************************************************
	 * TextArea ó
	 *
	 */
	public static String setContent(String content)
	{
		StringBuffer sb = new StringBuffer();
		
		char[] c = new char[content.length()];
		content.getChars(0, content.length(), c, 0);
		
		for(int i=0; i<c.length; i++)
		{
			if( c[i] !=13 )	
			{
				if( c[i]==10 )
					sb.append("<br>");
				else
					sb.append( (char)c[i] );
			}
		}
		
		return sb.toString();
	}

//  ... ó...
	public static String shortTitle(String str,int i){
		String rtn = str;

		if (rtn == null)
		{
			rtn = "";

		}else{
			if(rtn.length() > i) rtn = rtn.substring(0,i) + "...";
		}

		return rtn;
	}

// Ȯ ó...
	public static String fileExt(String str){
		String rtn = "";
		StringTokenizer st = new StringTokenizer(str,".");

		while(st.hasMoreTokens()){
			rtn = (String)st.nextToken();
		}

		return rtn;
	}


// Ȯڿ  ̹ ó...
	public static String fileExtImg(String str){
		String ext = str.toLowerCase();
		String rtn = "etc";

		if(ext.equals("bmp")){
			rtn = "bmp";
		}else if(ext.equals("doc")){
			rtn = "doc";
		}else if(ext.equals("exe")){
			rtn = "exe";
		}else if(ext.equals("gif")){
			rtn = "gif";
		}else if(ext.equals("htm")){
			rtn = "htm";
		}else if(ext.equals("hwp")){
			rtn = "hwp";
		}else if(ext.equals("jpg")){
			rtn = "jpg";
		}else if(ext.equals("rar")){
			rtn = "rar";
		}else if(ext.equals("txt")){
			rtn = "txt";
		}else if(ext.equals("zip")){
			rtn = "zip";
		}

		return rtn;
	}
	
	/*********************************************************
	 * JDK 1.4      replaceAll()    ϴ Լ
	 * JDK 1.4   
	 *
	 */
	public static String replace(String str, String sOld, String sNew) 
	{
		StringBuffer sb = new StringBuffer();
		while(str.length() != 0) 
		{
			int begin = str.indexOf(sOld);
			if(begin == -1) 
			{
				sb.append(str);
				break;
			} else 
			{
				int end = begin + sOld.length();
				sb.append(str.substring(0, begin));
				sb.append(sNew);
				str = str.substring(end);
			}
		}
		return sb.toString();
	}
	
	/*********************************************************
	 * JDK 1.4    
	 * replaceAll() Լ.
	 *
	 */
	public static String replaceAllUtil(String tkn)
	{
		//return tkn.replaceAll(",","");
		return "";
	}
	
	public static String replaceAllUtil(String tkn, String a, String b)
	{
		//return tkn.replaceAll(a,b);
		return "";
	}
	
	
}
