package kal.base.com.util;

import java.io.*;
import java.util.*;
import java.lang.reflect.Array;
import java.lang.reflect.Field;

/**
 *   Ͻʽÿ.
 * ۼ ¥: (2002-07-11  11:27:55)
 * @author: chkim-K
 */
public class ObjectPrinter {

	String section = ";";
	
	public ObjectPrinter()
	{	
		section = ";";
	}
	
	public ObjectPrinter(String sec)
	{	
		section = sec;
	}
	
	public String getNames(Object entity) throws Exception
	{
		StringBuffer sb = new StringBuffer();
		if ( entity == null )
			throw new NullPointerException("null entity class");
	
		Class c = entity.getClass();
		Field field[] = c.getFields();
		String fieldname = "";
		
		try 
		{
			for (int i=0 ; i<field.length; i++) 
			{
				fieldname = field[i].getName();
				sb.append(fieldname + section); 
			}
			return sb.toString();
		}catch(Exception e){
			return "";		
		}
	}
	
	public String getTypes(Object entity) throws Exception
	{
		StringBuffer sb = new StringBuffer();
		if ( entity == null )
			throw new NullPointerException("null entity class");
	
		Class c = entity.getClass();
		Field field[] = c.getFields();
		String fieldtype = "";
		
		try 
		{
			for (int i=0 ; i<field.length; i++) 
			{
				fieldtype = field[i].getType().getName();
				if( fieldtype.equals("java.lang.String") ) fieldtype = "VARCHAR";
				else if( fieldtype.equals("int") ) fieldtype = "NUMERIC";
				else if( fieldtype.equals("long") ) fieldtype = "NUMERIC";
				else if( fieldtype.equals("double") ) fieldtype = "NUMERIC";
				else if( fieldtype.equals("float") ) fieldtype = "NUMERIC";
				else if( fieldtype.equals("boolean") ) fieldtype = "VARCHAR";
				sb.append(fieldtype + section); 
			}
			return sb.toString();
		}catch(Exception e){
			return "";		
		}
	}

	public String getValues(Object entity) throws Exception
	{
		StringBuffer sb = new StringBuffer();
		if ( entity == null )
			throw new NullPointerException("null entity class");
	
		Class c = entity.getClass();
		Field field[] = c.getFields();
		String fieldtype = "";
		String fieldname = "";
		
		try 
		{
			for (int i=0 ; i<field.length; i++) 
			{
				fieldtype = field[i].getType().getName();
				fieldname = field[i].getName();

				if ( fieldtype.equals("java.lang.String")) {
					sb.append(field[i].get(entity) + section); 
				}
				else if ( fieldtype.equals("int")) {
					sb.append(field[i].getInt(entity) + section); 
				}
				else if ( fieldtype.equals("double")) {
					sb.append(field[i].getDouble(entity) + section); 
				}
				else if ( fieldtype.equals("long")) {
					sb.append(field[i].getLong(entity) + section); 
				}
				else if ( fieldtype.equals("float")) {
					sb.append(field[i].get(entity) + section); 
				}
				else if ( fieldtype.equals("boolean")) {
					sb.append(field[i].getBoolean(entity) + section); 
					
				}
			}
			return sb.toString();
		}catch(Exception e){
			return "";		
		}
	}
}