package kal.base.ffs.dbbean;

import java.util.ArrayList;
import java.util.HashMap;

import kal.base.jdf.db.EntityData;

/**
 * Flight Following Chart - Enroute ȭ鿡  Entity
 * ۼ ¥: 2007-01-09
 * @author: 
 */
public class FfsQ030BG extends EntityData {
		
	//
	private String syskey; //2007.03.22 ߰
	
	// 2007.01.17 ߰
	private String ddMonYy;
	private String std;
	private String atd;
	private String planid;
	
	private String sta; //2007.06.26 ߰
	
	private String schDdMonYy; //2007.07.09 ߰
	
	private String estDepDt;
	private String regionCd;
	private String lcfRatio; // 2007.03.07 ߰
	private String fltNum;
	
	private String dailySactyp; //2007.06.28 ߰
	private String actypMel; //2007.06.28 ߰
	
	private String restrictE; //2007.06.28 ߰
	
	private String pmsn; //2007.06.28 ߰
	private String firstLegFltDt; //2007.06.28 ߰
	private String schDepDt; //2007.06.28 ߰
	
	private String regno;
	
	private String mel; //2007.06.28 ߰
	
	private String sactyp;
	private String stnfr;
	private String stnto;
	private String tkofT;
	private String estArvDt;
	private String curTime; // 2007.02.12 ߰
	private String altPort;
	private String extrFuel;
	private String discAlert;
	
	
	private String speed;
	private String etopsPorts;
	private String refilePoint;
	private String refilePort;
	private String refileAltPorts;
	
	private String posTmpst; //2007.07.26 ߰ : Call Sign   ǥϱ  .
	private String rmkTmpst; //2007.07.26 ߰ : Call Sign   ǥϱ  .
	
	private String naiY; //2008.12.22 ߰
	
	private String diffMin; //2008.12.22 ߰
	
	//
	private String posMsg; // 2007.01.30 ߰
	
	// 2007.02.05 ߰
	private String divert;
	private String fltLevel;
	private String fob;
	private String pointAta;
	private String waypointMismatch;
	
	private String fltNumColor;
	private String regnoColor;
	private String wxStnfr;
	private String wxStnto;
	private String takeOff;
	private String eta;
	private String etd;//2016.12.12
	private String wxAltPort;
	private String extraFuel;
	private String crzMode;
	private String wxEtopPort;
	private String wxRefilePort;
	private String wxRefileAltPort;
	//private String notamStnfr;
	//private String notamStnto;
	//private String notamAltPort;
	//private String notamEtopPort;
	//private String notamRefilePort;
	//private String notamRefileAltPort;
	private String notam; //2007.06.26 ߰
	
	//2011.12.06 ߰
	private String manWxStnfr;
	private String manWxStnto;
	private String manWxAlertPort;
	
	private String allColumns;
	
	//ȭ
	private String regionD;
	private String lcfD; // 2007.03.07 ߰
	private String callSignD;
	private String acRegD;
	private String acTypeD;
	private String podD;
	private String poaD;
	private String toD;
	private String etaD;
	private String etdD; //2016.12.12
	private String statusD; // 2007.02.12 ߰
	private String altD;
	private String ccfD; //2010.03.29 ߰
	private String extraD;
	private String cruiseModeD;
	private String etopsD;
	private String refileD;
	//private String nfD;
	//private String ntD;
	//private String naD;
	//private String neD;
	//private String nrD;
	//private String nraD;
	private String notamD; //2007.06.26 ߰
	
	// 2007.01.24 ߰
	private String colorAR;
	private String tagAR;
	private String remarksAR;
	
	//2007.05.22 ߰
	private String smiFltNum;
	private String smiTimeStamp;
	private String acarsD;
	
	//2007.05.29 ߰
	private String mFltNum;
	private String mSmi;
	private String mRawMsg;
	
	//2008.09.23 ߰
	private String checkTakeoff;
	private String checkPos;
	private String dataTakeoff;
	private String dataPos;
	
	//2010.03.29 ߰
	private String padFuel;
	private String extrTank;
	
	//2011.06.07 ߰
	private String arvGap;
	
	//	2013.04.24 ߰
	private String etaMsg;
	
	//	@2014.02.21߰
	private String altHightime;

	//	@2014-05-21
	private	ArrayList<HashMap> frightPlanCheckLogT		;//new ArrayList<HashMap>(10);
	private String altEnrouteFuel;
	private String altRefileFuel;
	private String altFuelOverburn;
	private String refileEra;
	private String altRefileAcars;
	private String d1;
	private String d2;
	private String d3;
	private String d4;
	private String d5;
	private String d6;
	private String d7;
	
	//2016.12.12 ߰
	private String d8;
	private String d9;
	
	private String schArvDt;
	private String planConfirm;
	private String isCommented;
	private String staD;
	private String chkD;
	private String altEnrouteFule;
	private String altRefileFule;
	private String altFuleOverburn;
	//	@2014-07-22
	private String plnExtrFuel1;
	private String plnExtrRsn1;
	private String plnExtrFuel2;
	private String plnExtrRsn2;
	private String extrFuelDisc;
	
	//20140903 FLIGHT_ALERT_T.DOC_NO, PRV_DOC_NO ߰
	private String docNo;
	private String prvDocNo;
	
	//20140918 PLN_TANK_FUEL ߰
	private String plnTankFuel;
	
	//2016.12.12 LANT_T, ROUTE ߰
	private String landT;
	private String route;
	
	//20160415 ߰
	private String gbn;
	private String tankeringAlert;
	private String pmsnAlert;
	private String callsignAlert;
	private String posMsgAlert;
	private String fltLevelAlert;
	private String pointAtaAlert;
	private String melAlert;
	private String hightimeAlert;
	private String enrouteFuel;
	private String refileFuel;
	private String fuelOverburn;
	private String refileAcars;
	private String actDepDt;
	private String tkofDt;
	private String taxiTimeAlert;
	private String abhr;
	private String etaAlert;
	private String progress;
	private String remainTime;
	private String edtoEtp;
	private String weatherAlert;
	private String commented;
	private String estDate;
	private	ArrayList<HashMap> flightPlanCheckLogT;
	private String legNum;
	private	String releaseSyskey;
	private String extrPad;
	
	//@2018-04-04				
	private String etopsY= null;
	private String edtoConfirm= null;
	
	//@2018-08-23
	private String eldt;
	private String eldtAlert;
	private String eldtManual;
		
	//@2018-10-11
	private String psnSendAcars;
	private String psnMin;
	private String psnManualDt;

	//-----------------------------------	plnExtr
	public String getPlnExtrFuel1() {
		return plnExtrFuel1;
	}
	public void setPlnExtrFuel1(String plnExtrFuel1) {
		this.plnExtrFuel1 = plnExtrFuel1;
	}	
	public String getPlnExtrRsn1() {
		return plnExtrRsn1;
	}
	public void setPlnExtrRsn1(String plnExtrRsn1) {
		this.plnExtrRsn1 = plnExtrRsn1;
	}
	public String getPlnExtrFuel2() {
		return plnExtrFuel2;
	}
	public void setPlnExtrFuel2(String plnExtrFuel2) {
		this.plnExtrFuel2 = plnExtrFuel2;
	}
	public String getPlnExtrRsn2() {
		return plnExtrRsn2;
	}
	public void setPlnExtrRsn2(String plnExtrRsn2) {
		this.plnExtrRsn2 = plnExtrRsn2;
	}
	public String getExtrFuelDisc() {
		return extrFuelDisc;
	}
	public void setExtrFuelDisc(String extrFuelDisc) {
		this.extrFuelDisc = extrFuelDisc;
	}
	//-----------------------------------	altEnrouteFuel
	public String getAltEnrouteFuel(){
		return altEnrouteFuel;
	}
	public void setAltEnrouteFuel(String altEnrouteFuel){
		this.altEnrouteFuel	=	altEnrouteFuel;
	}
	//-----------------------------------	altRefileFuel
	public String getAltRefileFuel(){
		return altRefileFuel;
	}
	public void setAltRefileFuel(String altRefileFuel){
		this.altRefileFuel	=	altRefileFuel;
	}
	//-----------------------------------	altFuelOverburn
	public String getAltFuelOverburn(){
		return altFuelOverburn;
	}
	public void setAltFuelOverburn(String altFuelOverburn){
		this.altFuelOverburn	=	altFuelOverburn;
	}
	//-----------------------------------	refileEra
	public String getRefileEra(){
		return refileEra;
	}
	public void setRefileEra(String refileEra){
		this.refileEra	=	refileEra;
	}
	//-----------------------------------	altRefileAcars
	public String getAltRefileAcars(){
		return altRefileAcars;
	}
	public void setAltRefileAcars(String altRefileAcars){
		this.altRefileAcars	=	altRefileAcars;
	}
	//-----------------------------------	d1
	public String getD1(){
		return d1;
	}
	public void setD1(String d1){
		this.d1	=	d1;
	}
	//-----------------------------------	d2
	public String getD2(){
		return d2;
	}
	public void setD2(String d2){
		this.d2	=	d2;
	}
	//-----------------------------------	d3
	public String getD3(){
		return d3;
	}
	public void setD3(String d3){
		this.d3	=	d3;
	}
	//-----------------------------------	d4
	public String getD4(){
		return d4;
	}
	public void setD4(String d4){
		this.d4	=	d4;
	}
	//-----------------------------------	d5
	public String getD5(){
		return d5;
	}
	public void setD5(String d5){
		this.d5	=	d5;
	}
	//-----------------------------------	d6
	public String getD6(){
		return d6;
	}
	public void setD6(String d6){
		this.d6	=	d6;
	}
//	-----------------------------------	d7
	public String getD7(){
		return d7;
	}
	public void setD7(String d7){
		this.d7	=	d7;
	}
	
	//2016.12.12 ߰
	public String getD8(){
		return d8;
	}
	public void setD8(String d8){
		this.d8	=	d8;
	}
	
	public String getD9(){
		return d9;
	}
	public void setD9(String d9){
		this.d9	=	d9;
	}
	
	//-----------------------------------	schArvDt
	public String getSchArvDt(){
		return schArvDt;
	}
	public void setSchArvDt(String schArvDt){
		this.schArvDt	=	schArvDt;
	}
	//-----------------------------------	planConfirm
	public String getPlanConfirm(){
		return planConfirm;
	}
	public void setPlanConfirm(String planConfirm){
		this.planConfirm	=	planConfirm;
	}
	//-----------------------------------	isCommented
	public String getIsCommented(){
		return isCommented;
	}
	public void setIsCommented(String isCommented){
		this.isCommented	=	isCommented;
	}

	public ArrayList<HashMap> getFrightPlanCheckLogT() {
		return frightPlanCheckLogT;
	}
	public void setFrightPlanCheckLogT(ArrayList<HashMap> frightPlanCheckLogT) {
		this.frightPlanCheckLogT = frightPlanCheckLogT;
	}
	
	public String getChkD() {
		return chkD;
	}
	public void setChkD(String chkD) {
		this.chkD = chkD;
	}
	public String getStaD() {
		return staD;
	}
	public void setStaD(String staD) {
		this.staD = staD;
	}
//	-----------------------------------	altEnrouteFule
	public String getAltEnrouteFule(){
		return altEnrouteFule;
	}
	public void setAltEnrouteFule(String altEnrouteFule){
		this.altEnrouteFule	=	altEnrouteFule;
	}
	//-----------------------------------	altRefileFule
	public String getAltRefileFule(){
		return altRefileFule;
	}
	public void setAltRefileFule(String altRefileFule){
		this.altRefileFule	=	altRefileFule;
	}
	//-----------------------------------	altFuleOverburn
	public String getAltFuleOverburn(){
		return altFuleOverburn;
	}
	public void setAltFuleOverburn(String altFuleOverburn){
		this.altFuleOverburn	=	altFuleOverburn;
	}
	
	public String getAltHightime() {
		return altHightime;
	}
	public void setAltHightime(String altHightime) {
		this.altHightime = altHightime;
	}
	
	public String getEtaMsg() {
		return etaMsg;
	}
	public void setEtaMsg(String etaMsg) {
		this.etaMsg = etaMsg;
	}
	

	/**
	 * @return acarsD
	 */
	public String getAcarsD() {
		return acarsD;
	}

	/**
	 * @param acarsD Ϸ acarsD
	 */
	public void setAcarsD(String acarsD) {
		this.acarsD = acarsD;
	}

	/**
	 * @return acRegD
	 */
	public String getAcRegD() {
		return acRegD;
	}

	/**
	 * @param acRegD Ϸ acRegD
	 */
	public void setAcRegD(String acRegD) {
		this.acRegD = acRegD;
	}

	/**
	 * @return acTypeD
	 */
	public String getAcTypeD() {
		return acTypeD;
	}

	/**
	 * @param acTypeD Ϸ acTypeD
	 */
	public void setAcTypeD(String acTypeD) {
		this.acTypeD = acTypeD;
	}

	/**
	 * @return actypMel
	 */
	public String getActypMel() {
		return actypMel;
	}

	/**
	 * @param actypMel Ϸ actypMel
	 */
	public void setActypMel(String actypMel) {
		this.actypMel = actypMel;
	}

	/**
	 * @return allColumns
	 */
	public String getAllColumns() {
		return allColumns;
	}

	/**
	 * @param allColumns Ϸ allColumns
	 */
	public void setAllColumns(String allColumns) {
		this.allColumns = allColumns;
	}

	/**
	 * @return altD
	 */
	public String getAltD() {
		return altD;
	}

	/**
	 * @param altD Ϸ altD
	 */
	public void setAltD(String altD) {
		this.altD = altD;
	}

	/**
	 * @return altPort
	 */
	public String getAltPort() {
		return altPort;
	}

	/**
	 * @param altPort Ϸ altPort
	 */
	public void setAltPort(String altPort) {
		this.altPort = altPort;
	}

	/**
	 * @return arvGap
	 */
	public String getArvGap() {
		return arvGap;
	}

	/**
	 * @param arvGap Ϸ arvGap
	 */
	public void setArvGap(String arvGap) {
		this.arvGap = arvGap;
	}

	/**
	 * @return atd
	 */
	public String getAtd() {
		return atd;
	}

	/**
	 * @param atd Ϸ atd
	 */
	public void setAtd(String atd) {
		this.atd = atd;
	}

	/**
	 * @return callSignD
	 */
	public String getCallSignD() {
		return callSignD;
	}

	/**
	 * @param callSignD Ϸ callSignD
	 */
	public void setCallSignD(String callSignD) {
		this.callSignD = callSignD;
	}

	/**
	 * @return ccfD
	 */
	public String getCcfD() {
		return ccfD;
	}

	/**
	 * @param ccfD Ϸ ccfD
	 */
	public void setCcfD(String ccfD) {
		this.ccfD = ccfD;
	}

	/**
	 * @return checkPos
	 */
	public String getCheckPos() {
		return checkPos;
	}

	/**
	 * @param checkPos Ϸ checkPos
	 */
	public void setCheckPos(String checkPos) {
		this.checkPos = checkPos;
	}

	/**
	 * @return checkTakeoff
	 */
	public String getCheckTakeoff() {
		return checkTakeoff;
	}

	/**
	 * @param checkTakeoff Ϸ checkTakeoff
	 */
	public void setCheckTakeoff(String checkTakeoff) {
		this.checkTakeoff = checkTakeoff;
	}

	/**
	 * @return colorAR
	 */
	public String getColorAR() {
		return colorAR;
	}

	/**
	 * @param colorAR Ϸ colorAR
	 */
	public void setColorAR(String colorAR) {
		this.colorAR = colorAR;
	}

	/**
	 * @return cruiseModeD
	 */
	public String getCruiseModeD() {
		return cruiseModeD;
	}

	/**
	 * @param cruiseModeD Ϸ cruiseModeD
	 */
	public void setCruiseModeD(String cruiseModeD) {
		this.cruiseModeD = cruiseModeD;
	}

	/**
	 * @return crzMode
	 */
	public String getCrzMode() {
		return crzMode;
	}

	/**
	 * @param crzMode Ϸ crzMode
	 */
	public void setCrzMode(String crzMode) {
		this.crzMode = crzMode;
	}

	/**
	 * @return curTime
	 */
	public String getCurTime() {
		return curTime;
	}

	/**
	 * @param curTime Ϸ curTime
	 */
	public void setCurTime(String curTime) {
		this.curTime = curTime;
	}

	/**
	 * @return dailySactyp
	 */
	public String getDailySactyp() {
		return dailySactyp;
	}

	/**
	 * @param dailySactyp Ϸ dailySactyp
	 */
	public void setDailySactyp(String dailySactyp) {
		this.dailySactyp = dailySactyp;
	}

	/**
	 * @return dataPos
	 */
	public String getDataPos() {
		return dataPos;
	}

	/**
	 * @param dataPos Ϸ dataPos
	 */
	public void setDataPos(String dataPos) {
		this.dataPos = dataPos;
	}

	/**
	 * @return dataTakeoff
	 */
	public String getDataTakeoff() {
		return dataTakeoff;
	}

	/**
	 * @param dataTakeoff Ϸ dataTakeoff
	 */
	public void setDataTakeoff(String dataTakeoff) {
		this.dataTakeoff = dataTakeoff;
	}

	/**
	 * @return ddMonYy
	 */
	public String getDdMonYy() {
		return ddMonYy;
	}

	/**
	 * @param ddMonYy Ϸ ddMonYy
	 */
	public void setDdMonYy(String ddMonYy) {
		this.ddMonYy = ddMonYy;
	}

	/**
	 * @return diffMin
	 */
	public String getDiffMin() {
		return diffMin;
	}

	/**
	 * @param diffMin Ϸ diffMin
	 */
	public void setDiffMin(String diffMin) {
		this.diffMin = diffMin;
	}

	/**
	 * @return divert
	 */
	public String getDivert() {
		return divert;
	}

	/**
	 * @param divert Ϸ divert
	 */
	public void setDivert(String divert) {
		this.divert = divert;
	}

	/**
	 * @return estArvDt
	 */
	public String getEstArvDt() {
		return estArvDt;
	}

	/**
	 * @param estArvDt Ϸ estArvDt
	 */
	public void setEstArvDt(String estArvDt) {
		this.estArvDt = estArvDt;
	}

	/**
	 * @return estDepDt
	 */
	public String getEstDepDt() {
		return estDepDt;
	}

	/**
	 * @param estDepDt Ϸ estDepDt
	 */
	public void setEstDepDt(String estDepDt) {
		this.estDepDt = estDepDt;
	}

	/**
	 * @return eta
	 */
	public String getEta() {
		return eta;
	}

	/**
	 * @param eta Ϸ eta
	 */
	public void setEta(String eta) {
		this.eta = eta;
	}

	/**
	 * @return etaD
	 */
	public String getEtaD() {
		return etaD;
	}

	/**
	 * @param etaD Ϸ etaD
	 */
	public void setEtaD(String etaD) {
		this.etaD = etaD;
	}
	
	/**
	 * @param eta Ϸ etd 2016.12.12
	 */
	public String getEtd() {
		return etd;
	}
	
	public void setEtd(String etd) {
		this.etd = etd;
	}

	/**
	 * @return etaD
	 */
	public String getEtdD() {
		return etdD;
	}

	/**
	 * @param etaD Ϸ etaD
	 */
	public void setEtdD(String etdD) {
		this.etdD = etdD;
	}

	/**
	 * @return etopsD
	 */
	public String getEtopsD() {
		return etopsD;
	}

	/**
	 * @param etopsD Ϸ etopsD
	 */
	public void setEtopsD(String etopsD) {
		this.etopsD = etopsD;
	}

	/**
	 * @return etopsPorts
	 */
	public String getEtopsPorts() {
		return etopsPorts;
	}

	/**
	 * @param etopsPorts Ϸ etopsPorts
	 */
	public void setEtopsPorts(String etopsPorts) {
		this.etopsPorts = etopsPorts;
	}

	/**
	 * @return extraD
	 */
	public String getExtraD() {
		return extraD;
	}

	/**
	 * @param extraD Ϸ extraD
	 */
	public void setExtraD(String extraD) {
		this.extraD = extraD;
	}

	/**
	 * @return extraFuel
	 */
	public String getExtraFuel() {
		return extraFuel;
	}

	/**
	 * @param extraFuel Ϸ extraFuel
	 */
	public void setExtraFuel(String extraFuel) {
		this.extraFuel = extraFuel;
	}

	/**
	 * @return extrFuel
	 */
	public String getExtrFuel() {
		return extrFuel;
	}

	//2016.07.27 ߰
	public String getDiscAlert() {
		return discAlert;
	}
	
	public void setDiscAlert(String discAlert) {
		this.discAlert = discAlert;
	}	

	/**
	 * @param extrFuel Ϸ extrFuel
	 */
	public void setExtrFuel(String extrFuel) {
		this.extrFuel = extrFuel;
	}

	/**
	 * @return extrTank
	 */
	public String getExtrTank() {
		return extrTank;
	}

	/**
	 * @param extrTank Ϸ extrTank
	 */
	public void setExtrTank(String extrTank) {
		this.extrTank = extrTank;
	}

	/**
	 * @return firstLegFltDt
	 */
	public String getFirstLegFltDt() {
		return firstLegFltDt;
	}

	/**
	 * @param firstLegFltDt Ϸ firstLegFltDt
	 */
	public void setFirstLegFltDt(String firstLegFltDt) {
		this.firstLegFltDt = firstLegFltDt;
	}

	/**
	 * @return fltLevel
	 */
	public String getFltLevel() {
		return fltLevel;
	}

	/**
	 * @param fltLevel Ϸ fltLevel
	 */
	public void setFltLevel(String fltLevel) {
		this.fltLevel = fltLevel;
	}

	/**
	 * @return fltNum
	 */
	public String getFltNum() {
		return fltNum;
	}

	/**
	 * @param fltNum Ϸ fltNum
	 */
	public void setFltNum(String fltNum) {
		this.fltNum = fltNum;
	}

	/**
	 * @return fltNumColor
	 */
	public String getFltNumColor() {
		return fltNumColor;
	}

	/**
	 * @param fltNumColor Ϸ fltNumColor
	 */
	public void setFltNumColor(String fltNumColor) {
		this.fltNumColor = fltNumColor;
	}

	/**
	 * @return fob
	 */
	public String getFob() {
		return fob;
	}

	/**
	 * @param fob Ϸ fob
	 */
	public void setFob(String fob) {
		this.fob = fob;
	}

	/**
	 * @return lcfD
	 */
	public String getLcfD() {
		return lcfD;
	}

	/**
	 * @param lcfD Ϸ lcfD
	 */
	public void setLcfD(String lcfD) {
		this.lcfD = lcfD;
	}

	/**
	 * @return lcfRatio
	 */
	public String getLcfRatio() {
		return lcfRatio;
	}

	/**
	 * @param lcfRatio Ϸ lcfRatio
	 */
	public void setLcfRatio(String lcfRatio) {
		this.lcfRatio = lcfRatio;
	}

	/**
	 * @return manWxAlertPort
	 */
	public String getManWxAlertPort() {
		return manWxAlertPort;
	}

	/**
	 * @param manWxAlertPort Ϸ manWxAlertPort
	 */
	public void setManWxAlertPort(String manWxAlertPort) {
		this.manWxAlertPort = manWxAlertPort;
	}

	/**
	 * @return manWxStnfr
	 */
	public String getManWxStnfr() {
		return manWxStnfr;
	}

	/**
	 * @param manWxStnfr Ϸ manWxStnfr
	 */
	public void setManWxStnfr(String manWxStnfr) {
		this.manWxStnfr = manWxStnfr;
	}

	/**
	 * @return manWxStnto
	 */
	public String getManWxStnto() {
		return manWxStnto;
	}

	/**
	 * @param manWxStnto Ϸ manWxStnto
	 */
	public void setManWxStnto(String manWxStnto) {
		this.manWxStnto = manWxStnto;
	}

	/**
	 * @return mel
	 */
	public String getMel() {
		return mel;
	}

	/**
	 * @param mel Ϸ mel
	 */
	public void setMel(String mel) {
		this.mel = mel;
	}

	/**
	 * @return mFltNum
	 */
	public String getMFltNum() {
		return mFltNum;
	}

	/**
	 * @param fltNum Ϸ mFltNum
	 */
	public void setMFltNum(String fltNum) {
		mFltNum = fltNum;
	}

	/**
	 * @return mRawMsg
	 */
	public String getMRawMsg() {
		return mRawMsg;
	}

	/**
	 * @param rawMsg Ϸ mRawMsg
	 */
	public void setMRawMsg(String rawMsg) {
		mRawMsg = rawMsg;
	}

	/**
	 * @return mSmi
	 */
	public String getMSmi() {
		return mSmi;
	}

	/**
	 * @param smi Ϸ mSmi
	 */
	public void setMSmi(String smi) {
		mSmi = smi;
	}

	/**
	 * @return naiY
	 */
	public String getNaiY() {
		return naiY;
	}

	/**
	 * @param naiY Ϸ naiY
	 */
	public void setNaiY(String naiY) {
		this.naiY = naiY;
	}

	/**
	 * @return notam
	 */
	public String getNotam() {
		return notam;
	}

	/**
	 * @param notam Ϸ notam
	 */
	public void setNotam(String notam) {
		this.notam = notam;
	}

	/**
	 * @return notamD
	 */
	public String getNotamD() {
		return notamD;
	}

	/**
	 * @param notamD Ϸ notamD
	 */
	public void setNotamD(String notamD) {
		this.notamD = notamD;
	}

	/**
	 * @return padFuel
	 */
	public String getPadFuel() {
		return padFuel;
	}

	/**
	 * @param padFuel Ϸ padFuel
	 */
	public void setPadFuel(String padFuel) {
		this.padFuel = padFuel;
	}

	/**
	 * @return planid
	 */
	public String getPlanid() {
		return planid;
	}

	/**
	 * @param planid Ϸ planid
	 */
	public void setPlanid(String planid) {
		this.planid = planid;
	}

	/**
	 * @return pmsn
	 */
	public String getPmsn() {
		return pmsn;
	}

	/**
	 * @param pmsn Ϸ pmsn
	 */
	public void setPmsn(String pmsn) {
		this.pmsn = pmsn;
	}

	/**
	 * @return poaD
	 */
	public String getPoaD() {
		return poaD;
	}

	/**
	 * @param poaD Ϸ poaD
	 */
	public void setPoaD(String poaD) {
		this.poaD = poaD;
	}

	/**
	 * @return podD
	 */
	public String getPodD() {
		return podD;
	}

	/**
	 * @param podD Ϸ podD
	 */
	public void setPodD(String podD) {
		this.podD = podD;
	}

	/**
	 * @return pointAta
	 */
	public String getPointAta() {
		return pointAta;
	}

	/**
	 * @param pointAta Ϸ pointAta
	 */
	public void setPointAta(String pointAta) {
		this.pointAta = pointAta;
	}

	/**
	 * @return posMsg
	 */
	public String getPosMsg() {
		return posMsg;
	}

	/**
	 * @param posMsg Ϸ posMsg
	 */
	public void setPosMsg(String posMsg) {
		this.posMsg = posMsg;
	}

	/**
	 * @return posTmpst
	 */
	public String getPosTmpst() {
		return posTmpst;
	}

	/**
	 * @param posTmpst Ϸ posTmpst
	 */
	public void setPosTmpst(String posTmpst) {
		this.posTmpst = posTmpst;
	}

	/**
	 * @return refileAltPorts
	 */
	public String getRefileAltPorts() {
		return refileAltPorts;
	}

	/**
	 * @param refileAltPorts Ϸ refileAltPorts
	 */
	public void setRefileAltPorts(String refileAltPorts) {
		this.refileAltPorts = refileAltPorts;
	}

	/**
	 * @return refileD
	 */
	public String getRefileD() {
		return refileD;
	}

	/**
	 * @param refileD Ϸ refileD
	 */
	public void setRefileD(String refileD) {
		this.refileD = refileD;
	}

	/**
	 * @return refilePoint
	 */
	public String getRefilePoint() {
		return refilePoint;
	}

	/**
	 * @param refilePoint Ϸ refilePoint
	 */
	public void setRefilePoint(String refilePoint) {
		this.refilePoint = refilePoint;
	}

	/**
	 * @return refilePort
	 */
	public String getRefilePort() {
		return refilePort;
	}

	/**
	 * @param refilePort Ϸ refilePort
	 */
	public void setRefilePort(String refilePort) {
		this.refilePort = refilePort;
	}

	/**
	 * @return regionCd
	 */
	public String getRegionCd() {
		return regionCd;
	}

	/**
	 * @param regionCd Ϸ regionCd
	 */
	public void setRegionCd(String regionCd) {
		this.regionCd = regionCd;
	}

	/**
	 * @return regionD
	 */
	public String getRegionD() {
		return regionD;
	}

	/**
	 * @param regionD Ϸ regionD
	 */
	public void setRegionD(String regionD) {
		this.regionD = regionD;
	}

	/**
	 * @return regno
	 */
	public String getRegno() {
		return regno;
	}

	/**
	 * @param regno Ϸ regno
	 */
	public void setRegno(String regno) {
		this.regno = regno;
	}

	/**
	 * @return regnoColor
	 */
	public String getRegnoColor() {
		return regnoColor;
	}

	/**
	 * @param regnoColor Ϸ regnoColor
	 */
	public void setRegnoColor(String regnoColor) {
		this.regnoColor = regnoColor;
	}

	/**
	 * @return remarksAR
	 */
	public String getRemarksAR() {
		return remarksAR;
	}

	/**
	 * @param remarksAR Ϸ remarksAR
	 */
	public void setRemarksAR(String remarksAR) {
		this.remarksAR = remarksAR;
	}

	/**
	 * @return restrictE
	 */
	public String getRestrictE() {
		return restrictE;
	}

	/**
	 * @param restrictE Ϸ restrictE
	 */
	public void setRestrictE(String restrictE) {
		this.restrictE = restrictE;
	}

	/**
	 * @return rmkTmpst
	 */
	public String getRmkTmpst() {
		return rmkTmpst;
	}

	/**
	 * @param rmkTmpst Ϸ rmkTmpst
	 */
	public void setRmkTmpst(String rmkTmpst) {
		this.rmkTmpst = rmkTmpst;
	}

	/**
	 * @return sactyp
	 */
	public String getSactyp() {
		return sactyp;
	}

	/**
	 * @param sactyp Ϸ sactyp
	 */
	public void setSactyp(String sactyp) {
		this.sactyp = sactyp;
	}

	/**
	 * @return schDdMonYy
	 */
	public String getSchDdMonYy() {
		return schDdMonYy;
	}

	/**
	 * @param schDdMonYy Ϸ schDdMonYy
	 */
	public void setSchDdMonYy(String schDdMonYy) {
		this.schDdMonYy = schDdMonYy;
	}

	/**
	 * @return schDepDt
	 */
	public String getSchDepDt() {
		return schDepDt;
	}

	/**
	 * @param schDepDt Ϸ schDepDt
	 */
	public void setSchDepDt(String schDepDt) {
		this.schDepDt = schDepDt;
	}

	/**
	 * @return smiFltNum
	 */
	public String getSmiFltNum() {
		return smiFltNum;
	}

	/**
	 * @param smiFltNum Ϸ smiFltNum
	 */
	public void setSmiFltNum(String smiFltNum) {
		this.smiFltNum = smiFltNum;
	}

	/**
	 * @return smiTimeStamp
	 */
	public String getSmiTimeStamp() {
		return smiTimeStamp;
	}

	/**
	 * @param smiTimeStamp Ϸ smiTimeStamp
	 */
	public void setSmiTimeStamp(String smiTimeStamp) {
		this.smiTimeStamp = smiTimeStamp;
	}

	/**
	 * @return speed
	 */
	public String getSpeed() {
		return speed;
	}

	/**
	 * @param speed Ϸ speed
	 */
	public void setSpeed(String speed) {
		this.speed = speed;
	}

	/**
	 * @return sta
	 */
	public String getSta() {
		return sta;
	}

	/**
	 * @param sta Ϸ sta
	 */
	public void setSta(String sta) {
		this.sta = sta;
	}

	/**
	 * @return statusD
	 */
	public String getStatusD() {
		return statusD;
	}

	/**
	 * @param statusD Ϸ statusD
	 */
	public void setStatusD(String statusD) {
		this.statusD = statusD;
	}

	/**
	 * @return std
	 */
	public String getStd() {
		return std;
	}

	/**
	 * @param std Ϸ std
	 */
	public void setStd(String std) {
		this.std = std;
	}

	/**
	 * @return stnfr
	 */
	public String getStnfr() {
		return stnfr;
	}

	/**
	 * @param stnfr Ϸ stnfr
	 */
	public void setStnfr(String stnfr) {
		this.stnfr = stnfr;
	}

	/**
	 * @return stnto
	 */
	public String getStnto() {
		return stnto;
	}

	/**
	 * @param stnto Ϸ stnto
	 */
	public void setStnto(String stnto) {
		this.stnto = stnto;
	}

	/**
	 * @return syskey
	 */
	public String getSyskey() {
		return syskey;
	}

	/**
	 * @param syskey Ϸ syskey
	 */
	public void setSyskey(String syskey) {
		this.syskey = syskey;
	}

	/**
	 * @return tagAR
	 */
	public String getTagAR() {
		return tagAR;
	}

	/**
	 * @param tagAR Ϸ tagAR
	 */
	public void setTagAR(String tagAR) {
		this.tagAR = tagAR;
	}

	/**
	 * @return takeOff
	 */
	public String getTakeOff() {
		return takeOff;
	}

	/**
	 * @param takeOff Ϸ takeOff
	 */
	public void setTakeOff(String takeOff) {
		this.takeOff = takeOff;
	}

	/**
	 * @return tkofT
	 */
	public String getTkofT() {
		return tkofT;
	}

	/**
	 * @param tkofT Ϸ tkofT
	 */
	public void setTkofT(String tkofT) {
		this.tkofT = tkofT;
	}

	/**
	 * @return toD
	 */
	public String getToD() {
		return toD;
	}

	/**
	 * @param toD Ϸ toD
	 */
	public void setToD(String toD) {
		this.toD = toD;
	}

	/**
	 * @return waypointMismatch
	 */
	public String getWaypointMismatch() {
		return waypointMismatch;
	}

	/**
	 * @param waypointMismatch Ϸ waypointMismatch
	 */
	public void setWaypointMismatch(String waypointMismatch) {
		this.waypointMismatch = waypointMismatch;
	}

	/**
	 * @return wxAltPort
	 */
	public String getWxAltPort() {
		return wxAltPort;
	}

	/**
	 * @param wxAltPort Ϸ wxAltPort
	 */
	public void setWxAltPort(String wxAltPort) {
		this.wxAltPort = wxAltPort;
	}

	/**
	 * @return wxEtopPort
	 */
	public String getWxEtopPort() {
		return wxEtopPort;
	}

	/**
	 * @param wxEtopPort Ϸ wxEtopPort
	 */
	public void setWxEtopPort(String wxEtopPort) {
		this.wxEtopPort = wxEtopPort;
	}

	/**
	 * @return wxRefileAltPort
	 */
	public String getWxRefileAltPort() {
		return wxRefileAltPort;
	}

	/**
	 * @param wxRefileAltPort Ϸ wxRefileAltPort
	 */
	public void setWxRefileAltPort(String wxRefileAltPort) {
		this.wxRefileAltPort = wxRefileAltPort;
	}

	/**
	 * @return wxRefilePort
	 */
	public String getWxRefilePort() {
		return wxRefilePort;
	}

	/**
	 * @param wxRefilePort Ϸ wxRefilePort
	 */
	public void setWxRefilePort(String wxRefilePort) {
		this.wxRefilePort = wxRefilePort;
	}

	/**
	 * @return wxStnfr
	 */
	public String getWxStnfr() {
		return wxStnfr;
	}

	/**
	 * @param wxStnfr Ϸ wxStnfr
	 */
	public void setWxStnfr(String wxStnfr) {
		this.wxStnfr = wxStnfr;
	}

	/**
	 * @return wxStnto
	 */
	public String getWxStnto() {
		return wxStnto;
	}

	/**
	 * @param wxStnto Ϸ wxStnto
	 */
	public void setWxStnto(String wxStnto) {
		this.wxStnto = wxStnto;
	}
	
	
	/**
	 * 20140903 FLIGHT_ALERT_T.DOC_NO, PRV_DOC_NO ߰
	 */
	public String getDocNo() {
		return docNo;
	}
	public void setDocNo(String docNo) {
		this.docNo = docNo;
	}
	public String getPrvDocNo() {
		return prvDocNo;
	}
	public void setPrvDocNo(String prvDocNo) {
		this.prvDocNo = prvDocNo;
	}
	
	/**
	 * 20140918 PLN_TANK_FUEL ߰
	 */
	public String getPlnTankFuel() {
		return plnTankFuel;
	}
	public void setPlnTankFuel(String plnTankFuel) {
		this.plnTankFuel = plnTankFuel;
	}
	
	/**
	 * 2016.12.12 LAND_T, ROUTE  ߰
	 */
	public String getLandT() {
		return landT;
	}
	public void setLandT(String landT) {
		this.landT = landT;
	}
	
	public String getRoute() {
		return route;
	}
	public void setRoute(String route) {
		this.route = route;
	}
	
	
	/**
	 * 20160415 ߰
	 */
	public String getGbn() {
		return gbn;
	}
	public void setGbn(String gbn) {
		this.gbn = gbn;
	}
	public String getTankeringAlert() {
		return tankeringAlert;
	}
	public void setTankeringAlert(String tankeringAlert) {
		this.tankeringAlert = tankeringAlert;
	}
	public String getPmsnAlert() {
		return pmsnAlert;
	}
	public void setPmsnAlert(String pmsnAlert) {
		this.pmsnAlert = pmsnAlert;
	}
	public String getCallsignAlert() {
		return callsignAlert;
	}
	public void setCallsignAlert(String callsignAlert) {
		this.callsignAlert = callsignAlert;
	}
	public String getPosMsgAlert() {
		return posMsgAlert;
	}
	public void setPosMsgAlert(String posMsgAlert) {
		this.posMsgAlert = posMsgAlert;
	}
	public String getFltLevelAlert() {
		return fltLevelAlert;
	}
	public void setFltLevelAlert(String fltLevelAlert) {
		this.fltLevelAlert = fltLevelAlert;
	}
	public String getPointAtaAlert() {
		return pointAtaAlert;
	}
	public void setPointAtaAlert(String pointAtaAlert) {
		this.pointAtaAlert = pointAtaAlert;
	}
	public String getMelAlert() {
		return melAlert;
	}
	public void setMelAlert(String melAlert) {
		this.melAlert = melAlert;
	}
	public String getHightimeAlert() {
		return hightimeAlert;
	}
	public void setHightimeAlert(String hightimeAlert) {
		this.hightimeAlert = hightimeAlert;
	}
	public String getEnrouteFuel() {
		return enrouteFuel;
	}
	public void setEnrouteFuel(String enrouteFuel) {
		this.enrouteFuel = enrouteFuel;
	}
	public String getRefileFuel() {
		return refileFuel;
	}
	public void setRefileFuel(String refileFuel) {
		this.refileFuel = refileFuel;
	}
	public String getFuelOverburn() {
		return fuelOverburn;
	}
	public void setFuelOverburn(String fuelOverburn) {
		this.fuelOverburn = fuelOverburn;
	}
	public String getRefileAcars() {
		return refileAcars;
	}
	public void setRefileAcars(String refileAcars) {
		this.refileAcars = refileAcars;
	}
	public String getActDepDt() {
		return actDepDt;
	}
	public void setActDepDt(String actDepDt) {
		this.actDepDt = actDepDt;
	}
	public String getTkofDt() {
		return tkofDt;
	}
	public void setTkofDt(String tkofDt) {
		this.tkofDt = tkofDt;
	}
	public String getTaxiTimeAlert() {
		return taxiTimeAlert;
	}
	public void setTaxiTimeAlert(String taxiTimeAlert) {
		this.taxiTimeAlert = taxiTimeAlert;
	}
	public String getAbhr() {
		return abhr;
	}
	public void setAbhr(String abhr) {
		this.abhr = abhr;
	}
	public String getEtaAlert() {
		return etaAlert;
	}
	public void setEtaAlert(String etaAlert) {
		this.etaAlert = etaAlert;
	}
	public String getProgress() {
		return progress;
	}
	public void setProgress(String progress) {
		this.progress = progress;
	}
	public String getRemainTime() {
		return remainTime;
	}
	public void setRemainTime(String remainTime) {
		this.remainTime = remainTime;
	}
	public String getEdtoEtp() {
		return edtoEtp;
	}
	public void setEdtoEtp(String edtoEtp) {
		this.edtoEtp = edtoEtp;
	}
	public String getWeatherAlert() {
		return weatherAlert;
	}
	public void setWeatherAlert(String weatherAlert) {
		this.weatherAlert = weatherAlert;
	}
	public String getCommented() {
		return commented;
	}
	public void setCommented(String commented) {
		this.commented = commented;
	}
	public String getEstDate() {
		return estDate;
	}
	public void setEstDate(String estDate) {
		this.estDate = estDate;
	}
	public ArrayList<HashMap> getFlightPlanCheckLogT() {
		return flightPlanCheckLogT;
	}
	public void setFlightPlanCheckLogT(ArrayList<HashMap> flightPlanCheckLogT) {
		this.flightPlanCheckLogT = flightPlanCheckLogT;
	}
	public String getLegNum() {
		return legNum;
	}
	public void setLegNum(String legNum) {
		this.legNum = legNum;
	}
	public String getReleaseSyskey() {
		return releaseSyskey;
	}
	public void setReleaseSyskey(String releaseSyskey) {
		this.releaseSyskey = releaseSyskey;
	}
	public String getExtrPad() {
		return extrPad;
	}
	public void setExtrPad(String extrPad) {
		this.extrPad = extrPad;
	}
	
	
	//@2018-04-06	
	public String getEtopsY() {
		return etopsY;
	}
	public void setEtopsY(String etopsY) {
		this.etopsY = etopsY;
	}
	public String getEdtoConfirm() {
		return edtoConfirm;
	}
	public void setEdtoConfirm(String edtoConfirm) {
		this.edtoConfirm = edtoConfirm;
	}
	
	
	//@2018-08-10
	public String getEldt() {
		return eldt;
	}
	public void setEldt(String eldt) {
		this.eldt = eldt;
	}
	public String getEldtAlert() {
		return eldtAlert;
	}
	public void setEldtAlert(String eldtAlert) {
		this.eldtAlert = eldtAlert;
	}	
	public String getEldtManual() {
		return eldtManual;
	}
	public void setEldtManual(String eldtManual) {
		this.eldtManual = eldtManual;
	}	
	
	
	
	//@2018-10-11
	public String getPsnSendAcars() {
		return psnSendAcars;
	}
	public void setPsnSendAcars(String psnSendAcars) {
		this.psnSendAcars = psnSendAcars;
	}		
	public String getPsnMin() {
		return psnMin;
	}
	public void setPsnMin(String psnMin) {
		this.psnMin = psnMin;
	}
	public String getPsnManualDt() {
		return psnManualDt;
	}
	public void setPsnManualDt(String psnManualDt) {
		this.psnManualDt = psnManualDt;
	}	
}

