package kal.base.ffs.query;

import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Planned PLD, Changed PLD ȸ,  ȭ SQL 
  * @author Copyright (c) 2008/08/19  
  */   
public class FfsA250Query {
	private static FfsA250Query instance = new FfsA250Query();
	
	public static FfsA250Query getInstance() {
		return instance;
	}
	
	/** 
	  * Planned PLD, Changed PLD ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2008/08/19  
	  */
	public String selAccReq(FfsA250BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 		ACC_PAX_PLD_WT, ACC_CGO_PLD_WT, ACC_OTH_PLD_WT, ");
		sql.append(" 		REQ_PAX_PLD_WT, REQ_CGO_PLD_WT, REQ_OTH_PLD_WT, ");
		sql.append(" 		REQ_CGO_PLD_ZERO_Y, "); //2008.10.15 ߰
		sql.append(" 	    ACC_PACK1, ACC_PACK2, ACC_PACK3, REQ_PACK1, REQ_PACK2, REQ_PACK3 "); //2009.10.21 ߰ : PACK  ߰
		sql.append(" FROM ");
		sql.append(" 		PDP_FLT_PAYLOAD_T ");
		sql.append(" WHERE ");
		sql.append(" 		FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" 		AND FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" 		AND STNFR = '" + params.getStnfr() + "' ");
		sql.append(" 		AND STNTO = '" + params.getStnto() + "' ");
		
		//Logger.debug.println("[BASE:FfsA250Query:selAccReq] sql : "+sql.toString());
		//System.out.println("[BASE:FfsA250Query:selAccReq] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * PDP_FLT_PAYLOAD_T  SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2008/08/20  
	  */
	public String updAccReq(FfsA250BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE ");
		sql.append(" 		PDP_FLT_PAYLOAD_T ");
		sql.append(" SET ");
		sql.append(" 		STATUS_X = 'A', ");
		//sql.append(" 		ACC_PAX_PLD_WT = REQ_PAX_PLD_WT, ");
		//sql.append(" 		ACC_CGO_PLD_WT = REQ_CGO_PLD_WT, ");
		//sql.append(" 		ACC_OTH_PLD_WT = REQ_OTH_PLD_WT, ");
		//2008.09.17  : ACC <- REQ  ׸ update Ѵ.
		sql.append(" 		ACC_ADLT_PAX_Q = REQ_ADLT_PAX_Q, ");
		sql.append(" 		ACC_CHLD_PAX_Q = REQ_CHLD_PAX_Q, ");
		sql.append(" 		ACC_INFT_PAX_Q = REQ_INFT_PAX_Q, ");
		sql.append(" 		ACC_PAX_AVG_WT = REQ_PAX_AVG_WT, ");
		sql.append(" 		ACC_ADLT_PAX_WT = REQ_ADLT_PAX_WT, ");
		sql.append(" 		ACC_CHLD_PAX_WT = REQ_CHLD_PAX_WT, ");
		sql.append(" 		ACC_INFT_PAX_WT = REQ_INFT_PAX_WT, ");
		sql.append(" 		ACC_PAX_ADJ_WT = REQ_PAX_ADJ_WT, ");
		sql.append(" 		ACC_PAX_ADJ_RSN = REQ_PAX_ADJ_RSN, ");
		sql.append(" 		ACC_PAX_PLD_WT = REQ_PAX_PLD_WT, ");
		sql.append(" 		ACC_CGO_BOOK_WT = REQ_CGO_BOOK_WT, ");
		sql.append(" 		ACC_CGO_BOOK_UNIT = REQ_CGO_BOOK_UNIT, ");
		sql.append(" 		ACC_CGO_ULD_WT = REQ_CGO_ULD_WT, ");
		sql.append(" 		ACC_CGO_ULD_UNIT = REQ_CGO_ULD_UNIT, ");
		sql.append(" 		ACC_CGO_PLD_WT = REQ_CGO_PLD_WT, ");
		sql.append(" 		ACC_OTH_WT = REQ_OTH_WT, ");
		sql.append(" 		ACC_OTH_UNIT = REQ_OTH_UNIT, ");
		sql.append(" 		ACC_OTH_RSN = REQ_OTH_RSN, ");
		sql.append(" 		ACC_OTH_PLD_WT = REQ_OTH_PLD_WT, ");
		sql.append(" 		ACC_CGO_PLD_ZERO_Y = REQ_CGO_PLD_ZERO_Y, ");
		sql.append(" 		ACC_DTG = SYSDATE, ");
		sql.append(" 		ACC_USERID = '" + params.getEmpNo() + "', ");
		
		//2008.10.27 ߰
		sql.append(" 		ACC_PAX_DTG = REQ_PAX_DTG, ");
		sql.append(" 		ACC_PAX_USERID = REQ_PAX_USERID, ");
		sql.append(" 		ACC_CGO_DTG = REQ_CGO_DTG, ");
		sql.append(" 		ACC_CGO_USERID = REQ_CGO_USERID, ");
		
		//2009.10.21 ߰
		sql.append(" 		ACC_PACK1 = REQ_PACK1, ");
		sql.append(" 		ACC_PACK2 = REQ_PACK2, ");
		sql.append(" 		ACC_PACK3 = REQ_PACK3 ");
		
		sql.append(" WHERE ");
		sql.append(" 		FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" 		AND FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" 		AND STNFR = '" + params.getStnfr() + "' ");
		sql.append(" 		AND STNTO = '" + params.getStnto() + "' ");
		
		//System.out.println("[BASE:FfsA250Query:updAccReq] sql : "+sql.toString());
		//Logger.debug.println("[BASE:FfsA250Query:updAccReq] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * MS_TELEX_MSG_T Է
	  * @return String Query 
	  * @author Copyright (c) 2008/08/20 
	  */
	public String insMsTelexMsgORG(String seq, String msg, String projectNo){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO MS_TELEX_MSG_T (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ORIGIN_ADDR, MESSAGE, PRIORITY, SYS_MQID, PROJECT_NO, PROCESSED, ERROR_REPLY) ");
		sql.append(" VALUES ('PLD_UPD', SYSDATE, "+seq+", 1, 1, 'SELXWKE','"+msg+"', 1, TO_CHAR(SYSDATE, 'YYYYMMDDHH24MI')||TRIM(TO_CHAR("+seq+",'00000')), '"+projectNo+"', 'N', ' ') ");
		
		//System.out.println("[BASE:FfsA250Query:insMsTelexMsg] sql : "+sql.toString());
		//Logger.debug.println("[BASE:FfsA250Query:insMsTelexMsg] sql : "+sql.toString());
		return sql.toString();	
	}
	//20150428 MHS
	public String insMsTelexMsg(String seq, String msg, String projectNo){
		
		msg = msg != null ? msg.replace("\"", "") : msg;
		
		StringBuffer sql = new StringBuffer();
		
		//sql.append(" INSERT INTO MS_TELEX_MSG_T (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ORIGIN_ADDR, MESSAGE, PRIORITY, SYS_MQID, PROJECT_NO, PROCESSED, ERROR_REPLY) ");
		sql.append(" INSERT INTO KFOS.MS_TELEX_MHS_T (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ORIGIN_ADDR, MESSAGE, PRIORITY, SYS_MQID, PROJECT_NO, PROCESSED, ERROR_REPLY) ");
		sql.append(" VALUES ('PLD_UPD', SYSDATE, "+seq+", 1, 1, 'SELXWKE','"+msg+"', 1, TO_CHAR(SYSDATE, 'YYYYMMDDHH24MI')||TRIM(TO_CHAR("+seq+",'00000')), '"+projectNo+"', 'N', ' ') ");
		
		//System.out.println("[BASE:FfsA250Query:insMsTelexMsg] sql : "+sql.toString());
		//Logger.debug.println("[BASE:FfsA250Query:insMsTelexMsg] sql : "+sql.toString());
		return sql.toString();	
	}
	
	/** 
	  * PDP_FLT_PAYLOAD_T  SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2008/08/20  
	  */
	public String updStatusX_back(FfsA250BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE ");
		sql.append(" 		PDP_FLT_PAYLOAD_T ");
		sql.append(" SET ");
		sql.append(" 		STATUS_X = 'X', ");
		//2008.09.17 ߰ : REQ <- PRQ  ׸ update Ѵ.
		sql.append(" 		REQ_ADLT_PAX_Q = PRQ_ADLT_PAX_Q, ");
		sql.append(" 		REQ_CHLD_PAX_Q = PRQ_CHLD_PAX_Q, ");
		sql.append(" 		REQ_INFT_PAX_Q = PRQ_INFT_PAX_Q, ");
		sql.append(" 		REQ_PAX_AVG_WT = PRQ_PAX_AVG_WT, ");
		sql.append(" 		REQ_ADLT_PAX_WT = PRQ_ADLT_PAX_WT, ");
		sql.append(" 		REQ_CHLD_PAX_WT = PRQ_CHLD_PAX_WT, ");
		sql.append(" 		REQ_INFT_PAX_WT = PRQ_INFT_PAX_WT, ");
		sql.append(" 		REQ_PAX_ADJ_WT = PRQ_PAX_ADJ_WT, ");
		sql.append(" 		REQ_PAX_ADJ_RSN = PRQ_PAX_ADJ_RSN, ");
		sql.append(" 		REQ_PAX_PLD_WT = PRQ_PAX_PLD_WT, ");
		sql.append(" 		REQ_CGO_BOOK_WT = PRQ_CGO_BOOK_WT, ");
		sql.append(" 		REQ_CGO_BOOK_UNIT = PRQ_CGO_BOOK_UNIT, ");
		sql.append(" 		REQ_CGO_ULD_WT = PRQ_CGO_ULD_WT, ");
		sql.append(" 		REQ_CGO_ULD_UNIT = PRQ_CGO_ULD_UNIT, ");
		sql.append(" 		REQ_CGO_PLD_WT = PRQ_CGO_PLD_WT, ");
		sql.append(" 		REQ_OTH_WT = PRQ_OTH_WT, ");
		sql.append(" 		REQ_OTH_UNIT = PRQ_OTH_UNIT, ");
		sql.append(" 		REQ_OTH_RSN = PRQ_OTH_RSN, ");
		sql.append(" 		REQ_OTH_PLD_WT = PRQ_OTH_PLD_WT, ");
		sql.append(" 		REQ_CGO_PLD_ZERO_Y = PRQ_CGO_PLD_ZERO_Y, ");
		
		//2008.10.27 ߰
		sql.append(" 		REQ_PAX_DTG = PRQ_PAX_DTG, ");
		sql.append(" 		REQ_PAX_USERID = PRQ_PAX_USERID, ");
		sql.append(" 		REQ_CGO_DTG = PRQ_CGO_DTG, ");
		sql.append(" 		REQ_CGO_USERID = PRQ_CGO_USERID, ");
		
		//2009.10.21 ߰
		sql.append(" 		REQ_PACK1 = PRQ_PACK1, ");
		sql.append(" 		REQ_PACK2 = PRQ_PACK2, ");
		sql.append(" 		REQ_PACK3 = PRQ_PACK3 ");
		
		sql.append(" WHERE ");
		sql.append(" 		FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" 		AND FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" 		AND STNFR = '" + params.getStnfr() + "' ");
		sql.append(" 		AND STNTO = '" + params.getStnto() + "' ");
		
		//System.out.println("[BASE:FfsA250Query:updStatusX] sql : "+sql.toString());
		//Logger.debug.println("[BASE:FfsA250Query:updStatusX] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String updStatusX(FfsA250BG params) {//@2018-08
		StringBuffer sql = new StringBuffer();
		
		sql.append("	UPDATE PDP_FLT_PAYLOAD_T ");
		sql.append("	 SET ");
		sql.append("		STATUS_X = 'X'");
		sql.append("	,	REQ_ADLT_PAX_Q = NVL(PRQ_ADLT_PAX_Q ,	REQ_ADLT_PAX_Q)");
		sql.append("	,	REQ_CHLD_PAX_Q = NVL(PRQ_CHLD_PAX_Q ,	REQ_CHLD_PAX_Q)");
		sql.append("	,	REQ_INFT_PAX_Q = NVL(PRQ_INFT_PAX_Q ,	REQ_INFT_PAX_Q)");
		sql.append("	,	REQ_PAX_AVG_WT = NVL(PRQ_PAX_AVG_WT ,	REQ_PAX_AVG_WT)");
		sql.append("	,	REQ_ADLT_PAX_WT = NVL(PRQ_ADLT_PAX_WT ,	REQ_ADLT_PAX_WT)");
		sql.append("	,	REQ_CHLD_PAX_WT = NVL(PRQ_CHLD_PAX_WT ,	REQ_CHLD_PAX_WT)");
		sql.append("	,	REQ_INFT_PAX_WT = NVL(PRQ_INFT_PAX_WT ,	REQ_INFT_PAX_WT)");
		sql.append("	,	REQ_PAX_ADJ_WT = NVL(PRQ_PAX_ADJ_WT ,	REQ_PAX_ADJ_WT)");
		sql.append("	,	REQ_PAX_ADJ_RSN = NVL(PRQ_PAX_ADJ_RSN ,	REQ_PAX_ADJ_RSN)");
		sql.append("	,	REQ_PAX_PLD_WT = NVL(PRQ_PAX_PLD_WT ,	REQ_PAX_PLD_WT)");
		sql.append("	,	REQ_CGO_BOOK_WT = NVL(PRQ_CGO_BOOK_WT ,	REQ_CGO_BOOK_WT)");
		sql.append("	,	REQ_CGO_BOOK_UNIT = NVL(PRQ_CGO_BOOK_UNIT ,	REQ_CGO_BOOK_UNIT)");
		sql.append("	,	REQ_CGO_ULD_WT = NVL(PRQ_CGO_ULD_WT ,	REQ_CGO_ULD_WT)");
		sql.append("	,	REQ_CGO_ULD_UNIT = NVL(PRQ_CGO_ULD_UNIT ,	REQ_CGO_ULD_UNIT)");
		sql.append("	,	REQ_CGO_PLD_WT = NVL(PRQ_CGO_PLD_WT ,	REQ_CGO_PLD_WT)");
		sql.append("	,	REQ_OTH_WT = NVL(PRQ_OTH_WT ,	REQ_OTH_WT)");
		sql.append("	,	REQ_OTH_UNIT = NVL(PRQ_OTH_UNIT ,	REQ_OTH_UNIT)");
		sql.append("	,	REQ_OTH_RSN = NVL(PRQ_OTH_RSN ,	REQ_OTH_RSN)");
		sql.append("	,	REQ_OTH_PLD_WT = NVL(PRQ_OTH_PLD_WT ,	REQ_OTH_PLD_WT)");
		sql.append("	,	REQ_CGO_PLD_ZERO_Y = NVL(PRQ_CGO_PLD_ZERO_Y ,	REQ_CGO_PLD_ZERO_Y)");
		sql.append("	,	REQ_PAX_DTG = NVL(PRQ_PAX_DTG ,	REQ_PAX_DTG)");
		sql.append("	,	REQ_PAX_USERID = NVL(PRQ_PAX_USERID ,	REQ_PAX_USERID)");
		sql.append("	,	REQ_CGO_DTG = NVL(PRQ_CGO_DTG ,	REQ_CGO_DTG)");
		sql.append("	,	REQ_CGO_USERID = NVL(PRQ_CGO_USERID ,	REQ_CGO_USERID)");
		sql.append("	,	REQ_PACK1 = NVL(PRQ_PACK1 ,	REQ_PACK1)");
		sql.append("	,	REQ_PACK2 = NVL(PRQ_PACK2 ,	REQ_PACK2)");
		sql.append("	,	REQ_PACK3 = NVL(PRQ_PACK ,	REQ_PACK3)");
		sql.append("	WHERE");
		sql.append("				FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "',	'YYYYMMDD')");
		sql.append("	AND	FLT_NUM = '" + params.getFltNum() + "'");
		sql.append("	AND	STNFR = '" + params.getStnfr() + "'");
		sql.append("	AND	STNTO = '" + params.getStnto() + "'");
		
		//System.out.println("[BASE:FfsA250Query:updStatusX] sql : "+sql.toString());
		//Logger.debug.println("[BASE:FfsA250Query:updStatusX] sql : "+sql.toString());
		return sql.toString();
	}
	
}
