package kal.base.ffs.query;

import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * (Permission Information) SQL 
  * @author Copyright (c) 2007/06/21  
  */   
public class FfsQ210Query {
	private static FfsQ210Query instance = new FfsQ210Query();
	
	public static FfsQ210Query getInstance() {
		return instance;
	}
	
	/** 
	  * (Permission Information) ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2007/06/21  
	  */
	public String selPmsn(FfsQ210BG params) {
		StringBuffer sql = new StringBuffer();
		/*
		 * 2012.10.29  ڵ ü.  ڵ
		 SELECT D.NATION_ENG_N, C.PMSN_NO 
		 FROM DAILY_SCH_LOG_T A, OF_DAILY_T C, NATION_T D 
		 WHERE A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') 
		 	AND A.FLT_NUM = '" + params.getFltNum() + "' 
		 	AND A.STNFR = '" + params.getStnfr() + "' 
		 	AND A.STNTO = '" + params.getStnto() + "' 
		 	AND A.ACTIVE = 'Y' 
		 	AND A.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT(+) 
		 	AND A.FLT_NUM = C.FLT_NUM 
		 	AND A.LEG_NUM = C.LEG_NUM 
		 	AND A.TIMESTAMP = C.TIMESTAMP 
		 	AND C.NATION_C = D.NATION_C 
		 UNION 
		 ( SELECT D.NATION_ENG_N, ' ' 
		 FROM DAILY_SCH_LOG_T A, AIR_ROUTE_T B, NATION_T D 
		 WHERE A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') 
		 	AND A.FLT_NUM = '" + params.getFltNum() + "' 
		 	AND A.STNFR = '" + params.getStnfr() + "' 
		 	AND A.STNTO = '" + params.getStnto() + "' 
		 	AND A.ACTIVE = 'Y' 
		 	AND A.FLT_NUM = B.FLT_NUM 
		 	AND A.SEASON = B.SEASON_C 
		 	AND B.NATION_C = D.NATION_C 
		 MINUS 
		 SELECT D.NATION_ENG_N, ' ' 
		 FROM DAILY_SCH_LOG_T A, OF_DAILY_T C, NATION_T D 
		 WHERE A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') 
		 	AND A.FLT_NUM = '" + params.getFltNum() + "' 
		 	AND A.STNFR = '" + params.getStnfr() + "' 
		 	AND A.STNTO = '" + params.getStnto() + "' 
		 	AND A.ACTIVE = 'Y' 
		 	AND A.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT(+) 
		 	AND A.FLT_NUM = C.FLT_NUM 
		 	AND A.LEG_NUM = C.LEG_NUM 
		 	AND A.TIMESTAMP = C.TIMESTAMP 
		 	AND C.NATION_C = D.NATION_C ) 
		 */
		sql.append(" SELECT D.NATION_ENG_N, C.PMSN_NO ");
		sql.append(" FROM DAILY_SCH_LOG_T A, OFLT_Daily_Pmsn_T C, NATION_T D ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" 	AND A.FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" 	AND A.STNFR = '" + params.getStnfr() + "' ");
		sql.append(" 	AND A.STNTO = '" + params.getStnto() + "' ");
		sql.append(" 	AND A.ACTIVE = 'Y' ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT(+) ");
		sql.append(" 	AND A.FLT_NUM = C.FLT_NUM ");
		sql.append(" 	AND A.STNFR = C.STNFR ");
		sql.append("    AND A.STNTO = C.STNTO ");
		sql.append(" 	AND A.TIMESTAMP = C.TIMESTAMP ");
		sql.append(" 	AND C.CTRY_CD = D.NATION_C ");
		sql.append(" UNION ");
		sql.append(" ( SELECT D.NATION_ENG_N, ' ' ");
		sql.append(" FROM DAILY_SCH_LOG_T A, OFLT_Route_T B, NATION_T D ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" 	AND A.FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" 	AND A.STNFR = '" + params.getStnfr() + "' ");
		sql.append(" 	AND A.STNTO = '" + params.getStnto() + "' ");
		sql.append(" 	AND A.ACTIVE = 'Y' ");
		sql.append(" 	AND A.FLT_NUM = B.FLT_NUM ");
		sql.append("    AND A.SEASON = B.SEASON ");
		sql.append("    AND A.STNFR = B.STNFR ");
		sql.append("    AND A.STNTO = B.STNTO ");
		sql.append("    AND B.OVERFLT_Y = 'Y' ");
		sql.append("    AND B.CTRY_CD = D.NATION_C ");
		sql.append(" MINUS ");
		sql.append(" SELECT D.NATION_ENG_N, ' ' ");
		sql.append(" FROM DAILY_SCH_LOG_T A, OFLT_Daily_Pmsn_T C, NATION_T D ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" 	AND A.FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" 	AND A.STNFR = '" + params.getStnfr() + "' ");
		sql.append(" 	AND A.STNTO = '" + params.getStnto() + "' ");
		sql.append(" 	AND A.ACTIVE = 'Y' ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT(+) ");
		sql.append(" 	AND A.FLT_NUM = C.FLT_NUM ");
		sql.append(" 	AND A.STNFR = C.STNFR ");
		sql.append("    AND A.STNTO = C.STNTO ");
		sql.append(" 	AND A.TIMESTAMP = C.TIMESTAMP ");
		sql.append(" 	AND C.CTRY_CD = D.NATION_C ) ");

		Logger.debug.println("[BASE:FfsQ210Query:selPmsn] sql : "+sql.toString());
		return sql.toString();
	}

}
