package kal.base.ffs.query;

import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;

 /**
  *  Fuel & Weight ȸ ȭ SQL 
  * @author Copyright (c) 2009/06/04  
  */   
public class FfsQ410Query {
	private static FfsQ410Query instance = new FfsQ410Query();
	
	public static FfsQ410Query getInstance() {
		return instance;
	}
	
	/** 
	  * Fuel & Weight ȸ
	  * @return String Query  
	  * @author Copyright (c) 2009/06/04  
	  */
	public String selMain(FfsQ410BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(A.FIRST_LEG_FLT_DT,'YYMMDD') FIRST_LEG_FLT_DT, TO_CHAR(A.SCH_DEP_DT,'YYMMDD') SCHDEPDT, ");
		sql.append(" A.FLT_NUM, A.SACTYP, A.REGNO, A.STNFR, A.STNTO, D.REGION_CD, ");
		sql.append(" DECODE(A.ARV_STS,'ACT',TO_CHAR(A.ACT_DEP_DT,'HH24MI'),TO_CHAR(A.EST_DEP_DT,'HH24MI')) ETD, ");
		sql.append(" decode(a.arv_sts,'ACT',DECODE(A.LAND_T,NULL,'',CASE WHEN A.LAND_T < A.TKOF_T THEN SUBSTR(TO_CHAR(FLOOR(((TO_DATE(A.LAND_T,'hh24mi')+1-TO_DATE(A.TKOF_T,'HH24MI'))*24*60)/60),'00'),2,2)||SUBSTR(TO_CHAR(MOD((TO_DATE(A.LAND_T,'HH24MI')+1-TO_DATE(A.TKOF_T,'HH24MI'))*24*60,60),'00'),2,2) ELSE SUBSTR(TO_CHAR(FLOOR(((TO_DATE(A.LAND_T,'hh24mi')-TO_DATE(A.TKOF_T,'HH24MI'))*24*60)/60),'00'),2,2)||SUBSTR(TO_CHAR(MOD((TO_DATE(A.LAND_T,'HH24MI')-TO_DATE(A.TKOF_T,'HH24MI'))*24*60,60),'00'),2,2) END),NVL2(c.ABHR,TRIM(TO_CHAR(TRUNC(c.ABHR/60),'00'))||TRIM(TO_CHAR(MOD(c.ABHR,60),'00')),'')) FT, ");
		// : 2011.5.19 FT κ ڵ ü =>sql.append(" DECODE(A.ARV_STS,'ACT',SUBSTR(TO_CHAR(FLOOR(((TO_DATE(A.LAND_T,'HH24MI')-TO_DATE(A.TKOF_T,'HH24MI'))*24*60)/60),'00'),2,2)||SUBSTR(TO_CHAR(MOD((TO_DATE(A.LAND_T,'HH24MI')-TO_DATE(A.TKOF_T,'HH24MI'))*24*60,60),'00'),2,2),SUBSTR(TO_CHAR(ABHR/60-1,'00'),2,2)||SUBSTR(TO_CHAR(MOD(ABHR,60),'00'),2,2)) FT, ");
		// : 2011.5.20 FT κ ڵ ü =>sql.append(" NVL2(C.ABHR,TRIM(TO_CHAR(TRUNC(C.ABHR/60),'00'))||TRIM(TO_CHAR(MOD(C.ABHR,60),'00')),'') FT, ");
		sql.append(" decode(a.arv_sts,'ACT',DECODE(A.ARV_STS,'ACT',SUBSTR(TO_CHAR(FLOOR(((A.ACT_ARV_DT-A.ACT_DEP_DT)*24*60)/60),'00'),2,2)||SUBSTR(TO_CHAR(MOD((A.ACT_ARV_DT-A.ACT_DEP_DT)*24*60,60),'00'),2,2),''),SUBSTR(TO_CHAR(FLOOR(((A.SCH_ARV_DT-A.SCH_DEP_DT)*24*60)/60),'00'),2,2)||SUBSTR(TO_CHAR(MOD((A.SCH_ARV_DT-A.SCH_DEP_DT)*24*60,60),'00'),2,2)) BT, ");
		// : 2011.5.20 BT κ ڵ ü =>sql.append(" DECODE(A.ARV_STS,'ACT',SUBSTR(TO_CHAR(FLOOR(((A.ACT_ARV_DT-A.ACT_DEP_DT)*24*60)/60),'00'),2,2)||SUBSTR(TO_CHAR(MOD((A.ACT_ARV_DT-A.ACT_DEP_DT)*24*60,60),'00'),2,2),SUBSTR(TO_CHAR(FLOOR(((A.SCH_ARV_DT-A.SCH_DEP_DT)*24*60)/60),'00'),2,2)||SUBSTR(TO_CHAR(MOD((A.SCH_ARV_DT-A.SCH_DEP_DT)*24*60,60),'00'),2,2)) BT, ");
		sql.append(" B.PLN_PLD, B.ACT_PLD, B.PLN_TOW, B.ACT_TOW, B.PLN_RAMP_FUEL, B.PLN_TKOF_FUEL, B.PLN_TRIP_FUEL, B.PLN_FOD_FUEL, B.ACT_FOD_FUEL ");
		sql.append(" FROM DAILY_SCH_T A, FLT_FUEL_WT_T B, FLIGHT_PLAN_T C, CM_CITYPAIR_DEF_T D ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT BETWEEN TO_DATE('"+params.getPFrDate()+"','YYMMDD')-2 AND TO_DATE('"+params.getPToDate()+"','YYMMDD')+2 "); 
		sql.append(" AND A.SCH_DEP_DT BETWEEN TO_DATE('"+params.getPFrDate()+"'||'0000','YYMMDDHH24MI') AND TO_DATE('"+params.getPToDate()+"'||'2359','YYMMDDHH24MI') ");
		sql.append(" AND NVL(A.DEP_STS,'') <> 'INI' "); //2009.07.24 ߰
		sql.append(" AND A.FIRST_LEG_FLT_DT=B.FIRST_LEG_FLT_DT(+) ");
		sql.append(" AND A.FLT_NUM=B.FLT_NUM(+) ");
		sql.append(" AND A.STNFR=B.STNFR(+) ");
		sql.append(" AND A.STNTO=B.STNTO(+) ");
		sql.append(" AND A.FIRST_LEG_FLT_DT=C.FIRST_LEG_FLT_DT(+) "); 
		sql.append(" AND A.FLT_NUM=C.FLT_NUM(+) ");
		sql.append(" AND A.STNFR=C.STNFR(+) ");
		sql.append(" AND A.STNTO=C.STNTO(+) ");
		sql.append(" AND A.ACTNID <> 'CNL' ");
		sql.append(" AND C.ACTIVE(+)='Y' ");
		sql.append(" AND A.STNFR=D.DEP_PORT ");
		sql.append(" AND A.STNTO=D.ARV_PORT ");
		sql.append(" AND A.KACTYP NOT IN ('79S','7FG','7FR','7GG','ABH') ");
		if (!params.getPRegionCd().equals("")) {
			sql.append(" AND D.REGION_CD IN ("+params.getPRegionCd()+") ");
		}
		if (!params.getPFltNum().equals("")) {
			sql.append(" AND A.FLT_NUM='"+params.getPFltNum()+"' ");
		}
		if (!params.getPStnfr().equals("")) {
			sql.append(" AND A.STNFR='"+params.getPStnfr()+"' ");
		}
		if (!params.getPStnto().equals("")) {
			sql.append(" AND A.STNTO='"+params.getPStnto()+"' ");
		}
		sql.append(" ORDER BY SCH_DEP_DT ");

		//System.out.println("[BASE:FfsQ410Query:selMain] sql : "+sql.toString());
		Logger.debug.println("[BASE:FfsQ410Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
