package kal.base.ffs.query;

import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;

public class FfsQ710Query {
	
private static FfsQ710Query instance = new FfsQ710Query();
	
	public static FfsQ710Query getInstance() {
		return instance;
	}
	
	/** 
	  * jinair List ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2007/09/07 
	  */
	public String selFfsQ710Main(){

		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT   ");
		sql.append(" 	C.FLT_NUM, C.REGNO, C.SACTYP, C.STNFR, C.STNTO, TO_CHAR(C.EST_DEP_DT,'HH24:MI') ETD, TO_CHAR(C.EST_ARV_DT,'HH24:MI') ETA, ");
		sql.append(" 	TRUNC(MOD((C.SCH_ARV_DT - C.SCH_DEP_DT), 1) * 24) BLOCK_TIME, A.CC_FUEL_50, A.CC_FUEL_75, A.CC_FUEL_95, A.CCF_CALC_Y, TO_CHAR(A.TIMESTMP,'YYYYMMDD') TIMESTMP, A.CRZ_SPEED,B.ROUTE_NO, ");
		sql.append(" 	case when(sysdate < sysdate-15) then 'Y'  ");
		sql.append(" 	else 'N'  ");
		sql.append(" 	end as sysdt  ");
		sql.append(" FROM kfos.JNA_CITYPAIR_AC_T A, kfos.JNA_CITYPAIR_DEF_T B, DAILY_SCH_T C ");
		sql.append(" WHERE C.EST_DEP_DT >= SYSDATE - 9/24 AND ");
		sql.append(" C.EST_DEP_DT <= SYSDATE + 15/24 AND ");
		sql.append(" C.DEP_STS <> 'INI' AND ");
		sql.append(" C.ACTNID <> 'CNL' AND ");
		sql.append(" C.FLT_PLANNED = 'N' AND ");
		sql.append(" C.STNFR = B.DEP_PORT AND ");
		sql.append(" C.STNTO = B.ARV_PORT AND ");
		sql.append(" C.STNFR = A.DEP_PORT AND ");
		sql.append(" C.STNTO = A.ARV_PORT AND ");
		sql.append(" C.SACTYP = A.SACTYP AND ");
		sql.append(" C.FLT_NUM NOT LIKE '43%' AND ");
		sql.append(" C.FLT_NUM NOT LIKE '45%' AND ");
		sql.append(" C.FLT_NUM NOT LIKE '463%' AND ");
		sql.append(" C.FLT_NUM NOT LIKE '473%' AND ");
		sql.append(" C.FLT_NUM NOT LIKE '483%' AND ");
		sql.append(" C.FLT_NUM LIKE '4%' ");
		sql.append(" ORDER BY C.EST_DEP_DT DESC ");
		
		//System.out.println("[BASE:FfsQ710Query:selFfsQ710Main] sql : "+sql.toString());
		Logger.debug.println("[BASE:FfsQ710Query:selFfsQ710Main] sql : "+sql.toString());
		
		return sql.toString();
		
		
	}	
	

}
