package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * IROPS Message SQL 
  * @author Copyright (c) 2005/07/04 HIST  
  */  
public class IroQ070Query {
	private static IroQ070Query instance = new IroQ070Query();
	
	public static IroQ070Query getInstance() {
		return instance;
	}
	
	/** 
	  * IROPS Message ̿Ϸ ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2005/07/04 HIST 
	  */
	public String selMain(IroQ070BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select To_Char(Timestamp-(9/24),'YYYY/MM/DD HH24:MI') Timestmp,Arln_Cd,Title_x,Title_e,");
		sql.append(" To_Char(First_Leg_Flt_Dt,'YYYYMMDD') First_Leg_Flt_Dt,Flt_Num,Stnfr,Stnto,Seq_Num,Option_Num,Decision_c,Decision_e");
		sql.append(" From Irops_Sch_t");
		sql.append(" Where Trim(Decision_e) is Not Null");
		sql.append(" And Message is Null");
		if (!params.getTimestmp().equals("")) {
			sql.append(" And Timestamp >= To_Date('20"+params.getTimestmp()+"0000','YYYYMMDDHH24MI')+(9/24)");
			sql.append(" And Timestamp <= To_Date('20"+params.getTimestmp()+"2359','YYYYMMDDHH24MI')+(9/24)");
		}
		if (!params.getFlt_num().equals(""))
			sql.append(" And Flt_Num = '"+params.getFlt_num()+"'");
		sql.append(" And Trim(Project_No) is Null");
		sql.append(" And Complete_y = 'Y'");
		sql.append(" Order by Timestamp");

		
		Logger.debug.println("[BASE:IroQ070Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}//end of class