package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.com.query.*;
import kal.base.iro.dbbean.*;
import kal.base.iro.query.*;

  /**
   * DSS Messenger Popup SQL 
   * @author Copyright (c) 2005/12/20 
   */
public class IroQ290Query {
	private static IroQ290Query instance = new IroQ290Query();
	
	public static IroQ290Query getInstance() {
		return instance;
	}
	
	/** 
	  * DSS Messenger Popup SQLԼ.
	  * @param entity IroQ290BG 
	  * @return String Query 
	  * @author Copyright (c) 2005/12/20 
	  */
	public String selMain(IroQ290BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT TO_CHAR(MSG_DTG, 'YYYYMMDD HH24MISS') HH24MISS, DESK_X CODEX, ");
		sql.append(" 	TITLE_E, COMMENT_E, TO_CHAR(REPLY_DTG, 'YYYYMMDD HH24MISS') REPLYDTG ");
		sql.append(" FROM IROPS_MSG_T ");
		sql.append(" WHERE MSG_DTG >= SYSDATE-(1/1440) ");
		sql.append(" ORDER BY MSG_DTG ");

		//Logger.debug.println("[BASE:IroQ290Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS Messenger Popup ȸSQLԼ.
	  * @param entity IroQ290BG 
	  * @return String Query 
	  * @author Copyright (c) 2005/12/20 
	  */
	public String selDetail(IroQ290BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT TO_CHAR(A.MSG_DTG, 'HH24:MI:SS') HH24MISS, NVL(B.CODE_X, ' ') CODEX, ");
		sql.append(" 	A.TITLE_E, A.COMMENT_E, TO_CHAR(A.REPLY_DTG, 'YYYYMMDD HH24MISS') REPLYDTG ");
		sql.append(" FROM IROPS_MSG_T A, CODE_T B ");
		sql.append(" WHERE A.MSG_DTG = TO_DATE('"+ entity.getMsgDtg() +"', 'YYYYMMDD HH24MISS') ");
		sql.append(" 	AND A.DESK_X = '"+ entity.getCodeX() +"' ");
		sql.append(" 	AND B.STEP_X(+) = '0' ");
		sql.append(" 	AND B.CODE_C(+) = 'Head' ");  	
		sql.append(" 	AND B.USE_Y(+) = 'N' ");
		sql.append(" 	AND A.DESK_X = B.DESC_E(+) ");
		sql.append(" ORDER BY A.MSG_DTG ");

		Logger.debug.println("[BASE:IroQ290Query:selDetail] sql : "+sql.toString());
		return sql.toString();
	}
}