package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Time Consumption SQL 
  * @author Copyright (c) 2009/08/27  
  */ 
public class IroQ440Query {
	private static IroQ440Query instance = new IroQ440Query();
	
	public static IroQ440Query getInstance() {
		return instance;
	}
	
	/** 
	  * Time Consumption ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/27 
	  */
	public String selMain(IroQ440BG params) {
		StringBuffer sql = new StringBuffer();
		
		if (params.getUserId().equals("")) { //ALL 
			
			/*
			sql.append(" SELECT B.COMMENT_X, TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) RNG, COUNT(*) CNT ");
			sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B ");
			
			//2010.04.15  : DSS_IROPS_SCH_T.SCH_DEP_DT -> DSS_IROPS_T.IROPS_DT
			//sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			//sql.append(" AND B.SCH_DEP_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append(" WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append(" AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			
			sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append(" AND A.PROCESS_X = 'M' ");
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}
			sql.append(" GROUP BY B.COMMENT_X, TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) ");
			*/
			
			//2010.05.28  : FLT  CASE  
			sql.append(" SELECT DECODE(COMT_X, 1, 'CNL', 2, 'DLA', 3, 'CHG', 4, 'RTR', 5, 'DIV', 'NEW') COMMENT_X, RNG, COUNT(*) CNT ");
			sql.append(" FROM (SELECT MIN(DECODE(B.COMMENT_X, 'CNL', 1, 'DLA', 2, 'CHG', 3, 'RTR', 4, 'DIV', 5, 6)) COMT_X, ");
			sql.append("     MAX(TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0)) RNG ");
			sql.append("     FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B ");
			sql.append("     WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append("     AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append("     AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append("     AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append("     AND A.PROCESS_X = 'M' ");
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}
			sql.append("     GROUP BY A.DSS_START_DT, B.SEQ_NUM) ");
			sql.append(" GROUP BY COMT_X, RNG ");
			
		} else { //ڸ 
			
			/*
			sql.append(" SELECT B.COMMENT_X, TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) RNG, COUNT(*) CNT ");
			sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DSS_IROPS_DESK_T C ");
			
			//2010.04.15  : DSS_IROPS_SCH_T.SCH_DEP_DT -> DSS_IROPS_T.IROPS_DT
			//sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			//sql.append(" AND B.SCH_DEP_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append(" WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append(" AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			
			sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append(" AND A.PROCESS_X = 'M' ");
			sql.append(" AND B.DSS_START_DT = C.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = C.SEQ_NUM ");
			//DESK_X + USER_ID
			sql.append(" AND C.DESK_X = '"+params.getUserId().substring(0,1)+"' ");
			sql.append(" AND C.USER_ID = '"+params.getUserId().substring(1)+"' ");
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}
			sql.append(" GROUP BY B.COMMENT_X, TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) ");
			*/
			
			//2010.05.28  : FLT  CASE  
			sql.append(" SELECT DECODE(COMT_X, 1, 'CNL', 2, 'DLA', 3, 'CHG', 4, 'RTR', 5, 'DIV', 'NEW') COMMENT_X, RNG, COUNT(*) CNT ");
			sql.append(" FROM (SELECT MIN(DECODE(B.COMMENT_X, 'CNL', 1, 'DLA', 2, 'CHG', 3, 'RTR', 4, 'DIV', 5, 6)) COMT_X, ");
			sql.append("     MAX(TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0)) RNG ");
			sql.append("     FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DSS_IROPS_DESK_T C ");
			sql.append("     WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append("     AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append("     AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append("     AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append("     AND A.PROCESS_X = 'M' ");
			sql.append("     AND B.DSS_START_DT = C.DSS_START_DT ");
			sql.append("     AND B.SEQ_NUM = C.SEQ_NUM ");
			//DESK_X + USER_ID
			sql.append("     AND C.DESK_X = '"+params.getUserId().substring(0,1)+"' ");
			sql.append("     AND C.USER_ID = '"+params.getUserId().substring(1)+"' ");
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}
			sql.append("     GROUP BY A.DSS_START_DT, B.SEQ_NUM) ");
			sql.append(" GROUP BY COMT_X, RNG ");
		}
		
		System.out.println("[BASE:IroQ440Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}

}
