package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Station Statistics SQL 
  * @author Copyright (c) 2009/09/28  
  */ 
public class IroQ510Query {
	private static IroQ510Query instance = new IroQ510Query();
	
	public static IroQ510Query getInstance() {
		return instance;
	}
	
	/** 
	  * Station Statistics ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/28  
	  */
	public String selMain(IroQ510BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT STNFR, COUNT(*) TOTAL, ");
		sql.append(" SUM(DECODE(COMMENT_X,'DLA',1)) DLA, "); 
		sql.append(" SUM(DECODE(COMMENT_X,'CHG',1)) CHG, "); 
		sql.append(" SUM(DECODE(COMMENT_X,'CNL',1)) CNL, "); 
		sql.append(" SUM(DECODE(COMMENT_X,'RTR',1)) RTR, "); 
		sql.append(" SUM(DECODE(COMMENT_X,'DIV',1)) DIV, "); 
		sql.append(" SUM(DECODE(COMMENT_X,'NEW',1)) NEW ");
		sql.append(" FROM DSS_IROPS_SCH_T A, DSS_IROPS_T B ");
		sql.append(" WHERE A.SCH_DEP_DT BETWEEN TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
		sql.append(" AND TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
		sql.append(" AND A.DSS_START_DT = B.DSS_START_DT ");
		sql.append(" AND A.SEQ_NUM = B.SEQ_NUM ");
		sql.append(" AND B.PROCESS_X IN ('M') ");
		
		if (!params.getStn().equals("")) {
			sql.append(" AND A.STNFR = '"+params.getStn()+"' ");
		}
		if (!params.getRouteX().equals("")) {
			sql.append(" AND A.ROUTE_X = '"+params.getRouteX()+"' ");
		}
		
		sql.append(" GROUP BY STNFR ");
		
		System.out.println("[BASE:IroQ510Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
