package kal.base.jdf.com;

/**
 * @(#) Config.java
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr.
 */
 
public interface Config {

	/**
	 * @return java.lang.String
	 * @param key java.lang.String
	 */
	 public String get(String key);

	/**
	 * @return boolean
	 * @param key java.lang.String
	 */
	public boolean getBoolean(String key);

	/**
	 * @return int
	 * @param key java.lang.String
	 */
	public int getInt(String key);

	/**
	 * @return java.util.Properties
	 */
	public java.util.Properties getProperties()	;

	/**
	 * @return java.lang.String
	 * @param key java.lang.String
	 */
	public String getString(String key);

	/**
	 * 
	 * @return last modification time.
	 */
	long lastModified();
}