package kal.base.not.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.not.dbbean.*;

 /**
   *  Archived NOTAM SQL 
   * @author Copyright (c) 2008/01/22 
   */
public class NotQ730Query {
	private static NotQ730Query instance = new NotQ730Query();
	
	public static NotQ730Query getInstance() {
		return instance;
	}
	
	/** 
	  * REGION_CD ȸ SQLԼ.
	  * @param 
	  * @return String Query 
	  * @author Copyright (c) 2008/01/22 
	  */
	public String selRCd() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT REGION_CD FROM CM_REGION_T ");
				
		Logger.debug.println("[BASE:NotQ730Query:selRCd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IATA_PORT ȸ SQLԼ.
	  * @param NotQ730BG params
	  * @return String Query 
	  * @author Copyright (c) 2008/01/23 
	  */
	public String selIataPort(String port) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT IATA_PORT ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE ICAO_PORT = '"+port+"' ");
		sql.append(" 	OR IATA_PORT = '"+port+"' ");
	
		Logger.debug.println("[BASE:NotQ730Query:selIataPort] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ARCHIVED NOTAM ȸ SQLԼ.
	  * @param NotQ730BG params
	  * @return String Query 
	  * @author Copyright (c) 2008/01/23 
	  */
	public String selArcList(NotQ730BG params) {
		StringBuffer sql = new StringBuffer();
				
		sql.append(" SELECT ");
		sql.append(" 	A.FLT_NUM, A.STNFR, A.STNTO, B.REGION_CD, ");
		sql.append(" 	TO_CHAR(A.EST_DEP_DT,'YYYY-MM-DD') OPS_DT, ");
		sql.append(" 	TO_CHAR(A.EST_DEP_DT, 'HH24MI') ETD, ");
		sql.append(" 	DECODE(A.DEP_STS, 'ACT', TO_CHAR(A.ACT_DEP_DT, 'HH24MI'), '') ATD, ");
		sql.append(" 	TO_CHAR(B.SEND_DT, 'YYYY-MM-DD HH24:MI') SEND_DT, ");
		sql.append(" 	TO_CHAR(B.SEND_DT, 'YYYYMMDDHH24MISS') SEND_KEY, ");
		sql.append(" 	B.SENT_TP ");
		sql.append(" FROM DAILY_SCH_T A, BS_NOTAM_ARCHIVE_T B ");		
		sql.append(" WHERE A.FIRST_LEG_FLT_DT BETWEEN TO_DATE('"+params.getPFromDt()+"', 'YYMMDD') -2 ");
		sql.append(" 	AND TO_DATE('"+params.getPToDt()+"', 'YYMMDD') ");
		sql.append(" 	AND A.EST_DEP_DT BETWEEN TO_DATE('"+params.getPFromDt()+"'||'0000', 'YYMMDDHH24MI') ");
		sql.append(" 	AND TO_DATE('"+params.getPToDt()+"'||'2359', 'YYMMDDHH24MI') ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" 	AND A.STNFR = B.STNFR ");
		sql.append(" 	AND A.STNTO = B.STNTO ");
		sql.append(" 	AND B.PORT_SEQ = 1 ");
		if (!params.getPFltId().equals("") || !params.getPDep().equals("") || !params.getPArr().equals("") || !params.getPArea().equals("")) {
			String temp = "";
			if (!params.getPFltId().equals("")) temp = "A.FLT_NUM = '"+params.getPFltId()+"' ";
			if (!params.getPDep().equals("")) {
				if (temp.equals("")) temp = "A.STNFR = '"+params.getPDep()+"' ";
				else temp = temp + " AND A.STNFR = '"+params.getPDep()+"' ";
			}
			if (!params.getPArr().equals("")) {
				if (temp.equals("")) temp = "A.STNTO = '"+params.getPArr()+"' ";
				else temp = temp + " AND A.STNTO = '"+params.getPArr()+"' ";
			}
			if (!params.getPArea().equals("")) {
				if (temp.equals("")) temp = "B.REGION_CD = '"+params.getPArea()+"' ";
				else temp = temp + " OR B.REGION_CD = '"+params.getPArea()+"' ";
			}
			sql.append(" AND ( " + temp + " ) ");
		}
		sql.append(" ORDER BY SEND_DT, A.FLT_NUM ");
		
		Logger.debug.println("[BASE:NotQ730Query:selArcList] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NOT_NUM ȸ SQLԼ.
	  * @param NotQ730BG params
	  * @return String Query 
	  * @author Copyright (c) 2008/01/24 
	  */
	public String selArcNotNum(NotQ730BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT NOT_PORT, NOT_NUM ");
		sql.append(" FROM BS_NOTAM_ARCHIVE_T ");
		sql.append(" WHERE SEND_DT = TO_DATE('"+params.getPSendDt()+"', 'YYYYMMDDHH24MISS') ");
		sql.append(" 	AND FLT_NUM = '"+params.getPFltId()+"' ");
		sql.append(" 	AND STNFR = '"+params.getPDep()+"' ");
		sql.append(" 	AND STNTO = '"+params.getPArr()+"' ");
		sql.append(" ORDER BY PORT_SEQ ");
	
		Logger.debug.println("[BASE:NotQ730Query:selArcNotNum] sql : "+sql.toString());
		return sql.toString();
	}
}
