package kal.base.pbf.db;

import kal.base.jdf.com.*;
import kal.base.jdf.db.*;

import java.sql.*;
import javax.sql.*;
import javax.naming.*;


public class ToolConnectionResource extends ConnectionResourceManager {
	private static DataSource ds = null;

	public ToolConnectionResource() throws DBOpenException {
		super();
		try {
			//kal.base.jdf.com.Config conf = new kal.base.jdf.com.Configuration();
			//String datasource = conf.get("kal.base.jdf.com.tool.generator.db.datasource");
			//String user = conf.get("kal.base.jdf.com.tool.generator.db.user");
			//String password = conf.get("kal.base.jdf.com.tool.generator.db.password");
			
			String datasource = "jdbc/BASE";
			//String user = "kpms";
			//String password = "pmsk";
			
			synchronized ( ToolConnectionResource.class ) {
				if ( ds == null ) {
					java.util.Hashtable props = new java.util.Hashtable();
					//props.put(Context.INITIAL_CONTEXT_FACTORY, "com.ibm.ejs.ns.jndi.CNInitialContextFactory");
					props.put(Context.INITIAL_CONTEXT_FACTORY, "com.ibm.websphere.naming.WsnInitialContextFactory");
					Context ctx = null;
					try {
						ctx = new InitialContext(props);
						ds = (DataSource)ctx.lookup(datasource);
					}
					finally {
						if ( ctx != null ) ctx.close();
					}
				}
			}
			//java.sql.Connection conn = ds.getConnection( user, password );
			java.sql.Connection conn = ds.getConnection();
			super.setConnection(conn);
		}
		catch(Exception e) {
			throw new DBOpenException(e.getMessage());
		}
	}

	public ToolConnectionResource(ConnectionContext ctx) {
		super(ctx);
	}

	public void release() {
		// release connection into "Connection Pool" :  Ǿ ִ. - chkim
		if ( connection != null ) {
			try {
				connection.close();
			} catch(Exception e){}
			connection = null;
		}
	}
}