package kal.base.rep.query;

import kal.base.jdf.com.Logger;
import kal.base.rep.dbbean.RepQ020BG;
import kal.base.com.query.*;

 /**
   * ׽ SQL 
   * @author Copyright (c) 2005/02/21 
   */  
public class RepQ020Query {
	private static RepQ020Query instance = new RepQ020Query();
	
	public static RepQ020Query getInstance() {
		return instance;
	}
	/** 
	  * (yyyymm) ȸ SQLԼ.
	  * @param entity RepQ020BG ׽
	  * @return String Query 
	  * @author Copyright (c) 2005/02/21 
	  */
	public String selDate(RepQ020BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Code_c, SUBSTR(Desc_e,0,6) Desc_e  ");
		sql.append(" From Code_T  ");
		sql.append(" Where Step_x = '1'   And  ");
		sql.append(" 	Use_y  = 'N'   And  ");
		sql.append(" 	Code_x = 'REPORT MONTH'  And ");
		sql.append(" 	End_D  > SYSDATE ");
		sql.append(" Order By Prty_no  ");
		
		Logger.debug.println("[BASE:RepQ020Query:selDate] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ׽  ȸ SQLԼ.
	  * @param entity RepQ020BG ׽
	  * @return String Query 
	  * @author Copyright (c) 2005/02/21 
	  */
	public String selSkd(RepQ020BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Code_c1, Sum(Flt_q1) Sum1, Sum(Flt_q2) Sum2");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d In('"+entity.getReport_d()+"', To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm'))  And ");
		sql.append(" 	Report_x = 'A' ");
		sql.append(" Group By Report_d, Code_c1 ");
		
		Logger.debug.println("[BASE:RepQ020Query:selSkd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ׽ ü ȸ SQLԼ.
	  * @param entity RepQ020BG ׽
	  * @return String Query 
	  * @author Copyright (c) 2005/02/21 
	  */
	public String selOntime(RepQ020BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Code_c2, Code_c1, Code_c3,  Flt_q1, Flt_q2, Flt_q3 ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d In('"+entity.getReport_d()+"', To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm'))  And ");
		sql.append(" 	Report_x = 'B' ");
		sql.append(" Order By Report_d, Code_c2, Code_c1, Code_c3 ");
		
		Logger.debug.println("[BASE:RepQ020Query:selOntime] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ׽Divert/Return ȸ SQLԼ.
	  * @param entity RepQ020BG ׽
	  * @return String Query 
	  * @author Copyright (c) 2005/02/22 
	  */
	public String selDivert(RepQ020BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Code_c1, Sum(Flt_q1) Sum1, Sum(Flt_q2) Sum2, Sum(Flt_q3) Sum3 ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d In('"+entity.getReport_d()+"', To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm'))  And ");
		sql.append("        Report_x = 'C' ");
		sql.append(" Group By Report_d, Code_c1 ");
		
		Logger.debug.println("[BASE:RepQ020Query:selDivert] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ׽   ֿ  Ȳ ȸ SQLԼ.
	  * @param entity RepQ020BG ׽
	  * @return String Query 
	  * @author Copyright (c) 2005/02/22 
	  */
	public String selGround(RepQ020BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Code_c2,  Sum(Flt_q1) Sum1");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d = '"+entity.getReport_d()+"' And ");
		sql.append(" 	  Report_x = 'D'  ");
		sql.append(" Group By Report_d, Code_c2  ");
		
		Logger.debug.println("[BASE:RepQ020Query:selGround] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ׽   ֿ  Ȳ  ȸ SQLԼ.
	  * @param entity RepQ020BG ׽
	  * @return String Query 
	  * @author Copyright (c) 2005/02/22 
	  */
	public String selTotalGround(RepQ020BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Code_c2,  Sum(Flt_q1) Sum1");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d >= '"+entity.getReport_d().substring(0,4)+"01"+"' And ");
		sql.append(" 	  Report_d <= '"+entity.getReport_d()+"' And ");
		sql.append(" 	  Report_x = 'D'  ");
		sql.append(" Group By Report_d, Code_c2  ");
		
		Logger.debug.println("[BASE:RepQ020Query:selTotalGround] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ׽    м ȸ SQLԼ.
	  * @param entity RepQ020BG ׽
	  * @return String Query 
	  * @author Copyright (c) 2005/02/22 
	  */
	public String selIrrType(RepQ020BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Code_c3,  Sum(Flt_q1) Sum1 ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d >= '"+entity.getReport_d().substring(0,4)+"01"+"' And ");
		sql.append(" 	  Report_d <= '"+entity.getReport_d()+"' And ");
		sql.append(" 	Report_x = 'D'  And ");
		sql.append(" 	Code_c2 = 'D'  ");
		sql.append(" Group By Report_d, Code_c3 ");
		 
		Logger.debug.println("[BASE:RepQ020Query:selIrrType] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ׽   м ȸ SQLԼ.
	  * @param entity RepQ020BG ׽
	  * @return String Query 
	  * @author Copyright (c) 2005/03/02 
	  */
	public String selAccType(RepQ020BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Code_c3,  Sum(Flt_q1) Sum1 ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d >= '"+entity.getReport_d().substring(0,4)+"01"+"' And ");
		sql.append(" 	  Report_d <= '"+entity.getReport_d()+"' And ");
		sql.append(" 	Report_x = 'D'  And ");
		sql.append(" 	Code_c2 = 'G'  ");
		sql.append(" Group By Report_d, Code_c3 ");
		 
		Logger.debug.println("[BASE:RepQ020Query:selAccType] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ׽ ֿ   ȸ SQLԼ.
	  * @param entity RepQ020BG ׽
	  * @return String Query 
	  * @author Copyright (c) 2005/03/02 
	  */
	public String selAccDetail(RepQ020BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Irr_d, Code_x, Flt_num, Dom_x, Actyp, Regno, Legstn, Reason_e, Decision_e, Remark_e ");
		sql.append(" From Ops_Irr_T  ");
		sql.append(" Where Irr_d >= '"+entity.getReport_d()+"01"+"' And Irr_d <= '"+entity.getReport_d()+"31"+"' And  ");
		sql.append(" 	  Code_x = 'G'  ");
		sql.append(" Order By Code_x, Irr_d  ");
		 
		Logger.debug.println("[BASE:RepQ020Query:selAccDetail] sql : "+sql.toString());
		return sql.toString();
	}
		
	/** 
	  * ׽ ֿ   ȸ SQLԼ.
	  * @param entity RepQ020BG ׽
	  * @return String Query 
	  * @author Copyright (c) 2005/03/02 
	  */
	public String selIrrDetail(RepQ020BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Irr_d, Code_x, Flt_num, Dom_x, Actyp, Regno, LegStn, Reason_e, Decision_e, Remark_e ");
		sql.append(" From Ops_Irr_T  ");
		sql.append(" Where Irr_d >= '"+entity.getReport_d()+"01"+"' And Irr_d <= '"+entity.getReport_d()+"31"+"' And  ");
		sql.append(" 	  Code_x = 'D' ");
		sql.append(" Order By Code_x, Irr_d  ");
		 
		Logger.debug.println("[BASE:RepQ020Query:selIrrDetail] sql : "+sql.toString());
		return sql.toString();
	}
}
