package kal.base.rep.query;

import kal.base.jdf.com.Logger;
import kal.base.rep.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * IROPS Report ׽¹  ȭ鿡  Query
 * ۼ ¥: 2005-03-02
 * @author: HIST  
 */
public class RepQ060Query {
	private static RepQ060Query instance = new RepQ060Query();
	
	public static RepQ060Query getInstance() {
		return instance;
	}
	
	/** 
	  * IROPS Report ׽¹  οȲ SQLԼ.
	  * @param reportD String yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/03/02 HIST 
	  */
	public String selStaff(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		//οȲ
		sql.append(" Select Code_c3,");
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'A',Flt_q1,'0'),'0')) Now_Capt_skd,");//2004__ȹ
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'A',Flt_q2,'0'),'0')) Now_Capt_res,");//2004__
		sql.append("        	Sum(Decode(Report_d,To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm'),Decode(Code_c2,'A',Flt_q2,'0'),'0')) Bef_Capt_res,");//2003__
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'B',Flt_q1,'0'),'0')) Now_Sub_skd,");//2004_α_ȹ
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'B',Flt_q2,'0'),'0')) Now_Sub_res,");//2004_α_
		sql.append("        	Sum(Decode(Report_d,To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm'),Decode(Code_c2,'B',Flt_q2,'0'),'0')) Bef_Sub_res");//2003_α_
		sql.append(" From 	Ops_Report_t");
		sql.append(" Where Report_d In ('"+reportD+"',To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm')) And");
		sql.append("       		Report_x = 'H' And");
		sql.append("       		Code_c1 = 'A'");
		sql.append(" Group By Code_c3");
				
		Logger.debug.println("[BASE:RepQ060Query:selStaff] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IROPS Report ׽¹  δð SQLԼ.
	  * @param reportD String yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/03/02 HIST 
	  */
	public String selFlight(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		//δð
		sql.append(" Select Code_c3,");
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'A',Flt_q1,'0'),'0')) Now_Capt_skd,"); //2004__ȹ
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'A',Flt_q2,'0'),'0')) Now_Capt_res,"); //2004__
		sql.append("        	Sum(Decode(Report_d,To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm'),Decode(Code_c2,'A',Flt_q2,'0'),'0')) Bef_Capt_res,"); //2003__
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'B',Flt_q1,'0'),'0')) Now_Sub_skd,"); //2004_α_ȹ
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'B',Flt_q2,'0'),'0')) Now_Sub_res,"); //2004_α_
		sql.append("        	Sum(Decode(Report_d,To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm'),Decode(Code_c2,'B',Flt_q2,'0'),'0')) Bef_Sub_res,"); //2003_α_
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'C',Flt_q1,'0'),'0')) Now_Ros_skd,"); //2004__ȹ
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'C',Flt_q2,'0'),'0')) Now_Ros_res,"); //2004__
		sql.append("        	Sum(Decode(Report_d,To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm'),Decode(Code_c2,'C',Flt_q2,'0'),'0')) Bef_Ros_res");  //2003__
		sql.append(" From 	Ops_Report_t");
		sql.append(" Where Report_d In ('"+reportD+"',To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm')) And");
		sql.append("       		Report_x = 'H' And");
		sql.append("       		Code_c1 = 'B'");
		sql.append(" Group By Code_c3");
				
		Logger.debug.println("[BASE:RepQ060Query:selFlight] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS Report ׽¹  Loss   SQLԼ.
	  * @param reportD String yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/03/02 HIST 
	  */
	public String selLossPre(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		//Loss  
		sql.append(" Select Code_c3,");
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'D',Flt_q1,'0'),'0')) Now_Loss_skd,"); //2004_Loss_ȹ
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'D',Flt_q2,'0'),'0')) Now_Loss_res,"); //2004_Loss_
		sql.append("        	Sum(Decode(Report_d,To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm'),Decode(Code_c2,'D',Flt_q2,'0'),'0')) Bef_Loss_res,"); //2003_Loss_
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'E',Flt_q1,'0'),'0')) Now_Resv_skd,"); //2004_Reserve_ȹ
		sql.append("       	 	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'E',Flt_q2,'0'),'0')) Now_Resv_res,"); //2004_Reserve_
		sql.append("        	Sum(Decode(Report_d,To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm'),Decode(Code_c2,'E',Flt_q2,'0'),'0')) Bef_Resv_res,"); //2003_Reserve_
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'F',Flt_q1,'0'),'0')) Now_Std_skd,");  //2004_StandBy_ȹ
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'F',Flt_q2,'0'),'0')) Now_Std_res,"); //2004_StandBy_
		sql.append("        	Sum(Decode(Report_d,To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm'),Decode(Code_c2,'F',Flt_q2,'0'),'0')) Bef_std_res,"); //2003_StandBy_
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'A',Flt_q1,'0'),'0')) Now_Over_skd,"); //2004_ٺ
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Decode(Code_c2,'B',Flt_q1,'0'),'0')) Now_Lack_skd"); //2004_Һ
		sql.append(" From 	Ops_Report_t");
		sql.append(" Where Report_d In ('"+reportD+"',To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm')) And");
		sql.append("       		Report_x = 'H' And");
		sql.append("       		Code_c1 = 'C'");
		sql.append(" Group By Code_c3");
				
		Logger.debug.println("[BASE:RepQ060Query:selLossPre] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS Report ׽¹  Loss  SQLԼ.
	  * @param reportD String yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/03/02 HIST 
	  */
	public String selLossOrg(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		//Loss 
		sql.append(" Select Decode(Report_d,'"+reportD+"','ݿ','⵿') Report_d,");
		sql.append("        	Sum(Decode(Code_c2,'A',Flt_q1,'0')) Day_q,");
		sql.append("        	Sum(Decode(Code_c2,'B',Flt_q1,'0')) Vac_q,");
		sql.append("        	Sum(Decode(Code_c2,'C',Flt_q1,'0')) Tran_q,");
		sql.append("        	Sum(Decode(Code_c2,'D',Flt_q1,'0')) Oth_q");
		sql.append(" From 	Ops_Report_t");
		sql.append(" Where Report_d In ('"+reportD+"',To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm')) And");
		sql.append("       		Report_x = 'H' And");
		sql.append("       		Code_c1 = 'D'");
		sql.append(" Group By Report_d");
		sql.append(" Order By Report_d");
				
		Logger.debug.println("[BASE:RepQ060Query:selLossOrg] sql : "+sql.toString());
		return sql.toString();
	}
	
}//end of class
