package kal.base.skd.query;

import kal.base.jdf.com.Logger;
import kal.base.skd.dbbean.SkdQ030BG;
import kal.base.com.query.*;

 /**
   * Planning SKD INFO SQL 
   * @author Copyright (c) 2005/01/17 
   */    
public class SkdQ030Query {
		
	private static SkdQ030Query instance = new SkdQ030Query();
	
	public static SkdQ030Query getInstance() {
		return instance;
	}
	/** 
	  * Planning SKD INFO main ȸ SQLԼ.
	  * @param entity SkdQ030BG Planning SKD INFO
	  * @return String Query 
	  * @author Copyright (c) 2005/01/17 
	  */
	public String selMain(SkdQ030BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select A.Flt_Num, A.Kactyp, A.Regno, A.Stnfr,  A.Stnto, A.Est_Dep_Dt Ord_1, A.Sch_Dep_Dt Ord_2, "); 
		if(entity.getTime_x().equals("utc")){  
			sql.append("		 TO_CHAR(A.SCH_DEP_DT,'YYYYMMDD') SCH_DATE,"); //2010.09.07 ߰ :  ¥ ߰
			sql.append("		 To_Char(A.Sch_Dep_Dt,'hh24:mi') Sch_Dep_Dt, To_Char(A.Est_Dep_Dt,'hh24:mi') Est_Dep_Dt,");
			sql.append("        To_Char(A.Act_Dep_Dt,'hh24:mi') Act_Dep_Dt, Dep_Gmt_Offset,");
			sql.append("        To_Char(A.Sch_Arv_Dt,'hh24:mi') Sch_Arv_Dt, To_Char(A.Est_Arv_Dt,'hh24:mi') Est_Arv_Dt,");
			sql.append("        To_Char(A.Act_Arv_Dt,'hh24:mi') Act_Arv_Dt, Arv_Gmt_Offset, ");
			sql.append("		(Substr(Tkof_t,1,2)||':'||Substr(Tkof_t,3,2)) Tkof_t,");
			sql.append("		(Substr(Land_t,1,2)||':'||Substr(Land_t,3,2)) Land_t,");
		}
		else if(entity.getTime_x().equals("kst")){
			sql.append("		 TO_CHAR(A.SCH_DEP_DT + 540/1440,'YYYYMMDD') SCH_DATE,"); //2010.09.07 ߰ :  ¥ ߰
			sql.append("        To_Char(A.Sch_Dep_Dt + 540/1440,'hh24:mi') Sch_Dep_Dt, To_Char(A.Est_Dep_Dt + 540/1440,'hh24:mi') Est_Dep_Dt,");
			sql.append("        To_Char(A.Act_Dep_Dt + 540/1440,'hh24:mi') Act_Dep_Dt, Dep_Gmt_Offset,");
			sql.append("        To_Char(A.Sch_Arv_Dt + 540/1440,'hh24:mi') Sch_Arv_Dt, To_Char(A.Est_Arv_Dt + 540/1440,'hh24:mi') Est_Arv_Dt,");
			sql.append("        To_Char(A.Act_Arv_Dt + 540/1440,'hh24:mi') Act_Arv_Dt, Arv_Gmt_Offset, ");
			sql.append("		TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(Tkof_t),'0000'),'YYYYMMDDHH24MI')+(540/1440),'HH24:MI') Tkof_t,");
			sql.append(" 		TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(Land_t),'0000'),'YYYYMMDDHH24MI')+(540/1440),'HH24:MI') Land_t,");
		}
		else if(entity.getTime_x().equals("loc")){
			sql.append("		 TO_CHAR(A.SCH_DEP_DT_LOC,'YYYYMMDD') SCH_DATE,"); //2010.09.07 ߰ :  ¥ ߰
			sql.append("        To_Char(A.Sch_Dep_Dt_Loc,'hh24:mi') Sch_Dep_Dt, To_Char(A.Est_Dep_Dt_Loc,'hh24:mi') Est_Dep_Dt,");
			sql.append("        To_Char(A.Act_Dep_Dt_Loc,'hh24:mi') Act_Dep_Dt, Dep_Gmt_Offset,");
			sql.append("        To_Char(A.Sch_Arv_Dt_Loc,'hh24:mi') Sch_Arv_Dt, To_Char(A.Est_Arv_Dt_Loc,'hh24:mi') Est_Arv_Dt,");
			sql.append("        To_Char(A.Act_Arv_Dt_Loc,'hh24:mi') Act_Arv_Dt, Arv_Gmt_Offset, ");
			sql.append("		TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(Tkof_t),'0000'),'YYYYMMDDHH24MI')+(DEP_GMT_OFFSET/1440),'HH24:MI') Tkof_t,");
			sql.append(" 		TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(Land_t),'0000'),'YYYYMMDDHH24MI')+(ARV_GMT_OFFSET/1440),'HH24:MI') Land_t,");
		}
		sql.append("  To_Char(A.First_Leg_Flt_Dt,'yyyymmdd') First_Leg_Flt_Dt, A.Dep_Sts, A.Arv_Sts, ");
		sql.append("	A.ADMRAD "); //2008.02.21 ߰ : ADMRAD 'A' or 'R' 츸 REGNO Display
		sql.append(" From Daily_Sch_T A , ");
		sql.append(" (Select Distinct Regno");
		sql.append("          From Daily_Sch_T ");
		sql.append("          Where Arln_Cd = 'KE' And ");
		sql.append(" 			SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.12.02 ߰ :  FLT 
		if(entity.getTime_x().equals("utc")){  
			sql.append("       	Sch_Dep_Dt >= To_Date('"+entity.getSch_dep_dt()+" 0000','yyyymmdd hh24mi') And");
			sql.append("       	Sch_Dep_Dt <= To_Date('"+entity.getSch_dep_dt()+" 2359','yyyymmdd hh24mi') + 2 And ");
		}
		else if(entity.getTime_x().equals("kst")){
			sql.append("       	Sch_Dep_Dt >= To_Date('"+entity.getSch_dep_dt()+" 0000','yyyymmdd hh24mi') - 540/1440 And");
			sql.append("          Sch_Dep_Dt <= To_Date('"+entity.getSch_dep_dt()+" 2359','yyyymmdd hh24mi') - 540/1440 + 2 And ");
		}
		else if(entity.getTime_x().equals("loc")){
			sql.append("          Sch_Dep_Dt_Loc >= To_Date('"+entity.getSch_dep_dt()+" 0000','yyyymmdd hh24mi') And");
			sql.append("          Sch_Dep_Dt_Loc <= To_Date('"+entity.getSch_dep_dt()+" 2359','yyyymmdd hh24mi') + 2 And ");
		}
		sql.append("                Dep_Sts <> 'INI' And");
		sql.append("                Actnid  <> 'CNL' And");
		sql.append("                Regno   <> 'ZZZZZ' ");
		if(!entity.getStnfr().equals("")){
			sql.append("            And (StnFr = '"+entity.getStnfr()+"' Or Stnto = '"+entity.getStnfr()+"')  ");
		}
		sql.append("          ) B ");
		sql.append(" Where A.Arln_Cd = 'KE' And ");
		sql.append(" 			 SUBSTR(A.FLT_NUM, 1, 1) <> '4' AND "); //2008.12.02 ߰ :  FLT 
		if(entity.getTime_x().equals("utc")){  
			sql.append("       A.Sch_Dep_Dt >= To_Date('"+entity.getSch_dep_dt()+" 0000','yyyymmdd hh24mi') And ");
			sql.append("       A.Sch_Dep_Dt <= To_Date('"+entity.getSch_dep_dt()+" 2359','yyyymmdd hh24mi') + 2 And");
		}
		else if(entity.getTime_x().equals("kst")){
			sql.append("       A.Sch_Dep_Dt >= To_Date('"+entity.getSch_dep_dt()+" 0000','yyyymmdd hh24mi') - 540/1440 And ");
			sql.append("       A.Sch_Dep_Dt <= To_Date('"+entity.getSch_dep_dt()+" 2359','yyyymmdd hh24mi') - 540/1440 + 2 And");
		}
		else if(entity.getTime_x().equals("loc")){
			sql.append("       A.Sch_Dep_Dt_Loc >= To_Date('"+entity.getSch_dep_dt()+" 0000','yyyymmdd hh24mi') And ");
			sql.append("       A.Sch_Dep_Dt_Loc <= To_Date('"+entity.getSch_dep_dt()+" 2359','yyyymmdd hh24mi') + 2 And");
		}
		//DOM/INT/CGO ȸ
		sql.append(ComQ01Query.getInstance().selDomIntQ(entity.getDom_int_x()));
		sql.append("       A.Dep_Sts    <> 'INI'  And");
		sql.append("       A.Actnid     <> 'CNL' And");
		sql.append("       A.Regno      = B.Regno");
		//sql.append(" Order By Kactyp, Regno, Ord_2, Ord_1"); 2010.09.10 
		sql.append(" Order By Kactyp, Regno, Ord_1, Ord_2 ");
		
		System.out.println("[BASE:SkdQ030Query:selMain] sql : "+sql.toString());
		Logger.debug.println("[BASE:SkdQ030Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	 * Planning SKD INFO Daily crew ȸ SQLԼ.
	  * @param entity SkdQ030BG Planning SKD INFO
	  * @return String Query 
	  * @author Copyright (c) 2005/01/17 
	  */
	public String selDailyCrew(SkdQ030BG params) {
		StringBuffer sql = new StringBuffer();
		
		/*
		int int_dt = Integer.parseInt(params.getSch_dep_dt());
		
		if (int_dt < 20100501) {
		
			sql.append(" Select TO_CHAR(B.FIRST_LEG_FLT_DT,'YYYYMMDD')||B.Flt_Num||B.Port_a||B.Port_b name_key, Substr(D.Surname,1,30) Surname"); //2010.09.07  : name_key FIRST_LEG_FLT_DT ߰
			sql.append(" From DUTY_PRD_SEG_V B, ROSTER_V C, CREW_V D");
			if (params.getTime_x().equals("utc")) {
				sql.append(" Where B.Act_Str_Dt_TM_Gmt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi')+(540/1440) And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
				sql.append("       B.Act_Str_Dt_TM_Gmt <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi')+(540/1440) And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
			} else if (params.getTime_x().equals("loc")) {
				sql.append(" Where B.Str_Dt_TM_Loc >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi')-(2/24) And");
				sql.append("       B.Str_Dt_TM_Loc <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi')+(2/24) And");
			} else {
				sql.append(" Where B.Act_Str_Dt_TM_Gmt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi') And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
				sql.append("       B.Act_Str_Dt_TM_Gmt <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi') And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
			}
			sql.append("       B.Delete_Ind = 'N' And");
			sql.append("       B.Series_num = C.Series_Num And");
			sql.append("       C.Delete_Ind = 'N' And");
			sql.append("       C.Staff_Num  = D.Staff_Num And");
			sql.append("       B.Port_a <> B.Port_b And");
			sql.append("       B.Flt_Num Not In('RST','LO','0') And");
			sql.append("       C.Acting_Rank = 'CAP'");
			//sql.append("       (C.Acting_Rank = 'CAP' or B.Cop_Duty_Cd In('CM','P1','P2'))");
			sql.append(" Order By 1");
			
		} else {
			
			sql.append(" Select TO_CHAR(B.FIRST_LEG_FLT_DT,'YYYYMMDD')||B.Flt_Num||B.Port_a||B.Port_b name_key, Substr(D.Surname,1,30) Surname"); //2010.09.07  : name_key FIRST_LEG_FLT_DT ߰
			sql.append(" From DUTY_PRD_SEG_V@kfos2airfd B, ROSTER_V@kfos2airfd C, CREW_V@kfos2airfd D");
			if (params.getTime_x().equals("utc")) {
				sql.append(" Where B.Act_Str_Dt_TM_Gmt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi') And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
				sql.append("       B.Act_Str_Dt_TM_Gmt <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi') And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
			} else if (params.getTime_x().equals("loc")) {
				sql.append(" Where B.Str_Dt_TM_Loc >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi')-(2/24) And");
				sql.append("       B.Str_Dt_TM_Loc <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi')+(2/24) And");
			} else {
				sql.append(" Where B.Act_Str_Dt_TM_Gmt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi') And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
				sql.append("       B.Act_Str_Dt_TM_Gmt <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi') And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
			}
			sql.append("       B.Delete_Ind = 'N' And");
			sql.append("       B.Series_num = C.Series_Num And");
			sql.append("       C.Delete_Ind = 'N' And");
			sql.append("       C.Staff_Num  = D.Staff_Num And");
			sql.append("       B.Port_a <> B.Port_b And");
			sql.append("       B.Flt_Num Not In('RST','LO','0') And");
			sql.append("       C.Acting_Rank = 'CAP'");
			//sql.append("       (C.Acting_Rank = 'CAP' or B.Cop_Duty_Cd In('CM','P1','P2'))");
			sql.append(" Order By 1");
		}
		*/
		
		sql.append(" Select TO_CHAR(B.FIRST_LEG_FLT_DT,'YYYYMMDD')||B.Flt_Num||B.Port_a||B.Port_b name_key, Substr(D.Surname,1,30) Surname"); //2010.09.07  : name_key FIRST_LEG_FLT_DT ߰
		//2017.02.09
		sql.append(" From DUTY_PRD_SEG_V@kfos2airfd B, ROSTER_V@kfos2airfd C, CREW_V@kfos2airfd D");
		//sql.append(" From DUTY_PRD_SEG_V@KFOS2FDPRD B, ROSTER_V@KFOS2FDPRD C, CREW_V@KFOS2FDPRD D");
		if (params.getTime_x().equals("utc")) {
			sql.append(" Where B.Act_Str_Dt_TM_Gmt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi') And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
			sql.append("       B.Act_Str_Dt_TM_Gmt <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi') + 1 And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
		} else if (params.getTime_x().equals("loc")) {
			sql.append(" Where B.Str_Dt_TM_Loc >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi')-(2/24) And");
			sql.append("       B.Str_Dt_TM_Loc <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi')+(2/24) + 1 And");
		} else {
			sql.append(" Where B.Act_Str_Dt_TM_Gmt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi') And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
			sql.append("       B.Act_Str_Dt_TM_Gmt <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi') + 1 And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
		}
		sql.append("       B.Delete_Ind = 'N' And");
		sql.append("       B.Series_num = C.Series_Num And");
		sql.append("       C.Delete_Ind = 'N' And");
		sql.append("       C.Staff_Num  = D.Staff_Num And");
		sql.append("       B.Port_a <> B.Port_b And");
		sql.append("       B.Flt_Num Not In('RST','LO','0') And");
		sql.append("       C.Acting_Rank = 'CAP'");
		//sql.append("       (C.Acting_Rank = 'CAP' or B.Cop_Duty_Cd In('CM','P1','P2'))");
		sql.append(" Order By 1");
		
		System.out.println("[BASE:SkdQ030Query:selDailyCrew] sql : "+sql.toString());
		Logger.debug.println("[BASE:SkdQ030Query:selDailyCrew] sql : "+sql.toString());
		return sql.toString();
	}	

	/** 
	  * Planning SKD INFO crew ȸ SQLԼ.
	  * @param entity SkdQ030BG Planning SKD INFO
	  * @return String Query 
	  * @author Copyright (c) 2005/01/17 
	  */	
	public String selCrew(SkdQ030BG params, String flt_num, String sch_dep_dt) {
		StringBuffer sql = new StringBuffer();
		
		/*
		int int_dt = Integer.parseInt(sch_dep_dt.substring(0,8));
		
		if (int_dt < 20100501) {
		
			sql.append(" Select Substr(D.Surname,1,30) Surname");
			sql.append(" From DUTY_PRD_SEG_V B,ROSTER_V C, CREW_V D");
			sql.append(" Where B.Delete_Ind = 'N' And");
			sql.append("            B.First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') and");
			sql.append("            B.Flt_Num    = '"+params.getFlt_num()+"'   And");
			sql.append("            B.Port_a     = '"+params.getStnfr()+"'        And");
			sql.append("            B.Port_b     = '"+params.getStnto()+"'       And");
			sql.append("            B.Series_num = C.Series_Num And");
			sql.append("            C.Delete_Ind = 'N' And");
			sql.append("            C.Staff_Num  = D.Staff_Num And");
			sql.append("           (C.Acting_Rank = 'CAP' or B.Cop_Duty_Cd In('CM','P1','P2')) And");
			sql.append("            Rownum = 1");
			
		} else {
			
			sql.append(" Select Substr(D.Surname,1,30) Surname");
			sql.append(" From DUTY_PRD_SEG_V@kfos2airfd B,ROSTER_V@kfos2airfd C, CREW_V@kfos2airfd D");
			sql.append(" Where B.Delete_Ind = 'N' And");
			sql.append("            B.First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') and");
			sql.append("            B.Flt_Num    = '"+params.getFlt_num()+"'   And");
			sql.append("            B.Port_a     = '"+params.getStnfr()+"'        And");
			sql.append("            B.Port_b     = '"+params.getStnto()+"'       And");
			sql.append("            B.Series_num = C.Series_Num And");
			sql.append("            C.Delete_Ind = 'N' And");
			sql.append("            C.Staff_Num  = D.Staff_Num And");
			sql.append("           (C.Acting_Rank = 'CAP' or B.Cop_Duty_Cd In('CM','P1','P2')) And");
			sql.append("            Rownum = 1");
		}
		*/
		
		sql.append(" Select Substr(D.Surname,1,30) Surname");
		//2017.02.09
		sql.append(" From DUTY_PRD_SEG_V@kfos2airfd B,ROSTER_V@kfos2airfd C, CREW_V@kfos2airfd D");
		//sql.append(" From DUTY_PRD_SEG_V@KFOS2FDPRD B,ROSTER_V@KFOS2FDPRD C, CREW_V@KFOS2FDPRD D");
		sql.append(" Where B.Delete_Ind = 'N' And");
		sql.append("            B.First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') and");
		sql.append("            B.Flt_Num    = '"+flt_num+"'   And");
		sql.append("            B.Port_a     = '"+params.getStnfr()+"'        And");
		sql.append("            B.Port_b     = '"+params.getStnto()+"'       And");
		sql.append("            B.Series_num = C.Series_Num And");
		sql.append("            C.Delete_Ind = 'N' And");
		sql.append("            C.Staff_Num  = D.Staff_Num And");
		sql.append("           (C.Acting_Rank = 'CAP' or B.Cop_Duty_Cd In('CM','P1','P2')) And");
		sql.append("            Rownum = 1");
		
		System.out.println("[BASE:SkdQ010Query:selCrew] sql : "+sql.toString());
		Logger.debug.println("[BASE:SkdQ010Query:selCrew] sql : "+sql.toString());
		return sql.toString();
	}
}
