package kal.base.sta.query;

import kal.base.jdf.com.Logger;
import kal.base.sta.dbbean.StaQ330BG;
import kal.base.com.query.ComQ01Query;

 /**
   * Cancel Status(A/C TYPE) SQL 
   * @author Copyright (c) 2005/01/27 
   */  
public class StaQ330Query {
	private static StaQ330Query instance = new StaQ330Query();
	
	public static StaQ330Query getInstance() {
		return instance;
	}
	/** 
	  * Cancel Status(A/C TYPE) main ȸ SQLԼ.
	  * @param entity StaQ330BG Cancel Status(A/C TYPE)
	  * @return String Query 
	  * @author Copyright (c) 2005/01/27 
	  */
	public String selMain(StaQ330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Kactyp, Decode(Actnid,'CNL','CNL','NEW') Actnid, Chgreas, Count(*) Total  ");
		sql.append(" From Daily_Sch_t  ");
		sql.append(" Where Arln_cd = 'KE' And ");
		sql.append(" 	SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.31 ߰ :  FLT 
		sql.append(" 	Sch_Dep_Dt >= To_Date('"+entity.getStart_date()+" 0000','yyyymmdd hh24mi') And  ");
		sql.append(" 	Sch_Dep_Dt <= To_Date('"+entity.getEnd_date()+" 2359','yyyymmdd hh24mi') And  ");
		sql.append(" 	Timestamp >= Sch_Dep_Dt - 39/24 And  ");
		sql.append(" 	Stnfr <> Stnto And ");
		sql.append(" 	Dep_Sts <> 'INI'   ");
		sql.append(" Group By Kactyp, Decode(Actnid,'CNL','CNL','NEW'), Chgreas ");
		sql.append(" Order By 1, 2, 3  ");	
		
		//Logger.debug.println("[BASE:StaQ330Query:selMain] sql : "+sql.toString());
		System.out.println("[BASE:StaQ330Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
