package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * Alternate Airport Information   Query
 * ۼ ¥: 2009-12-14
 * @author: 
 */
public class SupA670Query{
	private static SupA670Query instance = new SupA670Query();
	
	public static SupA670Query getInstance() {
		return instance;
	}
	
	/** 
	  * Station ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/12/14 
	  */
	public String selStation(String stn) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT, IATA_PORT ");
		sql.append(" FROM CM_PORT_T ");
		if (stn.length() == 4) {
			sql.append(" WHERE ICAO_PORT = '"+stn+"' ");	//(STN 4ڸ )
		} else {
			sql.append(" WHERE IATA_PORT = '"+stn+"' "); 	//(STN 3ڸ )
		}
		
		System.out.println("[BASE:SupA670Query:selStation] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alternate Airport Information ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/12/14 
	  */
	public String selAltnStn(SupA670BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ALTN_STN ");
		sql.append(" FROM BS_ALTN_PORT_T ");
		sql.append(" WHERE IATA_PORT = '"+params.getIata_port()+"' ");
		
		System.out.println("[BASE:SupA670Query:selAltnStn] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alternate Airport Information  SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/12/14 
	  */
	public String updAltnStn(SupA670BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE BS_ALTN_PORT_T ");
		sql.append(" SET ALTN_STN = '"+params.getAltn_stn()+"', ");
		sql.append(" TIMESTMP = SYSDATE, ");
		sql.append(" USERID = '"+params.getUserid()+"' ");
		sql.append(" WHERE IATA_PORT = '"+params.getIata_port()+"' ");
		
		System.out.println("[BASE:SupA670Query:updAltnStn] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alternate Airport Information Է SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/12/14 
	  */
	public String insAltnStn(SupA670BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO BS_ALTN_PORT_T (IATA_PORT, ALTN_STN, TIMESTMP, USERID) ");
		sql.append(" VALUES ('"+params.getIata_port()+"','"+params.getAltn_stn()+"',SYSDATE,'"+params.getUserid()+"') ");
		
		System.out.println("[BASE:SupA670Query:insAltnStn] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alternate Airport Information  SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/12/14 
	  */
	public String delAltnStn(SupA670BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" DELETE FROM BS_ALTN_PORT_T ");
		sql.append(" WHERE IATA_PORT = '"+params.getIata_port()+"' ");
		
		System.out.println("[BASE:SupA670Query:delAltnStn] sql : "+sql.toString());
		return sql.toString();
	}
}
