package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * New Company Route Information   Query
 * ۼ ¥: 2009-12-15
 * @author: 
 */
public class SupA680Query{
	private static SupA680Query instance = new SupA680Query();
	
	public static SupA680Query getInstance() {
		return instance;
	}

	/** 
	  * Station ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/12/15 
	  */
	public String selStation(String stn) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ICAO_PORT, IATA_PORT, CTRY_CD ");
		sql.append(" FROM CM_PORT_T ");
		if (stn.length() == 4) {
			sql.append(" WHERE ICAO_PORT = '"+stn+"' ");	//(STN 4ڸ )
		} else {
			sql.append(" WHERE IATA_PORT = '"+stn+"' "); 	//(STN 3ڸ )
		}
		
		System.out.println("[BASE:SupA680Query:selStation] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FIR ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/12/15 
	  */
	public String selFir(String fir_cd) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT * ");
		sql.append(" FROM BS_FIR_T ");
		sql.append(" WHERE FIR_CD = '"+fir_cd+"' ");
		
		System.out.println("[BASE:SupA680Query:selFir] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * RTE_CD ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/12/15 
	  */
	public String selRteCd(SupA680BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT RTE_CD ");
		sql.append(" FROM BS_COMP_ROUTE_T ");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"' ");
		sql.append(" AND ARR_STN = '"+params.getArr_stn()+"' ");
		
		System.out.println("[BASE:SupA680Query:selRteCd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Company Route Information ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/12/15 
	  */
	public String selCompRoute(SupA680BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT * ");
		sql.append(" FROM BS_COMP_ROUTE_T ");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"' ");
		sql.append(" AND ARR_STN = '"+params.getArr_stn()+"' ");
		sql.append(" AND RTE_CD = '"+params.getRte_cd()+"' ");
		
		System.out.println("[BASE:SupA680Query:selCompRoute] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Company Route Information  SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/12/15 
	  */
	public String updCompRoute(SupA680BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE BS_COMP_ROUTE_T ");
		sql.append(" SET ETOPS_STN = '"+params.getEtops_stn()+"', ");
		sql.append(" ENRTE_STN = '"+params.getEnrte_stn()+"', ");
		sql.append(" REFILE_STN = '"+params.getRefile_stn()+"', ");
		sql.append(" OTHERS_STN = '"+params.getOthers_stn()+"', ");
		sql.append(" RTE_FIR = '"+params.getRte_fir()+"', ");
		sql.append(" TIMESTMP = SYSDATE, ");
		sql.append(" USERID = '"+params.getUserid()+"' ");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"' ");
		sql.append(" AND ARR_STN = '"+params.getArr_stn()+"' ");
		sql.append(" AND RTE_CD = '"+params.getRte_cd()+"' ");
		
		System.out.println("[BASE:SupA680Query:updCompRoute] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Company Route Information Է SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/12/15 
	  */
	public String insCompRoute(SupA680BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO BS_COMP_ROUTE_T (DEP_STN, ARR_STN, RTE_CD, ETOPS_STN, ENRTE_STN, REFILE_STN, OTHERS_STN, RTE_FIR, TIMESTMP, USERID) ");
		sql.append(" VALUES ('"+params.getDep_stn()+"','"+params.getArr_stn()+"','"+params.getRte_cd()+"','"+params.getEtops_stn()+"','"+params.getEnrte_stn()+"','"+params.getRefile_stn()+"','"+params.getOthers_stn()+"','"+params.getRte_fir()+"',SYSDATE,'"+params.getUserid()+"') ");
		
		System.out.println("[BASE:SupA680Query:insCompRoute] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Company Route Information  SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/12/15 
	  */
	public String delCompRoute(SupA680BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" DELETE FROM BS_COMP_ROUTE_T ");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"' ");
		sql.append(" AND ARR_STN = '"+params.getArr_stn()+"' ");
		sql.append(" AND RTE_CD = '"+params.getRte_cd()+"' ");
		
		System.out.println("[BASE:SupA680Query:delCompRoute] sql : "+sql.toString());
		return sql.toString();
	}
	
}
