package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.SupQ240BG;
import kal.base.com.query.ComQ01Query;

 /**
   * SIGMET/AIRREP INFO SQL 
   * @author Copyright (c) 2005/06/20 
   */
public class SupQ240Query {
	private static SupQ240Query instance = new SupQ240Query();
	
	public static SupQ240Query getInstance() {
		return instance;
	}
	
	/** 
	  * SIGMET/AIRREP INFO main ȸ SQLԼ.
	  * @param entity SupQ240BG SIGMET/AIRREP INFO
	  * @return String Query 
	  * @author Copyright (c) 2005/06/20 
	  */
	public String selMain(SupQ240BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT MSG_TEXT ");
		sql.append(" FROM BS_SIGMET_T ");
		sql.append(" WHERE MSG_TYP = '" + entity.getMsg_typ() + "' AND ");
		sql.append(" 		   MSG_DTG >= SYSDATE-1 ");
		sql.append(" ORDER BY MSG_DTG DESC ");
		
		Logger.debug.println("[BASE:SupQ240Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
