package kal.base.ocb.ejb;
import kal.base.jdf.db.BusinessException;
import java.util.Hashtable;
import kal.base.ocb.dbbean.OcbA025BG;
import kal.base.ocb.dbbean.OcbQ020BG;
import kal.base.ocb.dbbean.OcbQ130BG;
import kal.base.ocb.dbbean.OcbQ140BG;
/**
 * Remote interface for Enterprise Bean: OcbAllSL
 */
public interface OcbAllSL extends javax.ejb.EJBObject {
	/** 
	  * <b> Operation Control Board ȸԼ</b>. 
	  * @param reportD String ȸ yyyymm
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/03/10 HIST 
	  */
	public Hashtable selOcbQ010Main(String reportD)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b> OCB Daily Operations Information2 ȸԼ</b>. 
	  * @param reportD String ȸ yyyymm
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/03/29 HIST 
	  */
	public Hashtable selOcbQ030Main(String reportD)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * Restriction Airport Popup ԷԼ. 
	  * @param params OcbA025BG Է
	  * @return returnValue int 
	  * @exception Exception
	  * @author Copyright (c) 2005/03/28 
	  */
	public int insOcbA025Main(OcbA025BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * Daily Operation Info1 ȸԼ
	  * @param params OcbQ020BG Է
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/03/29 
	  */
	public Hashtable selOcbQ020Main(OcbQ020BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * Restriction Airport Լ
	  * @param params OcbQ020BG 
	  * @return returnValue int 
	  * @exception Exception
	  * @author Copyright (c) 2005/03/30 
	  */
	public int delOcbQ020ResAir(
		String[] irops_d,
		String[] apt_c,
		String[] seq_no)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b> KE Resource Monitor Detail 1 ȸԼ</b>. 
	  * @param reportM String ȸ yyyymm
	  * @param reportD String ȸ  yyyymmdd
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/03/10 HIST 
	  */
	public Hashtable selOcbQ110Main(String reportM, String reportD)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * Departure On Time Pcnt Detail I ȸ Լ
	  * @param params OcbQ130BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/04/28 
	  */
	public Hashtable selOcbQ130Main(OcbQ130BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b> KE Resource Monitor Detail II ȸԼ</b>. 
	  * @param reportD String ȸ  yyyymmdd
	  * @param kacTyp String KACTYP
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/04/29 HIST 
	  */
	public Hashtable selOcbQ120Main(String reportD,String kacTyp)
		throws BusinessException, java.rmi.RemoteException;

	/** 
	  * Departure On Time Pcnt Detail II main ȸԼ.
	  * @param entity OcbQ140BG Departure On Time Pcnt Detail II
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/04/29 
	  */
	public Hashtable selOcbQ140Main(OcbQ140BG params)
		throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param reportD
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selOcbQ010IropsDetail(String reportD) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param reportD
	 * @param current
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selOcbQ010IropsStatus(String reportD, String current) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String selOcbQ010IropsCheck() throws BusinessException, java.rmi.RemoteException;
}
