package kal.base.ocb.ejb;

//ڹ 
import java.io.*;
import java.sql.*;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.*;

//Project 
import kal.base.jdf.com.*;
import kal.base.jdf.db.*;
import kal.base.pbf.db.*;
import kal.base.jdf.jtx.*;
import kal.base.com.query.ComQ01Query;
import kal.base.com.util.*;
import kal.base.jdf.ejb.*;

//OCB
import kal.base.ocb.query.*;
import kal.base.ocb.dbbean.*;
//SKD
import kal.base.skd.dbbean.*;
import kal.base.skd.query.*;

/**
 * Bean implementation class for Enterprise Bean: OcbAllSL
 */
public class OcbAllSLBean extends BeanAdapter {

	/** 
	  * <b> Operation Control Board ȸԼ</b>. 
	  * @param reportD String ȸ yyyymm
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * ۼ ¥ : 2009.09.17
	  */
	public Hashtable selOcbQ010IropsStatus(String reportD, String current) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    
	    try {
	    	//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DB TABLE ȸ
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().selDbTime("YYYYMMDDHH24MI","9/24");//@2019-08-20
			rs = stmt.executeQuery(sql);

			String nowTime = "";
			if (rs.next()) nowTime = StringUtil.checkString(rs.getString("DB_TIME"));
            
			//üȯ
			if (rs != null) rs.close();
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			
			/********** KE Flight Status - IROPS **********/ //2009.09.17 ߰
			List listIropsDom = new LinkedList();
			List listIropsInt = new LinkedList();
			List listIropsCgo = new LinkedList();
			
			List listIropsAll = new LinkedList(); //2010.07.23 ߰
			
			stmt = conn.createStatement();
			sql = OcbQ010Query.getInstance().selIropsStatus(reportD);
			rs = stmt.executeQuery(sql);
			
			String prevFirstLegFltDt = "";
			String prevFltNum = "";
			String prevDdMon = "";
			String prevStnfr = "";
			String prevStnto = "";
			String prevTitleE = "";
			String prevCommentX = "";
			String prevCommentE = "";
			String prevRouteX = "";
			String prevSchDepDt = ""; //2010.04.12 ߰
			
			String prevArvSts = "";
			String prevActnid = "";
			String prevArvDt = "";
			
			while (rs.next()) {
				/* 2009.11.26  : DOM, INT, CGO 
				OcbQ010BG entity = new OcbQ010BG();
				StringBuffer iropsBf = new StringBuffer();
				iropsBf.append("KE"+StringUtil.checkString(rs.getString("FLT_NUM")));
				iropsBf.append("/"+StringUtil.checkString(rs.getString("DDMON")));
				iropsBf.append(" "+StringUtil.checkString(rs.getString("STNFR")));
				iropsBf.append("/"+StringUtil.checkString(rs.getString("STNTO")));
				iropsBf.append(" "+StringUtil.checkString(rs.getString("TITLE_E")));
				iropsBf.append("<BR>["+StringUtil.checkString(rs.getString("COMMENT_E"))+"]");
				entity.setIropsReport(iropsBf.toString());
				*/
				/* 2010.02.22 ߰ : FLT_NUM ߺǸ ͸ ´.
				OcbQ010BG entity = new OcbQ010BG();
				
				entity.setIrops_flt_num(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setIrops_ddmon(StringUtil.checkString(rs.getString("DDMON")));
				entity.setIrops_stnfr(StringUtil.checkString(rs.getString("STNFR")));
				entity.setIrops_stnto(StringUtil.checkString(rs.getString("STNTO")));
				entity.setIrops_title_e(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setIrops_comment_x(StringUtil.checkString(rs.getString("COMMENT_X")));
				//2010.02.17 ߰ : DEP_STS='ACT' ̰ COMMENT_X='DLA' ̸ DELAY_MIN ǥ
				if (StringUtil.checkString(rs.getString("DEP_STS")).equals("ACT") && StringUtil.checkString(rs.getString("COMMENT_X")).equals("DLA")) {
					entity.setIrops_comment_e(StringUtil.checkString(rs.getString("COMMENT_E")) + " (" + StringUtil.checkString(rs.getString("DELAY_MIN")) + "MIN)");
				} else {
					entity.setIrops_comment_e(StringUtil.checkString(rs.getString("COMMENT_E")));
				}
				entity.setIrops_route_x(StringUtil.checkString(rs.getString("ROUTE_X")));
				
				//2010.02.17 ߰
				//CURRENT ư ý ARV_STS='ACT' ̰ų ACTNID='CNL' ̸ ARV_DT  SYSDATE   Ⱥ.
				if (current.equals("Y")) {
					
					String arvSts = StringUtil.checkString(rs.getString("ARV_STS"));
					String actnid = StringUtil.checkString(rs.getString("ACTNID"));
					String arvDt = StringUtil.checkString(rs.getString("ARV_DT"));
					
					boolean currOk = true;
					
					if (arvSts.equals("ACT") || actnid.equals("CNL")) {
						if (!arvDt.equals("")) {
							if (Long.parseLong(arvDt) < Long.parseLong(nowTime)) currOk = false;
						}
					}
					
					if (currOk) {
						if (StringUtil.checkString(rs.getString("ROUTE_X")).equals("DOM")) listIropsDom.add(entity);
						else if (StringUtil.checkString(rs.getString("ROUTE_X")).equals("INT")) listIropsInt.add(entity);
						else if (StringUtil.checkString(rs.getString("ROUTE_X")).equals("CGO")) listIropsCgo.add(entity);	
					}
					
				} else { //ALL ư (⺻)
					
					if (StringUtil.checkString(rs.getString("ROUTE_X")).equals("DOM")) listIropsDom.add(entity);
					else if (StringUtil.checkString(rs.getString("ROUTE_X")).equals("INT")) listIropsInt.add(entity);
					else if (StringUtil.checkString(rs.getString("ROUTE_X")).equals("CGO")) listIropsCgo.add(entity);	
				}
				*/
				if ((!StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT")).equals(prevFirstLegFltDt) 
						|| !StringUtil.checkString(rs.getString("FLT_NUM")).equals(prevFltNum) 
						|| !StringUtil.checkString(rs.getString("STNFR")).equals(prevStnfr)) && !prevFirstLegFltDt.equals("")) {
					
					OcbQ010BG entity = new OcbQ010BG();
					
					entity.setIrops_flt_num(prevFltNum);
					entity.setIrops_ddmon(prevDdMon);
					entity.setIrops_stnfr(prevStnfr);
					entity.setIrops_stnto(prevStnto);
					entity.setIrops_title_e(prevTitleE);
					entity.setIrops_comment_x(prevCommentX);
					entity.setIrops_comment_e(prevCommentE);
					entity.setIrops_route_x(prevRouteX);
					entity.setIrops_sch_dep_dt(prevSchDepDt); //2010.04.12 ߰
					
					//2010.02.17 ߰
					//CURRENT ư ý ARV_STS='ACT' ̰ų ACTNID='CNL' ̸ ARV_DT  SYSDATE   Ⱥ.
					if (current.equals("Y")) {
						boolean currOk = true;
						
						if (prevArvSts.equals("ACT") || prevActnid.equals("CNL")) {
							if (!prevArvDt.equals("")) {
								if (Long.parseLong(prevArvDt) < Long.parseLong(nowTime)) currOk = false;
							}
						}
						
						if (currOk) {
							if (prevRouteX.equals("DOM")) listIropsDom.add(entity);
							else if (prevRouteX.equals("INT")) listIropsInt.add(entity);
							else if (prevRouteX.equals("CGO")) listIropsCgo.add(entity);
							
							if (prevRouteX.equals("DOM") || prevRouteX.equals("INT")) listIropsAll.add(entity); //2010.07.23 ߰
						}
						
					} else { //ALL ư (⺻)
						
						if (prevRouteX.equals("DOM")) listIropsDom.add(entity);
						else if (prevRouteX.equals("INT")) listIropsInt.add(entity);
						else if (prevRouteX.equals("CGO")) listIropsCgo.add(entity);
						
						if (prevRouteX.equals("DOM") || prevRouteX.equals("INT")) listIropsAll.add(entity); //2010.07.23 ߰
					}
				}
				
				prevFirstLegFltDt = StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT"));
				prevFltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
				prevDdMon = StringUtil.checkString(rs.getString("DDMON"));
				prevStnfr = StringUtil.checkString(rs.getString("STNFR"));
				prevStnto = StringUtil.checkString(rs.getString("STNTO"));
				prevTitleE = StringUtil.checkString(rs.getString("TITLE_E"));
				prevCommentX = StringUtil.checkString(rs.getString("COMMENT_X"));
				//2010.02.17 ߰ : DEP_STS='ACT' ̰ COMMENT_X='DLA' ̸ DELAY_MIN ǥ
				if (StringUtil.checkString(rs.getString("DEP_STS")).equals("ACT") && StringUtil.checkString(rs.getString("COMMENT_X")).equals("DLA")) {
					prevCommentE = StringUtil.checkString(rs.getString("COMMENT_E")) + " (" + StringUtil.checkString(rs.getString("DELAY_MIN")) + "MIN)";
				} else {
					prevCommentE = StringUtil.checkString(rs.getString("COMMENT_E"));
				}
				prevRouteX = StringUtil.checkString(rs.getString("ROUTE_X"));
				prevSchDepDt = StringUtil.checkString(rs.getString("SCH_DEP_DT")); //2010.04.12 ߰
				
				prevArvSts = StringUtil.checkString(rs.getString("ARV_STS"));
				prevActnid = StringUtil.checkString(rs.getString("ACTNID"));
				prevArvDt = StringUtil.checkString(rs.getString("ARV_DT"));
			}
			
			// row ´.
			if (!prevFirstLegFltDt.equals("")) {
				
				OcbQ010BG entity = new OcbQ010BG();
				
				entity.setIrops_flt_num(prevFltNum);
				entity.setIrops_ddmon(prevDdMon);
				entity.setIrops_stnfr(prevStnfr);
				entity.setIrops_stnto(prevStnto);
				entity.setIrops_title_e(prevTitleE);
				entity.setIrops_comment_x(prevCommentX);
				entity.setIrops_comment_e(prevCommentE);
				entity.setIrops_route_x(prevRouteX);
				entity.setIrops_sch_dep_dt(prevSchDepDt); //2010.04.12 ߰
				
				//2010.02.17 ߰
				//CURRENT ư ý ARV_STS='ACT' ̰ų ACTNID='CNL' ̸ ARV_DT  SYSDATE   Ⱥ.
				if (current.equals("Y")) {
					boolean currOk = true;
					
					if (prevArvSts.equals("ACT") || prevActnid.equals("CNL")) {
						if (!prevArvDt.equals("")) {
							if (Long.parseLong(prevArvDt) < Long.parseLong(nowTime)) currOk = false;
						}
					}
					
					if (currOk) {
						if (prevRouteX.equals("DOM")) listIropsDom.add(entity);
						else if (prevRouteX.equals("INT")) listIropsInt.add(entity);
						else if (prevRouteX.equals("CGO")) listIropsCgo.add(entity);
						
						if (prevRouteX.equals("DOM") || prevRouteX.equals("INT")) listIropsAll.add(entity); //2010.07.23 ߰
					}
					
				} else { //ALL ư (⺻)
					
					if (prevRouteX.equals("DOM")) listIropsDom.add(entity);
					else if (prevRouteX.equals("INT")) listIropsInt.add(entity);
					else if (prevRouteX.equals("CGO")) listIropsCgo.add(entity);
					
					if (prevRouteX.equals("DOM") || prevRouteX.equals("INT")) listIropsAll.add(entity); //2010.07.23 ߰
				}
			}
			
			hashData.put("IROPS_LIST_DOM", listIropsDom);
			hashData.put("IROPS_LIST_INT", listIropsInt);
			hashData.put("IROPS_LIST_CGO", listIropsCgo);
			
			hashData.put("IROPS_LIST_ALL", listIropsAll); //2010.07.23 ߰
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
	    	
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ010IropsStatus:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ010IropsStatus:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * <b> Operation Control Board ȸԼ</b>. 
	  * @param reportD String ȸ yyyymm
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/03/10 HIST 
	  */
	public Hashtable selOcbQ010Main(String reportD) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   
	    try {
	    	//Number Format 
	    	DecimalFormat df1 = new DecimalFormat("#,##0");
	    	DecimalFormat df2 = new DecimalFormat("##0.0");
	    	
	    	//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			/********** KE Flight Status - IROPS **********/ //2009.09.17 ߰
			List listIropsDom = new LinkedList();
			List listIropsInt = new LinkedList();
			List listIropsCgo = new LinkedList();

			//DB TABLE ȸ
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().selDbTime("YYYYMMDDHH24MI","0");
			rs = stmt.executeQuery(sql);
			
			String nowTime = "";
			if (rs.next()) nowTime = StringUtil.checkString(rs.getString("DB_TIME"));
			
			stmt = conn.createStatement();
			sql = OcbQ010Query.getInstance().selIropsStatus(reportD);
			rs = stmt.executeQuery(sql);
			
			String prevFirstLegFltDt = "";
			String prevFltNum = "";
			String prevDdMon = "";
			String prevStnfr = "";
			String prevStnto = "";
			String prevTitleE = "";
			String prevCommentX = "";
			String prevCommentE = "";
			String prevRouteX = "";
			String prevArvSts = "";
			String prevActnid = "";
			String prevArvDt = "";

			
			while (rs.next()) {
				/* 2009.11.26  : DOM, INT, CGO 
				OcbQ010BG entity = new OcbQ010BG();
				StringBuffer iropsBf = new StringBuffer();
				iropsBf.append("KE"+StringUtil.checkString(rs.getString("FLT_NUM")));
				iropsBf.append("/"+StringUtil.checkString(rs.getString("DDMON")));
				iropsBf.append(" "+StringUtil.checkString(rs.getString("STNFR")));
				iropsBf.append("/"+StringUtil.checkString(rs.getString("STNTO")));
				iropsBf.append(" "+StringUtil.checkString(rs.getString("TITLE_E")));
				iropsBf.append("<BR>["+StringUtil.checkString(rs.getString("COMMENT_E"))+"]");
				entity.setIropsReport(iropsBf.toString());
				*/
				/* 2010.02.22 ߰ : FLT_NUM ߺǸ ͸ ´.
				OcbQ010BG entity = new OcbQ010BG();
				
				entity.setIrops_flt_num(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setIrops_ddmon(StringUtil.checkString(rs.getString("DDMON")));
				entity.setIrops_stnfr(StringUtil.checkString(rs.getString("STNFR")));
				entity.setIrops_stnto(StringUtil.checkString(rs.getString("STNTO")));
				entity.setIrops_title_e(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setIrops_comment_x(StringUtil.checkString(rs.getString("COMMENT_X")));
				//2010.02.17 ߰ : DEP_STS='ACT' ̰ COMMENT_X='DLA' ̸ DELAY_MIN ǥ
				if (StringUtil.checkString(rs.getString("DEP_STS")).equals("ACT") && StringUtil.checkString(rs.getString("COMMENT_X")).equals("DLA")) {
					entity.setIrops_comment_e(StringUtil.checkString(rs.getString("COMMENT_E")) + " (" + StringUtil.checkString(rs.getString("DELAY_MIN")) + "MIN)");
				} else {
					entity.setIrops_comment_e(StringUtil.checkString(rs.getString("COMMENT_E")));
				}
				entity.setIrops_route_x(StringUtil.checkString(rs.getString("ROUTE_X")));
				
				if (StringUtil.checkString(rs.getString("ROUTE_X")).equals("DOM")) listIropsDom.add(entity);
				else if (StringUtil.checkString(rs.getString("ROUTE_X")).equals("INT")) listIropsInt.add(entity);
				else if (StringUtil.checkString(rs.getString("ROUTE_X")).equals("CGO")) listIropsCgo.add(entity);
				*/
				if ((!StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT")).equals(prevFirstLegFltDt) 
						|| !StringUtil.checkString(rs.getString("FLT_NUM")).equals(prevFltNum) 
						|| !StringUtil.checkString(rs.getString("STNFR")).equals(prevStnfr)) && !prevFirstLegFltDt.equals("")) {
					
					OcbQ010BG entity = new OcbQ010BG();
					
					entity.setIrops_flt_num(prevFltNum);
					entity.setIrops_ddmon(prevDdMon);
					entity.setIrops_stnfr(prevStnfr);
					entity.setIrops_stnto(prevStnto);
					entity.setIrops_title_e(prevTitleE);
					entity.setIrops_comment_x(prevCommentX);
					entity.setIrops_comment_e(prevCommentE);
					entity.setIrops_route_x(prevRouteX);
					
					//2017.03.23 ð   Ⱥ̰
					boolean currOk = true;
					
					System.out.println("---------------------------------------------------------------------");
					System.out.println("prevFltNum:"+prevFltNum + " prevArvSts:"+prevArvSts + " prevActnid:"+prevActnid +" prevArvDt:"+prevArvDt +" prevCommentX:"+prevCommentX);
					System.out.println("prevArvDt:"+Long.parseLong(prevArvDt));
					System.out.println("  nowTime:"+Long.parseLong(nowTime));
					
					if (prevArvSts.equals("ACT") || prevActnid.equals("CNL")) {
						if (!prevArvDt.equals("")) {
							
							if (Long.parseLong(prevArvDt) < Long.parseLong(nowTime)){ 
								
								currOk = false;
								System.out.println("  currOk = false:"+currOk);	
								
							}else{
								System.out.println("  currOk =  true:"+currOk);	
							}
						}
					}
					
					if (currOk) {
					
						if (prevRouteX.equals("DOM")) listIropsDom.add(entity);
						else if (prevRouteX.equals("INT")) listIropsInt.add(entity);
						else if (prevRouteX.equals("CGO")) listIropsCgo.add(entity);
					}	
											
				
				}
				
				prevFirstLegFltDt = StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT"));
				prevFltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
				prevDdMon = StringUtil.checkString(rs.getString("DDMON"));
				prevStnfr = StringUtil.checkString(rs.getString("STNFR"));
				prevStnto = StringUtil.checkString(rs.getString("STNTO"));
				prevTitleE = StringUtil.checkString(rs.getString("TITLE_E"));
				prevCommentX = StringUtil.checkString(rs.getString("COMMENT_X"));
				
				//2017.03.23 ߰
				prevArvSts = StringUtil.checkString(rs.getString("ARV_STS"));
				prevActnid = StringUtil.checkString(rs.getString("ACTNID"));
				prevArvDt = StringUtil.checkString(rs.getString("ARV_DT"));
				
				//2010.02.17 ߰ : DEP_STS='ACT' ̰ COMMENT_X='DLA' ̸ DELAY_MIN ǥ
				if (StringUtil.checkString(rs.getString("DEP_STS")).equals("ACT") && StringUtil.checkString(rs.getString("COMMENT_X")).equals("DLA")) {
					prevCommentE = StringUtil.checkString(rs.getString("COMMENT_E")) + " (" + StringUtil.checkString(rs.getString("DELAY_MIN")) + "MIN)";
				} else {
					prevCommentE = StringUtil.checkString(rs.getString("COMMENT_E"));
				}
				prevRouteX = StringUtil.checkString(rs.getString("ROUTE_X"));

			}
			
			
			// row ´.
			if (!prevFirstLegFltDt.equals("")) {
				
				OcbQ010BG entity = new OcbQ010BG();
				
				System.out.println("prevFltNum:"+prevFltNum);
				
				entity.setIrops_flt_num(prevFltNum);
				entity.setIrops_ddmon(prevDdMon);
				entity.setIrops_stnfr(prevStnfr);
				entity.setIrops_stnto(prevStnto);
				entity.setIrops_title_e(prevTitleE);
				entity.setIrops_comment_x(prevCommentX);
				entity.setIrops_comment_e(prevCommentE);
				entity.setIrops_route_x(prevRouteX);
				
				
				//2017.03.23 ð   Ⱥ̰
				boolean currOk = true;
				
				//System.out.println("---------------------------------------------------------------------");
				//System.out.println("prevFltNum:"+prevFltNum + " prevArvSts:"+prevArvSts + " prevActnid:"+prevActnid +" prevArvDt:"+prevArvDt);
				//System.out.println("prevArvDt:"+Long.parseLong(prevArvDt));
				//System.out.println("  nowTime:"+Long.parseLong(nowTime));
				
				if (prevArvSts.equals("ACT") || prevActnid.equals("CNL")) {
					if (!prevArvDt.equals("")) {
						
						if (Long.parseLong(prevArvDt) < Long.parseLong(nowTime)){ 
							
							//System.out.println("  currOk = false :"+currOk);	
							currOk = false;
						}else{
							System.out.println("  currOk =   true:"+currOk);	
						}
					}
				}
				
				if (currOk) {
					if (prevRouteX.equals("DOM")) listIropsDom.add(entity);
					else if (prevRouteX.equals("INT")) listIropsInt.add(entity);
					else if (prevRouteX.equals("CGO")) listIropsCgo.add(entity);
				}
				
			}
			
			hashData.put("IROPS_LIST_DOM", listIropsDom);
			hashData.put("IROPS_LIST_INT", listIropsInt);
			hashData.put("IROPS_LIST_CGO", listIropsCgo);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			/********** KE Flight Status - IROPS **********/ //-----> .
			///ӽ÷ Departure 
			List listDep = new LinkedList();
			stmt = conn.createStatement();
			sql = OcbQ010Query.getInstance().selIropsDep(reportD);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				OcbQ010BG entity = new OcbQ010BG();
				StringBuffer iropsDep = new StringBuffer();
				iropsDep.append(StringUtil.checkString(rs.getString("Irops_Info")));
				iropsDep.append(" - ");
				iropsDep.append(StringUtil.checkString(rs.getString("Irops_Desc")));
				entity.setIrops_dep(iropsDep.toString());
				listDep.add(entity);
			}
			hashData.put("IROPSDEP",listDep);
			
			/*
			String iropsDep = "";
			while (rs.next()) {
				iropsDep += StringUtil.checkString(rs.getString("Irops_Info"));
				iropsDep += "&nbsp;-&nbsp;";
				iropsDep += StringUtil.checkString(rs.getString("Irops_Desc"));
				iropsDep += "<BR><BR>";
			}
			if (iropsDep.length() > 8) iropsDep = iropsDep.substring(0,iropsDep.length()-8);
			hashData.put("IROPSDEP",iropsDep);
			*/
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			/********** KE Operational Performace **********/
			double[] calPer = new double[2];
			OcbQ010BG opData = new OcbQ010BG();
			opData.setPer_date(reportD);
			//(1)
			stmt = conn.createStatement();
			sql = OcbQ010Query.getInstance().selOpPer1(reportD);
			rs = stmt.executeQuery(sql);
			
			while(rs.next()) {
				if (StringUtil.checkString(rs.getString(2)).equals("ALL")) {
					calPer[0] = rs.getDouble(1);	//ü
				} else {
					calPer[1] = rs.getDouble(1);	//ϰ
				}
			}
			if (calPer[0] != 0 && calPer[1] != 0) {
				opData.setPer_dep(df2.format(((calPer[0] - calPer[1])/calPer[0])*100));
			} else opData.setPer_dep("0");
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//(2)
			stmt = conn.createStatement();
			sql = OcbQ010Query.getInstance().selOpPer2(reportD);
			rs = stmt.executeQuery(sql);
			
			while(rs.next()) {
				if (StringUtil.checkString(rs.getString(2)).equals("ALL")) {
					calPer[0] = rs.getDouble(1);	//ü
				} else {
					calPer[1] = rs.getDouble(1);	//ϰ
				}
			}
			if (calPer[0] != 0 && calPer[1] != 0) {
				//opData.setPer_arv(df2.format((calPer[1]/calPer[0])*100));
				opData.setPer_arv(df2.format(((calPer[0] - calPer[1])/calPer[0])*100));
			} else opData.setPer_arv("0");
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//(3)(6)
			double calLF[] = new double[2];
			//calLF[0] : ACT_CHKIN + EST_BOOK + SCH_BOOK
			//calLF[1] : ACT_CFG + EST_CFG + SCH_CFG
			stmt = conn.createStatement();
			sql = OcbQ010Query.getInstance().selOpPer36(reportD);
			rs = stmt.executeQuery(sql);
			
			/*
			  	 		CFG		BOOK	CHKIN
			1	ACT	68283	52109	50236
			2	EST	187		168		168
			3	SCH	18768	14419	8160
			*/
			
			//Passenger Count(3) = ACT_Chkin_Cnt
			//L/F(6) = (ACT_CHKIN + EST_BOOK + SCH_BOOK) / (ACT_CFG + EST_CFG + SCH_CFG) * 100
			while(rs.next()) {
				if (StringUtil.checkString(rs.getString("Dep_Sts")).equals("ACT")) {
					opData.setPer_pass(df1.format(rs.getDouble("Chkin_Cnt")));
					calLF[0] += rs.getDouble("Chkin_Cnt");
					calLF[1] += rs.getDouble("Cfg_Cnt");
				} else {
					calLF[0] += rs.getDouble("Book_Cnt");
					calLF[1] += rs.getDouble("Cfg_Cnt");	
				}
			}
			if (calLF[0] != 0 && calLF[1] != 0) {
				opData.setPer_lf(df2.format((calLF[0]/calLF[1])*100));
			} else {
				opData.setPer_pass("0");
				opData.setPer_lf("0");
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//(4)(5)
			stmt = conn.createStatement();
			sql = OcbQ010Query.getInstance().selOpPer45(reportD);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				opData.setPer_bag(df1.format(rs.getDouble("Bag_q")));
				opData.setPer_cgo(df1.format(rs.getDouble("Cgo_q")));
			} else {
				opData.setPer_bag("0");
				opData.setPer_cgo("0");
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//(7)
            //	opData.setPer_eqp("");
			//2012.05.30 T/S PAX ׸ 
			stmt = conn.createStatement();
			sql = OcbQ010Query.getInstance().selTsPax(reportD);
			rs = stmt.executeQuery(sql);
			
			if(rs.next()){
			    opData.setTsPax(StringUtil.checkString(rs.getString("BOOK_Q"))+"/"+StringUtil.checkString(rs.getString("CHKIN_Q")));
			}else{
				opData.setTsPax("0/0");
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			hashData.put("OPDATA",opData);
			
			/********** Operational Contral Board **********/
			OcbQ010BG ocbData = new OcbQ010BG();	
			//۾ ȸ
			String reportM = null;
			stmt = conn.createStatement();
			sql = OcbQ010Query.getInstance().selWorkMon();
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) reportM = StringUtil.checkString(rs.getString("Code_c"));
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			if (reportM != null) {
				//ȸ  
				hashData.put("REPORTM",reportM);
				
				//
				stmt = conn.createStatement();
				sql = OcbQ010Query.getInstance().selGauge1(reportM);
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) {
					ocbData.setGag_rl_1(StringUtil.checkString(rs.getString("gag_per")));		//Real ġ
					ocbData.setGag_rd_1(StringUtil.OCBConvGag(ocbData.getGag_rl_1()));	//5 ȯġ
				} else {
					ocbData.setGag_rl_1("0");
					ocbData.setGag_rd_1("0");
				}
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//
				stmt = conn.createStatement();
				sql = OcbQ010Query.getInstance().selGauge2(reportM);
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) {
					ocbData.setGag_rl_2(StringUtil.checkString(rs.getString("gag_per")));		//Real ġ
					ocbData.setGag_rd_2(StringUtil.OCBConvGag(ocbData.getGag_rl_2()));	//5 ȯġ
				} else {
					ocbData.setGag_rl_2("0");
					ocbData.setGag_rd_2("0");
				}
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//
				stmt = conn.createStatement();
				sql = OcbQ010Query.getInstance().selGauge3(reportM);
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) {
					ocbData.setGag_rl_3(StringUtil.checkString(rs.getString("gag_per")));		//Real ġ
					ocbData.setGag_rd_3(StringUtil.OCBConvGag(ocbData.getGag_rl_3()));	//5 ȯġ
				} else {
					ocbData.setGag_rl_3("0");
					ocbData.setGag_rd_3("0");
				}
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//
				stmt = conn.createStatement();
				sql = OcbQ010Query.getInstance().selGauge4(reportM);
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) {
					ocbData.setGag_rl_4(StringUtil.checkString(rs.getString("gag_per")));		//Real ġ
					ocbData.setGag_rd_4(StringUtil.OCBConvGag(ocbData.getGag_rl_4()));	//5 ȯġ
				} else {
					ocbData.setGag_rl_4("0");
					ocbData.setGag_rd_4("0");
				}
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//Ͽ
				/*
				ѰǼ = NEW + (CNL_A - CNL_B)
				CNL Ǽ = (CNL_A - CNL_B)
				׷ NEW / ѰǼ *100
				*/
				double[] dayOpn = new double[3];
				stmt = conn.createStatement();
				sql = OcbQ010Query.getInstance().selGauge5(reportD);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					if (rs.getString("Actnid").equals("NEW")) {
						dayOpn[0] = rs.getDouble("Data_Cnt");	//NEW
					} else if (rs.getString("Actnid").equals("CNL") && rs.getString("Flag").equals("A")) {
						dayOpn[1] = rs.getDouble("Data_Cnt");	//CNL A
					} else if (rs.getString("Actnid").equals("CNL") && rs.getString("Flag").equals("B")) {
						dayOpn[2] = rs.getDouble("Data_Cnt");	//CNL B
					}
				}
				
				if (dayOpn[0] == 0) {
					ocbData.setGag_rl_5("0");		//Real ġ
					ocbData.setGag_rd_5("0");		//5 ȯġ	
				} else {
					ocbData.setGag_rl_5(df2.format((dayOpn[0] / (dayOpn[0] +(dayOpn[1]-dayOpn[2])))*100));		//Real ġ
					ocbData.setGag_rd_5(StringUtil.OCBConvGag(ocbData.getGag_rl_5()));											//5 ȯġ	
				}
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//
				ocbData.setGag_rl_6(opData.getPer_dep());
				ocbData.setGag_rd_6(StringUtil.OCBConvGag(ocbData.getGag_rl_6()));
				
				//2007.04.27 ߰ : try catch ߰(FUEL DB  ϰ ȭ  .)
				try {
				
					// ZFW CG  ==> 2005.12.19 ߰
					stmt = conn.createStatement();
					sql = OcbQ010Query.getInstance().selGauge7(reportD);
					rs = stmt.executeQuery(sql);
					
					if (rs.next()) {
						double maczfw_q = rs.getDouble("MACZFWQ");
						double maczfw_ideal_q = rs.getDouble("MACZFWIDEALQ");
						DecimalFormat df = new DecimalFormat("#,###.#");
						
						if (maczfw_q == 0 || maczfw_ideal_q == 0) {
							ocbData.setGag_rl_7("50");
							ocbData.setGag_rd_7("50");
						} else {
							ocbData.setGag_rl_7(df.format(maczfw_q/maczfw_ideal_q * 100));
							if ((maczfw_q/maczfw_ideal_q * 100) < 50) ocbData.setGag_rd_7("50");
							else if ((maczfw_q/maczfw_ideal_q * 100) > 150) ocbData.setGag_rd_7("150");
							else ocbData.setGag_rd_7(StringUtil.OCBConvGag2(maczfw_q/maczfw_ideal_q * 100));
						}
					} else {
						ocbData.setGag_rl_7("50");
						ocbData.setGag_rd_7("50");
					}
					
					if (stmt != null) stmt.close();
					if (rs != null) rs.close();
					if (sql != null) sql = null;
				
				//2007.04.27 ߰ : try catch ߰(FUEL DB  ϰ ȭ  .)
				} catch (SQLException se) {
					ocbData.setGag_rl_7("50");
					ocbData.setGag_rd_7("50");
				}
				
				// ZFW CG  ==> 2005.12.19 ߰
				stmt = conn.createStatement();
				sql = OcbQ010Query.getInstance().selGauge8(reportM);
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) {
					double flt_q3 = rs.getDouble("FLTQ3");
					DecimalFormat df = new DecimalFormat("#,###.#");
					
					ocbData.setGag_rl_8(df.format(flt_q3));
					if (flt_q3 < 50) ocbData.setGag_rd_8("50");
					else if (flt_q3 > 150) ocbData.setGag_rd_8("150");
					else ocbData.setGag_rd_8(StringUtil.OCBConvGag2(flt_q3));
					
				} else {
					ocbData.setGag_rl_8("50");
					ocbData.setGag_rd_8("50");
				}
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				hashData.put("OCBDATA",ocbData);
			}
			
			/********** Resource Monitor **********/
			/*
			 A : ü   B :     C : ϴ ִ 
			 A - B : ( ̳ʽ ̸ )  B - C : 󿡼  
			 ==>Ұ :  ,  ,  ( ʴ )
			*/
			double[] calRM = new double[3];
			double[] allRM = new double[3];
			String befTyp = "";		// Actyp
			String nowTyp = "";		// Actyp
			List listRM = new LinkedList();
			List listRM2 = new LinkedList();
			
			stmt = conn.createStatement();
			sql = OcbQ010Query.getInstance().selReMonitor(reportM, reportD);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				//Actyp
				nowTyp = StringUtil.checkString(rs.getString("Code_c3"));
				String dataFlag = StringUtil.checkString(rs.getString("Data_Flag"));
				
				if (befTyp.equals("") || nowTyp.equals(befTyp)) {
					if (dataFlag.equals("A")) {				//ü 
						calRM[0] = rs.getDouble("Data_Cnt");
						allRM[0] += calRM[0];
					} else if (dataFlag.equals("B")) {	//  
						calRM[1] = rs.getDouble("Data_Cnt");
						allRM[1] += calRM[1];
					} else if (dataFlag.equals("C")) {	//ϴ ִ 
						calRM[2] = rs.getDouble("Data_Cnt");
						allRM[2] += calRM[2];
					}
				} else {
					// Typ Ʋ Data Add
					OcbQ010BG rmData = new OcbQ010BG();
					rmData.setKactyp(befTyp);
					if (calRM[0] == 0) {
						rmData.setFix_per("0");
						rmData.setRest_per("0");
						rmData.setFlt_per("0");
					} else {
						//  A-B
						if (calRM[0] - calRM[1] > 0) rmData.setFix_per(df2.format(((calRM[0] - calRM[1])/calRM[0])*100));
						else rmData.setFix_per("0");
						//ִ  B-C
						if (calRM[1] - calRM[2] != 0) rmData.setRest_per(df2.format(((calRM[1] - calRM[2])/calRM[0])*100));
						else rmData.setRest_per("0");
						//ִ  C
						if (calRM[2] != 0) rmData.setFlt_per(df2.format((calRM[2]/calRM[0])*100));
						else rmData.setFlt_per("0");
					}
					listRM.add(rmData);
					
					//double Array ʱȭ
					calRM = new double[3];
					
					//űԵó ó
					if (dataFlag.equals("A")) {				//ü 
						calRM[0] = rs.getDouble("Data_Cnt");
						allRM[0] += calRM[0];
					} else if (dataFlag.equals("B")) {	//  
						calRM[1] = rs.getDouble("Data_Cnt");
						allRM[1] += calRM[1];
					} else if (dataFlag.equals("C")) {	//ϴ ִ 
						calRM[2] = rs.getDouble("Data_Cnt");
						allRM[2] += calRM[2];
					}
				}
				
				//Type ü
				befTyp = nowTyp;	
			}
			if (listRM.size() > 0) {
				// Ϳ ó
				OcbQ010BG rmData = new OcbQ010BG();
				rmData.setKactyp(nowTyp);
				if (calRM[0] == 0) {
					rmData.setFix_per("0");
					rmData.setRest_per("0");
					rmData.setFlt_per("0");
				} else {
					//  A-B
					if (calRM[0] - calRM[1] != 0) rmData.setFix_per(df2.format(((calRM[0] - calRM[1])/calRM[0])*100));
					else rmData.setFix_per("0");
					//ִ  B-C
					if (calRM[1] - calRM[2] != 0) rmData.setRest_per(df2.format(((calRM[1] - calRM[2])/calRM[0])*100));
					else rmData.setRest_per("0");
					//ִ  C
					if (calRM[2] != 0) rmData.setFlt_per(df2.format((calRM[2]/calRM[0])*100));
					else rmData.setFlt_per("0");
				}
				listRM.add(rmData);
				
				//KE ALL Data ó
				rmData = new OcbQ010BG();
				rmData.setKactyp("KE ALL");
				if (allRM[0] == 0) {
					rmData.setFix_per("0");
					rmData.setRest_per("0");
					rmData.setFlt_per("0");
				} else {
					//  A-B
					if (allRM[0] - allRM[1] != 0) rmData.setFix_per(df2.format(((allRM[0] - allRM[1])/allRM[0])*100));
					else rmData.setFix_per("0");
					//ִ  B-C
					if (allRM[1] - allRM[2] != 0) rmData.setRest_per(df2.format(((allRM[1] - allRM[2])/allRM[0])*100));
					else rmData.setRest_per("0");
					//ִ  C
					if (allRM[2] != 0) rmData.setFlt_per(df2.format((allRM[2]/allRM[0])*100));
					else rmData.setFlt_per("0");
				}
				listRM.add(rmData);
				
				//List ü KE ALL 1 
				OcbQ010BG tmpEntity = (OcbQ010BG)listRM.get(listRM.size()-1);
				listRM2.add(tmpEntity);
				// 2 Add
				for (int rmSize=0; rmSize<listRM.size()-1; rmSize++) {
					tmpEntity = (OcbQ010BG)listRM.get(rmSize);
					listRM2.add(tmpEntity);
				}
			}
			if (listRM2.size() > 0) hashData.put("RMDATA",listRM2);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
	    	
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ010Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ010Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * Restriction Airport Popup ԷԼ. 
	  * @param params OcbA025BG Է
	  * @return returnValue int 
	  * @exception Exception
	  * @author Copyright (c) 2005/03/28 
	  */
	public int insOcbA025Main(OcbA025BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
		
		//Return ü
	    int returnValue = 0;
	   
	    try {    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Restriction Airport Popup Max Seq_no ȸ
			stmt = conn.createStatement();
			sql = OcbA025Query.getInstance().selMaxSeqNo(params);
			rs = stmt.executeQuery(sql);
			
			int seqNo = 0;
			if (rs.next()) seqNo = rs.getInt("Seq_No") + 1;
			if (seqNo == 0) throw new BusinessException("Restriction Airport Seq Num Exception!!");
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			params.setSeq_no(String.valueOf(seqNo).toString());
			
			//Restriction Airport Popup Insert
			stmt = conn.createStatement();
			sql = OcbA025Query.getInstance().insIropsAptT(params);
			returnValue = stmt.executeUpdate(sql);

			if (returnValue != 1) {
				throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
			} else {
				returnValue = 1;				
			}
			
			//Data Commit
			conn.commit();
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
	  		Logger.debug.println("[BASE:OcbAllSLBean:insOcbA025Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:OcbAllSLBean:insOcbA025Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:OcbAllSLBean:insOcbA025Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function	
	
	/** 
	  * Daily Operation Info1 ȸԼ
	  * @param params OcbQ020BG Է
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/03/29 
	  */	 
	 public Hashtable selOcbQ020Main(OcbQ020BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = null;
	    
	    try {    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Restriction Airport ȸ
			listData = new LinkedList();
			stmt = conn.createStatement();
			sql = OcbQ020Query.getInstance().selResAir(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				OcbQ020BG entity = new OcbQ020BG();
				entity.setIrops_d(StringUtil.checkString(rs.getString("Irops_d")));
				entity.setApt_c(StringUtil.checkString(rs.getString("Apt_c")));
				entity.setSeq_no(StringUtil.checkString(rs.getString("Seq_no")));
				entity.setProb_c(StringUtil.checkString(rs.getString("Prob_c"))+"%");
				entity.setReason_e(StringUtil.checkString(rs.getString("Reason_e")));
				String start = StringUtil.checkString(rs.getString("Start_t"));
				String end = StringUtil.checkString(rs.getString("End_t"));
				if(start.length() == 4) { start = start.substring(0,2) + ":" + start.substring(2,4); }
				if(end.length() == 4) { end = end.substring(0,2) + ":" + end.substring(2,4); }
				entity.setStart_t(start);
				entity.setEnd_t(end);
				entity.setRemark_e(StringUtil.checkString(rs.getString("Remark_e")));
				
				listData.add(entity);
			}
			hashData.put("RESAIR",listData);
			
			if (listData != null) listData = null;
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//IRR FLT STATUS DOMȸ
			listData = new LinkedList();
			stmt = conn.createStatement();
			sql = OcbQ020Query.getInstance().selIrrFltDom(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {	
				OcbQ020BG entity = new OcbQ020BG();	
				entity.setFlt_num("KE"+StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setTitle_e(StringUtil.checkString(rs.getString("Title_e")));
				entity.setDecision_e(StringUtil.checkString(rs.getString("Decision_e")));
				String dep = "";  //߽ð
				String arv = "";   //ð
				if(!StringUtil.checkString(rs.getString("Actnid")).equals("CNL")){
					if(StringUtil.checkString(rs.getString("Dep_Sts")).equals("SCH")){
						dep = StringUtil.checkString(rs.getString("Sch_Dep_Dt_Loc"));
						arv = StringUtil.checkString(rs.getString("Sch_Arv_Dt_Loc"));
					}else if(StringUtil.checkString(rs.getString("Dep_Sts")).equals("EST")){
						dep = StringUtil.checkString(rs.getString("Est_Dep_Dt_Loc"));
						arv = StringUtil.checkString(rs.getString("Est_Arv_Dt_Loc"));
					}else if(StringUtil.checkString(rs.getString("Dep_Sts")).equals("ACT")){
						dep = StringUtil.checkString(rs.getString("Act_Dep_Dt_Loc"));
						if(StringUtil.checkString(rs.getString("Arv_Sts")).equals("ACT")){
							arv = StringUtil.checkString(rs.getString("Act_Arv_Dt_Loc"));
						}else{
							arv = StringUtil.checkString(rs.getString("Est_Arv_Dt_Loc"));
						}
					}
				}
				entity.setDep_dt(dep);
				entity.setArv_dt(arv);
				
				listData.add(entity);
			}
			hashData.put("IRRDOM",listData);
			
			if (listData != null) listData = null;
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//IRR FLT STATUS INTȸ
			listData = new LinkedList();
			stmt = conn.createStatement();
			sql = OcbQ020Query.getInstance().selIrrFltInt(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {	
				OcbQ020BG entity = new OcbQ020BG();	
				entity.setFlt_num("KE"+StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setTitle_e(StringUtil.checkString(rs.getString("Title_e")));
				entity.setDecision_e(StringUtil.checkString(rs.getString("Decision_e")));
				String dep = "";  //߽ð
				String arv = "";   //ð
				if(!StringUtil.checkString(rs.getString("Actnid")).equals("CNL")){
					if(StringUtil.checkString(rs.getString("Dep_Sts")).equals("SCH")){
						dep = StringUtil.checkString(rs.getString("Sch_Dep_Dt_Loc"));
						arv = StringUtil.checkString(rs.getString("Sch_Arv_Dt_Loc"));
					}else if(StringUtil.checkString(rs.getString("Dep_Sts")).equals("EST")){
						dep = StringUtil.checkString(rs.getString("Est_Dep_Dt_Loc"));
						arv = StringUtil.checkString(rs.getString("Est_Arv_Dt_Loc"));
					}else if(StringUtil.checkString(rs.getString("Dep_Sts")).equals("ACT")){
						dep = StringUtil.checkString(rs.getString("Act_Dep_Dt_Loc"));
						if(StringUtil.checkString(rs.getString("Arv_Sts")).equals("ACT")){
							arv = StringUtil.checkString(rs.getString("Act_Arv_Dt_Loc"));
						}else{
							arv = StringUtil.checkString(rs.getString("Est_Arv_Dt_Loc"));
						}
					}
				}
				entity.setDep_dt(dep);
				entity.setArv_dt(arv);
				
				listData.add(entity);
			}
			hashData.put("IRRINT",listData);
			
			if (listData != null) listData = null;
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//IRR FLT STATUS CGOȸ
			listData = new LinkedList();
			stmt = conn.createStatement();
			sql = OcbQ020Query.getInstance().selIrrFltCgo(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {	
				OcbQ020BG entity = new OcbQ020BG();	
				entity.setFlt_num("KE"+StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setTitle_e(StringUtil.checkString(rs.getString("Title_e")));
				entity.setDecision_e(StringUtil.checkString(rs.getString("Decision_e")));
				String dep = "";  //߽ð
				String arv = "";   //ð
				if(!StringUtil.checkString(rs.getString("Actnid")).equals("CNL")){
					if(StringUtil.checkString(rs.getString("Dep_Sts")).equals("SCH")){
						dep = StringUtil.checkString(rs.getString("Sch_Dep_Dt_Loc"));
						arv = StringUtil.checkString(rs.getString("Sch_Arv_Dt_Loc"));
					}else if(StringUtil.checkString(rs.getString("Dep_Sts")).equals("EST")){
						dep = StringUtil.checkString(rs.getString("Est_Dep_Dt_Loc"));
						arv = StringUtil.checkString(rs.getString("Est_Arv_Dt_Loc"));
					}else if(StringUtil.checkString(rs.getString("Dep_Sts")).equals("ACT")){
						dep = StringUtil.checkString(rs.getString("Act_Dep_Dt_Loc"));
						if(StringUtil.checkString(rs.getString("Arv_Sts")).equals("ACT")){
							arv = StringUtil.checkString(rs.getString("Act_Arv_Dt_Loc"));
						}else{
							arv = StringUtil.checkString(rs.getString("Est_Arv_Dt_Loc"));
						}
					}
				}
				entity.setDep_dt(dep);
				entity.setArv_dt(arv);
				
				listData.add(entity);
			}
			hashData.put("IRRCGO",listData);
			
			if (listData != null) listData = null;
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ020Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ020Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * Restriction Airport Լ
	  * @param params OcbQ020BG 
	  * @return returnValue int 
	  * @exception Exception
	  * @author Copyright (c) 2005/03/30 
	  */
	public int delOcbQ020ResAir(String[] irops_d, String[] apt_c, String[] seq_no) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
	    String sql = null;
		
		//Return ü
	    int returnValue = 0;
	   
	    try {    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			for(int i=0; i < irops_d.length; i++){
				
				//Restriction Airport Delete
				stmt = conn.createStatement();
				sql = OcbQ020Query.getInstance().delResAir(irops_d[i], apt_c[i], seq_no[i]);
				returnValue = stmt.executeUpdate(sql);
	
				if (returnValue != 1) {
					throw new BusinessException(MessageCode.getInstance().DELETE_EXPT);
				} else {
					returnValue = 1;				
				}
				
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			}
			//Data Commit
			conn.commit();
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
	  		Logger.debug.println("[BASE:OcbAllSLBean:delOcbQ020ResAir:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:OcbAllSLBean:delOcbQ020ResAir:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:OcbAllSLBean:delOcbQ020ResAir:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().DELETE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/** 
	  * <b> OCB Daily Operations Information2 ȸԼ</b>. 
	  * @param reportD String ȸ yyyymm
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/03/29 HIST 
	  */
	public Hashtable selOcbQ030Main(String reportD) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    
	    try {
	    	
	    	//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			/********** EARLY OPS FLTS **********/
			/*
			Է PARAM 20050328
			
			FLT   	REG 	  STD 	  ATD 	  STA 	  ETA 	  ATA 	  ROUTING
			KE0001	HL6531	20:30L	20:30L	20:30L	20:30L	20:30L	LAX - NRT - ICN
			
			- Next Data Leg_Num 1 ƴϸ  Data Display ϰ Route Station 
			- Dep_Sts / Arv_Sts Code Rule 
			*/
			List listEarly = new LinkedList();
			stmt = conn.createStatement();
			sql = OcbQ030Query.getInstance().selEarlyOpsFlts(reportD);
			rs = stmt.executeQuery(sql);
			
			int dataCnt = 0;
			String[] arrBef = new String[11];	    // Data
			String[] arrNex = new String[11];	// Data
			/*
			  arrData[0] : FLT
			  arrData[1] : REG
			  arrData[2] : STD
			  arrData[3] : ATD
			  arrData[4] : STA
			  arrData[5] : ETA
			  arrData[6] : ATA
			  arrData[7] : ROUTING
			  arrData[8] : Leg Num
			  arrData[9] : Dep Status
			  arrData[10] : Arv Status
			 */
			
			while (rs.next()) {
				arrNex[0] = StringUtil.checkString(rs.getString("Flt_Num"));
				arrNex[1] = StringUtil.checkString(rs.getString("Regno"));
				arrNex[2] = StringUtil.checkString(rs.getString("Sch_Dep_Dt_Loc"));
				arrNex[3] = StringUtil.checkString(rs.getString("Act_Dep_Dt_Loc"));
				arrNex[4] = StringUtil.checkString(rs.getString("Sch_Arv_Dt_Loc"));
				arrNex[5] = StringUtil.checkString(rs.getString("Est_Arv_Dt_Loc"));
				arrNex[6] = StringUtil.checkString(rs.getString("Act_Arv_Dt_Loc"));
				arrNex[7] = StringUtil.checkString(rs.getString("Stnfr")) + "-" + StringUtil.checkString(rs.getString("Stnto"));
				arrNex[8] = StringUtil.checkString(rs.getString("Leg_num"));
				arrNex[9] = StringUtil.checkString(rs.getString("Dep_Sts"));
				arrNex[10] = StringUtil.checkString(rs.getString("Arv_Sts"));
				
				//Flight Number  Leg Number Ʋ Route Data 
				if (dataCnt != 0) {
					if (arrNex[0].equals(arrBef[0]) && !arrNex[8].equals(arrBef[8])) {
						arrNex[7] = arrBef[7] + arrNex[7].substring(3);
					} else {
						OcbQ030BG entity = new OcbQ030BG();
						entity.setFlt_num(arrBef[0]);
						entity.setRegno(arrBef[1]);
						entity.setSch_dep_dt(arrBef[2]);
						entity.setSch_arv_dt(arrBef[4]);
						entity.setRouting(arrBef[7]);
						/***** Daily_Sch_T DB Dep/Arv Status Time  *****/
						String[] arrDep = StringUtil.StatusTime("D",arrBef[9],arrBef[10],"",arrBef[3],"");
						String[] arrArv = StringUtil.StatusTime("A",arrBef[9],arrBef[10],arrBef[5],arrBef[6],"");
						entity.setAct_dep_dt(arrDep[1]);
						entity.setEst_arv_dt(arrArv[0]);
						entity.setAct_arv_dt(arrArv[1]);
						//Data 
						listEarly.add(entity);
					}
				}
				// ü				
				for (int i=0; i<arrBef.length; i++) {
					arrBef[i] = arrNex[i];
				}
				dataCnt++;
			}
			//  ó
			if (listEarly.size() > 0) {
				OcbQ030BG entity = new OcbQ030BG();
				entity.setFlt_num(arrNex[0]);
				entity.setRegno(arrNex[1]);
				entity.setSch_dep_dt(arrNex[2]);
				entity.setSch_arv_dt(arrNex[4]);
				entity.setRouting(arrNex[7]);
				/***** Daily_Sch_T DB Dep/Arv Status Time  *****/
				String[] arrDep = StringUtil.StatusTime("D",arrNex[9],arrNex[10],"",arrNex[3],"");
				String[] arrArv = StringUtil.StatusTime("A",arrNex[9],arrNex[10],arrNex[5],arrNex[6],"");
				entity.setAct_dep_dt(arrDep[1]);
				entity.setEst_arv_dt(arrArv[0]);
				entity.setAct_arv_dt(arrArv[1]);
				//Data 
				listEarly.add(entity);
			}
			hashData.put("EARLY",listEarly);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			/********** EXTR/CHTR/FRY For TODAY **********/
			/*
			Է PARAM 20050329
			
			FLT	    DEP	ARV	TYPE 	STD	    ATD	    STA	    ATA
			KE8621	ICN	SGN	747	  E	  10:25L	20:20L	10:25L	20:20L
			
			- Dep_Sts / Arv_Sts Code Rule 
			- SVC TYPE 
			  1) FLT Num  ڸ(5°) Data  M,T,F,P ̸ Ferry
			  2) 1) ƴϰ SVC  G, A ̸ Extra
			                          C, H ̸ Charter
			                          P, T,K,W ̸ Ferry
			  3) 1) 2)  ȵǸ Line SkipѴ
			-  Extra, Charter, Ferry
			- Actnid = 'CNL' ̸ /ð " ", " "
			*/
			
			List listToday = new LinkedList();
			stmt = conn.createStatement();
			sql = OcbQ030Query.getInstance().selSvcToday(reportD);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				OcbQ030BG entity = new OcbQ030BG();
				entity.setSvc(StringUtil.checkString(rs.getString("SVC")));
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setKactyp(StringUtil.checkString(rs.getString("kactyp")));
				entity.setSch_dep_dt(StringUtil.checkString(rs.getString("Sch_Dep_Dt_Loc")));
				entity.setSch_arv_dt(StringUtil.checkString(rs.getString("Sch_Arv_Dt_Loc")));
				/***** Daily_Sch_T DB Dep/Arv Status Time  *****/
				String[] arrDep = StringUtil.StatusTime("D",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),"",StringUtil.checkString(rs.getString("Act_Dep_Dt_Loc")),"");
				String[] arrArv = StringUtil.StatusTime("A",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),"",StringUtil.checkString(rs.getString("Act_Arv_Dt_Loc")),"");
				entity.setAct_dep_dt(arrDep[1]);	//ATD
				entity.setAct_arv_dt(arrArv[1]);	//ATA
				
				if ((entity.getFlt_num()).length() == 5) {
					entity.setSvc("Ferry");
					listToday.add(entity);
				} else if ((entity.getSvc()).equals("G") || (entity.getSvc()).equals("A")) {
					entity.setSvc("Extra");
					listToday.add(entity);
				} else if ((entity.getSvc()).equals("C") || (entity.getSvc()).equals("H")) {
					entity.setSvc("Charter");
					listToday.add(entity);
				} else if ((entity.getSvc()).equals("P") || (entity.getSvc()).equals("T") || (entity.getSvc()).equals("K") || (entity.getSvc()).equals("W")) {
					entity.setSvc("Ferry");
					listToday.add(entity);
				}//̿ SKIP
			}
			hashData.put("TODAY",listToday);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			/********** EXTR/CHTR/FRY For TOMORROW **********/
			//TODAY  
			List listTomorrow = new LinkedList();
			stmt = conn.createStatement();
			sql = OcbQ030Query.getInstance().selSvcTomorrow(reportD);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				OcbQ030BG entity = new OcbQ030BG();
				entity.setSvc(StringUtil.checkString(rs.getString("SVC")));
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setKactyp(StringUtil.checkString(rs.getString("kactyp")));
				entity.setSch_dep_dt(StringUtil.checkString(rs.getString("Sch_Dep_Dt_Loc")));
				entity.setSch_arv_dt(StringUtil.checkString(rs.getString("Sch_Arv_Dt_Loc")));
				/***** Daily_Sch_T DB Dep/Arv Status Time  *****/
				String[] arrDep = StringUtil.StatusTime("D",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),"",StringUtil.checkString(rs.getString("Act_Dep_Dt_Loc")),"");
				String[] arrArv = StringUtil.StatusTime("A",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),"",StringUtil.checkString(rs.getString("Act_Arv_Dt_Loc")),"");
				entity.setAct_dep_dt(arrDep[1]);	//ATD
				entity.setAct_arv_dt(arrArv[1]);	//ATA
				
				if ((entity.getFlt_num()).length() == 5) {
					entity.setSvc("Ferry");
					listTomorrow.add(entity);
				} else if ((entity.getSvc()).equals("G") || (entity.getSvc()).equals("A")) {
					entity.setSvc("Extra");
					listTomorrow.add(entity);
				} else if ((entity.getSvc()).equals("C") || (entity.getSvc()).equals("H")) {
					entity.setSvc("Charter");
					listTomorrow.add(entity);
				} else if ((entity.getSvc()).equals("P") || (entity.getSvc()).equals("T") || (entity.getSvc()).equals("K") || (entity.getSvc()).equals("W")) {
					entity.setSvc("Ferry");
					listTomorrow.add(entity);
				}//̿ SKIP
			}
			hashData.put("TOMORROW",listTomorrow);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
	    	
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ030Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ030Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * <b> KE Resource Monitor Detail 1 ȸԼ</b>. 
	  * @param reportM String ȸ yyyymm
	  * @param reportD String ȸ  yyyymmdd
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/03/10 HIST 
	  */
	public Hashtable selOcbQ110Main(String reportM, String reportD) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    int data_cnt = 0;
	    Hashtable hashData = new Hashtable();
	   
	    try {
	    	//Number Format 
	    	DecimalFormat df1 = new DecimalFormat("#,##0");
	    	DecimalFormat df2 = new DecimalFormat("##0.0");
	    	
	    	//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			/*
			 A : ü   B :     C : ϴ ִ 
			 A - B : ( ̳ʽ ̸ )  B - C : 󿡼  
			 ==>Ұ :  ,  ,  ( ʴ )
			*/
			double[] calRM = new double[3];
			double[] allRM = new double[3];
			String befTyp = "";		// Actyp
			String nowTyp = "";		// Actyp
			List listRM = new LinkedList();
			List listRM2 = new LinkedList();
			
			stmt = conn.createStatement();
			sql = OcbQ010Query.getInstance().selReMonitor(reportM, reportD);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				data_cnt++;
				//Actyp
				nowTyp = StringUtil.checkString(rs.getString("Code_c3"));
				String dataFlag = StringUtil.checkString(rs.getString("Data_Flag"));
				//Logger.debug.println("[EJB] typ : "+nowTyp+", flag : "+dataFlag+", cnt : "+rs.getDouble("Data_Cnt"));
				
				if (befTyp.equals("") || nowTyp.equals(befTyp)) {
					if (dataFlag.equals("A")) {				//ü 
						calRM[0] = rs.getDouble("Data_Cnt");
						allRM[0] += calRM[0];
					} else if (dataFlag.equals("B")) {	//  
						calRM[1] = rs.getDouble("Data_Cnt");
						allRM[1] += calRM[1];
					} else if (dataFlag.equals("C")) {	//ϴ ִ 
						calRM[2] = rs.getDouble("Data_Cnt");
						allRM[2] += calRM[2];
					}
				} else {
					// Typ Ʋ Data Add
					OcbQ010BG rmData = new OcbQ010BG();
					rmData.setKactyp(befTyp);
					if (calRM[0] == 0) {
						rmData.setFix_per("0");
						rmData.setRest_per("0");
						rmData.setFlt_per("0");
					} else {
						//  A-B
						if (calRM[0] - calRM[1] > 0) rmData.setFix_per(df1.format(calRM[0] - calRM[1]));
						else rmData.setFix_per("0");
						//ִ  B-C
						if (calRM[1] - calRM[2] != 0) rmData.setRest_per(df1.format(calRM[1] - calRM[2]));
						else rmData.setRest_per("0");
						//ִ  C
						if (calRM[2] != 0) rmData.setFlt_per(df1.format(calRM[2]));
						else rmData.setFlt_per("0");
					}
					//listRM.add(rmData);
					hashData.put(rmData.getKactyp(),rmData);
					
					//double Array ʱȭ
					calRM = new double[3];
					
					//űԵó ó
					if (dataFlag.equals("A")) {				//ü 
						calRM[0] = rs.getDouble("Data_Cnt");
						allRM[0] += calRM[0];
					} else if (dataFlag.equals("B")) {	//  
						calRM[1] = rs.getDouble("Data_Cnt");
						allRM[1] += calRM[1];
					} else if (dataFlag.equals("C")) {	//ϴ ִ 
						calRM[2] = rs.getDouble("Data_Cnt");
						allRM[2] += calRM[2];
					}
				}
				
				//Type ü
				befTyp = nowTyp;	
			}
			//if (listRM.size() > 0) {
			if (data_cnt > 0) {
				// Ϳ ó
				OcbQ010BG rmData = new OcbQ010BG();
				rmData.setKactyp(nowTyp);
				if (calRM[0] == 0) {
					rmData.setFix_per("0");
					rmData.setRest_per("0");
					rmData.setFlt_per("0");
				} else {
					//  A-B
					if (calRM[0] - calRM[1] != 0) rmData.setFix_per(df1.format(calRM[0] - calRM[1]));
					else rmData.setFix_per("0");
					//ִ  B-C
					if (calRM[1] - calRM[2] != 0) rmData.setRest_per(df1.format(calRM[1] - calRM[2]));
					else rmData.setRest_per("0");
					//ִ  C
					if (calRM[2] != 0) rmData.setFlt_per(df1.format(calRM[2]));
					else rmData.setFlt_per("0");
				}
				//listRM.add(rmData);
				hashData.put(rmData.getKactyp(),rmData);
				
				//Logger.debug.println("[EJB] ALL 0 : "+allRM[0]+", 1 : "+allRM[1]+", 2 : "+allRM[2]);
				
				//KE ALL Data ó
				rmData = new OcbQ010BG();
				rmData.setKactyp("KE ALL");
				if (allRM[0] == 0) {
					rmData.setFix_per("0");
					rmData.setRest_per("0");
					rmData.setFlt_per("0");
				} else {
					//  A-B
					if (allRM[0] - allRM[1] != 0) rmData.setFix_per(df1.format(allRM[0] - allRM[1]));
					else rmData.setFix_per("0");
					//ִ  B-C
					if (allRM[1] - allRM[2] != 0) rmData.setRest_per(df1.format(allRM[1] - allRM[2]));
					else rmData.setRest_per("0");
					//ִ  C
					if (allRM[2] != 0) rmData.setFlt_per(df1.format(allRM[2]));
					else rmData.setFlt_per("0");
				}
				//listRM.add(rmData);
				hashData.put("ALL",rmData);
				
				/*
				//List ü KE ALL 1 
				OcbQ010BG tmpEntity = (OcbQ010BG)listRM.get(listRM.size()-1);
				listRM2.add(tmpEntity);
				// 2 Add
				for (int rmSize=0; rmSize<listRM.size()-1; rmSize++) {
					tmpEntity = (OcbQ010BG)listRM.get(rmSize);
					listRM2.add(tmpEntity);
				}
				*/
			}
			//if (listRM2.size() > 0) hashData.put("RMDATA",listRM2);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
	    	
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ110Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ110Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function		
	
	/** 
	  * <b> KE Resource Monitor Detail II ȸԼ</b>. 
	  * @param reportD String ȸ  yyyymmdd
	  * @param kacTyp String KACTYP
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/04/29 HIST 
	  */
	public Hashtable selOcbQ120Main(String reportD,String kacTyp) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		Statement stmt2 = null;
		ResultSet rs = null;
		ResultSet rs2 = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	    	//Number Format 
	    	DecimalFormat df1 = new DecimalFormat("#,##0");
	    	DecimalFormat df2 = new DecimalFormat("##0.0");
	    	
	    	//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Crew ȸ
			SkdQ010BG params = new SkdQ010BG();
			params.setSch_dep_dt(reportD);
			params.setTime_x("UTC");
			Hashtable hashCrew = new Hashtable();
			stmt = conn.createStatement();
			sql = SkdQ010Query.getInstance().selDailyCrew(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				hashCrew.put(StringUtil.checkString(rs.getString("name_key")),StringUtil.checkString(rs.getString("Surname")));
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//KE Resource Monitor Detail II ȸ
			stmt = conn.createStatement();
			sql = OcbQ120Query.getInstance().selKeDetail2(reportD,kacTyp);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				OcbQ120BG entity = new OcbQ120BG();
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setSch_dep_dt(StringUtil.checkString(rs.getString("Sch_Dep_Dt")));
				entity.setAct_dep_dt_kst(StringUtil.checkString(rs.getString("Act_Dep_Dt_Kst")));
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_Leg_Flt_Dt")));
				entity.setTime_x(StringUtil.checkString(rs.getString("Time_x")));
				//   IN Flight  شǱ  Rule ʿ.
				entity.setSch_dep_tm(StringUtil.checkString(rs.getString("Sch_Dep_Tm")));
				entity.setAct_dep_tm(StringUtil.checkString(rs.getString("Act_Dep_Tm")));
				entity.setTkof_t(StringUtil.checkString(rs.getString("Tkof_t")));
				entity.setEst_arv_tm(StringUtil.checkString(rs.getString("Est_Arv_Tm")));
				
				entity.setHideInfo(StringUtil.checkString(rs.getString("HIDEINFO"))); // 2006.09.15 ==> ߰
				
				/***** ¼//ž¼ RSVN  *****/
				double f_cfg = rs.getDouble("F_Cfg");
				double c_cfg = rs.getDouble("C_Cfg");
				double y_cfg = rs.getDouble("Y_Cfg");
				double f_book = rs.getDouble("F_Book");
				double c_book = rs.getDouble("C_Book");
				double y_book = rs.getDouble("Y_Book");
				double f_chkin = rs.getDouble("F_Chkin");
				double c_chkin = rs.getDouble("C_Chkin");
				double y_chkin = rs.getDouble("Y_Chkin");
				//¼ 0̸ ȭ̹Ƿ ¼//ž¼ ǥ ʿ䰡 .
				if ((f_cfg+c_cfg+y_cfg) == 0) {
					entity.setRsvn("");
				} else if ((f_chkin+c_chkin+y_chkin) == 0) {
					entity.setRsvn(df1.format(f_book)+"/"+df1.format(c_book)+"/"+df1.format(y_book));
				} else {
					entity.setRsvn(df1.format(f_chkin)+"/"+df1.format(c_chkin)+"/"+df1.format(y_chkin));
				}
				/***** Delay Code ǥ *****/
				if((StringUtil.checkString(rs.getString("Del_Rc1"))).equals("")) {
					entity.setDel_rc1("");
					entity.setDel_dur1("");
				}
				else {
					entity.setDel_rc1(StringUtil.checkString(rs.getString("Del_Rc1")));
					entity.setDel_dur1("/"+StringUtil.checkString(rs.getString("Del_Dur1")));
				}
				if((StringUtil.checkString(rs.getString("Del_Rc2"))).equals("")) {
					entity.setDel_rc2("");
					entity.setDel_dur2("");
				}
				else {
					entity.setDel_rc2(StringUtil.checkString(rs.getString("Del_Rc2")));
					entity.setDel_dur2("/"+StringUtil.checkString(rs.getString("Del_Dur2")));
				}
				/***** CAPT ȸ *****/
				//1 ȸ
				String surName = (String)hashCrew.get(entity.getFlt_num()+entity.getStnfr()+entity.getStnto()+"P1");
				if (surName != null) entity.setSurname(surName);
				else {
					//2 ȸ
					surName = (String)hashCrew.get(entity.getFlt_num()+entity.getStnfr()+entity.getStnto()+"PZ");
					if (surName != null) entity.setSurname(surName);
					else {
						if ((entity.getRegno().substring(2,3)).equals("7")) {
							stmt2 = conn.createStatement();
							sql = OcbQ120Query.getInstance().selCrew(entity);
							rs2 = stmt2.executeQuery(sql);
							if (rs2.next()) entity.setSurname(StringUtil.checkString(rs2.getString("Surname")));
							
							if (stmt2 != null) stmt2.close();
							if (rs2 != null) rs2.close();
							if (sql != null) sql = null;
						} else entity.setSurname("");
					}
				}
				listData.add(entity);
			}
			hashData.put("HASHDATA",listData);
	    	
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ120Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ120Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
			if (rs2 != null) try {rs2.close(); } catch(Exception e) {}
			if (stmt2 != null) try {stmt2.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function		
	
	
	/** 
	  * Departure On Time Pcnt Detail I ȸ Լ
	  * @param params OcbQ130BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/04/28 
	  */
	public Hashtable selOcbQ130Main(OcbQ130BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    
	    try {
	    	//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Departure On Time Pcnt Detail I ȸ
			stmt = conn.createStatement();
			sql = OcbQ130Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			OcbQ130BG entity = new OcbQ130BG();
			DecimalFormat df = new DecimalFormat("#,###.#");
			
			double[] t_flt = new double[6];
			double[] d_flt = new double[6];
			
			while (rs.next()) {
				
				String station = StringUtil.checkString(rs.getString("Station"));
				String ab = StringUtil.checkString(rs.getString("AB"));
				double total = rs.getDouble("Total");
				
				if(station.equals("1")){
					if(ab.equals("B")) d_flt[0] = total;
					else t_flt[0] = total;
				}else if(station.equals("2")){
					if(ab.equals("B")) d_flt[1] = total;
					else t_flt[1] = total;
				}else if(station.equals("3")){
					if(ab.equals("B")) d_flt[2] = total;
					else t_flt[2] = total;
				}else if(station.equals("4")){
					if(ab.equals("B")) d_flt[3] = total;
					else t_flt[3] = total; 
				}else if(station.equals("5")){
					if(ab.equals("B")) d_flt[4] = total;
					else t_flt[4] = total;
				}else if(station.equals("6")){
					if(ab.equals("B")) d_flt[5] = total;
					else t_flt[5] = total; 
				}
			}
			//GMP
			if(t_flt[0] != 0) entity.setGmpDelay(df.format((d_flt[0] / t_flt[0]) * 100));
			else entity.setGmpDelay("200");
			if(t_flt[0] != 0) entity.setGmpOntime(df.format((1 - (d_flt[0] / t_flt[0])) * 100));
			else entity.setGmpOntime("0");
			//ICN
			if(t_flt[1] != 0) entity.setIcnDelay(df.format((d_flt[1] / t_flt[1]) * 100));
			else entity.setIcnDelay("200");
			if(t_flt[1] != 0) entity.setIcnOntime(df.format((1 - (d_flt[1] / t_flt[1])) * 100));
			else entity.setIcnOntime("0");
			//CJU
			if(t_flt[2] != 0) entity.setCjuDelay(df.format((d_flt[2] / t_flt[2]) * 100));
			else entity.setCjuDelay("200");
			if(t_flt[2] != 0) entity.setCjuOntime(df.format((1 - (d_flt[2] / t_flt[2])) * 100));
			else entity.setCjuOntime("0");
			//PUS
			if(t_flt[3] != 0) entity.setPusDelay(df.format((d_flt[3] / t_flt[3]) * 100));
			else entity.setPusDelay("200");
			if(t_flt[3] != 0) entity.setPusOntime(df.format((1 - (d_flt[3] / t_flt[3])) * 100));
			else entity.setPusOntime("0");
			//NRT
			if(t_flt[4] != 0) entity.setNrtDelay(df.format((d_flt[4] / t_flt[4]) * 100));
			else entity.setNrtDelay("200");
			if(t_flt[4] != 0) entity.setNrtOntime(df.format((1 - (d_flt[4] / t_flt[4])) * 100));
			else entity.setNrtOntime("0");
			//LAX
			if(t_flt[5] != 0) entity.setLaxDelay(df.format((d_flt[5] / t_flt[5]) * 100));
			else entity.setLaxDelay("200");
			if(t_flt[5] != 0) entity.setLaxOntime(df.format((1 - (d_flt[5] / t_flt[5])) * 100));
			else entity.setLaxOntime("0");
			
			hashData.put("ONTDET_1", entity);
	    	
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ130Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:OcbAllSLBean:selOcbQ130Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function		
		
	/** 
	  * Departure On Time Pcnt Detail II main ȸԼ.
	  * @param entity OcbQ140BG Departure On Time Pcnt Detail II
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/04/29 
	  */
	public Hashtable selOcbQ140Main(OcbQ140BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	    
	    //UTC/KST/LOC
	   	String timeX = params.getTime_x();
	    try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Flight Progress Information ȸ
			stmt = conn.createStatement();
			sql = OcbQ140Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				
				OcbQ140BG entity = new OcbQ140BG();
				
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setSch_dep_date(StringUtil.checkString(rs.getString("Sch_Dep_Date")));
				entity.setKactyp(StringUtil.checkString(rs.getString("Kactyp")));
				entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setSpt_out(StringUtil.checkString(rs.getString("Spot_Out")));
				entity.setSpt_in(StringUtil.checkString(rs.getString("Spot_In")));
				entity.setSch_dep_dt(StringUtil.checkString(rs.getString("Sch_Dep_Dt")));
				entity.setSch_arv_dt(StringUtil.checkString(rs.getString("Sch_Arv_Dt")));
				
				/***** Daily_Sch_T DB Dep/Arv Status Time  *****/
				String estDepDt = StringUtil.checkString(rs.getString("Est_Dep_Dt"));
				String actDepDt = StringUtil.checkString(rs.getString("Act_Dep_Dt"));
				String tkofT = StringUtil.checkString(rs.getString("Tkof_T"));
				String estArvDt = StringUtil.checkString(rs.getString("Est_Arv_Dt"));
				String actArvDt = StringUtil.checkString(rs.getString("Act_Arv_Dt"));
				String landT = StringUtil.checkString(rs.getString("Land_T"));
					
				String[] arrDep = StringUtil.StatusTime("D",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),estDepDt,actDepDt,tkofT);
				String[] arrArv = StringUtil.StatusTime("A",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),estArvDt,actArvDt,landT);
					
				entity.setEst_dep_dt(StringUtil.checkString(arrDep[0]));
				entity.setAct_dep_dt(StringUtil.checkString(arrDep[1]));
				entity.setTkof_t(StringUtil.checkString(arrDep[2]));
				entity.setEst_arv_dt(StringUtil.checkString(arrArv[0]));
				entity.setAct_arv_dt(StringUtil.checkString(arrArv[1]));
				entity.setLand_t(StringUtil.checkString(arrArv[2]));
				
				if((StringUtil.checkString(rs.getString("Del_Rc1"))).equals("")) {
					entity.setDel_rc1("");
					entity.setDel_dur1("");
				}
				else {
					entity.setDel_rc1(StringUtil.checkString(rs.getString("Del_Rc1")));
					entity.setDel_dur1("/"+StringUtil.checkString(rs.getString("Del_Dur1")));
				}
				if((StringUtil.checkString(rs.getString("Del_Rc2"))).equals("")) {
					entity.setDel_rc2("");
					entity.setDel_dur2("");
				}
				else {
					entity.setDel_rc2(StringUtil.checkString(rs.getString("Del_Rc2")));
					entity.setDel_dur2("/"+StringUtil.checkString(rs.getString("Del_Dur2")));
				}
				entity.setSch_dep_dt_full(StringUtil.checkString(rs.getString("Sch_Dep_Dt_Full")));
				entity.setAct_dep_dt_kst(StringUtil.checkString(rs.getString("Act_Dep_Dt_Kst")));
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_Leg_Flt_Dt")));
				entity.setTime_x(StringUtil.checkString(timeX.toUpperCase()));
				
				entity.setHideInfo(StringUtil.checkString(rs.getString("HIDEINFO"))); // 2006.09.15 ==> ߰
				
				listData.add(entity);

			} 
			hashData.put("FLTINFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SkdAllSLBean:selOcbQ140Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SkdAllSLBean:selOcbQ140Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}	
	
	/**
	  *  Operations Control Board - KE Flight Status - IROPS ȸԼ. 
	  * @param String reportD
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/09/17 
	  */
	public Hashtable selOcbQ010IropsDetail(String reportD) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//IROPS ȸ
			stmt = conn.createStatement();
			sql = OcbQ010Query.getInstance().selIropsStatus(reportD);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				
				OcbQ010BG entity = new OcbQ010BG();
				
				entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
				entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
				entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
				entity.setSchDepDt(StringUtil.checkString(rs.getString("SCH_DEP_DT")));
				entity.setDssStartDt(StringUtil.checkString(rs.getString("DSS_START_DT")));
				entity.setSeqNum(StringUtil.checkString(rs.getString("SEQ_NUM")));
				
				listData.add(entity);
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();

			hashData.put("IROPS_DETAIL",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selOcbQ010IropsDetail:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selOcbQ010IropsDetail:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try { conn.close(); } catch(Exception e) {}
			if (rs != null) try { rs.close(); } catch(Exception e) {}
			if (stmt != null) try { stmt.close(); } catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  * 10 ̳ IROPS ߻  ȸ - QRS  --  .
	  * @return String ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2010/07/13 
	  */
	public String selOcbQ010IropsCheck() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//IROPS  ȸ
			stmt = conn.createStatement();
			sql = OcbQ010Query.getInstance().selIropsCheck();
			rs = stmt.executeQuery(sql);
			
			int cnt = 0;
			if (rs.next()) cnt = rs.getInt("CNT");
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if (cnt == 0) {
				returnValue = "N";
			} else {
				returnValue = "Y";
			}
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selOcbQ010IropsCheck:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selOcbQ010IropsCheck:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try { conn.close(); } catch(Exception e) {}
			if (rs != null) try { rs.close(); } catch(Exception e) {}
			if (stmt != null) try { stmt.close(); } catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
}//end of class
