package kal.base.rep.ejb;

//ڹ 
import java.io.*;
import java.sql.*;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.*;

//Project 
import kal.base.jdf.com.*;
import kal.base.jdf.db.*;
import kal.base.pbf.db.*;
import kal.base.jdf.jtx.*;
import kal.base.com.util.*;
import kal.base.jdf.ejb.*;

//REP
import kal.base.rep.query.*;
import kal.base.rep.dbbean.*;

/**
 * Bean implementation class for Enterprise Bean: RepAllSL
 */
public class RepAllSLBean extends BeanAdapter {
	/** 
	  * Executive Summary ȸԼ 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/16 
	  */
	public Hashtable selRepQ010Main(RepQ010BG params) throws BusinessException {
		
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    String reportD = params.getReport_d();
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			RepQ010BG entity = new RepQ010BG();
			DecimalFormat df = new DecimalFormat("#,###.#");
			
			if(!reportD.equals("")){
			
				entity.setReport_d(reportD);
				
				// ==>  2006.02.06   (4., 7.ǽ¹, 8.׽¹, 9-2 Fuel Dumping ȭ ó)
				//1. ȸ**************************************************
				stmt = conn.createStatement();
				sql = RepQ010Query.getInstance().selSkd(params);
				rs = stmt.executeQuery(sql);
				
				double plan = 0;
				double actual = 0;
				double plan_p = 0;
				double actual_p = 0;
				
				while(rs.next()){
					
					if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
						plan = rs.getDouble("Sum1");
						actual = rs.getDouble("Sum2"); //
					}
					else{
						plan_p = rs.getDouble("Sum1");
						actual_p = rs.getDouble("Sum2");
					}
				}
				entity.setSkd_plan(StringUtil.NumberFormatS(1,String.valueOf(plan).toString()));
				entity.setSkd_actual(StringUtil.NumberFormatS(1,String.valueOf(plan - actual).toString())); //=ȹ-
				if(plan !=0 && actual !=0){
					entity.setSkd_ratio(df.format(((plan - actual) / plan) * 100)+"%");
				}else{
					entity.setSkd_ratio("");
				}
				if(plan_p != 0 && actual_p != 0){
					entity.setSkd_past(df.format(((plan_p - actual_p) / plan_p) * 100)+"%");
				}else{
					entity.setSkd_past("");
				}
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//2.  ȸ**************************************************
				stmt = conn.createStatement();
				sql = RepQ010Query.getInstance().selOntime(params);
				rs = stmt.executeQuery(sql);
	
				double skd = 0;
				double delay = 0;
				double skd_p = 0;
				double delay_p = 0;
				
				while(rs.next()){
					
					if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
						skd = rs.getDouble("Sum1");
						delay = rs.getDouble("Sum2");	
					}
					else{
						skd_p = rs.getDouble("Sum1");
						delay_p = rs.getDouble("Sum2");
					}
				}
				entity.setOnt_skd(StringUtil.NumberFormatS(1,String.valueOf(skd).toString()));
				entity.setOnt_delay(StringUtil.NumberFormatS(1,String.valueOf(delay).toString()));
				if(skd !=0){
					entity.setOnt_ratio(df.format(((skd - delay) / skd) * 100)+"%");
				}else{
					entity.setOnt_ratio("");
				}
				if(skd_p != 0){
					entity.setOnt_past(df.format(((skd_p - delay_p) / skd_p) * 100)+"%");
				}else{
					entity.setOnt_past("");
				}
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//3. Divert/Return ȸ**************************************************
				stmt = conn.createStatement();
				sql = RepQ010Query.getInstance().selDivert(params);
				rs = stmt.executeQuery(sql);
	
				int dom_skd = 0;
				int dom_div = 0;
				int dom_ret = 0;
				int dom_div_p = 0;
				int dom_ret_p = 0;
				int int_skd = 0;
				int int_div = 0;
				int int_ret = 0;
				int int_div_p = 0;
				int int_ret_p = 0;
				int tot_skd = 0;
				int tot_div = 0;
				int tot_ret = 0;
				int tot_div_p = 0;
				int tot_ret_p = 0;
				
				while(rs.next()){
					
					if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
						if(StringUtil.checkString(rs.getString("Code_c1")).equals("D")){
							dom_skd = rs.getInt("Sum1");
							dom_div = rs.getInt("Sum2");
							dom_ret = rs.getInt("Sum3");
						}
						else{
							int_skd = int_skd + rs.getInt("Sum1");
							int_div = int_div + rs.getInt("Sum2");
							int_ret = int_ret + rs.getInt("Sum3");
						}
					}
					else{
						if(StringUtil.checkString(rs.getString("Code_c1")).equals("D")){
							dom_div_p = rs.getInt("Sum2");
							dom_ret_p = rs.getInt("Sum3");
						}
						else{
							int_div_p = int_div_p + rs.getInt("Sum2");
							int_ret_p = int_ret_p + rs.getInt("Sum3");
						}
					}
				}
				entity.setDom_skd(StringUtil.NumberFormatS(1,String.valueOf(dom_skd).toString()));
				entity.setDom_divert(StringUtil.NumberFormatS(1,String.valueOf(dom_div).toString()));
				entity.setDom_return(StringUtil.NumberFormatS(1,String.valueOf(dom_ret).toString()));
				entity.setInt_skd(StringUtil.NumberFormatS(1,String.valueOf(int_skd).toString()));
				entity.setInt_divert(StringUtil.NumberFormatS(1,String.valueOf(int_div).toString()));
				entity.setInt_return(StringUtil.NumberFormatS(1,String.valueOf(int_ret).toString()));
				entity.setTot_skd(StringUtil.NumberFormatS(1,String.valueOf(dom_skd+int_skd).toString()));
				entity.setTot_divert(StringUtil.NumberFormatS(1,String.valueOf(dom_div+int_div).toString()));
				entity.setTot_return(StringUtil.NumberFormatS(1,String.valueOf(dom_ret+int_ret).toString()));
				entity.setDom_divert_past("("+StringUtil.NumberFormatS(1,String.valueOf(dom_div_p).toString())+")");
				entity.setDom_return_past("("+StringUtil.NumberFormatS(1,String.valueOf(dom_ret_p).toString())+")");
				entity.setInt_divert_past("("+StringUtil.NumberFormatS(1,String.valueOf(int_div_p).toString())+")");
				entity.setInt_return_past("("+StringUtil.NumberFormatS(1,String.valueOf(int_ret_p).toString())+")");
				entity.setTot_divert_past("("+StringUtil.NumberFormatS(1,String.valueOf(dom_div_p+int_div_p).toString())+")");
				entity.setTot_return_past("("+StringUtil.NumberFormatS(1,String.valueOf(dom_ret_p+int_ret_p).toString())+")");
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//4-1.   ֿ  Ȳ ȸ**************************************************
				/*stmt = conn.createStatement();
				sql = RepQ010Query.getInstance().selGround(params);
				rs = stmt.executeQuery(sql);
				
				int ground = 0;
				int abnormal = 0;
				
				while(rs.next()){
					
					if(StringUtil.checkString(rs.getString("Code_c2")).equals("G")){
						ground = rs.getInt("Sum1");
					}
					else if(StringUtil.checkString(rs.getString("Code_c2")).equals("D")){
						abnormal = rs.getInt("Sum1");
					}
				}
				entity.setGro_ground(StringUtil.NumberFormatS(1,String.valueOf(ground).toString()));
				entity.setGro_abnormal(StringUtil.NumberFormatS(1,String.valueOf(abnormal).toString()));
				entity.setGro_total(StringUtil.NumberFormatS(1,String.valueOf(ground+abnormal).toString()));
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;*/
				
				//4-2.   ֿ  Ȳ  ȸ**************************************************
				/*stmt = conn.createStatement();
				sql = RepQ010Query.getInstance().selTotalGround(params);
				rs = stmt.executeQuery(sql);
				
				int tot_ground = 0;
				int tot_abnormal = 0;
				
				while(rs.next()){
					
					if(StringUtil.checkString(rs.getString("Code_c2")).equals("G")){
						tot_ground = tot_ground + rs.getInt("Sum1");
					}
					else if(StringUtil.checkString(rs.getString("Code_c2")).equals("D")){
						tot_abnormal = tot_abnormal + rs.getInt("Sum1");
					}
				}
				entity.setGro_tot_ground(StringUtil.NumberFormatS(1,String.valueOf(tot_ground).toString()));
				entity.setGro_tot_abnormal(StringUtil.NumberFormatS(1,String.valueOf(tot_abnormal).toString()));
				entity.setGro_tot_total(StringUtil.NumberFormatS(1,String.valueOf(tot_ground+tot_abnormal).toString()));
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;*/
				
				//5. 簡ð ȸ**************************************************
				stmt = conn.createStatement();
				sql = RepQ010Query.getInstance().selUtilization(params);
				rs = stmt.executeQuery(sql);
				
				double uti_tot_plan = 0;
				double uti_tot_actual = 0;
				double uti_plan = 0;
				double uti_actual = 0;
				double uti_tot_plan_p = 0;
				double uti_tot_actual_p = 0;
				double uti_plan_p = 0;
				double uti_actual_p = 0;
				
				while(rs.next()){
					
					if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
						if(StringUtil.checkString(rs.getString("Code_c2")).equals("B")){
							uti_tot_plan = rs.getDouble("Sum1");
							uti_tot_actual = rs.getDouble("Sum2");
						}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("A")){
							uti_plan = rs.getDouble("Sum1");
							uti_actual = rs.getDouble("Sum2");
						}
					}
					else{
						if(StringUtil.checkString(rs.getString("Code_c2")).equals("B")){
							uti_tot_actual_p = rs.getDouble("Sum2");
						}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("A")){
							uti_actual_p = rs.getDouble("Sum2");
						}
					}
				}
				entity.setUti_tot_plan(StringUtil.NumberFormatS(1,String.valueOf(uti_tot_plan).toString()));
				entity.setUti_tot_actual(StringUtil.NumberFormatS(1,String.valueOf(uti_tot_actual).toString()));
				if(uti_tot_actual_p != 0){
					double uti_tot_ratio = (uti_tot_actual - uti_tot_actual_p) / uti_tot_actual_p * 100;
					entity.setUti_tot_past(df.format(uti_tot_ratio)+"%");
				}else{
					entity.setUti_tot_past("");
				}
				if(uti_plan != 0){ entity.setUti_plan(StringUtil.NumberFormatS(1,String.valueOf(uti_tot_plan/uti_plan).toString())); }
				else{ entity.setUti_plan(""); }
				if(uti_actual != 0){ entity.setUti_actual(StringUtil.NumberFormatS(1,String.valueOf(uti_tot_actual/uti_actual).toString())); }
				else{ entity.setUti_actual(""); }
				if(uti_actual != 0 && uti_actual_p != 0 && (uti_tot_actual_p / uti_actual_p) != 0){
					double uti_ratio = ((uti_tot_actual / uti_actual) - (uti_tot_actual_p / uti_actual_p)) / (uti_tot_actual_p / uti_actual_p) * 100;
					entity.setUti_past(df.format(uti_ratio)+"%"); 
				}else{ entity.setUti_past(""); }
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//6-1. SKD ȹ ȸ**************************************************
				stmt = conn.createStatement();
				sql = RepQ010Query.getInstance().selPlan(params);
				rs = stmt.executeQuery(sql);
				
				double skd_plan = 0;
				double skd_plan_p = 0;
				
				while(rs.next()){
					
					if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
						skd_plan = rs.getDouble("Sum1");
					}
					else{
						skd_plan_p = rs.getDouble("Sum1");
					}
				}
				entity.setChg_plan(StringUtil.NumberFormatS(1,String.valueOf(skd_plan).toString()));
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//6-2. SKD  ȸ**************************************************
				stmt = conn.createStatement();
				sql = RepQ010Query.getInstance().selChange(params);
				rs = stmt.executeQuery(sql);
				
				double skd_chg = 0;
				double skd_chg_p = 0;
				
				while(rs.next()){
					
					if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
						skd_chg = rs.getDouble("Sum1");
					}
					else{
						skd_chg_p = rs.getDouble("Sum1");
					}
				}
				entity.setChg_change(StringUtil.NumberFormatS(1,String.valueOf(skd_chg).toString()));
				if(skd_plan != 0 && skd_chg != 0){
					double skd_ratio = (skd_chg / skd_plan) * 100;
					entity.setChg_ratio(StringUtil.NumberFormatS(1,String.valueOf(skd_ratio).toString())+"%");
				}else{
					entity.setChg_ratio("");
				}
				if(skd_plan_p != 0 && skd_chg_p != 0){
					double skd_ratio_p = (skd_chg_p / skd_plan_p) * 100;
					entity.setChg_past(StringUtil.NumberFormatS(1,String.valueOf(skd_ratio_p).toString())+"%");
				}else{
					entity.setChg_past("");
				}
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
	
				//9-1. Ҹ ȸ**************************************************
				stmt = conn.createStatement();
				sql = RepQ010Query.getInstance().selFuel(params);
				rs = stmt.executeQuery(sql);
				
				double fuel_plan = 0;
				double fuel_actual = 0;
				
				while(rs.next()){
					
					if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
						fuel_plan = rs.getDouble("Sum1") / 1000;
						fuel_actual = rs.getDouble("Sum2") / 1000;
					}
				}
				entity.setFue_plan(StringUtil.NumberFormatS(1,String.valueOf(fuel_plan).toString()));
				entity.setFue_actual(StringUtil.NumberFormatS(1,String.valueOf(fuel_actual).toString()));
				entity.setFue_quantity(StringUtil.NumberFormatS(1,String.valueOf(fuel_actual - fuel_plan).toString()));
				if(fuel_plan != 0){
					entity.setFue_ratio(df.format((fuel_actual - fuel_plan)/fuel_plan*100)+"%");
				}else{
					entity.setFue_ratio("");
				}
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//9-2. Fuel Dumping ȸ**************************************************
				/*stmt = conn.createStatement();
				sql = RepQ010Query.getInstance().selDumping(params);
				rs = stmt.executeQuery(sql);
				
				int dum_actual = 0;
				int dum_actual_tot = 0;
				int dum_past = 0;
				int dum_past_tot = 0;
				int dum_count = 0;
				
				while(rs.next()){
					if((StringUtil.checkString(rs.getString("Report_d")).substring(0,4)).equals(reportD.substring(0,4))){
						if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
							dum_actual = rs.getInt("Sum2");
						}
						dum_count = dum_count + rs.getInt("Sum1");
						dum_actual_tot = dum_actual_tot + rs.getInt("Sum2");
					}else{
						if((StringUtil.checkString(rs.getString("Report_d")).substring(4,6)).equals(reportD.substring(4,6))){
							dum_past = rs.getInt("Sum2");
						}
						dum_past_tot = dum_past_tot + rs.getInt("Sum2");
					}
				}
				entity.setDum_actual(StringUtil.NumberFormatS(1,String.valueOf(dum_actual).toString()));
				entity.setDum_past(StringUtil.NumberFormatS(1,String.valueOf(dum_past).toString()));
				entity.setDum_actual_tot(StringUtil.NumberFormatS(1,String.valueOf(dum_actual_tot).toString()));
				entity.setDum_past_tot(StringUtil.NumberFormatS(1,String.valueOf(dum_past_tot).toString()));
				entity.setDum_count(StringUtil.NumberFormatS(1,String.valueOf(dum_count).toString()));
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;*/
				
				//************************************************************************
				hashData.put("SUMMARYINFO",entity);
				if (entity != null) entity = null;
								
				//7. ǽ¹  ȸ*********************************************
				/*stmt = conn.createStatement();
				sql = RepQ010Query.getInstance().selCabinCrew(params);
				rs = stmt.executeQuery(sql);
				
				double[] flyingT = new double[12];
				double[] timeD = new double[8];
				
				while(rs.next()){
					//պð
					if(StringUtil.checkString(rs.getString("Code_c1")).equals("A")){
						if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
							if(StringUtil.checkString(rs.getString("Code_c2")).equals("B")){ 			//պð
								flyingT[0] = rs.getDouble("Flt_q1");
								flyingT[1] = rs.getDouble("Flt_q2");
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("D")){	//Loss
								flyingT[3] = rs.getDouble("Flt_q1");
								flyingT[4] = rs.getDouble("Flt_q2");
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("E")){	//Reserve
								flyingT[6] = rs.getDouble("Flt_q1");
								flyingT[7] = rs.getDouble("Flt_q2");
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("F")){	//Standby
								flyingT[9] = rs.getDouble("Flt_q1");
								flyingT[10] = rs.getDouble("Flt_q2");
							}
						//⵿
						}else{
							if(StringUtil.checkString(rs.getString("Code_c2")).equals("B")){ 			//պð
								flyingT[2] = rs.getDouble("Flt_q2");
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("D")){	//Loss
								flyingT[5] = rs.getDouble("Flt_q2");
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("E")){	//Reserve
								flyingT[8] = rs.getDouble("Flt_q2");
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("F")){	//Standby
								flyingT[11] = rs.getDouble("Flt_q2");
							}
						}
					//ð
					}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("C")){
						if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
							if(StringUtil.checkString(rs.getString("Code_c2")).equals("D")){			//80ð ̻
								timeD[0] = rs.getDouble("Flt_q1");
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("C")){	//70~79ð
								timeD[2] = rs.getDouble("Flt_q1");
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("B")){	//60~69ð
								timeD[4] = rs.getDouble("Flt_q1");
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("A")){	//60ð ̸
								timeD[6] = rs.getDouble("Flt_q1");
							}
						//⵿
						}else{
							if(StringUtil.checkString(rs.getString("Code_c2")).equals("D")){			//80ð ̻
								timeD[1] = rs.getDouble("Flt_q1");
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("C")){	//70~79ð
								timeD[3] = rs.getDouble("Flt_q1");
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("B")){	//60~69ð
								timeD[5] = rs.getDouble("Flt_q1");
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("A")){	//60ð ̸
								timeD[7] = rs.getDouble("Flt_q1");
							}
						}
					}
				}
				List listData = new LinkedList();
				//պð
				entity = new RepQ010BG();
				entity.setCab_plan(StringUtil.NumberFormatS(1,String.valueOf(flyingT[0]).toString()));
				entity.setCab_actual(StringUtil.NumberFormatS(1,String.valueOf(flyingT[1]).toString()));
				if( flyingT[2] != 0){ entity.setCab_compare(df.format(((flyingT[1] - flyingT[2]) / flyingT[2]) * 100)+"%"); }
				else{ entity.setCab_compare(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//Loss
				entity = new RepQ010BG();
				entity.setCab_plan(StringUtil.NumberFormatS(1,String.valueOf(flyingT[3]).toString()));
				entity.setCab_actual(StringUtil.NumberFormatS(1,String.valueOf(flyingT[4]).toString()));
				if( flyingT[5] != 0){ entity.setCab_compare(df.format(((flyingT[4] - flyingT[5]) / flyingT[5]) * 100)+"%"); }
				else{ entity.setCab_compare(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//Reserve
				entity = new RepQ010BG();
				entity.setCab_plan(StringUtil.NumberFormatS(1,String.valueOf(flyingT[6]).toString()));
				entity.setCab_actual(StringUtil.NumberFormatS(1,String.valueOf(flyingT[7]).toString()));
				if( flyingT[8] != 0){ entity.setCab_compare(df.format(((flyingT[7] - flyingT[8]) / flyingT[8]) * 100)+"%"); }
				else{ entity.setCab_compare(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//Standby
				entity = new RepQ010BG();
				entity.setCab_plan(StringUtil.NumberFormatS(1,String.valueOf(flyingT[9]).toString()));
				entity.setCab_actual(StringUtil.NumberFormatS(1,String.valueOf(flyingT[10]).toString()));
				if( flyingT[11] != 0){ entity.setCab_compare(df.format(((flyingT[10] - flyingT[11]) / flyingT[11]) * 100)+"%"); }
				else{ entity.setCab_compare(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				hashData.put("CABINCREW_1",listData);
				if (listData != null) listData = null;

				listData = new LinkedList();
				double timeTot = timeD[0] + timeD[2] + timeD[4] + timeD[6];
				double timeTotP = timeD[1] + timeD[3] + timeD[5] + timeD[7];
				//80ð ̻
				entity = new RepQ010BG();
				entity.setCab_many(StringUtil.NumberFormatS(1,String.valueOf(timeD[0]).toString()));
				if( timeTot != 0){ entity.setCab_ratio(df.format((timeD[0] / timeTot) * 100)+"%"); }
				else{ entity.setCab_ratio(""); }
				if( timeTotP != 0){ entity.setCab_past(df.format((timeD[1] / timeTotP) * 100)+"%"); }
				else{ entity.setCab_past(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//70~79ð
				entity = new RepQ010BG();
				entity.setCab_many(StringUtil.NumberFormatS(1,String.valueOf(timeD[2]).toString()));
				if( timeTot != 0){ entity.setCab_ratio(df.format((timeD[2] / timeTot) * 100)+"%"); }
				else{ entity.setCab_ratio(""); }
				if( timeTotP != 0){ entity.setCab_past(df.format((timeD[3] / timeTotP) * 100)+"%"); }
				else{ entity.setCab_past(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//60~69ð
				entity = new RepQ010BG();
				entity.setCab_many(StringUtil.NumberFormatS(1,String.valueOf(timeD[4]).toString()));
				if( timeTot != 0){ entity.setCab_ratio(df.format((timeD[4] / timeTot) * 100)+"%"); }
				else{ entity.setCab_ratio(""); }
				if( timeTotP != 0){ entity.setCab_past(df.format((timeD[5] / timeTotP) * 100)+"%"); }
				else{ entity.setCab_past(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//60ð ̸
				entity = new RepQ010BG();
				entity.setCab_many(StringUtil.NumberFormatS(1,String.valueOf(timeD[6]).toString()));
				if( timeTot != 0){ entity.setCab_ratio(df.format((timeD[6] / timeTot) * 100)+"%"); }
				else{ entity.setCab_ratio(""); }
				if( timeTotP != 0){ entity.setCab_past(df.format((timeD[7] / timeTotP) * 100)+"%"); }
				else{ entity.setCab_past(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;

				hashData.put("CABINCREW_2",listData);
				if (listData != null) listData = null;
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;*/
				
				//8. ׽¹  ȸ**************************************************
				/*stmt = conn.createStatement();
				sql = RepQ010Query.getInstance().selCockpitCrew(params);
				rs = stmt.executeQuery(sql);
				
				double[] crewT = new double[30];
				double[] crewP = new double[12];
				
				while(rs.next()){
					//պð
					if(StringUtil.checkString(rs.getString("Code_c1")).equals("G")){
						if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
							if(StringUtil.checkString(rs.getString("Code_c2")).equals("A")){ 			//պð()
								if(StringUtil.checkString(rs.getString("Code_c3")).equals("S")){		//ȹ
									crewT[0] = rs.getDouble("Flt_q1");											//
									crewT[1] = rs.getDouble("Flt_q2");											//߼
								}else if(StringUtil.checkString(rs.getString("Code_c3")).equals("A")){ //
									crewT[2] = rs.getDouble("Flt_q1");											//
									crewT[3] = rs.getDouble("Flt_q2");											//߼			
								}
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("B")){	//պð(α)
								if(StringUtil.checkString(rs.getString("Code_c3")).equals("S")){
									crewT[6] = rs.getDouble("Flt_q1");
									crewT[7] = rs.getDouble("Flt_q2");
								}else if(StringUtil.checkString(rs.getString("Code_c3")).equals("A")){
									crewT[8] = rs.getDouble("Flt_q1");
									crewT[9] = rs.getDouble("Flt_q2");
								}
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("C")){	//Loss
								if(StringUtil.checkString(rs.getString("Code_c3")).equals("S")){
									crewT[12] = rs.getDouble("Flt_q1");
									crewT[13] = rs.getDouble("Flt_q2");
								}else if(StringUtil.checkString(rs.getString("Code_c3")).equals("A")){
									crewT[14] = rs.getDouble("Flt_q1");
									crewT[15] = rs.getDouble("Flt_q2");
								}
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("D")){	//Reserve
								if(StringUtil.checkString(rs.getString("Code_c3")).equals("S")){
									crewT[18] = rs.getDouble("Flt_q1");
									crewT[19] = rs.getDouble("Flt_q2");
								}else if(StringUtil.checkString(rs.getString("Code_c3")).equals("A")){
									crewT[20] = rs.getDouble("Flt_q1");
									crewT[21] = rs.getDouble("Flt_q2");
								}
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("E")){	//Standby
								if(StringUtil.checkString(rs.getString("Code_c3")).equals("S")){
									crewT[24] = rs.getDouble("Flt_q1");
									crewT[25] = rs.getDouble("Flt_q2");
								}else if(StringUtil.checkString(rs.getString("Code_c3")).equals("A")){
									crewT[26] = rs.getDouble("Flt_q1");
									crewT[27] = rs.getDouble("Flt_q2");
								}
							}
						//⵿
						}else{
							if(StringUtil.checkString(rs.getString("Code_c2")).equals("A")){ 			//պð()
								if(StringUtil.checkString(rs.getString("Code_c3")).equals("A")){ //
									crewT[4] = rs.getDouble("Flt_q1");											//
									crewT[5] = rs.getDouble("Flt_q2");											//߼			
								}
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("B")){	//պð(α)
								if(StringUtil.checkString(rs.getString("Code_c3")).equals("A")){
									crewT[10] = rs.getDouble("Flt_q1");
									crewT[11] = rs.getDouble("Flt_q2");
								}
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("C")){	//Loss
								if(StringUtil.checkString(rs.getString("Code_c3")).equals("A")){
									crewT[16] = rs.getDouble("Flt_q1");
									crewT[17] = rs.getDouble("Flt_q2");
								}
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("D")){	//Reserve
								if(StringUtil.checkString(rs.getString("Code_c3")).equals("A")){
									crewT[22] = rs.getDouble("Flt_q1");
									crewT[23] = rs.getDouble("Flt_q2");
								}
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("E")){	//Standby
								if(StringUtil.checkString(rs.getString("Code_c3")).equals("A")){
									crewT[28] = rs.getDouble("Flt_q1");
									crewT[29] = rs.getDouble("Flt_q2");
								}
							}
						}
					/// ¹
					}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("H")){
						if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
							if(StringUtil.checkString(rs.getString("Code_c2")).equals("A")){			//ٺ
								if(StringUtil.checkString(rs.getString("Code_c3")).equals("A")){			//
									crewP[0] = rs.getDouble("Flt_q1");													//
									crewP[1] = rs.getDouble("Flt_q2");													//߼
									crewP[2] = rs.getDouble("Flt_q3");													//
								}else if(StringUtil.checkString(rs.getString("Code_c3")).equals("B")){	//α
									crewP[3] = rs.getDouble("Flt_q1");													//
									crewP[4] = rs.getDouble("Flt_q2");													//
									crewP[5] = rs.getDouble("Flt_q3");													//
								}
							}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("B")){	//Һ
								if(StringUtil.checkString(rs.getString("Code_c3")).equals("A")){			//
									crewP[6] = rs.getDouble("Flt_q1");													//
									crewP[7] = rs.getDouble("Flt_q2");													//߼
									crewP[8] = rs.getDouble("Flt_q3");													//
								}else if(StringUtil.checkString(rs.getString("Code_c3")).equals("B")){	//α
									crewP[9] = rs.getDouble("Flt_q1");													//
									crewP[10] = rs.getDouble("Flt_q2");													//
									crewP[11] = rs.getDouble("Flt_q3");													//
								}
							}
						}
					}
				}//while end
				listData = new LinkedList();
				//պð()
				entity = new RepQ010BG();
				entity.setCoc_plan_l(StringUtil.NumberFormatS(1,String.valueOf(crewT[0]).toString()));
				entity.setCoc_plan_m(StringUtil.NumberFormatS(1,String.valueOf(crewT[1]).toString()));
				entity.setCoc_actual_l(StringUtil.NumberFormatS(1,String.valueOf(crewT[2]).toString()));
				entity.setCoc_actual_m(StringUtil.NumberFormatS(1,String.valueOf(crewT[3]).toString()));
				if( crewT[4] != 0){ entity.setCoc_past_l(df.format(((crewT[2] - crewT[4]) / crewT[4]) * 100)+"%"); }
				else{ entity.setCoc_past_l(""); }
				if( crewT[5] != 0){ entity.setCoc_past_m(df.format(((crewT[3] - crewT[5]) / crewT[5]) * 100)+"%"); }
				else{ entity.setCoc_past_m(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//պð(α)
				entity = new RepQ010BG();
				entity.setCoc_plan_l(StringUtil.NumberFormatS(1,String.valueOf(crewT[6]).toString()));
				entity.setCoc_plan_m(StringUtil.NumberFormatS(1,String.valueOf(crewT[7]).toString()));
				entity.setCoc_actual_l(StringUtil.NumberFormatS(1,String.valueOf(crewT[8]).toString()));
				entity.setCoc_actual_m(StringUtil.NumberFormatS(1,String.valueOf(crewT[9]).toString()));
				if( crewT[10] != 0){ entity.setCoc_past_l(df.format(((crewT[8] - crewT[10]) / crewT[10]) * 100)+"%"); }
				else{ entity.setCoc_past_l(""); }
				if( crewT[11] != 0){ entity.setCoc_past_m(df.format(((crewT[9] - crewT[11]) / crewT[11]) * 100)+"%"); }
				else{ entity.setCoc_past_m(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//Loss
				entity = new RepQ010BG();
				entity.setCoc_plan_l(StringUtil.NumberFormatS(1,String.valueOf(crewT[12]).toString()));
				entity.setCoc_plan_m(StringUtil.NumberFormatS(1,String.valueOf(crewT[13]).toString()));
				entity.setCoc_actual_l(StringUtil.NumberFormatS(1,String.valueOf(crewT[14]).toString()));
				entity.setCoc_actual_m(StringUtil.NumberFormatS(1,String.valueOf(crewT[15]).toString()));
				if( crewT[16] != 0){ entity.setCoc_past_l(df.format(((crewT[14] - crewT[16]) / crewT[16]) * 100)+"%"); }
				else{ entity.setCoc_past_l(""); }
				if( crewT[17] != 0){ entity.setCoc_past_m(df.format(((crewT[15] - crewT[17]) / crewT[17]) * 100)+"%"); }
				else{ entity.setCoc_past_m(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//Reserve
				entity = new RepQ010BG();
				entity.setCoc_plan_l(StringUtil.NumberFormatS(1,String.valueOf(crewT[18]).toString()));
				entity.setCoc_plan_m(StringUtil.NumberFormatS(1,String.valueOf(crewT[19]).toString()));
				entity.setCoc_actual_l(StringUtil.NumberFormatS(1,String.valueOf(crewT[20]).toString()));
				entity.setCoc_actual_m(StringUtil.NumberFormatS(1,String.valueOf(crewT[21]).toString()));
				if( crewT[22] != 0){ entity.setCoc_past_l(df.format(((crewT[20] - crewT[22]) / crewT[22]) * 100)+"%"); }
				else{ entity.setCoc_past_l(""); }
				if( crewT[23] != 0){ entity.setCoc_past_m(df.format(((crewT[21] - crewT[23]) / crewT[23]) * 100)+"%"); }
				else{ entity.setCoc_past_m(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//Standby
				entity = new RepQ010BG();
				entity.setCoc_plan_l(StringUtil.NumberFormatS(1,String.valueOf(crewT[24]).toString()));
				entity.setCoc_plan_m(StringUtil.NumberFormatS(1,String.valueOf(crewT[25]).toString()));
				entity.setCoc_actual_l(StringUtil.NumberFormatS(1,String.valueOf(crewT[26]).toString()));
				entity.setCoc_actual_m(StringUtil.NumberFormatS(1,String.valueOf(crewT[27]).toString()));
				if( crewT[28] != 0){ entity.setCoc_past_l(df.format(((crewT[26] - crewT[28]) / crewT[28]) * 100)+"%"); }
				else{ entity.setCoc_past_l(""); }
				if( crewT[29] != 0){ entity.setCoc_past_m(df.format(((crewT[27] - crewT[29]) / crewT[29]) * 100)+"%"); }
				else{ entity.setCoc_past_m(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				hashData.put("COCKPITCREW_1",listData);
				if (listData != null) listData = null;
				
				listData = new LinkedList();
				/// ¹()
				entity = new RepQ010BG();
				entity.setCoc_over_l(StringUtil.NumberFormatS(1,String.valueOf(crewP[0]).toString()));
				entity.setCoc_over_m(StringUtil.NumberFormatS(1,String.valueOf(crewP[1]).toString()));
				entity.setCoc_over_r(df.format(crewP[2])+"%");
				entity.setCoc_under_l(StringUtil.NumberFormatS(1,String.valueOf(crewP[6]).toString()));
				entity.setCoc_under_m(StringUtil.NumberFormatS(1,String.valueOf(crewP[7]).toString()));
				entity.setCoc_under_r(df.format(crewP[8])+"%");
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				/// ¹(α)
				entity = new RepQ010BG();
				entity.setCoc_over_l(StringUtil.NumberFormatS(1,String.valueOf(crewP[3]).toString()));
				entity.setCoc_over_m(StringUtil.NumberFormatS(1,String.valueOf(crewP[4]).toString()));
				entity.setCoc_over_r(df.format(crewP[5])+"%");
				entity.setCoc_under_l(StringUtil.NumberFormatS(1,String.valueOf(crewP[9]).toString()));
				entity.setCoc_under_m(StringUtil.NumberFormatS(1,String.valueOf(crewP[10]).toString()));
				entity.setCoc_under_r(df.format(crewP[11])+"%");
				
				listData.add(entity);
				if (entity != null) entity = null;

				hashData.put("COCKPITCREW_2",listData);
				if (listData != null) listData = null;
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;*/
			}
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:RepAllSLBean:selRepQ010Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:RepAllSLBean:selRepQ010Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * ׽ ȸԼ 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/21 
	  */
	public Hashtable selRepQ020Main(RepQ020BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    String reportD = params.getReport_d();
	    String reportD_p = "";
	    if(!reportD.equals("")){
	    	reportD_p = String.valueOf(Integer.parseInt(reportD.substring(0,4)) - 1).toString() + reportD.substring(5,6);
	    }
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = null;
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			RepQ020BG entity = null;
			DecimalFormat df = new DecimalFormat("#,###.#");
			
			if(!reportD.equals("")){
				
				//1. ȸ*********************************************************************
				stmt = conn.createStatement();
				sql = RepQ020Query.getInstance().selSkd(params);
				rs = stmt.executeQuery(sql);
				entity = new RepQ020BG();
				
				double skdDomPlan = 0;
				double skdDomActual = 0;
				double skdIntPlan = 0;
				double skdIntActual = 0;
				double skdCgoPlan = 0;
				double skdCgoActual = 0;
				double skdTotPlan = 0;
				double skdTotActual = 0;
				double skdDomPlan_p = 0;
				double skdDomActual_p = 0;
				double skdIntPlan_p = 0;
				double skdIntActual_p = 0;
				double skdCgoPlan_p = 0;
				double skdCgoActual_p = 0;
				double skdTotPlan_p = 0;
				double skdTotActual_p = 0;
				
				while (rs.next()) {
				
					if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
						if(StringUtil.checkString(rs.getString("Code_c1")).equals("D")){	//
							skdDomPlan = rs.getDouble("Sum1");
							skdDomActual = rs.getDouble("Sum2");
							skdTotPlan = skdTotPlan + skdDomPlan;
							skdTotActual = skdTotActual + skdDomActual;
						}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("I")){	//
							skdIntPlan = rs.getDouble("Sum1");
							skdIntActual = rs.getDouble("Sum2");
							skdTotPlan = skdTotPlan + skdIntPlan;
							skdTotActual = skdTotActual + skdIntActual;
						}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("C")){	//ȭ
							skdCgoPlan = rs.getDouble("Sum1");
							skdCgoActual = rs.getDouble("Sum2");
							skdTotPlan = skdTotPlan + skdCgoPlan;
							skdTotActual = skdTotActual + skdCgoActual;
						}
					}else{
						if(StringUtil.checkString(rs.getString("Code_c1")).equals("D")){	//⵿ 
							skdDomPlan_p = rs.getDouble("Sum1");
							skdDomActual_p = rs.getDouble("Sum2");	
							skdTotPlan_p = skdTotPlan_p + skdDomPlan_p;
							skdTotActual_p = skdTotActual_p + skdDomActual_p;
						}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("I")){	//⵿ 
							skdIntPlan_p = rs.getDouble("Sum1");
							skdIntActual_p = rs.getDouble("Sum2");	
							skdTotPlan_p = skdTotPlan_p + skdIntPlan_p;
							skdTotActual_p = skdTotActual_p + skdIntActual_p;
						}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("C")){	//⵿ ȭ
							skdCgoPlan_p = rs.getDouble("Sum1");
							skdCgoActual_p = rs.getDouble("Sum2");	
							skdTotPlan_p = skdTotPlan_p + skdCgoPlan_p;
							skdTotActual_p = skdTotActual_p + skdCgoActual_p;
						}
					}
				}
				//
				entity.setSkd_dom_plan(StringUtil.NumberFormatS(1,String.valueOf(skdDomPlan).toString()));
				entity.setSkd_dom_cancel(StringUtil.NumberFormatS(1,String.valueOf(skdDomActual).toString()));
				entity.setSkd_dom_actual(StringUtil.NumberFormatS(1,String.valueOf(skdDomPlan-skdDomActual).toString()));
				if(skdDomPlan != 0 && skdDomActual != 0){
					entity.setSkd_dom_ratio(df.format(((skdDomPlan-skdDomActual) / skdDomPlan) * 100)+"%");
				}else{
					entity.setSkd_dom_ratio("");
				}
				if(skdDomPlan_p != 0 && skdDomActual_p != 0){
					entity.setSkd_dom_past(df.format(((skdDomPlan_p-skdDomActual_p) / skdDomPlan_p) * 100)+"%");
				}else{
					entity.setSkd_dom_past("");
				}
				//
				entity.setSkd_int_plan(StringUtil.NumberFormatS(1,String.valueOf(skdIntPlan).toString()));
				entity.setSkd_int_cancel(StringUtil.NumberFormatS(1,String.valueOf(skdIntActual).toString()));
				entity.setSkd_int_actual(StringUtil.NumberFormatS(1,String.valueOf(skdIntPlan-skdIntActual).toString()));
				if(skdIntPlan != 0 && skdIntActual != 0){
					entity.setSkd_int_ratio(df.format(((skdIntPlan-skdIntActual) / skdIntPlan) * 100)+"%");
				}else{
					entity.setSkd_int_ratio("");
				}
				if(skdIntPlan_p != 0 && skdIntActual_p != 0){
					entity.setSkd_int_past(df.format(((skdIntPlan_p-skdIntActual_p) / skdIntPlan_p) * 100)+"%");
				}else{
					entity.setSkd_int_past("");
				}
				//ȭ
				entity.setSkd_cgo_plan(StringUtil.NumberFormatS(1,String.valueOf(skdCgoPlan).toString()));
				entity.setSkd_cgo_cancel(StringUtil.NumberFormatS(1,String.valueOf(skdCgoActual).toString()));
				entity.setSkd_cgo_actual(StringUtil.NumberFormatS(1,String.valueOf(skdCgoPlan-skdCgoActual).toString()));
				if(skdCgoPlan != 0 && skdCgoActual != 0){
					entity.setSkd_cgo_ratio(df.format(((skdCgoPlan-skdCgoActual) / skdCgoPlan) * 100)+"%");
				}else{
					entity.setSkd_cgo_ratio("");
				}
				if(skdCgoPlan_p != 0 && skdCgoActual_p != 0){
					entity.setSkd_cgo_past(df.format(((skdCgoPlan_p-skdCgoActual_p) / skdCgoPlan_p) * 100)+"%");
				}else{
					entity.setSkd_cgo_past("");
				}
				//հ
				entity.setSkd_tot_plan(StringUtil.NumberFormatS(1,String.valueOf(skdTotPlan).toString()));
				entity.setSkd_tot_cancel(StringUtil.NumberFormatS(1,String.valueOf(skdTotActual).toString()));
				entity.setSkd_tot_actual(StringUtil.NumberFormatS(1,String.valueOf(skdTotPlan - skdTotActual).toString()));
				if(skdTotPlan != 0 && skdTotActual != 0){
					entity.setSkd_tot_ratio(df.format(((skdTotPlan - skdTotActual) / skdTotPlan) * 100)+"%");
				}else{
					entity.setSkd_tot_ratio("");
				}
				if(skdTotPlan_p != 0 && skdTotActual_p != 0){
					entity.setSkd_tot_past(df.format(((skdTotPlan_p - skdTotActual_p) / skdTotPlan_p) * 100)+"%");
				}else{
					entity.setSkd_tot_past("");
				}
				
				hashData.put("SKDINFO",entity);
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				if (entity != null) entity = null;
	
				//2.ü ȸ*********************************************************************
				stmt = conn.createStatement();
				sql = RepQ020Query.getInstance().selOntime(params);
				rs = stmt.executeQuery(sql);
				
				double[] ont_dep = new double[18];
				double[] ont_arr = new double[18];
				double[] dom_reason = new double[8];
				double[] int_reason = new double[8];
				double[] cgo_reason = new double[8];
				
				while (rs.next()) {
					if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
						//
						if(StringUtil.checkString(rs.getString("Code_c2")).equals("D")){
							String code_c3 = StringUtil.checkString(rs.getString("Code_c3"));
							if(StringUtil.checkString(rs.getString("Code_c1")).equals("D")){         //
								ont_dep[0] = ont_dep[0] + rs.getDouble("Flt_q3");
								ont_dep[1] = ont_dep[1] + rs.getDouble("Flt_q1");
								ont_dep[2] = ont_dep[2] + rs.getDouble("Flt_q2");
								
								if(code_c3.equals("A")){ dom_reason[0] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("B")){ dom_reason[1] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("C")){ dom_reason[2] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("D")){ dom_reason[3] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("E")){ dom_reason[4] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("F")){ dom_reason[5] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("O")){ dom_reason[6] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("K")){ dom_reason[7] = rs.getDouble("Flt_q2"); }
								
							}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("I")){ //
								ont_dep[3] = ont_dep[3] + rs.getDouble("Flt_q3");
								ont_dep[4] = ont_dep[4] + rs.getDouble("Flt_q1");
								ont_dep[5] = ont_dep[5] + rs.getDouble("Flt_q2");
								
								if(code_c3.equals("A")){ int_reason[0] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("B")){ int_reason[1] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("C")){ int_reason[2] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("D")){ int_reason[3] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("E")){ int_reason[4] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("F")){ int_reason[5] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("O")){ int_reason[6] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("K")){ int_reason[7] = rs.getDouble("Flt_q2"); }
								
							}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("C")){ //ȭ
								ont_dep[6] = ont_dep[6] + rs.getDouble("Flt_q3");
								ont_dep[7] = ont_dep[7] + rs.getDouble("Flt_q1");
								ont_dep[8] = ont_dep[8] + rs.getDouble("Flt_q2");
								
								if(code_c3.equals("A")){ cgo_reason[0] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("B")){ cgo_reason[1] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("C")){ cgo_reason[2] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("D")){ cgo_reason[3] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("E")){ cgo_reason[4] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("F")){ cgo_reason[5] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("O")){ cgo_reason[6] = rs.getDouble("Flt_q2"); }
								else if(code_c3.equals("K")){ cgo_reason[7] = rs.getDouble("Flt_q2"); }
							}
						//
						}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("A")){
							if(StringUtil.checkString(rs.getString("Code_c1")).equals("D")){		   //⵿
								ont_arr[0] = ont_arr[0] + rs.getDouble("Flt_q3");
								ont_arr[1] = ont_arr[1] + rs.getDouble("Flt_q1");
								ont_arr[2] = ont_arr[2] + rs.getDouble("Flt_q2");
							}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("I")){ //⵿ 
								ont_arr[3] = ont_arr[3] + rs.getDouble("Flt_q3");
								ont_arr[4] = ont_arr[4] + rs.getDouble("Flt_q1");
								ont_arr[5] = ont_arr[5] + rs.getDouble("Flt_q2");
							}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("C")){ //⵿ ȭ
								ont_arr[6] = ont_arr[6] + rs.getDouble("Flt_q3");
								ont_arr[7] = ont_arr[7] + rs.getDouble("Flt_q1");
								ont_arr[8] = ont_arr[8] + rs.getDouble("Flt_q2");
							}
						}
					}else{
						//⵿ 
						if(StringUtil.checkString(rs.getString("Code_c2")).equals("D")){
							if(StringUtil.checkString(rs.getString("Code_c1")).equals("D")){
								ont_dep[9] = ont_dep[9] + rs.getDouble("Flt_q3");
								ont_dep[10] = ont_dep[10] + rs.getDouble("Flt_q1");
								ont_dep[11] = ont_dep[11] + rs.getDouble("Flt_q2");
							}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("I")){
								ont_dep[12] = ont_dep[12] + rs.getDouble("Flt_q3");
								ont_dep[13] = ont_dep[13] + rs.getDouble("Flt_q1");
								ont_dep[14] = ont_dep[14] + rs.getDouble("Flt_q2");
							}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("C")){
								ont_dep[15] = ont_dep[15] + rs.getDouble("Flt_q3");
								ont_dep[16] = ont_dep[16] + rs.getDouble("Flt_q1");
								ont_dep[17] = ont_dep[17] + rs.getDouble("Flt_q2");
							}
					 	//⵿ 
						}else if(StringUtil.checkString(rs.getString("Code_c2")).equals("A")){
							if(StringUtil.checkString(rs.getString("Code_c1")).equals("D")){
								ont_arr[9] = ont_arr[9] + rs.getDouble("Flt_q3");
								ont_arr[10] = ont_arr[10] + rs.getDouble("Flt_q1");
								ont_arr[11] = ont_arr[11] + rs.getDouble("Flt_q2");
							}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("I")){
								ont_arr[12] = ont_arr[12] + rs.getDouble("Flt_q3");
								ont_arr[13] = ont_arr[13] + rs.getDouble("Flt_q1");
								ont_arr[14] = ont_arr[14] + rs.getDouble("Flt_q2");
							}else if(StringUtil.checkString(rs.getString("Code_c1")).equals("C")){
								ont_arr[15] = ont_arr[15] + rs.getDouble("Flt_q3");
								ont_arr[16] = ont_arr[16] + rs.getDouble("Flt_q1");
								ont_arr[17] = ont_arr[17] + rs.getDouble("Flt_q2");
							}
						}
					}
				}
				//
				listData = new LinkedList();
				// 
				entity = new RepQ020BG();
				entity.setOnt_dep_plan(StringUtil.NumberFormatS(1,String.valueOf(ont_dep[0]).toString()));
				entity.setOnt_dep_actual(StringUtil.NumberFormatS(1,String.valueOf(ont_dep[1]).toString()));
				entity.setOnt_dep_delay(StringUtil.NumberFormatS(1,String.valueOf(ont_dep[2]).toString()));
				if(ont_dep[1] != 0){ entity.setOnt_dep_ratio(df.format(((ont_dep[1] - ont_dep[2]) / ont_dep[1]) * 100)+"%"); }
				else{ entity.setOnt_dep_ratio(""); }
				if(ont_dep[10] != 0){ entity.setOnt_dep_past(df.format(((ont_dep[10] - ont_dep[11]) / ont_dep[10]) * 100)+"%"); }
				else{ entity.setOnt_dep_past(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				// 
				entity = new RepQ020BG();
				entity.setOnt_dep_plan(StringUtil.NumberFormatS(1,String.valueOf(ont_dep[3]).toString()));
				entity.setOnt_dep_actual(StringUtil.NumberFormatS(1,String.valueOf(ont_dep[4]).toString()));
				entity.setOnt_dep_delay(StringUtil.NumberFormatS(1,String.valueOf(ont_dep[5]).toString()));
				if(ont_dep[4] != 0){ entity.setOnt_dep_ratio(df.format(((ont_dep[4] - ont_dep[5]) / ont_dep[4]) * 100)+"%"); }
				else{ entity.setOnt_dep_ratio(""); }
				if(ont_dep[13] != 0){ entity.setOnt_dep_past(df.format(((ont_dep[13] - ont_dep[14]) / ont_dep[13]) * 100)+"%"); }
				else{ entity.setOnt_dep_past(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				// ȭ			
				entity = new RepQ020BG();
				entity.setOnt_dep_plan(StringUtil.NumberFormatS(1,String.valueOf(ont_dep[6]).toString()));
				entity.setOnt_dep_actual(StringUtil.NumberFormatS(1,String.valueOf(ont_dep[7]).toString()));
				entity.setOnt_dep_delay(StringUtil.NumberFormatS(1,String.valueOf(ont_dep[8]).toString()));
				if(ont_dep[7] != 0){ entity.setOnt_dep_ratio(df.format(((ont_dep[7] - ont_dep[8]) / ont_dep[7]) * 100)+"%"); }
				else{ entity.setOnt_dep_ratio(""); }
				if(ont_dep[16] != 0){ entity.setOnt_dep_past(df.format(((ont_dep[16] - ont_dep[17]) / ont_dep[16]) * 100)+"%"); }
				else{ entity.setOnt_dep_past(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				// հ
				entity = new RepQ020BG();
				double dep_plan = ont_dep[0] + ont_dep[3] + ont_dep[6];
				double dep_actual = ont_dep[1] + ont_dep[4] + ont_dep[7];
				double dep_delay = ont_dep[2] + ont_dep[5] + ont_dep[8];
				double dep_actual_p = ont_dep[10] + ont_dep[13] + ont_dep[16];
				double dep_delay_p = ont_dep[11] + ont_dep[14] + ont_dep[17];
				entity.setOnt_dep_plan(StringUtil.NumberFormatS(1,String.valueOf(dep_plan).toString()));
				entity.setOnt_dep_actual(StringUtil.NumberFormatS(1,String.valueOf(dep_actual).toString()));
				entity.setOnt_dep_delay(StringUtil.NumberFormatS(1,String.valueOf(dep_delay).toString()));
				if(dep_actual != 0){ entity.setOnt_dep_ratio(df.format(((dep_actual - dep_delay) / dep_actual) * 100)+"%"); }
				else{ entity.setOnt_dep_ratio(""); }
				if(dep_actual_p != 0){ entity.setOnt_dep_past(df.format(((dep_actual_p - dep_delay_p) / dep_actual_p) * 100)+"%"); }
				else{ entity.setOnt_dep_past(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				hashData.put("ONTDEPINFO",listData);
				if (listData != null) listData = null;
				
				//
				listData = new LinkedList();
				// 
				entity = new RepQ020BG();
				entity.setOnt_arr_plan(StringUtil.NumberFormatS(1,String.valueOf(ont_arr[0]).toString()));
				entity.setOnt_arr_actual(StringUtil.NumberFormatS(1,String.valueOf(ont_arr[1]).toString()));
				entity.setOnt_arr_delay(StringUtil.NumberFormatS(1,String.valueOf(ont_arr[2]).toString()));
				if(ont_arr[1] != 0){ entity.setOnt_arr_ratio(df.format(((ont_arr[1] - ont_arr[2]) / ont_arr[1]) * 100)+"%"); }
				else{ entity.setOnt_arr_ratio(""); }
				if(ont_arr[10] != 0){ entity.setOnt_arr_past(df.format(((ont_arr[10] - ont_arr[11]) / ont_arr[10]) * 100)+"%"); }
				else{ entity.setOnt_arr_past(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				// 
				entity = new RepQ020BG();
				entity.setOnt_arr_plan(StringUtil.NumberFormatS(1,String.valueOf(ont_arr[3]).toString()));
				entity.setOnt_arr_actual(StringUtil.NumberFormatS(1,String.valueOf(ont_arr[4]).toString()));
				entity.setOnt_arr_delay(StringUtil.NumberFormatS(1,String.valueOf(ont_arr[5]).toString()));
				if(ont_arr[4] != 0){ entity.setOnt_arr_ratio(df.format(((ont_arr[4] - ont_arr[5]) / ont_arr[4]) * 100)+"%"); }
				else{ entity.setOnt_arr_ratio(""); }
				if(ont_arr[13] != 0){ entity.setOnt_arr_past(df.format(((ont_arr[13] - ont_arr[14]) / ont_arr[13]) * 100)+"%"); }
				else{ entity.setOnt_arr_past(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				// ȭ			
				entity = new RepQ020BG();
				entity.setOnt_arr_plan(StringUtil.NumberFormatS(1,String.valueOf(ont_arr[6]).toString()));
				entity.setOnt_arr_actual(StringUtil.NumberFormatS(1,String.valueOf(ont_arr[7]).toString()));
				entity.setOnt_arr_delay(StringUtil.NumberFormatS(1,String.valueOf(ont_arr[8]).toString()));
				if(ont_arr[7] != 0){ entity.setOnt_arr_ratio(df.format(((ont_arr[7] - ont_arr[8]) / ont_arr[7]) * 100)+"%"); }
				else{ entity.setOnt_arr_ratio(""); }
				if(ont_arr[16] != 0){ entity.setOnt_arr_past(df.format(((ont_arr[16] - ont_arr[17]) / ont_arr[16]) * 100)+"%"); }
				else{ entity.setOnt_arr_past(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				// հ
				entity = new RepQ020BG();
				double arr_plan = ont_arr[0] + ont_arr[3] + ont_arr[6];
				double arr_actual = ont_arr[1] + ont_arr[4] + ont_arr[7];
				double arr_delay = ont_arr[2] + ont_arr[5] + ont_arr[8];
				double arr_actual_p = ont_arr[10] + ont_arr[13] + ont_arr[16];
				double arr_delay_p = ont_arr[11] + ont_arr[14] + ont_arr[17];
				entity.setOnt_arr_plan(StringUtil.NumberFormatS(1,String.valueOf(arr_plan).toString()));
				entity.setOnt_arr_actual(StringUtil.NumberFormatS(1,String.valueOf(arr_actual).toString()));
				entity.setOnt_arr_delay(StringUtil.NumberFormatS(1,String.valueOf(arr_delay).toString()));
				if(arr_actual != 0){ entity.setOnt_arr_ratio(df.format(((arr_actual - arr_delay) / arr_actual) * 100)+"%"); }
				else{ entity.setOnt_arr_ratio(""); }
				if(arr_actual_p != 0){ entity.setOnt_arr_past(df.format(((arr_actual_p - arr_delay_p) / arr_actual_p) * 100)+"%"); }
				else{ entity.setOnt_arr_past(""); }
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				hashData.put("ONTARRINFO",listData);
				if (listData != null) listData = null;
				
				//  м( )
				listData = new LinkedList();
				//
				entity = new RepQ020BG();
				double dom_total = dom_reason[0]+dom_reason[1]+dom_reason[2]+dom_reason[3]+dom_reason[4]+dom_reason[5]+dom_reason[6];
				entity.setDel_reason_a(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[0]).toString()));
				entity.setDel_reason_b(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[1]).toString()));
				entity.setDel_reason_c(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[2]).toString()));
				entity.setDel_reason_d(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[3]).toString()));
				entity.setDel_reason_e(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[4]).toString()));
				entity.setDel_reason_f(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[5]).toString()));
				entity.setDel_reason_o(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[6]).toString()));
				entity.setDel_reason_t(StringUtil.NumberFormatS(1,String.valueOf(dom_total).toString()));
				entity.setDel_reason_k(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[7]).toString()));
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//
				entity = new RepQ020BG();
				double int_total = int_reason[0]+int_reason[1]+int_reason[2]+int_reason[3]+int_reason[4]+int_reason[5]+int_reason[6];
				entity.setDel_reason_a(StringUtil.NumberFormatS(1,String.valueOf(int_reason[0]).toString()));
				entity.setDel_reason_b(StringUtil.NumberFormatS(1,String.valueOf(int_reason[1]).toString()));
				entity.setDel_reason_c(StringUtil.NumberFormatS(1,String.valueOf(int_reason[2]).toString()));
				entity.setDel_reason_d(StringUtil.NumberFormatS(1,String.valueOf(int_reason[3]).toString()));
				entity.setDel_reason_e(StringUtil.NumberFormatS(1,String.valueOf(int_reason[4]).toString()));
				entity.setDel_reason_f(StringUtil.NumberFormatS(1,String.valueOf(int_reason[5]).toString()));
				entity.setDel_reason_o(StringUtil.NumberFormatS(1,String.valueOf(int_reason[6]).toString()));
				entity.setDel_reason_t(StringUtil.NumberFormatS(1,String.valueOf(int_total).toString()));
				entity.setDel_reason_k(StringUtil.NumberFormatS(1,String.valueOf(int_reason[7]).toString()));
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//ȭ
				entity = new RepQ020BG();
				double cgo_total = cgo_reason[0]+cgo_reason[1]+cgo_reason[2]+cgo_reason[3]+cgo_reason[4]+cgo_reason[5]+cgo_reason[6];
				entity.setDel_reason_a(StringUtil.NumberFormatS(1,String.valueOf(cgo_reason[0]).toString()));
				entity.setDel_reason_b(StringUtil.NumberFormatS(1,String.valueOf(cgo_reason[1]).toString()));
				entity.setDel_reason_c(StringUtil.NumberFormatS(1,String.valueOf(cgo_reason[2]).toString()));
				entity.setDel_reason_d(StringUtil.NumberFormatS(1,String.valueOf(cgo_reason[3]).toString()));
				entity.setDel_reason_e(StringUtil.NumberFormatS(1,String.valueOf(cgo_reason[4]).toString()));
				entity.setDel_reason_f(StringUtil.NumberFormatS(1,String.valueOf(cgo_reason[5]).toString()));
				entity.setDel_reason_o(StringUtil.NumberFormatS(1,String.valueOf(cgo_reason[6]).toString()));
				entity.setDel_reason_t(StringUtil.NumberFormatS(1,String.valueOf(cgo_total).toString()));
				entity.setDel_reason_k(StringUtil.NumberFormatS(1,String.valueOf(cgo_reason[7]).toString()));
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//հ
				entity = new RepQ020BG();
				double tot_total = dom_total + int_total + cgo_total;
				entity.setDel_reason_a(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[0]+int_reason[0]+cgo_reason[0]).toString()));
				entity.setDel_reason_b(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[1]+int_reason[1]+cgo_reason[1]).toString()));
				entity.setDel_reason_c(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[2]+int_reason[2]+cgo_reason[2]).toString()));
				entity.setDel_reason_d(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[3]+int_reason[3]+cgo_reason[3]).toString()));
				entity.setDel_reason_e(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[4]+int_reason[4]+cgo_reason[4]).toString()));
				entity.setDel_reason_f(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[5]+int_reason[5]+cgo_reason[5]).toString()));
				entity.setDel_reason_o(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[6]+int_reason[6]+cgo_reason[6]).toString()));
				entity.setDel_reason_t(StringUtil.NumberFormatS(1,String.valueOf(tot_total).toString()));
				entity.setDel_reason_k(StringUtil.NumberFormatS(1,String.valueOf(dom_reason[7]+int_reason[7]+cgo_reason[7]).toString()));
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				//
				entity = new RepQ020BG();
				if(tot_total != 0){
					entity.setDel_reason_a(df.format((dom_reason[0]+int_reason[0]+cgo_reason[0])/tot_total*100)+"%");
					entity.setDel_reason_b(df.format((dom_reason[1]+int_reason[1]+cgo_reason[1])/tot_total*100)+"%");
					entity.setDel_reason_c(df.format((dom_reason[2]+int_reason[2]+cgo_reason[2])/tot_total*100)+"%");
					entity.setDel_reason_d(df.format((dom_reason[3]+int_reason[3]+cgo_reason[3])/tot_total*100)+"%");
					entity.setDel_reason_e(df.format((dom_reason[4]+int_reason[4]+cgo_reason[4])/tot_total*100)+"%");
					entity.setDel_reason_f(df.format((dom_reason[5]+int_reason[5]+cgo_reason[5])/tot_total*100)+"%");
					entity.setDel_reason_o(df.format((dom_reason[6]+int_reason[6]+cgo_reason[6])/tot_total*100)+"%");
					entity.setDel_reason_t(df.format((tot_total)/tot_total*100)+"%");
				}else{
					entity.setDel_reason_a("");
					entity.setDel_reason_b("");
					entity.setDel_reason_c("");
					entity.setDel_reason_d("");
					entity.setDel_reason_e("");
					entity.setDel_reason_f("");
					entity.setDel_reason_o("");
					entity.setDel_reason_t("");
				}	
				entity.setDel_reason_k("");
				
				listData.add(entity);
				if (entity != null) entity = null;
				
				hashData.put("REASONINFO",listData);
				if (listData != null) listData = null;
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//3. Divert/Return ȸ**************************************************************
				stmt = conn.createStatement();
				sql = RepQ020Query.getInstance().selDivert(params);
				rs = stmt.executeQuery(sql);
	
				int dom_skd = 0;
				int dom_div = 0;
				int dom_ret = 0;
				int dom_div_p = 0;
				int dom_ret_p = 0;
				int int_skd = 0;
				int int_div = 0;
				int int_ret = 0;
				int int_div_p = 0;
				int int_ret_p = 0;
				int tot_skd = 0;
				int tot_div = 0;
				int tot_ret = 0;
				int tot_div_p = 0;
				int tot_ret_p = 0;
				
				while(rs.next()){
					
					if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
						if(StringUtil.checkString(rs.getString("Code_c1")).equals("D")){
							dom_skd = rs.getInt("Sum1");
							dom_div = rs.getInt("Sum2");
							dom_ret = rs.getInt("Sum3");
						}else{
							int_skd = int_skd + rs.getInt("Sum1");
							int_div = int_div + rs.getInt("Sum2");
							int_ret = int_ret + rs.getInt("Sum3");
						}
					}else{
						if(StringUtil.checkString(rs.getString("Code_c1")).equals("D")){
							dom_div_p = rs.getInt("Sum2");
							dom_ret_p = rs.getInt("Sum3");
						}else{
							int_div_p = int_div_p + rs.getInt("Sum2");
							int_ret_p = int_ret_p + rs.getInt("Sum3");
						}
					}
				}
				entity = new RepQ020BG();
				entity.setDom_skd(StringUtil.NumberFormatS(1,String.valueOf(dom_skd).toString()));
				entity.setDom_divert(StringUtil.NumberFormatS(1,String.valueOf(dom_div).toString()));
				entity.setDom_return(StringUtil.NumberFormatS(1,String.valueOf(dom_ret).toString()));
				entity.setInt_skd(StringUtil.NumberFormatS(1,String.valueOf(int_skd).toString()));
				entity.setInt_divert(StringUtil.NumberFormatS(1,String.valueOf(int_div).toString()));
				entity.setInt_return(StringUtil.NumberFormatS(1,String.valueOf(int_ret).toString()));
				entity.setTot_skd(StringUtil.NumberFormatS(1,String.valueOf(dom_skd+int_skd).toString()));
				entity.setTot_divert(StringUtil.NumberFormatS(1,String.valueOf(dom_div+int_div).toString()));
				entity.setTot_return(StringUtil.NumberFormatS(1,String.valueOf(dom_ret+int_ret).toString()));
				entity.setDom_divert_past("("+StringUtil.NumberFormatS(1,String.valueOf(dom_div_p).toString())+")");
				entity.setDom_return_past("("+StringUtil.NumberFormatS(1,String.valueOf(dom_ret_p).toString())+")");
				entity.setInt_divert_past("("+StringUtil.NumberFormatS(1,String.valueOf(int_div_p).toString())+")");
				entity.setInt_return_past("("+StringUtil.NumberFormatS(1,String.valueOf(int_ret_p).toString())+")");
				entity.setTot_divert_past("("+StringUtil.NumberFormatS(1,String.valueOf(dom_div_p+int_div_p).toString())+")");
				entity.setTot_return_past("("+StringUtil.NumberFormatS(1,String.valueOf(dom_ret_p+int_ret_p).toString())+")");
				
				hashData.put("DIVERTINFO",entity);
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				if (entity != null) entity = null;
				
				// ==> 2006.02.06  : 4. ȭ  ó
				
				//4-1.   ֿ  Ȳ ȸ**************************************************************
				/*stmt = conn.createStatement();
				sql = RepQ020Query.getInstance().selGround(params);
				rs = stmt.executeQuery(sql);
				
				int ground = 0;
				int abnormal = 0;
				
				while(rs.next()){
					
					if(StringUtil.checkString(rs.getString("Code_c2")).equals("G")){
						ground = rs.getInt("Sum1");
					}
					else if(StringUtil.checkString(rs.getString("Code_c2")).equals("D")){
						abnormal = rs.getInt("Sum1");
					}
				}
				entity = new RepQ020BG();
				entity.setReport_d(reportD);
				entity.setGro_ground(StringUtil.NumberFormatS(1,String.valueOf(ground).toString()));
				entity.setGro_abnormal(StringUtil.NumberFormatS(1,String.valueOf(abnormal).toString()));
				entity.setGro_total(StringUtil.NumberFormatS(1,String.valueOf(ground+abnormal).toString()));
				
				hashData.put("GROUNDINFO",entity);
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				if (entity != null) entity = null;
				
				//4-2.   ֿ  Ȳ  ȸ**********************************************************
				stmt = conn.createStatement();
				sql = RepQ020Query.getInstance().selTotalGround(params);
				rs = stmt.executeQuery(sql);
				
				int tot_ground = 0;
				int tot_abnormal = 0;
				
				while(rs.next()){
					
					if(StringUtil.checkString(rs.getString("Code_c2")).equals("G")){
						tot_ground = tot_ground + rs.getInt("Sum1");
					}
					else if(StringUtil.checkString(rs.getString("Code_c2")).equals("D")){
						tot_abnormal = tot_abnormal + rs.getInt("Sum1");
					}
				}
				entity = new RepQ020BG();
				entity.setReport_d(reportD);
				entity.setGro_tot_ground(StringUtil.NumberFormatS(1,String.valueOf(tot_ground).toString()));
				entity.setGro_tot_abnormal(StringUtil.NumberFormatS(1,String.valueOf(tot_abnormal).toString()));
				entity.setGro_tot_total(StringUtil.NumberFormatS(1,String.valueOf(tot_ground+tot_abnormal).toString()));
				
				hashData.put("GROTOTINFO",entity);
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				if (entity != null) entity = null;
				
				//4-3.   м ***************************************************************
				stmt = conn.createStatement();
				sql = RepQ020Query.getInstance().selAccType(params);
				rs = stmt.executeQuery(sql);
	
				int acc_eng = 0;
				int acc_plane = 0;
				int acc_bird = 0;
				int acc_lightening = 0;
				int acc_etc = 0;
				int acc_total = 0;
				int acc_tot_eng = 0;
				int acc_tot_plane = 0;
				int acc_tot_bird = 0;
				int acc_tot_lightening = 0;
				int acc_tot_etc = 0;
				int acc_tot_total = 0;
				
				while(rs.next()){
					String type = StringUtil.checkString(rs.getString("Code_c3"));
					if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
						if(type.equals("A")){
							acc_eng = rs.getInt("Sum1");
							acc_tot_eng = acc_tot_eng + rs.getInt("Sum1");;
						}else if(type.equals("B")){
							acc_plane = rs.getInt("Sum1");
							acc_tot_plane = acc_tot_plane + rs.getInt("Sum1");
						}else if(type.equals("C")){
							acc_bird = rs.getInt("Sum1");
							acc_tot_bird = acc_tot_bird + rs.getInt("Sum1");
						}else if(type.equals("D")){
							acc_lightening = rs.getInt("Sum1");
							acc_tot_lightening = acc_tot_lightening + rs.getInt("Sum1");
						}else if(type.equals("O")){
							acc_etc = rs.getInt("Sum1");
							acc_tot_etc = acc_tot_etc + rs.getInt("Sum1");
						}
					}
					else{
						if(type.equals("A")){
							acc_tot_eng = acc_tot_eng + rs.getInt("Sum1");;
						}else if(type.equals("B")){
							acc_tot_plane = acc_tot_plane + rs.getInt("Sum1");
						}else if(type.equals("C")){
							acc_tot_bird = acc_tot_bird + rs.getInt("Sum1");
						}else if(type.equals("D")){
							acc_tot_lightening = acc_tot_lightening + rs.getInt("Sum1");
						}else if(type.equals("O")){
							acc_tot_etc = acc_tot_etc + rs.getInt("Sum1");
						}
					}
				}
				entity = new RepQ020BG();
				entity.setReport_d(reportD);
				entity.setAcc_eng(StringUtil.NumberFormatS(1,String.valueOf(acc_eng).toString()));
				entity.setAcc_plane(StringUtil.NumberFormatS(1,String.valueOf(acc_plane).toString()));
				entity.setAcc_bird(StringUtil.NumberFormatS(1,String.valueOf(acc_bird).toString()));
				entity.setAcc_lightening(StringUtil.NumberFormatS(1,String.valueOf(acc_lightening).toString()));
				entity.setAcc_etc(StringUtil.NumberFormatS(1,String.valueOf(acc_etc).toString()));
				entity.setAcc_total(StringUtil.NumberFormatS(1,String.valueOf(acc_eng+acc_plane+acc_bird+acc_lightening+acc_etc).toString()));
				
				entity.setAcc_tot_eng(StringUtil.NumberFormatS(1,String.valueOf(acc_tot_eng).toString()));
				entity.setAcc_tot_plane(StringUtil.NumberFormatS(1,String.valueOf(acc_tot_plane).toString()));
				entity.setAcc_tot_bird(StringUtil.NumberFormatS(1,String.valueOf(acc_tot_bird).toString()));
				entity.setAcc_tot_lightening(StringUtil.NumberFormatS(1,String.valueOf(acc_tot_lightening).toString()));
				entity.setAcc_tot_etc(StringUtil.NumberFormatS(1,String.valueOf(acc_tot_etc).toString()));
				entity.setAcc_tot_total(StringUtil.NumberFormatS(1,String.valueOf(acc_tot_eng+acc_tot_plane+acc_tot_bird+acc_tot_lightening+acc_tot_etc).toString()));
				
				hashData.put("ACCINFO",entity);
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				if (entity != null) entity = null;
				
				//4-4. ֿ   *****************************************************************				
				stmt = conn.createStatement();
				sql = RepQ020Query.getInstance().selAccDetail(params);
				rs = stmt.executeQuery(sql);
				
				List accDomList = new LinkedList();
				List accIntList = new LinkedList();
				List accCgoList = new LinkedList();
				
				while(rs.next()){
					entity = new RepQ020BG();
					String irr_d = StringUtil.checkString(rs.getString("Irr_d")).substring(4,6)+"/"+StringUtil.checkString(rs.getString("Irr_d")).substring(6,8);
					entity.setIrr_d(irr_d);
					entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_num")));
					entity.setActyp(StringUtil.checkString(rs.getString("Actyp")));
					entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
					entity.setLegstn(StringUtil.checkString(rs.getString("LegStn")));
					entity.setReason_e(StringUtil.checkString(rs.getString("Reason_e")));
					entity.setDecision_e(StringUtil.checkString(rs.getString("Decision_e")));
					entity.setRemark_e(StringUtil.checkString(rs.getString("Remark_e")));
					if(StringUtil.checkString(rs.getString("Dom_x")).equals("D")){
						accDomList.add(entity);
					}else if(StringUtil.checkString(rs.getString("Dom_x")).equals("I")){
						accIntList.add(entity);
					}else if(StringUtil.checkString(rs.getString("Dom_x")).equals("C")){
						accCgoList.add(entity);
					}
				}
				
				hashData.put("ACCDOM",accDomList);
				hashData.put("ACCINT",accIntList);
				hashData.put("ACCCGO",accCgoList);

				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//4-5.   м *************************************************************
				stmt = conn.createStatement();
				sql = RepQ020Query.getInstance().selIrrType(params);
				rs = stmt.executeQuery(sql);
	
				int irr_eng = 0;
				int irr_plane = 0;
				int irr_bird = 0;
				int irr_lightening = 0;
				int irr_etc = 0;
				int irr_total = 0;
				int irr_tot_eng = 0;
				int irr_tot_plane = 0;
				int irr_tot_bird = 0;
				int irr_tot_lightening = 0;
				int irr_tot_etc = 0;
				int irr_tot_total = 0;
				
				while(rs.next()){
					String type = StringUtil.checkString(rs.getString("Code_c3"));
					if(StringUtil.checkString(rs.getString("Report_d")).equals(reportD)){
						if(type.equals("A")){
							irr_eng = rs.getInt("Sum1");
							irr_tot_eng = irr_tot_eng + rs.getInt("Sum1");;
						}else if(type.equals("B")){
							irr_plane = rs.getInt("Sum1");
							irr_tot_plane = irr_tot_plane + rs.getInt("Sum1");
						}else if(type.equals("C")){
							irr_bird = rs.getInt("Sum1");
							irr_tot_bird = irr_tot_bird + rs.getInt("Sum1");
						}else if(type.equals("D")){
							irr_lightening = rs.getInt("Sum1");
							irr_tot_lightening = irr_tot_lightening + rs.getInt("Sum1");
						}else if(type.equals("O")){
							irr_etc = rs.getInt("Sum1");
							irr_tot_etc = irr_tot_etc + rs.getInt("Sum1");
						}
					}
					else{
						if(type.equals("A")){
							irr_tot_eng = irr_tot_eng + rs.getInt("Sum1");;
						}else if(type.equals("B")){
							irr_tot_plane = irr_tot_plane + rs.getInt("Sum1");
						}else if(type.equals("C")){
							irr_tot_bird = irr_tot_bird + rs.getInt("Sum1");
						}else if(type.equals("D")){
							irr_tot_lightening = irr_tot_lightening + rs.getInt("Sum1");
						}else if(type.equals("O")){
							irr_tot_etc = irr_tot_etc + rs.getInt("Sum1");
						}
					}
				}
				entity = new RepQ020BG();
				entity.setReport_d(reportD);
				entity.setIrr_eng(StringUtil.NumberFormatS(1,String.valueOf(irr_eng).toString()));
				entity.setIrr_plane(StringUtil.NumberFormatS(1,String.valueOf(irr_plane).toString()));
				entity.setIrr_bird(StringUtil.NumberFormatS(1,String.valueOf(irr_bird).toString()));
				entity.setIrr_lightening(StringUtil.NumberFormatS(1,String.valueOf(irr_lightening).toString()));
				entity.setIrr_etc(StringUtil.NumberFormatS(1,String.valueOf(irr_etc).toString()));
				entity.setIrr_total(StringUtil.NumberFormatS(1,String.valueOf(irr_eng+irr_plane+irr_bird+irr_lightening+irr_etc).toString()));
				
				entity.setIrr_tot_eng(StringUtil.NumberFormatS(1,String.valueOf(irr_tot_eng).toString()));
				entity.setIrr_tot_plane(StringUtil.NumberFormatS(1,String.valueOf(irr_tot_plane).toString()));
				entity.setIrr_tot_bird(StringUtil.NumberFormatS(1,String.valueOf(irr_tot_bird).toString()));
				entity.setIrr_tot_lightening(StringUtil.NumberFormatS(1,String.valueOf(irr_tot_lightening).toString()));
				entity.setIrr_tot_etc(StringUtil.NumberFormatS(1,String.valueOf(irr_tot_etc).toString()));
				entity.setIrr_tot_total(StringUtil.NumberFormatS(1,String.valueOf(irr_tot_eng+irr_tot_plane+irr_tot_bird+irr_tot_lightening+irr_tot_etc).toString()));
				
				hashData.put("IRRINFO",entity);
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				if (entity != null) entity = null;
				
				//4-6. ֿ   ***************************************************************
				stmt = conn.createStatement();
				sql = RepQ020Query.getInstance().selIrrDetail(params);
				rs = stmt.executeQuery(sql);
				
				List irrDomList = new LinkedList();
				List irrIntList = new LinkedList();
				List irrCgoList = new LinkedList();
				
				while(rs.next()){
					entity = new RepQ020BG();
					String irr_d = StringUtil.checkString(rs.getString("Irr_d")).substring(4,6)+"/"+StringUtil.checkString(rs.getString("Irr_d")).substring(6,8);
					entity.setIrr_d(irr_d);
					entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_num")));
					entity.setActyp(StringUtil.checkString(rs.getString("Actyp")));
					entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
					entity.setLegstn(StringUtil.checkString(rs.getString("LegStn")));
					entity.setReason_e(StringUtil.checkString(rs.getString("Reason_e")));
					entity.setDecision_e(StringUtil.checkString(rs.getString("Decision_e")));
					entity.setRemark_e(StringUtil.checkString(rs.getString("Remark_e")));
					if(StringUtil.checkString(rs.getString("Dom_x")).equals("D")){
						irrDomList.add(entity);
					}else if(StringUtil.checkString(rs.getString("Dom_x")).equals("I")){
						irrIntList.add(entity);
					}else if(StringUtil.checkString(rs.getString("Dom_x")).equals("C")){
						irrCgoList.add(entity);
					}
				}
				
				hashData.put("IRRDOM",irrDomList);
				hashData.put("IRRINT",irrIntList);
				hashData.put("IRRCGO",irrCgoList);

				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;*/
			}
			
		} catch(SQLException se) {
			Logger.debug.println("[BASE:RepAllSLBean:selRepQ020Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:RepAllSLBean:selRepQ020Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * 簡ð ȸԼ 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/25 
	  */
	public Hashtable selRepQ030Main(RepQ030BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    String reportD = params.getReport_d();
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			DecimalFormat df = new DecimalFormat("#,###.#");
			RepQ030BG entity = null;
				
			//簡ð ȸ
			stmt = conn.createStatement();
			sql = RepQ030Query.getInstance().selUtilTime(params);
			rs = stmt.executeQuery(sql);
			
			Vector pasCgo = new Vector();
			Vector actyp = new Vector();
			Vector totalPlan = new Vector();
			Vector totalActual = new Vector();
			Vector totalPast = new Vector();
			Vector timePlan = new Vector();
			Vector timeActual = new Vector();
			Vector timePast = new Vector();
			Vector perPlan = new Vector();
			Vector perActual = new Vector();
			Vector perPast = new Vector();
			Vector acdPlan = new Vector();
			Vector acdActual = new Vector();
			Vector acdPast = new Vector();
			
			while(rs.next()){
				pasCgo.addElement(StringUtil.checkString(rs.getString("a_b")));
				actyp.addElement(StringUtil.checkString(rs.getString("ACTYP")));
				totalPlan.addElement(StringUtil.checkString(rs.getString("a_plan")));
				totalActual.addElement(StringUtil.checkString(rs.getString("a_actual")));
				totalPast.addElement(StringUtil.checkString(rs.getString("a_past")));
				timePlan.addElement(StringUtil.checkString(rs.getString("b_plan")));
				timeActual.addElement(StringUtil.checkString(rs.getString("b_actual")));
				if(rs.getDouble("b_past") != 0){ timePast.addElement(df.format((rs.getDouble("b_actual") - rs.getDouble("b_past")) / rs.getDouble("b_past") * 100)+"%"); }
				else{ timePast.addElement("0%"); }
				if(rs.getDouble("a_plan") != 0){ perPlan.addElement(df.format(rs.getDouble("b_plan") / rs.getDouble("a_plan"))); }
				else{ perPlan.addElement("0"); }
				if(rs.getDouble("a_actual") != 0){ perActual.addElement(df.format(rs.getDouble("b_actual") / rs.getDouble("a_actual"))); }
				else{ perActual.addElement("0"); }
				if(rs.getDouble("a_actual") != 0 && rs.getDouble("a_past") != 0 && rs.getDouble("b_past") != 0){ 
					perPast.addElement(df.format(((rs.getDouble("b_actual") / rs.getDouble("a_actual")) - (rs.getDouble("b_past") / rs.getDouble("a_past"))) / (rs.getDouble("b_past") / rs.getDouble("a_past")) * 100)); 
				}else{ perPast.addElement("0%"); }
				acdPlan.addElement(StringUtil.checkString(rs.getString("c_plan")));
				acdActual.addElement(StringUtil.checkString(rs.getString("c_actual")));
				acdPast.addElement(StringUtil.checkString(rs.getString("c_past")));
			}
			
			if (actyp.size() > 0) {
				entity = new RepQ030BG();
				
				entity.setPas_cgo(pasCgo);
				entity.setActyp(actyp);
				entity.setTotal_plan(totalPlan);
				entity.setTotal_actual(totalActual);
				entity.setTotal_past(totalPast);
				entity.setTime_plan(timePlan);
				entity.setTime_actual(timeActual);
				entity.setTime_past(timePast);
				entity.setPer_plan(perPlan);
				entity.setPer_actual(perActual);
				entity.setPer_past(perPast);
				entity.setAcd_plan(acdPlan);
				entity.setAcd_actual(acdActual);
				entity.setAcd_past(acdPast);
				
				hashData.put("UTILTIME",entity);
			}
			
		} catch(SQLException se) {
			Logger.debug.println("[BASE:RepAllSLBean:selRepQ030Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:RepAllSLBean:selRepQ030Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
		
	/** 
	  * <b> IROPS Report Ҹ ޺ ȸԼ</b>. 
	  * @param authPmsn String User 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public Hashtable selRepQ070YyyyMm(String authPmsn) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listMon = new LinkedList();
	   
	    try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			// Select Code ȸ
			String lastMon = null;
			stmt = conn.createStatement();
			sql = RepQ070Query.getInstance().selYyyyMm();
			rs = stmt.executeQuery(sql);
			
			//  Admin̴
			//authPmsn = "A";
			
			if (rs.next()) {
				//Complete_y 'Y'̸ Code_c ̰ 
				if ((rs.getString("Complete_y")).equals("Y")) {
					lastMon = StringUtil.checkString(rs.getString("Code_c"));		// 200410
				} else {
					//ƴϸ Desc_e  ε ̰  User Admin̳Ŀ  Ʋ.	
					if (authPmsn.equals("A")) {
						lastMon = StringUtil.checkString(rs.getString("Desc_e"));		// 200410
					} else {
						lastMon = StringUtil.checkString(rs.getString("Code_c"));		// 200409
					}
				}
				
				listMon.add(lastMon);																		// Է 200410				
				listMon.add(StringUtil.addMons(lastMon,1));									//1 200409
				listMon.add(StringUtil.addMons(lastMon,2));									//2 200408
				listMon.add(StringUtil.addMons(lastMon,3));									//3 200407
				//Month ߰
				listMon.add(StringUtil.addMons(lastMon,4));									//3 200406
				listMon.add(StringUtil.addMons(lastMon,5));									//3 200405
				listMon.add(StringUtil.addMons(lastMon,6));									//3 200404
				listMon.add(StringUtil.addMons(lastMon,7));									//3 200403
			}
			hashData.put("YYYYMM",listMon);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selRepQ070YyyyMm:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selRepQ070YyyyMm:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
		
	/** 
	  * <b> IROPS Report Ҹ ȸԼ</b>. 
	  * @param reportD String ȸ yyyymm
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public Hashtable selRepQ070Main(String reportD) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listArea = new LinkedList();
	    List listTyp = new LinkedList();
	   
	    try {
	    	//Number Format 
	    	DecimalFormat df1 = new DecimalFormat("#,##0");
	    	DecimalFormat df2 = new DecimalFormat("##0.0");
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			// Ҹ ȸ
			stmt = conn.createStatement();
			sql = RepQ070Query.getInstance().selArea(reportD);
			rs = stmt.executeQuery(sql);
			
			String[] arrMsg = new String[4];
			double skdSum = 0;			//ȹհ
			double actSum = 0;			//հ
			double pasSkdSum = 0;		// ȹհ
			double pasActSum = 0;		// հ
			
			while (rs.next()) {
				String flag = StringUtil.checkString(rs.getString("Flag"));
				if (flag.equals("A")) {
					RepQ070BG entity = new RepQ070BG();
					entity.setFlag("D");		//
					entity.setSkd_q(df1.format(rs.getDouble("Skd_q")));
					entity.setAct_q(df1.format(rs.getDouble("Act_q")));
					entity.setRev_q(df1.format(rs.getDouble("Rev_q")));
					entity.setRev_p(df2.format(rs.getDouble("Rev_p")));
					//Data
					skdSum += rs.getDouble("Skd_q");
					actSum += rs.getDouble("Act_q");
					pasSkdSum += rs.getDouble("Skd_q");
					pasActSum += rs.getDouble("Act_q");
					listArea.add(entity);
					
					arrMsg[1] = " "+" ,  Ҹ "+df1.format(rs.getDouble("Act_q"))+"õ LBS ȹ "+df2.format(rs.getDouble("Rev_p"))+"% Under-burn";
				} else if (flag.equals("B")) {
					RepQ070BG entity = new RepQ070BG();
					entity.setFlag("I");			//
					entity.setSkd_q(df1.format(rs.getDouble("Skd_q")));
					entity.setAct_q(df1.format(rs.getDouble("Act_q")));
					entity.setRev_q(df1.format(rs.getDouble("Rev_q")));
					entity.setRev_p(df2.format(rs.getDouble("Rev_p")));
					//Data
					skdSum += rs.getDouble("Skd_q");
					actSum += rs.getDouble("Act_q");
					pasSkdSum += rs.getDouble("Skd_q");
					pasActSum += rs.getDouble("Act_q");
					listArea.add(entity);
					
					arrMsg[2] = " Ҹ "+df1.format(rs.getDouble("Act_q"))+"õ LBS ȹ "+df2.format(rs.getDouble("Rev_p"))+"% Under-burn";
				} else {
					RepQ070BG entity = new RepQ070BG();
					entity.setFlag("P");		// հ
					entity.setSkd_q(df1.format(pasSkdSum));
					entity.setAct_q(df1.format(pasActSum));
					entity.setRev_q(df1.format(pasActSum-pasSkdSum));
					entity.setRev_p(df2.format(((pasActSum-pasSkdSum)/pasSkdSum)*100));
					listArea.add(entity);
					
					entity = new RepQ070BG();
					entity.setFlag("C");		//ȭ
					entity.setSkd_q(df1.format(rs.getDouble("Skd_q")));
					entity.setAct_q(df1.format(rs.getDouble("Act_q")));
					entity.setRev_q(df1.format(rs.getDouble("Rev_q")));
					entity.setRev_p(df2.format(rs.getDouble("Rev_p")));
					//Data
					skdSum += rs.getDouble("Skd_q");
					actSum += rs.getDouble("Act_q");
					listArea.add(entity);
					
					arrMsg[3] = " "+"ȭ , Ҹ "+df1.format(rs.getDouble("Act_q"))+"õ LBS ȹ "+df2.format(rs.getDouble("Rev_p"))+"% Under-burn";
				}
			}
			// հó
			if (listArea.size() > 0) {
				RepQ070BG entity = new RepQ070BG();
				entity.setFlag("T");
				entity.setSkd_q(df1.format(skdSum));
				entity.setAct_q(df1.format(actSum));
				entity.setRev_q(df1.format(actSum-skdSum));
				entity.setRev_p(df2.format(((actSum-skdSum)/skdSum)*100));
				listArea.add(entity);
				
				arrMsg[0] = " "+reportD.substring(4)+"  Ҹ "+df1.format(actSum)+"õ LBS ȹ "+df2.format(((actSum-skdSum)/skdSum)*100)+"% Under-burn ( "+df1.format(actSum-skdSum)+"õ LBS )";
			}
			hashData.put("AREA",listArea);
			hashData.put("ARRMSG",arrMsg);
			
			//ڿȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			// Ҹ ȸ
			String befFlag = "";
			String nowFlag = "";
			int dataCnt = 0;
			stmt = conn.createStatement();
			sql = RepQ070Query.getInstance().selActyp(reportD);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				RepQ070BG entity2 = new RepQ070BG();
				dataCnt++;
				nowFlag = StringUtil.checkString(rs.getString("Flag"));
				entity2.setFlag(nowFlag);
				if (!nowFlag.equals(befFlag)) {
					hashData.put("cntPas",String.valueOf(dataCnt).toString());
					dataCnt = 0;
				}
				entity2.setActyp(StringUtil.checkString(rs.getString("Actyp")));
				entity2.setSkd_q(df1.format(rs.getDouble("Skd_q")));
				entity2.setAct_q(df1.format(rs.getDouble("Act_q")));
				entity2.setRev_q(df1.format(rs.getDouble("Rev_q")));
				entity2.setRev_p(df2.format(rs.getDouble("Rev_p")));
				listTyp.add(entity2);
				befFlag = nowFlag;
			}
			hashData.put("cntCgo",String.valueOf(dataCnt+1).toString());
			hashData.put("ACTYP",listTyp);
			
			//ڿȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			// ==> 2006.02.06  : Fuel Dumping ȭ  ó
			/*
			//Fuel Dumping
			RepQ070BG entity3 = new RepQ070BG();
			entity3.setYyyymm(reportD);
			
			//
			stmt = conn.createStatement();
			sql = RepQ070Query.getInstance().selDumping("N",reportD);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				entity3.setNow_q1(df1.format(rs.getDouble("Flt_q1")));							// Ǽ
				entity3.setNow_q2(df1.format(rs.getDouble("Flt_q2")));							// Dumping
			} else {
				entity3.setNow_q1("0");																			// Ǽ
				entity3.setNow_q2("0");																			// Dumping
			}
			
			//ڿȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//
			stmt = conn.createStatement();
			sql = RepQ070Query.getInstance().selDumping("B",reportD);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				entity3.setBef_q1(df1.format(rs.getDouble("Flt_q1")));							// Ǽ
				entity3.setBef_q2(df1.format(rs.getDouble("Flt_q2")));							// Dumping
			} else {
				entity3.setBef_q1("0");																			// Ǽ
				entity3.setBef_q2("0");																			// Dumping
			}
			
			//ڿȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			// 
			stmt = conn.createStatement();
			sql = RepQ070Query.getInstance().selDumpingSum("N",reportD);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				entity3.setNow_year(StringUtil.checkString(rs.getString("Report_d")));	//
				entity3.setSum_now_q1(df1.format(rs.getDouble("Flt_q1")));					// Ǽ 
				entity3.setSum_now_q2(df1.format(rs.getDouble("Flt_q2")));					// Dumping 
			} else {
				entity3.setNow_year(reportD.substring(0,4));																//
				entity3.setSum_now_q1("0");																// Ǽ 
				entity3.setSum_now_q2("0");																// Dumping 
			}
			
			//ڿȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			// 
			stmt = conn.createStatement();
			sql = RepQ070Query.getInstance().selDumpingSum("B",reportD);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				entity3.setBef_year(StringUtil.checkString(rs.getString("Report_d")));	//
				entity3.setSum_bef_q1(df1.format(rs.getDouble("Flt_q1")));					// Ǽ 
				entity3.setSum_bef_q2(df1.format(rs.getDouble("Flt_q2")));					// Dumping 
			} else {
				entity3.setBef_year(String.valueOf(Integer.valueOf(reportD.substring(0,4)).intValue() - 1).toString());	//
				entity3.setSum_bef_q1("0");																	// Ǽ 
				entity3.setSum_bef_q2("0");																	// Dumping 
			}
			hashData.put("DUMP",entity3);*/
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selRepQ070Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selRepQ070Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * <b> IROPS Report 캯Ȳ ȸԼ</b>. 
	  * @param reportD String ȸ yyyymm
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/23 HIST 
	  */
	public Hashtable selRepQ040Main(String reportD) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listView = new LinkedList();
	    List listPoint = new LinkedList();
	   
	    try {
	    	//Number Format 
	    	DecimalFormat df1 = new DecimalFormat("#,##0");
	    	DecimalFormat df2 = new DecimalFormat("##0.0");
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			// 泻 ȸ
			stmt = conn.createStatement();
			sql = RepQ040Query.getInstance().selView(reportD);
			rs = stmt.executeQuery(sql);
			
			double code_d30 = 0;		//D-30
			double code_d7 = 0;		//D-7
			double code_d2 = 0;		//D-2
			
			while (rs.next()) {
				RepQ040BG entity = new RepQ040BG();
				entity.setCode_c2(StringUtil.checkString(rs.getString("Code_c2")));
				entity.setCode_c3_d30(df1.format(rs.getDouble("Code_c3_d30")));
				entity.setCode_c3_d7(df1.format(rs.getDouble("Code_c3_d7")));
				entity.setCode_c3_d2(df1.format(rs.getDouble("Code_c3_d2")));
				entity.setCode_total(df1.format(rs.getDouble("Code_c3_d30") + rs.getDouble("Code_c3_d7") + rs.getDouble("Code_c3_d2")));
				//Ѱ踦 Ͽ 
				code_d30 += rs.getDouble("Code_c3_d30");
				code_d7 += rs.getDouble("Code_c3_d7");
				code_d2 += rs.getDouble("Code_c3_d2");
				listView.add(entity);
			}
			// Ѱ
			if (listView.size() > 0) {
				RepQ040BG entity = new RepQ040BG();
				entity.setCode_c2(StringUtil.checkString(""));
				entity.setCode_c3_d30(df1.format(code_d30));
				entity.setCode_c3_d7(df1.format(code_d7));
				entity.setCode_c3_d2(df1.format(code_d2));
				entity.setCode_total(df1.format(code_d30 + code_d7 + code_d2));
				listView.add(entity);
			}
			hashData.put("VIEW",listView);
			
			//ڿȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//κм ȸ
			stmt = conn.createStatement();
			sql = RepQ040Query.getInstance().selPointing(reportD);
			rs = stmt.executeQuery(sql);
			
			double code_a = 0;		//
			double code_b = 0;		//װ
			double code_c = 0;		//
			double code_d = 0;		//
			double code_total = 0;	//
			
			double code_a_total = 0;
			double code_b_total = 0;
			double code_c_total = 0;
			double code_d_total = 0;
			
			while (rs.next()) {
				RepQ040BG entity2 = new RepQ040BG();
				code_a = rs.getDouble("code_c3_a");
				code_b = rs.getDouble("Code_c3_b");
				code_c = rs.getDouble("Code_c3_c");
				code_d = rs.getDouble("Code_c3_d");
				code_total = rs.getDouble("code_c3_a")+rs.getDouble("code_c3_b")+rs.getDouble("code_c3_c")+rs.getDouble("code_c3_d");
				
				// Ǽ
				entity2.setCode_c2(StringUtil.checkString(rs.getString("Code_c2")));
				entity2.setCode_c3_a(df1.format(code_a));
				entity2.setCode_c3_b(df1.format(code_b));
				entity2.setCode_c3_c(df1.format(code_c));
				entity2.setCode_c3_d(df1.format(code_d));
				entity2.setCode_total(df1.format(code_total));
				listPoint.add(entity2);
				
				//Percent
				entity2 = new RepQ040BG();
				entity2.setCode_c2(StringUtil.checkString(rs.getString("Code_c2")));
				entity2.setCode_c3_a(df2.format((code_a/code_total)*100));
				entity2.setCode_c3_b(df2.format((code_b/code_total)*100));
				entity2.setCode_c3_c(df2.format((code_c/code_total)*100));
				entity2.setCode_c3_d(df2.format((code_d/code_total)*100));
				entity2.setCode_total(df1.format(100));
				listPoint.add(entity2);
				
				//Ѱ踦 Ͽ 
				code_a_total += code_a;
				code_b_total += code_b;
				code_c_total += code_c;
				code_d_total += code_d;
				
			}
			// Ѱ
			if (listPoint.size() > 0) {
				RepQ040BG entity2 = new RepQ040BG();
				entity2.setCode_c2("");
				entity2.setCode_c3_a(df1.format(code_a_total));
				entity2.setCode_c3_b(df1.format(code_b_total));
				entity2.setCode_c3_c(df1.format(code_c_total));
				entity2.setCode_c3_d(df1.format(code_d_total));
				entity2.setCode_total(df1.format(code_a_total+code_b_total+code_c_total+code_d_total));
				listPoint.add(entity2);
				
				//Percent
				double all_total = code_a_total+code_b_total+code_c_total+code_d_total;
				entity2 = new RepQ040BG();
				entity2.setCode_c2("");
				entity2.setCode_c3_a(df2.format((code_a_total/all_total)*100));
				entity2.setCode_c3_b(df2.format((code_b_total/all_total)*100));
				entity2.setCode_c3_c(df2.format((code_c_total/all_total)*100));
				entity2.setCode_c3_d(df2.format((code_d_total/all_total)*100));
				entity2.setCode_total(df1.format(100));
				listPoint.add(entity2);
			}
			hashData.put("POINT",listPoint);
			
			//ڿȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selRepQ040Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selRepQ040Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * <b> IROPS Report ǽ¹  ȸԼ</b>. 
	  * @param reportD String ȸ yyyymm
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/28 HIST 
	  */
	public Hashtable selRepQ050Main(String reportD) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listOper = new LinkedList();
	    List listLoss = new LinkedList();
	    List listFlight = new LinkedList();
	   
	    try {
	    	//Number Format 
	    	DecimalFormat df1 = new DecimalFormat("#,##0");
	    	DecimalFormat df2 = new DecimalFormat("##0.0");
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			// ȸ
			stmt = conn.createStatement();
			sql = RepQ050Query.getInstance().selOperation(reportD);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				RepQ050BG entity = new RepQ050BG();
				entity.setCode_c2(StringUtil.checkString(rs.getString("Code_c2")));
				entity.setData_q1(df1.format(rs.getDouble("Data_q1")));						//ݿ ȹ
				entity.setData_q2(df1.format(rs.getDouble("Data_q2")));						//ݿ 
				entity.setData_q3(df1.format(rs.getDouble("Data_q3")));						//⵿ 
				entity.setData_q4(df2.format(((rs.getDouble("Data_q2") - rs.getDouble("Data_q3"))/rs.getDouble("Data_q2")) * 100)+"%");
				listOper.add(entity);
			}
			hashData.put("OPERATION",listOper);
			
			//ڿȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//LOSS ȸ
			stmt = conn.createStatement();
			sql = RepQ050Query.getInstance().selLoss(reportD);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				RepQ050BG entity = new RepQ050BG();
				entity.setReport_d(StringUtil.checkString(rs.getString("Report_d")));
				entity.setData_q1(df1.format(rs.getDouble("Data_q1"))+"%");		//Day-off
				entity.setData_q2(df1.format(rs.getDouble("Data_q2"))+"%");		//ް
				entity.setData_q3(df1.format(rs.getDouble("Data_q3"))+"%");		//Ʒ
				entity.setData_q4(df1.format(rs.getDouble("Data_q4"))+"%");		//Ÿ
				listLoss.add(entity);
			}
			hashData.put("LOSS",listLoss);
			
			//ڿȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//ð  м ȸ
			stmt = conn.createStatement();
			sql = RepQ050Query.getInstance().selFlightTime(reportD);
			rs = stmt.executeQuery(sql);
			
			double dataQ1 = 0;		//60ð ̸
			double dataQ2 = 0;		//60 ~ 69ð
			double dataQ3 = 0;		//70 ~ 79 ð
			double dataQ4 = 0;		//80ð ̻
			double dataT = 0;		// հ
			
			while (rs.next()) {
				String report_d = StringUtil.checkString(rs.getString("Report_d"));
				if (report_d.equals(reportD)) {
					//ݳ ݿ
					RepQ050BG entity = new RepQ050BG();
					entity.setCode_c2("ο     ()");
					dataQ1 = rs.getDouble("Data_q1");
					dataQ2 = rs.getDouble("Data_q2");
					dataQ3 = rs.getDouble("Data_q3");
					dataQ4 = rs.getDouble("Data_q4");
					dataT = dataQ1 + dataQ2 + dataQ3 + dataQ4;
					entity.setData_q1(df1.format(dataQ1));
					entity.setData_q2(df1.format(dataQ2));
					entity.setData_q3(df1.format(dataQ3));
					entity.setData_q4(df1.format(dataQ4));
					listFlight.add(entity);
					
					RepQ050BG entity2 = new RepQ050BG();
					entity2.setCode_c2("   ()");
					entity2.setData_q1(df1.format((dataQ1/dataT)*100)+"%");
					entity2.setData_q2(df1.format((dataQ2/dataT)*100)+"%");
					entity2.setData_q3(df1.format((dataQ3/dataT)*100)+"%");
					entity2.setData_q4(df1.format((dataQ4/dataT)*100)+"%");
					listFlight.add(entity2);
				} else {
					// 
					RepQ050BG entity = new RepQ050BG();
					entity.setCode_c2("⵿ ()");
					dataQ1 = rs.getDouble("Data_q1");
					dataQ2 = rs.getDouble("Data_q2");
					dataQ3 = rs.getDouble("Data_q3");
					dataQ4 = rs.getDouble("Data_q4");
					dataT = dataQ1 + dataQ2 + dataQ3 + dataQ4;
					entity.setData_q1(df1.format((dataQ1/dataT)*100)+"%");
					entity.setData_q2(df1.format((dataQ2/dataT)*100)+"%");
					entity.setData_q3(df1.format((dataQ3/dataT)*100)+"%");
					entity.setData_q4(df1.format((dataQ4/dataT)*100)+"%");
					listFlight.add(entity);
				}
			}
			hashData.put("FLIGHT",listFlight);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selRepQ050Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selRepQ050Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * <b> IROPS Report ׽¹  ȸԼ</b>. 
	  * @param reportD String ȸ yyyymm
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/03/02 HIST 
	  */
	public Hashtable selRepQ060Main(String reportD) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   
	    try {
	    	//Number Format 
	    	DecimalFormat df1 = new DecimalFormat("#,##0");
	    	DecimalFormat df2 = new DecimalFormat("##0.0");
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//οȲ ȸ
			stmt = conn.createStatement();
			sql = RepQ060Query.getInstance().selStaff(reportD);
			rs = stmt.executeQuery(sql);
			
			int i = 0;  
			Vector vCodeC3 = new Vector();
			Vector vNowCaptSkd = new Vector();
			Vector vNowCaptRes = new Vector();
			Vector vBefCaptRes = new Vector();
			Vector vNowSubSkd = new Vector();
			Vector vNowSubRes = new Vector();
			Vector vBefSubRes = new Vector();
			
			while (rs.next()) {
				vCodeC3.addElement(StringUtil.checkString(rs.getString("Code_c3")));
				vNowCaptSkd.addElement(df1.format(rs.getDouble("Now_Capt_skd")));
				vNowCaptRes.addElement(df1.format(rs.getDouble("Now_Capt_res")));
				if (rs.getDouble("Bef_Capt_res") == 0 || (rs.getDouble("Now_Capt_res")-rs.getDouble("Bef_Capt_res")) == 0) 
					vBefCaptRes.addElement(df1.format(0)+"%");
				else 
					vBefCaptRes.addElement(df2.format(((rs.getDouble("Now_Capt_res")-rs.getDouble("Bef_Capt_res"))/rs.getDouble("Bef_Capt_res"))*100)+"%");
				vNowSubSkd.addElement(df1.format(rs.getDouble("Now_Sub_skd")));
				vNowSubRes.addElement(df1.format(rs.getDouble("Now_Sub_res")));
				if (rs.getDouble("Bef_Sub_res") == 0 || (rs.getDouble("Now_Sub_res")-rs.getDouble("Bef_Sub_res")) == 0)
					vBefSubRes.addElement(df1.format(0)+"%");
				else 					
					vBefSubRes.addElement(df2.format(((rs.getDouble("Now_Sub_res")-rs.getDouble("Bef_Sub_res"))/rs.getDouble("Bef_Sub_res"))*100)+"%");
				i++;
			}
			
			if (vCodeC3.size() > 0) {
				RepQ060BG entity = new RepQ060BG();
				entity.setCode_c3(vCodeC3);
				entity.setNow_capt_skd(vNowCaptSkd);
				entity.setNow_capt_res(vNowCaptRes);
				entity.setBef_capt_res(vBefCaptRes);
				entity.setNow_sub_skd(vNowSubSkd);
				entity.setNow_sub_res(vNowSubRes);
				entity.setBef_sub_res(vBefSubRes);
				hashData.put("STAFF",entity);
			}
			
			//ڿȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//δð ȸ
			stmt = conn.createStatement();
			sql = RepQ060Query.getInstance().selFlight(reportD);
			rs = stmt.executeQuery(sql);
			
			int j = 0;  
			vCodeC3 = new Vector();
			vNowCaptSkd = new Vector();
			vNowCaptRes = new Vector();
			vBefCaptRes = new Vector();
			vNowSubSkd = new Vector();
			vNowSubRes = new Vector();
			vBefSubRes = new Vector();
			Vector vNowRosSkd = new Vector();
			Vector vNowRosRes = new Vector();
			Vector vBefRosRes = new Vector();
			
			while (rs.next()) {
				vCodeC3.addElement(StringUtil.checkString(rs.getString("Code_c3")));
				vNowCaptSkd.addElement(df1.format(rs.getDouble("Now_Capt_skd")));
				vNowCaptRes.addElement(df1.format(rs.getDouble("Now_Capt_res")));
				if (rs.getDouble("Bef_Capt_res") == 0 || (rs.getDouble("Now_Sub_skd")-rs.getDouble("Bef_Capt_res")) == 0)
					vBefCaptRes.addElement(df1.format(0)+"%");
				else
					vBefCaptRes.addElement(df2.format(((rs.getDouble("Now_Capt_res")-rs.getDouble("Bef_Capt_res"))/rs.getDouble("Bef_Capt_res"))*100)+"%");
				vNowSubSkd.addElement(df1.format(rs.getDouble("Now_Sub_skd")));
				vNowSubRes.addElement(df1.format(rs.getDouble("Now_Sub_res")));
				if (rs.getDouble("Bef_Sub_res") == 0 || (rs.getDouble("Now_Sub_res")-rs.getDouble("Bef_Sub_res")) == 0)
					vBefSubRes.addElement(df1.format(0)+"%");
				else
					vBefSubRes.addElement(df2.format(((rs.getDouble("Now_Sub_res")-rs.getDouble("Bef_Sub_res"))/rs.getDouble("Bef_Sub_res"))*100)+"%");
				vNowRosSkd.addElement(df1.format(rs.getDouble("Now_Ros_skd")));
				vNowRosRes.addElement(df1.format(rs.getDouble("Now_Ros_res")));
				if (rs.getDouble("Bef_Ros_res") == 0 || (rs.getDouble("Now_Ros_res")-rs.getDouble("Bef_Ros_res")) == 0)
					vBefRosRes.addElement(df1.format(0)+"%");
				else
					vBefRosRes.addElement(df2.format(((rs.getDouble("Now_Ros_res")-rs.getDouble("Bef_Ros_res"))/rs.getDouble("Bef_Ros_res"))*100)+"%");
				j++;
			}
			
			if (vCodeC3.size() > 0) {
				RepQ060BG entity = new RepQ060BG();
				entity.setCode_c3(vCodeC3);
				entity.setNow_capt_skd(vNowCaptSkd);
				entity.setNow_capt_res(vNowCaptRes);
				entity.setBef_capt_res(vBefCaptRes);
				entity.setNow_sub_skd(vNowSubSkd);
				entity.setNow_sub_res(vNowSubRes);
				entity.setBef_sub_res(vBefSubRes);
				entity.setNow_ros_skd(vNowRosSkd);
				entity.setNow_ros_res(vNowRosRes);
				entity.setBef_ros_res(vBefRosRes);
				hashData.put("FLIGHT",entity);
			}
			
			//ڿȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Loss   ȸ
			stmt = conn.createStatement();
			sql = RepQ060Query.getInstance().selLossPre(reportD);
			rs = stmt.executeQuery(sql);
			
			int k = 0;  
			vCodeC3 = new Vector();
			Vector vNowLossSkd = new Vector();
			Vector vNowLossRes = new Vector();
			Vector vBefLossRes = new Vector();
			
			Vector vNowResvSkd = new Vector();
			Vector vNowResvRes = new Vector();
			Vector vBefResvRes = new Vector();
			
			Vector vNowStdSkd = new Vector();
			Vector vNowStdRes = new Vector();
			Vector vBefStdRes = new Vector();
			
			Vector vNowOverSkd = new Vector();
			Vector vNowOverRes = new Vector();
			Vector vBefOverRes = new Vector();
			
			Vector vNowLackSkd = new Vector();
			Vector vNowLackRes = new Vector();
			Vector vBefLackRes = new Vector();
			
			double dOverT = 0;
			double dLackT = 0;
			
			
			while (rs.next()) {
				vCodeC3.addElement(StringUtil.checkString(rs.getString("Code_c3")));
				vNowLossSkd.addElement(df1.format(rs.getDouble("Now_Loss_skd")));
				vNowLossRes.addElement(df1.format(rs.getDouble("Now_Loss_res")));
				if (rs.getDouble("Bef_Loss_res") == 0 || (rs.getDouble("Now_Loss_skd")-rs.getDouble("Bef_Loss_res")) == 0)
					vBefLossRes.addElement(df1.format(0)+"%");
				else
					vBefLossRes.addElement(df2.format(((rs.getDouble("Now_Loss_res")-rs.getDouble("Bef_Loss_res"))/rs.getDouble("Bef_Loss_res"))*100)+"%");
				vNowResvSkd.addElement(df1.format(rs.getDouble("Now_Resv_skd")));
				vNowResvRes.addElement(df1.format(rs.getDouble("Now_Resv_res")));
				if (rs.getDouble("Bef_Resv_res") == 0 || (rs.getDouble("Now_Resv_res")-rs.getDouble("Bef_Resv_res")) == 0)
					vBefResvRes.addElement(df1.format(0)+"%");
				else
					vBefResvRes.addElement(df2.format(((rs.getDouble("Now_Resv_res")-rs.getDouble("Bef_Resv_res"))/rs.getDouble("Bef_Resv_res"))*100)+"%");
				vNowStdSkd.addElement(df1.format(rs.getDouble("Now_Std_skd")));
				vNowStdRes.addElement(df1.format(rs.getDouble("Now_Std_res")));
				if (rs.getDouble("Bef_Std_res") == 0 || (rs.getDouble("Now_Std_res")-rs.getDouble("Bef_Std_res")) == 0)
					vBefStdRes.addElement(df1.format(0)+"%");
				else
					vBefStdRes.addElement(df2.format(((rs.getDouble("Now_Std_res")-rs.getDouble("Bef_Std_res"))/rs.getDouble("Bef_Std_res"))*100)+"%");
				
				dOverT += rs.getDouble("Now_Over_skd");
				vNowOverSkd.addElement(df1.format(rs.getDouble("Now_Over_skd")));

				dLackT += rs.getDouble("Now_Lack_skd");
				vNowLackSkd.addElement(df1.format(rs.getDouble("Now_Lack_skd")));

				k++;
			}
			
			if (vCodeC3.size() > 0) {
				RepQ060BG entity = new RepQ060BG();
				entity.setCode_c3(vCodeC3);

				entity.setNow_loss_skd(vNowLossSkd);
				entity.setNow_loss_res(vNowLossRes);
				entity.setBef_loss_res(vBefLossRes);
				
				entity.setNow_resv_skd(vNowResvSkd);
				entity.setNow_resv_res(vNowResvRes);
				entity.setBef_resv_res(vBefResvRes);
				
				entity.setNow_std_skd(vNowStdSkd);
				entity.setNow_std_res(vNowStdRes);
				entity.setBef_std_res(vBefStdRes);
				
				entity.setNow_over_skd(vNowOverSkd);
				for (int iOver=0; iOver<vNowOverSkd.size(); iOver++) {
					double dTemp = Double.valueOf((String)vNowOverSkd.get(iOver)).doubleValue();
					if (dTemp == 0 || dOverT == 0)
						vBefOverRes.addElement("0"+"%");
					else 
						vBefOverRes.addElement(df2.format( (dTemp/dOverT)*100  )+"%");
				}
				entity.setBef_over_res(vBefOverRes);
				
				
				entity.setNow_lack_skd(vNowLackSkd);
				for (int iLack=0; iLack<vNowLackSkd.size(); iLack++) {
					double dTemp = Double.valueOf((String)vNowLackSkd.get(iLack)).doubleValue();
					if (dTemp == 0 || dLackT == 0)
						vBefLackRes.addElement("0"+"%");
					else 
						vBefLackRes.addElement(df2.format( (dTemp/dLackT)*100  )+"%");
				}
				entity.setBef_lack_res(vBefLackRes);
				
				hashData.put("LOSSPRE",entity);
			}
			
			//ڿȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Loss  ȸ
			List listLoss = new LinkedList();
			stmt = conn.createStatement();
			sql = RepQ060Query.getInstance().selLossOrg(reportD);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				RepQ060BG entity = new RepQ060BG();
				entity.setReport_d(StringUtil.checkString(rs.getString("Report_d")));
				entity.setDay_q(df1.format(rs.getDouble("Day_q"))+"%");		//Day-off
				entity.setVac_q(df1.format(rs.getDouble("Vac_q"))+"%");		//ް
				entity.setTran_q(df1.format(rs.getDouble("Tran_q"))+"%");	//Ʒ
				entity.setOth_q(df1.format(rs.getDouble("Oth_q"))+"%");		//Ÿ
				listLoss.add(entity);
			}
			hashData.put("LOSSORG",listLoss);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selRepQ060Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selRepQ060Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  *  Management Board ȸԼ 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/07/22 
	  */
	public Hashtable selRepQ310Main(RepQ310BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			RepQ310BG entity = new RepQ310BG();
	    	DecimalFormat df = new DecimalFormat("#,###.#");
			String todayDt = params.getToday();
			
			//Management Board ȸ
			stmt = conn.createStatement();
			sql = RepQ310Query.getInstance().selOperation(params);
			rs = stmt.executeQuery(sql);
			
			double y_dom_pl = 0;		//  ȹ
			double y_dom_op = 0;	//  
			double y_dom_on = 0;	//  ÿ
			double y_pax_pl = 0;		//  ȹ
			double y_pax_op = 0;		//  
			double y_pax_on = 0;		//  ÿ
			double y_cgo_pl = 0;		// ȭ ȹ
			double y_cgo_op = 0;	// ȭ 
			double y_cgo_on = 0;	// ȭ ÿ
			double t_dom_pl = 0;		//  ȹ
			double t_dom_op = 0;		//  
			double t_dom_on = 0;		//  ÿ
			double t_pax_pl = 0;		//  ȹ
			double t_pax_op = 0;		//  
			double t_pax_on = 0;		//  ÿ
			double t_cgo_pl = 0;		// ȭ ȹ
			double t_cgo_op = 0;		// ȭ 
			double t_cgo_on = 0;		// ȭ ÿ
			
			double y_dom_cfg = 0;		// DOM ¼
			double y_jpn_cfg = 0;			// JPN ¼
			double y_chn_cfg = 0;		// CHN ¼
			double y_sea_cfg = 0;		// SEA ¼
			double y_aus_cfg = 0;		// AUS ¼
			double y_eur_cfg = 0;		// EUR ¼
			double y_usa_cfg = 0;		// USA ¼
			double y_etc_cfg = 0;			// Ÿ ¼
			double y_dom_chkin = 0;	// DOM ž
			double y_jpn_chkin = 0;		// JPN ž
			double y_chn_chkin = 0;	// CHN ž
			double y_sea_chkin = 0;	// SEA ž
			double y_aus_chkin = 0;	// AUS ž
			double y_eur_chkin = 0;		// EUR ž
			double y_usa_chkin = 0;	// USA ž
			double y_etc_chkin = 0;		// Ÿ ž
			
			double t_dom_cfg = 0;		// DOM ¼
			double t_jpn_cfg = 0;			// JPN ¼
			double t_chn_cfg = 0;		// CHN ¼
			double t_sea_cfg = 0;		// SEA ¼
			double t_aus_cfg = 0;		// AUS ¼
			double t_eur_cfg = 0;			// EUR ¼
			double t_usa_cfg = 0;		// USA ¼
			double t_etc_cfg = 0;			// Ÿ ¼
			double t_dom_book = 0;		// DOM 
			double t_jpn_book = 0;		// JPN 
			double t_chn_book = 0;		// CHN 
			double t_sea_book = 0;		// SEA 
			double t_aus_book = 0;		// AUS 
			double t_eur_book = 0;		// EUR 
			double t_usa_book = 0;		// USA 
			double t_etc_book = 0;		// Ÿ 
			
			while (rs.next()) {
				
				String regionFlt = StringUtil.checkString(rs.getString("Region_Flt"));	//Region_Flt
				String domPax = StringUtil.checkString(rs.getString("Dom_Pax"));		//DOM/PAX/CGO
				String newCnl = StringUtil.checkString(rs.getString("New_Cnl"));		//NEW/CNL
				String regDel = StringUtil.checkString(rs.getString("Reg_Del"));		//REG/DEL
				int cnt = rs.getInt("Cnt");																//COUNT
				int sum1 = rs.getInt("Sum_1");														//¼
				int sum2 = rs.getInt("Sum_2");														//
				int sum3 = rs.getInt("Sum_3");														//ž
				
				//OPERATIONS STATUS**************************************************************
				//PAX LOAD FACTOR****************************************************************
				//
				if(!(StringUtil.checkString(rs.getString("Sch_Dep_Dt"))).equals(todayDt)){
					//DOM
					if(domPax.equals("DOM")){
						y_dom_pl = y_dom_pl + cnt;
						if(newCnl.equals("NEW")){
							y_dom_op = y_dom_op + cnt;
							y_dom_cfg = y_dom_cfg + sum1;
							y_dom_chkin = y_dom_chkin + sum3;
							if(regDel.equals("REG")){
								y_dom_on = y_dom_on + cnt;
							}
						}
					//PAX
					}else if(domPax.equals("PAX")){
						y_pax_pl = y_pax_pl + cnt;
						if(newCnl.equals("NEW")){
							y_pax_op = y_pax_op + cnt;
							if(regDel.equals("REG")){
								y_pax_on = y_pax_on + cnt;
							}
							if(regionFlt.equals("2")){
								y_jpn_cfg = y_jpn_cfg + sum1;
								y_jpn_chkin = y_jpn_chkin + sum3;
							}else if(regionFlt.equals("3")){
								y_chn_cfg = y_chn_cfg + sum1;
								y_chn_chkin = y_chn_chkin + sum3;
							}else if(regionFlt.equals("4")){
								y_sea_cfg = y_sea_cfg + sum1;
								y_sea_chkin = y_sea_chkin + sum3;
							}else if(regionFlt.equals("5") || regionFlt.equals("8")){
								y_aus_cfg = y_aus_cfg + sum1;
								y_aus_chkin = y_aus_chkin + sum3;
							}else if(regionFlt.equals("7")){
								y_eur_cfg = y_eur_cfg + sum1;
								y_eur_chkin = y_eur_chkin + sum3;
							}else if(regionFlt.equals("6")){
								y_usa_cfg = y_usa_cfg + sum1;
								y_usa_chkin = y_usa_chkin + sum3;
							}else{
								y_etc_cfg = y_etc_cfg + sum1;
								y_etc_chkin = y_etc_chkin + sum3;
							}
						}
					//CGO
					}else if(domPax.equals("CGO")){
						y_cgo_pl = y_cgo_pl + cnt;
						if(newCnl.equals("NEW")){
							y_cgo_op = y_cgo_op + cnt;
							if(regDel.equals("REG")){
								y_cgo_on = y_cgo_on + cnt;
							}
						}
					}
				//
				}else{
					//DOM
					if(domPax.equals("DOM")){
						t_dom_pl = t_dom_pl + cnt;
						if(newCnl.equals("NEW")){
							t_dom_op = t_dom_op + cnt;
							t_dom_cfg = t_dom_cfg + sum1;
							t_dom_book = t_dom_book + sum2;
							if(regDel.equals("REG")){
								t_dom_on = t_dom_on + cnt;
							}
						}
					//PAX
					}else if(domPax.equals("PAX")){
						t_pax_pl = t_pax_pl + cnt;
						if(newCnl.equals("NEW")){
							t_pax_op = t_pax_op + cnt;
							if(regDel.equals("REG")){
								t_pax_on = t_pax_on + cnt;
							}
							if(regionFlt.equals("2")){
								t_jpn_cfg = t_jpn_cfg + sum1;
								t_jpn_book = t_jpn_book + sum2;
							}else if(regionFlt.equals("3")){
								t_chn_cfg = t_chn_cfg + sum1;
								t_chn_book = t_chn_book + sum2;
							}else if(regionFlt.equals("4")){
								t_sea_cfg = t_sea_cfg + sum1;
								t_sea_book = t_sea_book + sum2;
							}else if(regionFlt.equals("5") || regionFlt.equals("8")){
								t_aus_cfg = t_aus_cfg + sum1;
								t_aus_book = t_aus_book + sum2;
							}else if(regionFlt.equals("7")){
								t_eur_cfg = t_eur_cfg + sum1;
								t_eur_book = t_eur_book + sum2;
							}else if(regionFlt.equals("6")){
								t_usa_cfg = t_usa_cfg + sum1;
								t_usa_book = t_usa_book + sum2;
							}else{
								t_etc_cfg = t_etc_cfg + sum1;
								t_etc_book = t_etc_book + sum2;
							}
						}
					//CGO
					}else if(domPax.equals("CGO")){
						t_cgo_pl = t_cgo_pl + cnt;
						if(newCnl.equals("NEW")){
							t_cgo_op = t_cgo_op + cnt;
							if(regDel.equals("REG")){
								t_cgo_on = t_cgo_on + cnt;
							}
						}
					}
				}
			}
			
			// DOM (Operation Result)
			entity.setY_dom_pl(StringUtil.NumberFormatS(1,String.valueOf(y_dom_pl).toString()));
			entity.setY_dom_op(StringUtil.NumberFormatS(1,String.valueOf(y_dom_op).toString()));
			if(y_dom_pl != 0)		entity.setY_dom_re(df.format((y_dom_op / y_dom_pl) * 100)+"%");
			else		entity.setY_dom_re("");
			if(y_dom_op != 0)		entity.setY_dom_on(df.format((y_dom_on / y_dom_op) * 100)+"%");
			else		entity.setY_dom_on("");
			
			// PAX (Operation Result)
			entity.setY_pax_pl(StringUtil.NumberFormatS(1,String.valueOf(y_pax_pl).toString()));
			entity.setY_pax_op(StringUtil.NumberFormatS(1,String.valueOf(y_pax_op).toString()));
			if(y_pax_pl != 0)		entity.setY_pax_re(df.format((y_pax_op / y_pax_pl) * 100)+"%");
			else		entity.setY_pax_re("");
			if(y_pax_op != 0)		entity.setY_pax_on(df.format((y_pax_on / y_pax_op) * 100)+"%");
			else		entity.setY_pax_on("");
			
			// CGO (Operation Result)
			entity.setY_cgo_pl(StringUtil.NumberFormatS(1,String.valueOf(y_cgo_pl).toString()));
			entity.setY_cgo_op(StringUtil.NumberFormatS(1,String.valueOf(y_cgo_op).toString()));
			if(y_cgo_pl != 0)		entity.setY_cgo_re(df.format((y_cgo_op / y_cgo_pl) * 100)+"%");
			else		entity.setY_cgo_re("");
			if(y_cgo_op != 0)		entity.setY_cgo_on(df.format((y_cgo_on / y_cgo_op) * 100)+"%");
			else		entity.setY_cgo_on("");
			
			// TOTAL (Operation Result)
			entity.setY_tot_pl(StringUtil.NumberFormatS(1,String.valueOf(y_dom_pl + y_pax_pl + y_cgo_pl).toString()));
			entity.setY_tot_op(StringUtil.NumberFormatS(1,String.valueOf(y_dom_op + y_pax_op + y_cgo_op).toString()));
			if((y_dom_pl + y_pax_pl + y_cgo_pl) != 0) entity.setY_tot_re(df.format(((y_dom_op + y_pax_op + y_cgo_op) / (y_dom_pl + y_pax_pl + y_cgo_pl)) * 100)+"%");
			else entity.setY_tot_re("");
			if((y_dom_op + y_pax_op + y_cgo_op) != 0) entity.setY_tot_on(df.format(((y_dom_on + y_pax_on + y_cgo_on) / (y_dom_op + y_pax_op + y_cgo_op)) * 100)+"%");
			else entity.setY_tot_on("");
			
			// DOM (Real-Time Operations Status)
			entity.setT_dom_pl(StringUtil.NumberFormatS(1,String.valueOf(t_dom_pl).toString()));
			entity.setT_dom_op(StringUtil.NumberFormatS(1,String.valueOf(t_dom_op).toString()));
			if(t_dom_pl != 0)		entity.setT_dom_re(df.format((t_dom_op / t_dom_pl) * 100)+"%");
			else		entity.setT_dom_re("");
			if(t_dom_op != 0)		entity.setT_dom_on(df.format((t_dom_on / t_dom_op) * 100)+"%");
			else		entity.setT_dom_on("");
			
			// PAX (Real-Time Operations Status)
			entity.setT_pax_pl(StringUtil.NumberFormatS(1,String.valueOf(t_pax_pl).toString()));
			entity.setT_pax_op(StringUtil.NumberFormatS(1,String.valueOf(t_pax_op).toString()));
			if(t_pax_pl != 0)		entity.setT_pax_re(df.format((t_pax_op / t_pax_pl) * 100)+"%");
			else		entity.setT_pax_re("");
			if(t_pax_op != 0)		entity.setT_pax_on(df.format((t_pax_on / t_pax_op) * 100)+"%");
			else		entity.setT_pax_on("");
			
			// CGO (Real-Time Operations Status)
			entity.setT_cgo_pl(StringUtil.NumberFormatS(1,String.valueOf(t_cgo_pl).toString()));
			entity.setT_cgo_op(StringUtil.NumberFormatS(1,String.valueOf(t_cgo_op).toString()));
			if(t_cgo_pl != 0)		entity.setT_cgo_re(df.format((t_cgo_op / t_cgo_pl) * 100)+"%");
			else		entity.setT_cgo_re("");
			if(t_cgo_op != 0)		entity.setT_cgo_on(df.format((t_cgo_on / t_cgo_op) * 100)+"%");
			else		entity.setT_cgo_on("");
			
			// TOTAL (Real-Time Operations Status)
			entity.setT_tot_pl(StringUtil.NumberFormatS(1,String.valueOf(t_dom_pl + t_pax_pl + t_cgo_pl).toString()));
			entity.setT_tot_op(StringUtil.NumberFormatS(1,String.valueOf(t_dom_op + t_pax_op + t_cgo_op).toString()));
			if((t_dom_pl + t_pax_pl + t_cgo_pl) != 0) entity.setT_tot_re(df.format(((t_dom_op + t_pax_op + t_cgo_op) / (t_dom_pl + t_pax_pl + t_cgo_pl)) * 100)+"%");
			else entity.setT_tot_re("");
			if((t_dom_op + t_pax_op + t_cgo_op) != 0) entity.setT_tot_on(df.format(((t_dom_on + t_pax_on + t_cgo_on) / (t_dom_op + t_pax_op + t_cgo_op)) * 100)+"%");
			else entity.setT_tot_on("");
			
			// PAX LOAD FACTOR
			if(y_dom_cfg != 0)	entity.setY_dom(df.format((y_dom_chkin / y_dom_cfg) * 100));
			else		entity.setY_dom("0");
			if(y_jpn_cfg != 0)	entity.setY_jpn(df.format((y_jpn_chkin / y_jpn_cfg) * 100));
			else		entity.setY_jpn("0");
			if(y_chn_cfg != 0)	entity.setY_chn(df.format((y_chn_chkin / y_chn_cfg) * 100));
			else		entity.setY_chn("0");
			if(y_sea_cfg != 0)	entity.setY_sea(df.format((y_sea_chkin / y_sea_cfg) * 100));
			else		entity.setY_sea("0");
			if(y_aus_cfg != 0)	entity.setY_aus(df.format((y_aus_chkin / y_aus_cfg) * 100));
			else		entity.setY_aus("0");
			if(y_eur_cfg != 0)	entity.setY_eur(df.format((y_eur_chkin / y_eur_cfg) * 100));
			else		entity.setY_eur("0");
			if(y_usa_cfg != 0)	entity.setY_usa(df.format((y_usa_chkin / y_usa_cfg) * 100));
			else		entity.setY_usa("0");
			double y_tot_cfg = y_dom_cfg + y_jpn_cfg + y_chn_cfg + y_sea_cfg + y_aus_cfg + y_eur_cfg + y_usa_cfg + y_etc_cfg;
			double y_tot_chkin = y_dom_chkin + y_jpn_chkin + y_chn_chkin + y_sea_chkin + y_aus_chkin + y_eur_chkin + y_usa_chkin + y_etc_chkin;
			if(y_tot_cfg != 0)	entity.setY_tot(df.format((y_tot_chkin / y_tot_cfg) * 100));
			else		entity.setY_tot("0");
			
			// PAX LOAD FACTOR
			if(t_dom_cfg != 0)	entity.setT_dom(df.format((t_dom_book / t_dom_cfg) * 100));
			else		entity.setT_dom("0");
			if(t_jpn_cfg != 0)	entity.setT_jpn(df.format((t_jpn_book / t_jpn_cfg) * 100));
			else		entity.setT_jpn("0");
			if(t_chn_cfg != 0)	entity.setT_chn(df.format((t_chn_book / t_chn_cfg) * 100));
			else		entity.setT_chn("0");
			if(t_sea_cfg != 0)	entity.setT_sea(df.format((t_sea_book / t_sea_cfg) * 100));
			else		entity.setT_sea("0");
			if(t_aus_cfg != 0)	entity.setT_aus(df.format((t_aus_book / t_aus_cfg) * 100));
			else		entity.setT_aus("0");
			if(t_eur_cfg != 0)	entity.setT_eur(df.format((t_eur_book / t_eur_cfg) * 100));
			else		entity.setT_eur("0");
			if(t_usa_cfg != 0)	entity.setT_usa(df.format((t_usa_book / t_usa_cfg) * 100));
			else		entity.setT_usa("0");
			double t_tot_cfg = t_dom_cfg + t_jpn_cfg + t_chn_cfg + t_sea_cfg + t_aus_cfg + t_eur_cfg + t_usa_cfg + t_etc_cfg;
			double t_tot_book = t_dom_book + t_jpn_book + t_chn_book + t_sea_book + t_aus_book + t_eur_book + t_usa_book + t_etc_book;
			if(t_tot_cfg != 0)	entity.setT_tot(df.format((t_tot_book / t_tot_cfg) * 100));
			else		entity.setT_tot("0");
			
			// ۾  ȸ
			stmt = conn.createStatement();
			sql = RepQ310Query.getInstance().selMonth(params);
			rs = stmt.executeQuery(sql);
			
			String Code_c = "";
			while (rs.next()) {
				Code_c = StringUtil.checkString(rs.getString("Code_c"));
			}
			
			if(!Code_c.equals("")){
				params.setReport_d(Code_c);
				entity.setReport_d(Code_c);
				
				//Monthly Report ȸ
				stmt = conn.createStatement();
				sql = RepQ310Query.getInstance().selMonthlyReport(params);
				rs = stmt.executeQuery(sql);
				
				double reg_sum1 = 0;
				double reg_sum2 = 0;
				double ont_sum1 = 0;
				double ont_sum2 = 0;
				double loa_sum1 = 0;
				double loa_sum3 = 0;
				
				while (rs.next()) {
					String reportX = StringUtil.checkString(rs.getString("Report_x"));
					String reportD = StringUtil.checkString(rs.getString("Report_d"));
					int sum1 = rs.getInt("Sum1");
					int sum2 = rs.getInt("Sum2");
					int sum3 = rs.getInt("Sum3");
					
					//
					if(reportX.equals("A")){
						reg_sum1 = reg_sum1 + sum1;
						reg_sum2 = reg_sum2 + sum2;
					//ü
					}else if(reportX.equals("B")){
						ont_sum1 = ont_sum1 + sum1;
						ont_sum2 = ont_sum2 + sum2;
					//L/F
					}else if(reportX.equals("L")){
						loa_sum1 = loa_sum1 + sum1;
						loa_sum3 = loa_sum3 + sum3;
					}
				}
				if(reg_sum1 != 0)	entity.setRegularity_tot(df.format((reg_sum2 / reg_sum1) * 100)+"%");
				else		entity.setRegularity_tot("0%");
				if(ont_sum1 != 0)	entity.setOntime_tot(df.format((ont_sum2 / ont_sum1) * 100)+"%");
				else 	entity.setOntime_tot("0%");
				if(loa_sum1 != 0)		entity.setLoadfactor_tot(df.format((loa_sum3 / loa_sum1) * 100)+"%");
				else		entity.setLoadfactor_tot("0%");
				
			}else{
				entity.setRegularity_tot("");
				entity.setOntime_tot("");
				entity.setLoadfactor_tot("");
			}
						
			hashData.put("MNGBOARD",entity);
			
		} catch(SQLException se) {
			Logger.debug.println("[BASE:RepAllSLBean:selRepQ310Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:RepAllSLBean:selRepQ310Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  *  PAX Load Factor ȸԼ 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/07/27 
	  */
	public Hashtable selRepQ330Main(RepQ330BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			RepQ330BG entity = new RepQ330BG();
	    	DecimalFormat df = new DecimalFormat("#,###.#");
			
			//PAX Load Factor ȸ
			stmt = conn.createStatement();
			sql = RepQ330Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			double dom_cfg = 0;		//DOM ¼
			double dom_chkin = 0;	//DOM ž
			double pax_cfg = 0;		//PAX ¼
			double pax_chkin = 0;	//PAX ž
			
			while (rs.next()) {
				String domPax = StringUtil.checkString(rs.getString("Dom_Pax"));		//DOM/PAX/CGO
				String newCnl = StringUtil.checkString(rs.getString("New_Cnl"));		//NEW/CNL
				int sum1 = rs.getInt("Sum1");														//¼
				int sum2 = rs.getInt("Sum2");														//ž
				
				if(domPax.equals("DOM")){
					if(newCnl.equals("NEW")){
						dom_cfg = dom_cfg + sum1;
						dom_chkin = dom_chkin + sum2;
					}
				}else if(domPax.equals("PAX")){
					if(newCnl.equals("NEW")){
						pax_cfg = pax_cfg + sum1;
						pax_chkin = pax_chkin + sum2;
					}
				}
			}
			entity.setDom_cfg(StringUtil.NumberFormatS(1,String.valueOf(dom_cfg).toString()));
			entity.setDom_chkin(StringUtil.NumberFormatS(1,String.valueOf(dom_chkin).toString()));
			entity.setPax_cfg(StringUtil.NumberFormatS(1,String.valueOf(pax_cfg).toString()));
			entity.setPax_chkin(StringUtil.NumberFormatS(1,String.valueOf(pax_chkin).toString()));
			if(dom_cfg != 0)	entity.setDom_lf(df.format((dom_chkin / dom_cfg) * 100)+"%");
			else entity.setDom_lf("");
			if(pax_cfg != 0)	entity.setPax_lf(df.format((pax_chkin / pax_cfg) * 100)+"%");
			else entity.setPax_lf("");
			
			hashData.put("PAXLOAD",entity);
			
		} catch(SQLException se) {
			Logger.debug.println("[BASE:RepAllSLBean:selRepQ330Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:RepAllSLBean:selRepQ330Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  *  CGO Load Factor ȸԼ 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/07/27 
	  */
	public Hashtable selRepQ340Main(RepQ340BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			RepQ340BG entity = new RepQ340BG();
	    	DecimalFormat df = new DecimalFormat("#,###.#");
			
			//CGOLoad Factor ȸ
			stmt = conn.createStatement();
			sql = RepQ340Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			double freighter_s = 0;		//ȭ 
			double freighter_c = 0;		//ȭ 
			double passenger_s = 0;	// 
			double passenger_c = 0;	// 
			
			while (rs.next()) {
				if(!StringUtil.checkString(rs.getString("FRE_S")).equals(""))		freighter_s = Integer.parseInt(StringUtil.checkString(rs.getString("FRE_S")));
				if(!StringUtil.checkString(rs.getString("FRE_C")).equals(""))		freighter_c = Integer.parseInt(StringUtil.checkString(rs.getString("FRE_C")));
				if(!StringUtil.checkString(rs.getString("PAS_S")).equals(""))		passenger_s = Integer.parseInt(StringUtil.checkString(rs.getString("PAS_S")));
				if(!StringUtil.checkString(rs.getString("PAS_C")).equals(""))		passenger_c = Integer.parseInt(StringUtil.checkString(rs.getString("PAS_C")));
			}
			
			entity.setFreighter_s(StringUtil.NumberFormatS(1,String.valueOf(freighter_s).toString()));
			entity.setFreighter_c(StringUtil.NumberFormatS(1,String.valueOf(freighter_c).toString()));
			entity.setPassenger_s(StringUtil.NumberFormatS(1,String.valueOf(passenger_s).toString()));
			entity.setPassenger_c(StringUtil.NumberFormatS(1,String.valueOf(passenger_c).toString()));
			if(freighter_s != 0)	entity.setFreighter_l(df.format((freighter_c / freighter_s) * 100)+"%");
			else 	entity.setFreighter_l("");
			if(passenger_s != 0)	entity.setPassenger_l(df.format((passenger_c / passenger_s) * 100)+"%");
			else 	entity.setPassenger_l("");
			entity.setTotal_s(StringUtil.NumberFormatS(1,String.valueOf(freighter_s + passenger_s).toString()));
			entity.setTotal_c(StringUtil.NumberFormatS(1,String.valueOf(freighter_c + passenger_c).toString()));
			if((freighter_s + passenger_s) != 0)	entity.setTotal_l(df.format(((freighter_c + passenger_c) / (freighter_s + passenger_s)) * 100)+"%");
			else		entity.setTotal_l("");
			
			if(freighter_s != 0){	
				entity.setF_s_height(df.format((freighter_s / (freighter_s + passenger_s)) * 100)+"%");
				if(freighter_c != 0)	entity.setF_c_height(df.format((freighter_c / (freighter_s + passenger_s)) * 100)+"%");
				else 	entity.setF_c_height("1%");
			}else{
				entity.setF_s_height("1%");
				entity.setF_c_height("1%");
			}
			if(passenger_s != 0){	
				entity.setP_s_height(df.format((passenger_s / (freighter_s + passenger_s)) * 100)+"%");
				if(passenger_c != 0)	entity.setP_c_height(df.format((passenger_c / (freighter_s + passenger_s)) * 100)+"%");
				else 	entity.setP_c_height("1%");
			}else{
				entity.setP_s_height("1%");
				entity.setP_c_height("1%");
			}
			if(freighter_s != 0 && passenger_s != 0){	
				entity.setT_s_height("100%");
				if(freighter_c != 0 && passenger_c != 0)		entity.setT_c_height(df.format(((freighter_c + passenger_c) / (freighter_s + passenger_s)) * 100)+"%");
				else 	entity.setT_c_height("1%");
			}else{ 
				entity.setT_s_height("1%");
				entity.setT_c_height("1%");
			}
			
			hashData.put("CGOLOAD",entity);
			
		} catch(SQLException se) {
			Logger.debug.println("[BASE:RepAllSLBean:selRepQ340Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:RepAllSLBean:selRepQ340Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
}//end of class
