package kal.base.skd.ejb;
import kal.base.skd.dbbean.*;
import kal.base.jdf.db.BusinessException;
import java.util.Hashtable;
import java.util.Vector;
import kal.base.skd.dbbean.SkdQ030BG;
import kal.base.skd.dbbean.SkdQ020BG;
import kal.base.skd.dbbean.SkdQ050BG;
import kal.base.skd.dbbean.SkdQ110BG;
import kal.base.skd.dbbean.SkdQ060BG;
import kal.base.skd.dbbean.SkdQ070BG;
import kal.base.skd.dbbean.SkdA080BG;
import kal.base.skd.dbbean.SkdQ090BG;
/**
 * Remote interface for Enterprise Bean: SkdAllSL
 */
public interface SkdAllSL extends javax.ejb.EJBObject {
	/** 
	  * <b>Daily SKD Display ȸԼ</b>. 
	  * @param params SkdQ010BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/18 HIST 
	  */
	public Hashtable selSkdQ010Main(SkdQ010BG params)
		throws BusinessException, java.rmi.RemoteException;
	
	public Hashtable selSkdQ010Kactyp()
			throws BusinessException, java.rmi.RemoteException;//@2017-07-07
	/** 
	  * <b>Detail FLT Status ȸԼ</b>. 
	  * @param params SkdQ040BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/20 HIST 
	  */
	public Hashtable selSkdQ040Main(SkdQ040BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * Planning SKD INFO main ȸԼ.
	  * @param entity SkdQ030BG Planning SKD INFO
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/01/17 
	  */
	public Hashtable selSkdQ030Main(SkdQ030BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * Flight Progress Information main ȸԼ.
	  * @param entity SkdQ020BG Flight Progress Information
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/01/20 
	  */
	public Hashtable selSkdQ020Main(SkdQ020BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * HUB Station Information main ȸԼ.
	  * @param entity SkdQ050BG HUB Station Information
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/02/02 
	  */
	public Hashtable selSkdQ050Main(SkdQ050BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * Gantt Chart main ȸԼ.
	  * @param entity SkdQ110BG 
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2006/04/24 
	  */
	public Hashtable selSkdQ110Main(SkdQ110BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * Gantt Chart main ȸԼ.
	  * @param entity SkdQ110BG 
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2006/04/24 
	  */
	public Hashtable selSkdQ110Crew(SkdQ110BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * HUB Station Info Detail ȸ Լ
	  * @param entity SkdQ060BG 
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2006/05/09 
	  */
	public Hashtable selSkdQ060Main(SkdQ060BG params)
		throws BusinessException, java.rmi.RemoteException;
	/**
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selSkdQ070Season() throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selSkdQ070Kactyp()
			throws BusinessException, java.rmi.RemoteException;//@2017-07-10
	public Hashtable selSkdQ070Main(SkdQ070BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selSkdA080Kactyp() throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selSkdA080Main(SkdA080BG params) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param timeData
	 * @param hashParam
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String insSkdA080Send(SkdA080BG timeData, Hashtable hashParam) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param empNo
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public String selFodisAuth(String empNo) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param empNo
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable updFodisLogin(String empNo) throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param params
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public Hashtable selSkdQ090Main(SkdQ090BG params) throws BusinessException, java.rmi.RemoteException;
}
