package kal.base.wea.ejb;
import kal.base.sup.dbbean.SupQ210BG;
import java.util.Hashtable;
import kal.base.jdf.db.BusinessException;
import kal.base.sup.dbbean.SupA340BG;
import kal.base.sup.dbbean.SupQ010BG;
import kal.base.sup.dbbean.SupQ220BG;
/**
 * Remote interface for Enterprise Bean: WeaAllSL
 */
public interface WeaAllSL extends javax.ejb.EJBObject {
	/** 
	  * <b>BASE2 Current Weather Request Send Լ</b>. 
	  * @param hashData Hashtable  
	  * @return boolean Weather Send  "Y" / "N"
	  * @exception Exception
	  * @author Copyright (c) 2005/08/19 HIST 
	  */
	public boolean sendCurrWxReq(SupQ210BG params, Hashtable hashData)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>BASE2 WEATHER INPUT Է Լ</b>. 
	  * @param params SupA340BG Է
	  * @return boolean Weather Input 
	  * @exception Exception
	  * @author Copyright (c) 2005/08/22 HIST 
	  */
	public SupA340BG insSupA340Main(SupA340BG params)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>BASE2 Notam Request Send Լ</b>. 
	  * @param params SupQ010BG ȸ
	  * @param hashData Hashtable  
	  * @return boolean NOTAM Send  "Y" / "N"
	  * @exception Exception
	  * @author Copyright (c) 2005/08/19 HIST 
	  */
	public boolean sendNotamReq(SupQ010BG params, Hashtable hashData)
		throws BusinessException, java.rmi.RemoteException;
	/** 
	  * <b>BASE2 Link Site Manage ȸ Լ</b>. 
	  * @return hashData Hashtable ȸ 
	  * @exception Exception
	  * @author Copyright (c) 2005/08/23 HIST 
	  */
	public Hashtable selSupA910Main()
		throws BusinessException, java.rmi.RemoteException;
	/**
	 * @param sendParam
	 * @param hashData
	 * @return
	 * @throws BusinessException
	 * @throws java.rmi.RemoteException
	 */
	public boolean sendPastWxReq(SupQ220BG sendParam, Hashtable hashData) throws BusinessException, java.rmi.RemoteException;
}
