package kal.base.ffs.daemon;

import java.io.FileReader;
import java.io.BufferedReader;
import java.util.Timer;
import java.util.TimerTask;
import java.util.HashMap;
import java.rmi.RemoteException;

import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Before Released
 */
public class FfsQ010Daemon {
	
	private static FfsQ010Daemon FfsQ010Daemon = new FfsQ010Daemon();
	
	public static FfsQ010Daemon getInstance() {
		return FfsQ010Daemon;
	}
	
	public static int i = 0;
	
	// 2007.01.24 ߰
	public static HashMap alertRule;
	
	private FfsQ010Daemon() {
		//if (FfsQ010Daemon.i == 0) {
		if (FfsQ010Daemon == null) {
			try {				
				Timer timer;
				timer = new Timer();
				timer.scheduleAtFixedRate(new FfsQ010Task(timer), 0, 60000); //60ʸ ȸ
				//Logger.debug.println("<< FfsQ010Daemon Start >>");
				System.out.println("<< FfsQ010Daemon Start >>");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	// 2007.01.24 ߰
	public static void FfsQ010AlertRule() {
		try {
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			alertRule = sl.selAlertRule("1");
		} catch(Exception e) {
			if (e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ010AlertRule] "+((RemoteException)e).getMessage());
			} else {
				Logger.debug.println("[BASE:FfsQ010AlertRule] "+((Exception)e).getMessage());
			}
		}
	}
}