package kal.base.ffs.daemon;

import java.rmi.RemoteException;
import java.util.Timer;
import java.util.TimerTask;
import java.util.HashMap;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Before Released
 */
public class FfsQ010Task extends TimerTask {
	
	Timer timer;
	public static HashMap hMap = new HashMap();
	
	public FfsQ010Task() { }
	
	public FfsQ010Task(Timer _timer) {
		this.timer = _timer;
	}
	
	public void run() {
		try {
			
			//System.out.println("FfsQ010Task @@@@@@@@ 11111");
			//System.out.println("FfsQ010Daemon.i : " + FfsQ010Daemon.i++);
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			
			//System.out.println("FfsQ010Task @@@@@@@@ 22222");
			
			hMap = sl.allNotReleased();
			//System.out.println("HashMap size : " + hMap.size());
			
			System.out.println("FfsQ010Task @@@@@@@@ 33333");
			
		} catch(Exception e) {
			if (e instanceof RemoteException) {
				System.out.println("FfsQ010Task @@@@@@@@ 44444");
				System.out.println("[BASE:FfsQ010Task] "+((RemoteException)e).getMessage());
			} else {
				System.out.println("FfsQ010Task @@@@@@@@ 55555");
				System.out.println("[BASE:FfsQ010Task] "+((Exception)e).getMessage());				
			}
		}
	}
	
}
