package kal.base.ffs.daemon;

import java.io.FileReader;
import java.io.BufferedReader;
import java.util.Timer;
import java.util.TimerTask;
import java.util.HashMap;
import java.rmi.RemoteException;

import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Released
 */
public class FfsQ020Daemon {
	
	private static FfsQ020Daemon FfsQ020Daemon = new FfsQ020Daemon();
	
	public static FfsQ020Daemon getInstance() {
		return FfsQ020Daemon;
	}
	
	public static int i = 0;
	
	// 2007.01.24 ߰
	public static HashMap alertRule;
	
	private FfsQ020Daemon() {
		if (FfsQ020Daemon.i == 0) {
			try {
				Timer timer;
				timer = new Timer();
				timer.scheduleAtFixedRate(new FfsQ020Task(timer),0,60000); //60ʸ ȸ
				Logger.debug.println("<< FfsQ020Daemon Start >>");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	// 2007.01.24 ߰
	public static void FfsQ020AlertRule() {
		try {
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");			
			alertRule = sl.selAlertRule("2");
		} catch(Exception e) {
			if (e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ020AlertRule] "+((RemoteException)e).getMessage());
			} else {
				Logger.debug.println("[BASE:FfsQ020AlertRule] "+((Exception)e).getMessage());
			}
		}
	}
}
