package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.serv.ComUtil;
import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ffs.dbbean.FfsQ410BG;
import kal.base.ffs.dbbean.TarQ010BG;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Tarmac ȸ Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2011/07/29 
 */
public class TarQ010Serv extends PublicBaseServlet {
	/** 
	  * Tarmac ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2011/07/29 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String frDate = StringUtil.checkString(box.getString("fr_date")+" "+box.getString("fr_time"));
		String toDate = StringUtil.checkString(box.getString("to_date")+" "+box.getString("to_time"));
		String delay = StringUtil.checkString(box.getString("delay"));
		String status = StringUtil.checkString(box.getString("status"));
		String stn = StringUtil.checkString(box.getString("stn"));
		String RegionCdAll = StringUtil.checkString(box.getString("region_cd"));
		String schRegions = StringUtil.checkString(box.getString("sch_regions"));
		String sort = StringUtil.checkString(box.getString("sort"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			
			String regionCd = "";
			String regionAME = "X";
			String regionOCN = "";
			
			// region ڵ带 daily_sch_t ϴ  ڵ  ٲ
			//db   · ش
			if (!schRegions.equals("")) {
				int cnt = schRegions.length() / 3;
				for (int n=1; n<=cnt; n++) {
					String region = schRegions.substring((n*3)-3,n*3);
					if(region.equals("AME")) {
						region = "'6'"; 
						//regionAME = "5";
						//region = "'6'";
						//region = ""; 
						regionAME = "Y";
					}
					/*if(region.equals("OCN")){
						region = "";
						regionOCN = "Y";
					}*/
					else if(region.equals("EUR")) region = "'7','8'";
					else if(region.equals("CHN")) region = "'3'";
					else if(region.equals("SEA")) region = "'4'";
					else if(region.equals("OCN")) region = "'5'";
					else if(region.equals("JPN")) region = "'2'";
					else if(region.equals("DOM")) region = "'1'";
					if (regionCd.equals("")) regionCd = region;
					else regionCd = regionCd + ", " + region;
				}
			}
			if(!regionCd.equals("")){
			    regionCd = regionCd + ",'9'";
			}else{
				regionCd = regionCd + "'9'";
			}
			
			TarQ010BG params = new TarQ010BG();
			
			params.setPFrDate(frDate);
			params.setPToDate(toDate);
			params.setPDelay(delay);
			params.setPStatus(status);
			params.setPStn(stn);
			params.setPSchRegions(regionCd);
			params.setPSort(sort);
			params.setRegionAME(regionAME);
			params.setRegionOCN(regionOCN);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData  = sl.selTarDepArv(params);
			
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("TarDepArv", hashData, "TarDepArv", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//reflash ϱ  Ķͷ Ѿ  ٽ attribute ־ش
			req.setAttribute("fr_date",box.getString("fr_date"));
			req.setAttribute("fr_time",box.getString("fr_time"));
			req.setAttribute("to_date",box.getString("to_date"));
			req.setAttribute("to_time",box.getString("to_time"));
			req.setAttribute("delay",delay);
			req.setAttribute("status",status);
			req.setAttribute("stn",stn);
			req.setAttribute("sch_regions",schRegions);
			req.setAttribute("sort",sort);
			
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:TarQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:TarQ010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}//end selectTask
}
