package kal.base.iro.serv;
/*	=====================================================================================
@Author		:	v.bgkim@kalmate.net
@Create		:	2013-10-07	Start designing
@end			:	2013-11-08
@Modify		:	
@Purpose		:		
=====================================================================================	*/
import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.util.StringUtil;
import kal.base.iro.ejb.IroAllSL;
import kal.base.iro.dbbean.IroQ710BG;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;

public class IroQ711Serv extends PublicBaseServlet {
	/*-------------------------------------------------------------------	Field	
	----------------------------------------------------------------------	*/
	private static final long serialVersionUID = -0000000000000000000L;
	/*-------------------------------------------------------------------	logPrint
	----------------------------------------------------------------------	*/
	private void  logPrint(StackTraceElement	currentStack, String message){
		if(currentStack!=null){
			Logger.debug.println("Start	======================================="+currentStack.getClassName() +"."+currentStack.getMethodName());
			Logger.debug.println(message);
			Logger.debug.println("End---------------------------------------");
		}		
	}
	private void  logPrint(StackTraceElement	currentStack, Box box){
		if(currentStack!=null){
			Logger.debug.println("Start	======================================="+currentStack.getClassName() +"."+currentStack.getMethodName());
			//Logger.debug.println(message);
			
			String	key	=	null;
			Object	value	=	null;
			java.util.Iterator	iterator	=	((java.util.Set) box.keySet()).iterator();
			while(iterator.hasNext()){
				key	=	(String) iterator.next();
				value	=	box.get(key);
				Logger.debug.println("["+key+"]	"+value);
			}			
			Logger.debug.println("End---------------------------------------");
		}		
	}
	/*-------------------------------------------------------------------	selectTask
	----------------------------------------------------------------------	*/
	public void selectTask (HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box						box					=	HttpUtility.getBox(req);				 										    //Box ü 
		String					returnPage			=	StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String					dssStartDt			=	StringUtil.checkString(box.getString("dssStartDt"));
		String					seqNum			=	StringUtil.checkString(box.getString("seqNum"));
		//logPrint(new Throwable().getStackTrace()[0],box);
		try {
			//- - - - - - - - - - - - - - - - - - - - - - - - - -	params
			IroQ710BG	params				=	new IroQ710BG();
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			//- - - - - - - - - - - - - - - - - - - - - - - - - -	EJB LookUp
			IroAllSL	sl						=	(IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable			hashData			=	sl.selIroQ711Main(params);
			//- - - - - - - - - - - - - - - - - - - - - - - - - -	Set	return
			req.setAttribute("hashData", hashData);
			req.setAttribute("returnParam", "Y");
			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {		
			if(e instanceof RemoteException) {
				logPrint(e.getStackTrace()[0],"[RemoteException] "+((RemoteException)e).getMessage());
			} else {
				logPrint(e.getStackTrace()[0],"[Exception] "+e.getMessage());
			}
			printMessagePage2(req, res, e.getMessage(),returnPage,"select");
		} 
	}
	/*-------------------------------------------------------------------	insertTask
	----------------------------------------------------------------------	
	public void insertTask (HttpServletRequest req, HttpServletResponse res) throws Exception {
		
	}*/
	/*-------------------------------------------------------------------	updateTask
	----------------------------------------------------------------------	
	public void updateTask (HttpServletRequest req, HttpServletResponse res) throws Exception {
		
	}*/
	/*-------------------------------------------------------------------	deleteTask
	----------------------------------------------------------------------	
	public void deleteTask (HttpServletRequest req, HttpServletResponse res) throws Exception {
		
	}*/
	/*-------------------------------------------------------------------	checkTask
	----------------------------------------------------------------------	
	public void checkTask (HttpServletRequest req, HttpServletResponse res) throws Exception {
		
	}*/
}
