package kal.base.sys.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.*;
import kal.base.sys.ejb.SysAllSL;

/**
 * Ȳ
 * @version 	1.0
 * @author Copyright (c) 2006/04/07 
 */
public class SysQ120Serv extends PublicBaseServlet{

	/** 
	  * ȸ Main - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2006/04/07 
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 												//Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		//̵, йȣ 빮ڷ ȯ.
		String exeId = StringUtil.checkString(box.getString("exeId")).toUpperCase();
		String exePw = StringUtil.checkString(box.getString("exePw")).toUpperCase();
		HttpSession session = req.getSession();
		
		try {
			// Session  ش.
		    SysQ120BG temp = (SysQ120BG)session.getAttribute("SESSIONINFO");
		    if (temp != null) {
		    	try {
		    		session.invalidate();
		    		session = req.getSession();
		    	} catch (Exception e) { }
		    }
			
			//EJB Parameter 
			SysQ120BG params = new SysQ120BG();
			params.setExeId(exeId);
			params.setExePw(exePw);
			
			//EJB LookUp
			SysAllSL sl = (SysAllSL)EJBFinder.lookup("ejb/SysAllSL");
			SysQ120BG entity = sl.selSysQ120Main(params);
			
			//Session  ִ´.
			boolean newSession = session.isNew();
			if (entity != null) {
				session.setAttribute("SESSIONINFO",entity);
				req.setAttribute("loginOk","Y");
			} else {
				throw new Exception("̵ йȣ ƲȽϴ.");
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SysQ120Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SysQ120Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}
	
}
